// Note: Some Emscripten settings will significantly limit the speed of the generated code.
// Note: Some Emscripten settings may limit the speed of the generated code.
// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?{ ?[^}]* ?}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (vararg) return 8;
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      assert(args.length == sig.length-1);
      return FUNCTION_TABLE[ptr].apply(null, args);
    } else {
      assert(sig.length == 1);
      return FUNCTION_TABLE[ptr]();
    }
  },
  addFunction: function (func) {
    var table = FUNCTION_TABLE;
    var ret = table.length;
    assert(ret % 2 === 0);
    table.push(func);
    for (var i = 0; i < 2-1; i++) table.push(0);
    return ret;
  },
  removeFunction: function (index) {
    var table = FUNCTION_TABLE;
    table[index] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8);(assert((STACKTOP|0) < (STACK_MAX|0))|0); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + (assert(!staticSealed),size))|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + (assert(DYNAMICTOP > 0),size))|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((low>>>0)+((high>>>0)*4294967296)) : ((low>>>0)+((high|0)*4294967296))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.
var setjmpId = 1; // Used in setjmp/longjmp
var setjmpLabels = {};

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,Math_abs(tempDouble) >= 1 ? (tempDouble > 0 ? Math_min(Math_floor((tempDouble)/4294967296), 4294967295)>>>0 : (~~(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/4294967296)))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }
    assert(type, 'Must know what type to store in allocate!');

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    assert(ptr + i < TOTAL_MEMORY);
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    assert(ptr + i < TOTAL_MEMORY);
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    var i = 3;
    // params, etc.
    var basicTypes = {
      'v': 'void',
      'b': 'bool',
      'c': 'char',
      's': 'short',
      'i': 'int',
      'l': 'long',
      'f': 'float',
      'd': 'double',
      'w': 'wchar_t',
      'a': 'signed char',
      'h': 'unsigned char',
      't': 'unsigned short',
      'j': 'unsigned int',
      'm': 'unsigned long',
      'x': 'long long',
      'y': 'unsigned long long',
      'z': '...'
    };
    function dump(x) {
      //return;
      if (x) Module.print(x);
      Module.print(func);
      var pre = '';
      for (var a = 0; a < i; a++) pre += ' ';
      Module.print (pre + '^');
    }
    var subs = [];
    function parseNested() {
      i++;
      if (func[i] === 'K') i++; // ignore const
      var parts = [];
      while (func[i] !== 'E') {
        if (func[i] === 'S') { // substitution
          i++;
          var next = func.indexOf('_', i);
          var num = func.substring(i, next) || 0;
          parts.push(subs[num] || '?');
          i = next+1;
          continue;
        }
        if (func[i] === 'C') { // constructor
          parts.push(parts[parts.length-1]);
          i += 2;
          continue;
        }
        var size = parseInt(func.substr(i));
        var pre = size.toString().length;
        if (!size || !pre) { i--; break; } // counter i++ below us
        var curr = func.substr(i + pre, size);
        parts.push(curr);
        subs.push(curr);
        i += pre + size;
      }
      i++; // skip E
      return parts;
    }
    var first = true;
    function parse(rawList, limit, allowVoid) { // main parser
      limit = limit || Infinity;
      var ret = '', list = [];
      function flushList() {
        return '(' + list.join(', ') + ')';
      }
      var name;
      if (func[i] === 'N') {
        // namespaced N-E
        name = parseNested().join('::');
        limit--;
        if (limit === 0) return rawList ? [name] : name;
      } else {
        // not namespaced
        if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
        var size = parseInt(func.substr(i));
        if (size) {
          var pre = size.toString().length;
          name = func.substr(i + pre, size);
          i += pre + size;
        }
      }
      first = false;
      if (func[i] === 'I') {
        i++;
        var iList = parse(true);
        var iRet = parse(true, 1, true);
        ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
      } else {
        ret = name;
      }
      paramLoop: while (i < func.length && limit-- > 0) {
        //dump('paramLoop');
        var c = func[i++];
        if (c in basicTypes) {
          list.push(basicTypes[c]);
        } else {
          switch (c) {
            case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
            case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
            case 'L': { // literal
              i++; // skip basic type
              var end = func.indexOf('E', i);
              var size = end - i;
              list.push(func.substr(i, size));
              i += size + 2; // size + 'EE'
              break;
            }
            case 'A': { // array
              var size = parseInt(func.substr(i));
              i += size.toString().length;
              if (func[i] !== '_') throw '?';
              i++; // skip _
              list.push(parse(true, 1, true)[0] + ' [' + size + ']');
              break;
            }
            case 'E': break paramLoop;
            default: ret += '?' + c; break paramLoop;
          }
        }
      }
      if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
      return rawList ? list : ret + flushList();
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 16777216;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;


// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'Cannot fallback to non-typed array case: Code is too specialized');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
        assert(false, 'Character code ' + chr + ' (' + String.fromCharCode(chr) + ')  at offset ' + i + ' not in 0x00-0xFF.');
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    assert(str.charCodeAt(i) === str.charCodeAt(i)&0xff);
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore, sig) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore, sig) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled
var runDependencyTracking = {};

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (id) {
    assert(!runDependencyTracking[id]);
    runDependencyTracking[id] = 1;
    if (runDependencyWatcher === null && typeof setInterval !== 'undefined') {
      // Check for missing dependencies every few seconds
      runDependencyWatcher = setInterval(function() {
        var shown = false;
        for (var dep in runDependencyTracking) {
          if (!shown) {
            shown = true;
            Module.printErr('still waiting on run dependencies:');
          }
          Module.printErr('dependency: ' + dep);
        }
        if (shown) {
          Module.printErr('(end of list)');
        }
      }, 10000);
    }
  } else {
    Module.printErr('warning: run dependency added without ID');
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (id) {
    assert(runDependencyTracking[id]);
    delete runDependencyTracking[id];
  } else {
    Module.printErr('warning: run dependency removed without ID');
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===



STATIC_BASE = 8;

STATICTOP = STATIC_BASE + 5696;


/* global initializers */ __ATINIT__.push({ func: function() { runPostSets() } });



























var _stdout;
var _stdout=_stdout=allocate([0,0,0,0,0,0,0,0], "i8", ALLOC_STATIC);;


















































































































































































































































var ___fsmu8;























































/* memory initializer */ allocate([1,0,0,0,0,0,0,0,80,0,0,0,80,0,0,0,6,13,0,0,11,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,36,13,21,0,49,5,41,0,80,4,61,0,219,3,81,0,141,3,101,0,83,3,121,0,37,3,141,0,255,2,161,0,222,2,181,0,194,2,201,0,168,2,221,0,146,2,241,0,125,2,65,1,55,2,125,1,12,2,69,2,150,1,13,3,35,1,113,3,219,0,213,3,93,0,242,3,1,0,32,32,32,45,111,32,124,124,32,45,45,116,114,97,99,101,102,105,108,101,91,61,102,105,108,101,110,97,109,101,93,32,32,119,114,105,116,101,32,115,105,109,117,108,97,116,111,114,32,112,105,110,32,116,114,97,99,101,32,116,111,32,39,111,117,116,102,105,108,101,39,32,40,100,101,102,97,117,108,116,32,102,105,108,101,110,97,109,101,61,100,97,116,97,108,111,103,46,111,117,116,41,0,0,32,32,32,45,116,32,124,124,32,45,45,116,105,109,101,45,115,99,97,108,101,61,110,32,32,32,32,32,32,32,32,32,32,115,101,116,32,116,105,109,101,45,115,99,97,108,101,59,32,48,61,119,97,114,112,45,115,112,101,101,100,44,32,49,61,114,101,97,108,45,116,105,109,101,44,32,50,61,104,97,108,102,45,116,105,109,101,44,32,101,116,99,46,0,0,0,32,32,32,45,112,32,124,124,32,45,45,112,111,115,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,115,104,111,119,32,104,101,97,100,32,112,111,115,105,116,105,111,110,32,111,110,32,99,111,110,115,111,108,101,0,0,32,32,32,45,103,32,124,124,32,45,45,103,99,111,100,101,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,115,104,111,119,32,103,99,111,100,101,32,111,110,32,99,111,110,115,111,108,101,32,97,115,32,105,116,32,105,115,32,112,114,111,99,101,115,115,101,100,0,0,0,0,0,0,0,32,32,32,45,118,32,124,124,32,45,45,118,101,114,98,111,115,101,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,115,104,111,119,32,109,111,114,101,32,111,117,116,112,117,116,0,0,0,0,0,0,0,32,32,32,45,113,32,124,124,32,45,45,113,117,105,101,116,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,115,104,111,119,32,108,101,115,115,32,111,117,116,112,117,116,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,240,57,1,0,240,57,1,0,216,221,50,0,28,43,0,0,88,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,0,202,154,59,72,12,0,0,0,0,0,0,8,0,0,0,0,0,0,0,120,10,0,0,0,0,0,0,0,0,0,0,118,0,0,0,224,8,0,0,0,0,0,0,0,0,0,0,103,0,0,0,80,7,0,0,0,0,0,0,0,0,0,0,112,0,0,0,48,6,0,0,1,0,0,0,0,0,0,0,116,0,0,0,192,5,0,0,2,0,0,0,0,0,0,0,111,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,200,0,0,0,200,0,0,0,100,0,0,0,88,2,0,0,200,55,1,0,200,55,1,0,105,48,0,0,95,73,3,0,240,57,1,0,240,57,1,0,24,23,5,0,28,43,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,103,97,99,116,105,111,110,0,0,0,0,0,0,0,97,110,97,108,111,103,95,105,110,105,116,58,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,105,110,32,115,105,109,117,108,97,116,111,114,0,0,0,0,0,0,0,112,105,110,32,110,117,109,98,101,114,32,105,110,118,97,108,105,100,0,0,0,0,0,0,99,111,117,108,100,110,39,116,32,111,112,101,110,32,115,101,114,105,97,108,32,112,111,114,116,0,0,0,0,0,0,0,35,32,99,111,109,109,97,110,100,108,105,110,101,58,32,32,32,0,0,0,0,0,0,0,69,58,32,66,97,100,32,77,45,99,111,100,101,32,37,100,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,110,101,120,116,61,37,117,32,32,32,114,101,97,108,61,37,117,0,35,10,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,111,112,101,110,32,102,105,108,101,46,0,0,0,0,85,110,101,120,112,101,99,116,101,100,32,114,101,115,117,108,116,32,105,110,32,103,101,116,111,112,116,95,108,111,110,103,32,104,97,110,100,108,101,114,0,0,0,0,0,0,0,0,122,95,109,105,110,58,0,0,104,101,97,116,101,114,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,105,110,32,115,105,109,117,108,97,116,111,114,46,0,0,0,0,79,67,82,49,65,58,37,48,52,88,32,32,32,79,67,82,49,66,58,37,48,52,88,32,32,32,32,110,111,119,61,37,48,52,88,0,0,0,0,0,35,32,32,32,103,110,117,112,108,111,116,32,45,45,112,101,114,115,105,115,116,32,45,101,32,34,115,101,116,32,112,111,105,110,116,115,105,122,101,32,48,46,48,49,59,32,112,108,111,116,32,39,37,115,39,32,117,32,50,58,51,58,49,32,119,105,116,104,32,112,111,105,110,116,115,34,10,0,0,0,67,111,117,108,100,32,110,111,116,32,115,116,97,116,32,102,105,108,101,46,0,0,0,0,100,97,116,97,108,111,103,46,111,117,116,0,0,0,0,0,121,95,109,105,110,58,0,0,84,105,109,101,114,49,32,73,110,116,101,114,114,117,112,116,32,66,58,32,69,110,97,98,108,101,100,0,0,0,0,0,35,32,42,32,80,108,111,116,32,116,104,101,32,97,99,116,117,97,108,32,112,111,105,110,116,115,32,116,114,97,118,101,108,101,100,32,119,105,116,104,32,103,110,117,112,108,111,116,10,0,0,0,0,0,0,0,111,112,101,110,105,110,103,32,37,115,0,0,0,0,0,0,116,114,97,99,101,102,105,108,101,0,0,0,0,0,0,0,116,105,109,101,114,95,105,110,105,116,58,32,119,97,114,112,45,115,112,101,101,100,0,0,120,95,109,105,110,58,0,0,84,105,109,101,114,49,32,73,110,116,101,114,114,117,112,116,32,65,58,32,69,110,97,98,108,101,100,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,119,114,105,116,101,32,116,111,32,115,101,114,105,97,108,32,112,111,114,116,0,0,116,105,109,101,45,115,99,97,108,101,0,0,0,0,0,0,82,101,99,111,114,100,101,114,32,97,108,114,101,97,100,121,32,105,110,105,116,105,97,108,105,122,101,100,0,0,0,0,35,10,35,32,84,105,112,115,58,10,0,0,0,0,0,0,48,120,0,0,0,0,0,0,85,115,97,103,101,58,32,32,37,115,32,91,111,112,116,105,111,110,115,93,32,91,103,99,111,100,101,95,102,105,108,101,32,124,124,32,117,97,114,116,95,100,101,118,105,99,101,95,110,97,109,101,93,10,0,0,116,105,109,101,114,32,110,111,116,32,105,110,105,116,105,97,108,105,115,101,100,0,0,0,58,32,105,108,108,101,103,97,108,32,111,112,116,105,111,110,58,32,0,0,0,0,0,0,27,91,48,59,51,50,109,0,35,32,82,101,99,111,114,100,101,100,32,37,115,10,0,0,27,91,48,59,51,54,109,0,27,91,109,0,0,0,0,0,27,91,48,59,51,51,59,49,109,0,0,0,0,0,0,0,27,91,48,59,51,49,109,0,110,111,32,99,104,97,114,97,99,116,101,114,32,105,110,32,115,101,114,105,97,108,32,82,88,32,98,117,102,102,101,114,0,0,0,0,0,0,0,0,27,91,48,59,52,49,109,0,112,111,115,0,0,0,0,0,111,107,32,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,13,0,0,0,0,0,0,0,0,111,112,101,110,32,0,0,0,37,99,58,37,53,100,32,32,32,0,0,0,0,0,0,0,80,105,110,32,110,117,109,98,101,114,32,111,117,116,32,111,102,32,114,97,110,103,101,0,116,105,109,101,114,95,115,116,111,112,0,0,0,0,0,0,87,82,73,84,69,58,32,80,105,110,32,110,117,109,98,101,114,32,111,117,116,32,111,102,32,114,97,110,103,101,0,0,35,32,84,101,97,99,117,112,95,70,105,114,109,119,97,114,101,32,115,105,109,117,108,97,116,111,114,32,118,49,46,48,10,0,0,0,0,0,0,0,69,82,82,79,82,58,32,37,115,10,0,0,0,0,0,0,70,73,82,77,87,65,82,69,95,78,65,77,69,58,84,101,97,99,117,112,32,70,73,82,77,87,65,82,69,95,85,82,76,58,104,116,116,112,58,47,47,103,105,116,104,117,98,46,99,111,109,47,116,114,97,117,109,102,108,117,103,47,84,101,97,99,117,112,95,70,105,114,109,119,97,114,101,47,32,80,82,79,84,79,67,79,76,95,86,69,82,83,73,79,78,58,49,46,48,32,77,65,67,72,73,78,69,95,84,89,80,69,58,77,101,110,100,101,108,32,69,88,84,82,85,68,69,82,95,67,79,85,78,84,58,37,100,32,84,69,77,80,95,83,69,78,83,79,82,95,67,79,85,78,84,58,37,100,32,72,69,65,84,69,82,95,67,79,85,78,84,58,37,100,0,0,71,99,111,100,101,32,112,114,111,99,101,115,115,105,110,103,32,99,111,109,112,108,101,116,101,100,46,0,0,0,0,0,103,99,111,100,101,0,0,0,83,84,69,80,80,69,82,95,69,78,65,66,76,69,95,80,73,78,0,0,0,0,0,0,69,95,69,78,65,66,76,69,95,80,73,78,0,0,0,0,115,116,97,114,116,10,111,107,10,0,0,0,0,0,0,0,105,110,116,101,114,114,117,112,116,115,32,100,105,115,97,98,108,101,100,0,0,0,0,0,69,95,68,73,82,95,80,73,78,0,0,0,0,0,0,0,69,95,83,84,69,80,95,80,73,78,0,0,0,0,0,0,90,95,69,78,65,66,76,69,95,80,73,78,0,0,0,0,116,105,109,101,114,95,105,110,105,116,58,32,49,47,37,117,32,116,105,109,101,0,0,0,90,95,77,73,78,95,80,73,78,0,0,0,0,0,0,0,84,58,0,0,0,0,0,0,114,101,99,111,114,100,95,105,110,105,116,58,32,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,102,105,108,101,0,0,0,0,0,0,90,95,68,73,82,95,80,73,78,0,0,0,0,0,0,0,58,32,111,112,116,105,111,110,32,114,101,113,117,105,114,101,115,32,97,110,32,97,114,103,117,109,101,110,116,58,32,0,90,95,83,84,69,80,95,80,73,78,0,0,0,0,0,0,89,95,69,78,65,66,76,69,95,80,73,78,0,0,0,0,37,117,46,37,117,0,0,0,88,58,37,108,113,44,89,58,37,108,113,44,90,58,37,108,113,44,69,58,37,108,113,44,70,58,37,108,117,0,0,0,89,95,77,73,78,95,80,73,78,0,0,0,0,0,0,0,69,58,32,66,97,100,32,71,45,99,111,100,101,32,37,100,0,0,0,0,0,0,0,0,110,111,32,99,104,97,114,115,32,116,111,32,114,101,97,100,0,0,0,0,0,0,0,0,118,101,114,98,111,115,101,0,89,95,68,73,82,95,80,73,78,0,0,0,0,0,0,0,89,95,83,84,69,80,95,80,73,78,0,0,0,0,0,0,97,110,97,108,111,103,95,105,110,105,116,40,41,32,119,97,115,32,110,111,116,32,99,97,108,108,101,100,32,98,101,102,111,114,101,32,97,110,97,108,111,103,95,114,101,97,100,40,41,0,0,0,0,0,0,0,88,95,69,78,65,66,76,69,95,80,73,78,0,0,0,0,88,95,77,73,78,95,80,73,78,0,0,0,0,0,0,0,88,95,68,73,82,95,80,73,78,0,0,0,0,0,0,0,116,105,109,101,114,95,105,110,105,116,58,32,114,101,97,108,45,116,105,109,101,0,0,0,88,95,83,84,69,80,95,80,73,78,0,0,0,0,0,0,112,108,101,97,115,101,32,115,112,101,99,105,102,121,32,97,32,115,101,114,105,97,108,32,112,111,114,116,32,100,101,118,105,99,101,32,110,97,109,101,32,111,114,32,103,99,111,100,101,32,102,105,108,101,32,116,111,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,80,79,83,95,69,0,0,0,10,0,0,0,0,0,0,0,114,115,32,78,37,108,100,32,69,120,112,101,99,116,101,100,32,99,104,101,99,107,115,117,109,32,37,100,10,0,0,0,80,79,83,95,90,0,0,0,32,37,100,0,0,0,0,0,116,99,115,101,116,97,116,116,114,0,0,0,0,0,0,0,80,79,83,95,89,0,0,0,37,108,117,0,0,0,0,0,84,91,37,115,117,93,58,0,10,115,116,111,112,10,0,0,116,99,103,101,116,97,116,116,114,0,0,0,0,0,0,0,80,79,83,95,88,0,0,0,115,101,114,105,97,108,32,105,110,116,101,114,102,97,99,101,32,110,111,116,32,105,110,105,116,105,97,108,105,115,101,100,0,0,0,0,0,0,0,0,99,111,110,102,105,103,117,114,105,110,103,32,112,111,114,116,0,0,0,0,0,0,0,0,113,117,105,101,116,0,0,0,35,32,37,115,10,0,0,0,113,103,112,118,116,58,111,58,58,0,0,0,0,0,0,0,99,108,111,99,107,95,103,101,116,116,105,109,101,32,102,97,105,108,101,100,0,0,0,0,110,111,116,32,97,32,84,84,89,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,35,32,37,100,32,45,32,37,115,10,0,0,0,0,0,0,87,97,105,116,105,110,103,32,102,111,114,32,116,97,114,103,101,116,32,116,101,109,112,10,0,0,0,0,0,0,0,0,84,101,109,112,32,97,99,104,105,101,118,101,100,10,0,0], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
function runPostSets() {


}

var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  var _llvm_dbg_value=true;
;

  var _llvm_dbg_declare=undefined;

  
  function _memcpy(dest, src, num) {
      dest = dest|0; src = src|0; num = num|0;
      var ret = 0;
      ret = dest|0;
      if ((dest&3) == (src&3)) {
        while (dest & 3) {
          if ((num|0) == 0) return ret|0;
          HEAP8[(dest)]=HEAP8[(src)];
          dest = (dest+1)|0;
          src = (src+1)|0;
          num = (num-1)|0;
        }
        while ((num|0) >= 4) {
          HEAP32[((dest)>>2)]=HEAP32[((src)>>2)];
          dest = (dest+4)|0;
          src = (src+4)|0;
          num = (num-4)|0;
        }
      }
      while ((num|0) > 0) {
        HEAP8[(dest)]=HEAP8[(src)];
        dest = (dest+1)|0;
        src = (src+1)|0;
        num = (num-1)|0;
      }
      return ret|0;
    }var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  var _llvm_va_start=undefined;

  function _llvm_va_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 0777, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 0777 | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            assert(buffer.length);
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = {};
        for (var key in src.files) {
          if (!src.files.hasOwnProperty(key)) continue;
          var e = src.files[key];
          var e2 = dst.files[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create[key] = e;
            total++;
          }
        }
  
        var remove = {};
        for (var key in dst.files) {
          if (!dst.files.hasOwnProperty(key)) continue;
          var e = dst.files[key];
          var e2 = src.files[key];
          if (!e2) {
            remove[key] = e;
            total++;
          }
        }
  
        if (!total) {
          // early out
          return callback(null);
        }
  
        var completed = 0;
        function done(err) {
          if (err) return callback(err);
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        // create a single transaction to handle and IDB reads / writes we'll need to do
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        transaction.onerror = function transaction_onerror() { callback(this.error); };
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        for (var path in create) {
          if (!create.hasOwnProperty(path)) continue;
          var entry = create[path];
  
          if (dst.type === 'local') {
            // save file to local
            try {
              if (FS.isDir(entry.mode)) {
                FS.mkdir(path, entry.mode);
              } else if (FS.isFile(entry.mode)) {
                var stream = FS.open(path, 'w+', 0666);
                FS.write(stream, entry.contents, 0, entry.contents.length, 0, true /* canOwn */);
                FS.close(stream);
              }
              done(null);
            } catch (e) {
              return done(e);
            }
          } else {
            // save file to IDB
            var req = store.put(entry, path);
            req.onsuccess = function req_onsuccess() { done(null); };
            req.onerror = function req_onerror() { done(this.error); };
          }
        }
  
        for (var path in remove) {
          if (!remove.hasOwnProperty(path)) continue;
          var entry = remove[path];
  
          if (dst.type === 'local') {
            // delete file from local
            try {
              if (FS.isDir(entry.mode)) {
                // TODO recursive delete?
                FS.rmdir(path);
              } else if (FS.isFile(entry.mode)) {
                FS.unlink(path);
              }
              done(null);
            } catch (e) {
              return done(e);
            }
          } else {
            // delete file from IDB
            var req = store.delete(path);
            req.onsuccess = function req_onsuccess() { done(null); };
            req.onerror = function req_onerror() { done(this.error); };
          }
        }
      },getLocalSet:function (mount, callback) {
        var files = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint)
          .filter(isRealDir)
          .map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat, node;
  
          try {
            var lookup = FS.lookupPath(path);
            node = lookup.node;
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path)
              .filter(isRealDir)
              .map(toAbsolute(path)));
  
            files[path] = { mode: stat.mode, timestamp: stat.mtime };
          } else if (FS.isFile(stat.mode)) {
            files[path] = { contents: node.contents, mode: stat.mode, timestamp: stat.mtime };
          } else {
            return callback(new Error('node type not supported'));
          }
        }
  
        return callback(null, { type: 'local', files: files });
      },getDB:function (name, callback) {
        // look it up in the cache
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        req.onupgradeneeded = function req_onupgradeneeded() {
          db = req.result;
          db.createObjectStore(IDBFS.DB_STORE_NAME);
        };
        req.onsuccess = function req_onsuccess() {
          db = req.result;
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function req_onerror() {
          callback(this.error);
        };
      },getRemoteSet:function (mount, callback) {
        var files = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function transaction_onerror() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          store.openCursor().onsuccess = function store_openCursor_onsuccess(event) {
            var cursor = event.target.result;
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, files: files });
            }
  
            files[cursor.key] = cursor.value;
            cursor.continue();
          };
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[null],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || { recurse_count: 0 };
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            current = current.mount.root;
          }
  
          // follow symlinks
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
            this.parent = null;
            this.mount = null;
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            FS.hashAddNode(this);
          };
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          FS.FSNode.prototype = {};
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
        return new FS.FSNode(parent, name, mode, rdev);
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 1;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var completed = 0;
        var total = FS.mounts.length;
        function done(err) {
          if (err) {
            return callback(err);
          }
          if (++completed >= total) {
            callback(null);
          }
        };
  
        // sync all mounts
        for (var i = 0; i < FS.mounts.length; i++) {
          var mount = FS.mounts[i];
          if (!mount.type.syncfs) {
            done(null);
            continue;
          }
          mount.type.syncfs(mount, populate, done);
        }
      },mount:function (type, opts, mountpoint) {
        var lookup;
        if (mountpoint) {
          lookup = FS.lookupPath(mountpoint, { follow: false });
          mountpoint = lookup.path;  // use the absolute path
        }
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          root: null
        };
        // create a root node for the fs
        var root = type.mount(mount);
        root.mount = mount;
        mount.root = root;
        // assign the mount info to the mountpoint's node
        if (lookup) {
          lookup.node.mount = mount;
          lookup.node.mounted = true;
          // compatibility update FS.root if we mount to /
          if (mountpoint === '/') {
            FS.root = mount.root;
          }
        }
        // add to our cached list of mounts
        FS.mounts.push(mount);
        return root;
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 0666;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 0777;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 0666;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path, { follow: false });
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 0666 : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        } else {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0);
        } else {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=stdin.fd;
        assert(stdin.fd === 1, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=stdout.fd;
        assert(stdout.fd === 2, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=stderr.fd;
        assert(stderr.fd === 3, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
          if (this.stack) this.stack = demangleAll(this.stack);
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.root = FS.createNode(null, '/', 16384 | 0777, 0);
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var ret = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return (ret == -1) ? 0 : ret;
    }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  
  
  
  
  
  var _mkport=undefined;var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 0777, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var bytesWritten = _write(stream, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStream(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }
  
  
  function _strlen(ptr) {
      ptr = ptr|0;
      var curr = 0;
      curr = ptr;
      while (HEAP8[(curr)]) {
        curr = (curr + 1)|0;
      }
      return (curr - ptr)|0;
    }
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = HEAPF64[(((varargs)+(argIndex))>>3)];
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+8))>>2)]];
          argIndex += 8; // each 32-bit chunk is in a 64-bit block
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Math.max(Runtime.getNativeFieldSize(type), Runtime.getAlignSize(type, null, true));
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision === -1) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }

  
  var ___tm_formatted=allocate(44, "i8", ALLOC_STATIC);
  
  
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _mktime(tmPtr) {
      _tzset();
      var year = HEAP32[(((tmPtr)+(20))>>2)];
      var timestamp = new Date(year >= 1900 ? year : year + 1900,
                               HEAP32[(((tmPtr)+(16))>>2)],
                               HEAP32[(((tmPtr)+(12))>>2)],
                               HEAP32[(((tmPtr)+(8))>>2)],
                               HEAP32[(((tmPtr)+(4))>>2)],
                               HEAP32[((tmPtr)>>2)],
                               0).getTime() / 1000;
      HEAP32[(((tmPtr)+(24))>>2)]=new Date(timestamp).getDay();
      var yday = Math.round((timestamp - (new Date(year, 0, 1)).getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      return timestamp;
    }function _asctime_r(tmPtr, buf) {
      var date = new Date(_mktime(tmPtr)*1000);
      var formatted = date.toString();
      var datePart = formatted.replace(/\d{4}.*/, '').replace(/ 0/, '  ');
      var timePart = formatted.match(/\d{2}:\d{2}:\d{2}/)[0];
      formatted = datePart + timePart + ' ' + date.getFullYear() + '\n';
      formatted.split('').forEach(function(chr, index) {
        HEAP8[(((buf)+(index))|0)]=chr.charCodeAt(0);
      });
      HEAP8[(((buf)+(25))|0)]=0;
      return buf;
    }function _asctime(tmPtr) {
      return _asctime_r(tmPtr, ___tm_formatted);
    }

  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }


  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      _fsync(stream);
      return _close(stream);
    }


  function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var ret = _write(stream, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStream(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      return _write(stream, s, _strlen(s));
    }

  function _sigemptyset(set) {
      // int sigemptyset(sigset_t *set);
      HEAP32[((set)>>2)]=0;
      return 0;
    }

  function _sigaction(set) {
      // TODO:
      return 0;
    }

  function _setitimer() { throw 'setitimer not implemented yet' }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  function _usleep(useconds) {
      // int usleep(useconds_t useconds);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/usleep.html
      // We're single-threaded, so use a busy loop. Super-ugly.
      var msec = useconds / 1000;
      if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
        var start = window['performance']['now']();
        while (window['performance']['now']() - start < msec) {
          // Do nothing.
        }
      } else {
        var start = Date.now();
        while (Date.now() - start < msec) {
          // Do nothing.
        }
      }
      return 0;
    }

  
  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return tempRet0 = (tempDouble=ret,Math_abs(tempDouble) >= 1 ? (tempDouble > 0 ? Math_min(Math_floor((tempDouble)/4294967296), 4294967295)>>>0 : (~~(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/4294967296)))>>>0) : 0),ret>>>0;
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }

  
  function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }function _vprintf(format, va_arg) {
      return _printf(format, HEAP32[((va_arg)>>2)]);
    }


  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }

  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    }

  function _ioctl(fd, request, varargs) {
      var stream = FS.getStream(fd);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      var arg = HEAP32[((varargs)>>2)];
  
      try {
        return FS.ioctl(stream, request, arg);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }




  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }


  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  function _tcgetattr(fildes, termios_p) {
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/tcgetattr.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return -1;
      }
      return 0;
    }
;
;

  function _tcsetattr(fildes, optional_actions, termios_p) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/tcsetattr.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return -1;
      }
      return 0;
    }
;

  function ___errno_location() {
      return ___errno_state;
    }

  function _abort() {
      Module['abort']();
    }

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }

  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  function _memset(ptr, value, num) {
      ptr = ptr|0; value = value|0; num = num|0;
      var stop = 0, value4 = 0, stop4 = 0, unaligned = 0;
      stop = (ptr + num)|0;
      if ((num|0) >= 20) {
        // This is unaligned, but quite large, so work hard to get to aligned settings
        value = value & 0xff;
        unaligned = ptr & 3;
        value4 = value | (value << 8) | (value << 16) | (value << 24);
        stop4 = stop & ~3;
        if (unaligned) {
          unaligned = (ptr + 4 - unaligned)|0;
          while ((ptr|0) < (unaligned|0)) { // no need to check for stop, since we have large num
            HEAP8[(ptr)]=value;
            ptr = (ptr+1)|0;
          }
        }
        while ((ptr|0) < (stop4|0)) {
          HEAP32[((ptr)>>2)]=value4;
          ptr = (ptr+4)|0;
        }
      }
      while ((ptr|0) < (stop|0)) {
        HEAP8[(ptr)]=value;
        ptr = (ptr+1)|0;
      }
      return (ptr-num)|0;
    }




  var Browser={mainLoop:{scheduler:null,shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          assert(typeof url == 'string', 'createObjectURL must return a url as a string');
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            assert(typeof url == 'string', 'createObjectURL must return a url as a string');
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            var errorInfo = '?';
            function onContextCreationError(event) {
              errorInfo = event.statusMessage || errorInfo;
            }
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          // If this assert lands, it's likely because the browser doesn't support scrollX or pageXOffset
          // and we have no viable fallback.
          assert((typeof scrollX !== 'undefined') && (typeof scrollY !== 'undefined'), 'Unable to retrieve scroll position, mouse positions likely broken.');
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};
FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");



var FUNCTION_TABLE = [0,0,_recorder_close,0,_timer1_callback,0];

// EMSCRIPTEN_START_FUNCS

function _queue_full(){
 var label=0;


 var $0=HEAP8[(4680)]; //@line 43 "dda_queue.c"
 var $conv=($0&255); //@line 43 "dda_queue.c"
 var $1=HEAP8[(4688)]; //@line 43 "dda_queue.c"
 var $conv1=($1&255); //@line 43 "dda_queue.c"
 var $cmp=($0&255)>($1&255); //@line 43 "dda_queue.c"
 var $add=((($conv)+(8))|0); //@line 46 "dda_queue.c"
 var $conv_pn=($cmp?$conv:$add); //@line 43 "dda_queue.c"
 var $retval_0_in_in=((($conv_pn)-($conv1))|0); //@line 44 "dda_queue.c"
 var $retval_0_in=($retval_0_in_in|0)==1; //@line 44 "dda_queue.c"
 var $retval_0=(($retval_0_in<<31)>>31); //@line 44 "dda_queue.c"
 return $retval_0; //@line 48 "dda_queue.c"
}


function _queue_empty(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP8[(3824)]; //@line 54 "dda_queue.c"
 var $1=$0&1; //@line 54 "dda_queue.c"
 var $tobool=(($1<<24)>>24)==0; //@line 54 "dda_queue.c"
 _cli(); //@line 54 "dda_queue.c"
 var $2=HEAP8[(4680)]; //@line 55 "dda_queue.c"
 var $3=HEAP8[(4688)]; //@line 55 "dda_queue.c"
 var $cmp=(($2<<24)>>24)==(($3<<24)>>24); //@line 55 "dda_queue.c"
 if($cmp){label=2;break;}else{var $_off0=0;label=3;break;} //@line 55 "dda_queue.c"
 case 2: 
 var $conv1=($2&255); //@line 55 "dda_queue.c"
 var $4=((4000+((($conv1)*(80))&-1)+24)|0); //@line 55 "dda_queue.c"
 var $5=$4; //@line 55 "dda_queue.c"
 var $bf_load=HEAP8[($5)]; //@line 55 "dda_queue.c"
 var $bf_lshr=($bf_load&255)>>>1; //@line 55 "dda_queue.c"
 var $bf_clear=$bf_lshr&1; //@line 55 "dda_queue.c"
 var $sext=((($bf_clear)-(1))&255);
 var $_off0=$sext;label=3;break;
 case 3: 
 var $_off0;
 if($tobool){label=5;break;}else{label=4;break;} //@line 56 "dda_queue.c"
 case 4: 
 _sei(); //@line 56 "dda_queue.c"
 label=5;break; //@line 56 "dda_queue.c"
 case 5: 
 return $_off0; //@line undefined "dda_queue.c"
  default: assert(0, "bad label: " + label);
 }

}


function _queue_current_movement(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP8[(3824)]; //@line 65 "dda_queue.c"
 var $1=$0&1; //@line 65 "dda_queue.c"
 var $tobool=(($1<<24)>>24)==0; //@line 65 "dda_queue.c"
 _cli(); //@line 65 "dda_queue.c"
 var $2=HEAP8[(4680)]; //@line 66 "dda_queue.c"
 var $idxprom=($2&255); //@line 66 "dda_queue.c"
 var $arrayidx=((4000+((($idxprom)*(80))&-1))|0); //@line 66 "dda_queue.c"
 var $3=((4000+((($idxprom)*(80))&-1)+24)|0); //@line 68 "dda_queue.c"
 var $4=$3; //@line 68 "dda_queue.c"
 var $bf_load=HEAP8[($4)]; //@line 68 "dda_queue.c"
 var $5=$bf_load&11; //@line 68 "dda_queue.c"
 var $6=(($5<<24)>>24)==2; //@line 68 "dda_queue.c"
 var $current_0=($6?$arrayidx:0); //@line 68 "dda_queue.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 70 "dda_queue.c"
 case 2: 
 _sei(); //@line 70 "dda_queue.c"
 label=3;break; //@line 70 "dda_queue.c"
 case 3: 
 return $current_0; //@line 72 "dda_queue.c"
  default: assert(0, "bad label: " + label);
 }

}


function _queue_step(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP8[(4680)]; //@line 82 "dda_queue.c"
 var $idxprom=($0&255); //@line 82 "dda_queue.c"
 var $arrayidx=((4000+((($idxprom)*(80))&-1))|0); //@line 82 "dda_queue.c"
 var $1=((4000+((($idxprom)*(80))&-1)+24)|0); //@line 83 "dda_queue.c"
 var $2=$1; //@line 83 "dda_queue.c"
 var $bf_load=HEAP8[($2)]; //@line 83 "dda_queue.c"
 var $bf_clear=$bf_load&2; //@line 83 "dda_queue.c"
 var $tobool=(($bf_clear<<24)>>24)==0; //@line 83 "dda_queue.c"
 if($tobool){label=6;break;}else{label=2;break;} //@line 83 "dda_queue.c"
 case 2: 
 var $bf_clear3=$bf_load&8; //@line 84 "dda_queue.c"
 var $tobool4=(($bf_clear3<<24)>>24)==0; //@line 84 "dda_queue.c"
 if($tobool4){label=5;break;}else{label=3;break;} //@line 84 "dda_queue.c"
 case 3: 
 _setTimer(16000000); //@line 85 "dda_queue.c"
 var $call=_temp_achieved(); //@line 86 "dda_queue.c"
 var $tobool6=(($call<<24)>>24)==0; //@line 86 "dda_queue.c"
 if($tobool6){label=6;break;}else{label=4;break;} //@line 86 "dda_queue.c"
 case 4: 
 var $bf_load8=HEAP8[($2)]; //@line 87 "dda_queue.c"
 var $bf_clear11=$bf_load8&-7; //@line 87 "dda_queue.c"
 HEAP8[($2)]=$bf_clear11; //@line 87 "dda_queue.c"
 _serial_writestr_P(3272); //@line 88 "dda_queue.c"
 label=6;break; //@line 89 "dda_queue.c"
 case 5: 
 _dda_step($arrayidx); //@line 94 "dda_queue.c"
 label=6;break;
 case 6: 
 var $bf_load14=HEAP8[($2)]; //@line 99 "dda_queue.c"
 var $bf_clear16=$bf_load14&2; //@line 99 "dda_queue.c"
 var $cmp=(($bf_clear16<<24)>>24)==0; //@line 99 "dda_queue.c"
 if($cmp){label=7;break;}else{label=8;break;} //@line 99 "dda_queue.c"
 case 7: 
 _next_move(); //@line 100 "dda_queue.c"
 label=8;break; //@line 100 "dda_queue.c"
 case 8: 
 return; //@line 101 "dda_queue.c"
  default: assert(0, "bad label: " + label);
 }

}


function _next_move(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $call5=_queue_empty(); //@line 158 "dda_queue.c"
 var $cmp6=(($call5<<24)>>24)==0; //@line 158 "dda_queue.c"
 if($cmp6){label=2;break;}else{label=7;break;} //@line 158 "dda_queue.c"
 case 2: 
 var $0=HEAP8[(4680)]; //@line 158 "dda_queue.c"
 var $idxprom=($0&255); //@line 158 "dda_queue.c"
 var $1=((4000+((($idxprom)*(80))&-1)+24)|0); //@line 158 "dda_queue.c"
 var $2=$1; //@line 158 "dda_queue.c"
 var $bf_load=HEAP8[($2)]; //@line 158 "dda_queue.c"
 var $bf_clear=$bf_load&2; //@line 158 "dda_queue.c"
 var $cmp3=(($bf_clear<<24)>>24)==0; //@line 158 "dda_queue.c"
 if($cmp3){label=3;break;}else{label=7;break;}
 case 3: 
 var $add=((($0)+(1))&255); //@line 160 "dda_queue.c"
 var $and=$add&7; //@line 161 "dda_queue.c"
 var $idxprom9=($and&255); //@line 162 "dda_queue.c"
 HEAP8[(4680)]=$and; //@line 166 "dda_queue.c"
 var $3=((4000+((($idxprom9)*(80))&-1)+24)|0); //@line 167 "dda_queue.c"
 var $4=$3; //@line 167 "dda_queue.c"
 var $bf_load11=HEAP8[($4)]; //@line 167 "dda_queue.c"
 var $bf_clear13=$bf_load11&8; //@line 167 "dda_queue.c"
 var $tobool=(($bf_clear13<<24)>>24)==0; //@line 167 "dda_queue.c"
 if($tobool){label=5;break;}else{label=4;break;} //@line 167 "dda_queue.c"
 case 4: 
 _serial_writestr_P(3240); //@line 168 "dda_queue.c"
 var $bf_load14=HEAP8[($4)]; //@line 169 "dda_queue.c"
 var $bf_set=$bf_load14|2; //@line 169 "dda_queue.c"
 HEAP8[($4)]=$bf_set; //@line 169 "dda_queue.c"
 _setTimer(16000000); //@line 170 "dda_queue.c"
 label=6;break; //@line 171 "dda_queue.c"
 case 5: 
 var $arrayidx10=((4000+((($idxprom9)*(80))&-1))|0); //@line 162 "dda_queue.c"
 _dda_start($arrayidx10); //@line 173 "dda_queue.c"
 label=6;break;
 case 6: 
 var $call=_queue_empty(); //@line 158 "dda_queue.c"
 var $cmp=(($call<<24)>>24)==0; //@line 158 "dda_queue.c"
 if($cmp){label=2;break;}else{label=7;break;} //@line 158 "dda_queue.c"
 case 7: 
 return; //@line 176 "dda_queue.c"
  default: assert(0, "bad label: " + label);
 }

}


function _enqueue_home($t,$endstop_check,$endstop_stop_cond){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $call8=_queue_full(); //@line 108 "dda_queue.c"
 var $tobool9=(($call8<<24)>>24)==0; //@line 108 "dda_queue.c"
 if($tobool9){label=3;break;}else{label=2;break;} //@line 108 "dda_queue.c"
 case 2: 
 _delay_us(100); //@line 109 "dda_queue.c"
 var $call=_queue_full(); //@line 108 "dda_queue.c"
 var $tobool=(($call<<24)>>24)==0; //@line 108 "dda_queue.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 108 "dda_queue.c"
 case 3: 
 var $0=HEAP8[(4688)]; //@line 111 "dda_queue.c"
 var $add=((($0)+(1))&255); //@line 111 "dda_queue.c"
 var $and=$add&7; //@line 112 "dda_queue.c"
 var $idxprom=($and&255); //@line 114 "dda_queue.c"
 var $arrayidx=((4000+((($idxprom)*(80))&-1))|0); //@line 114 "dda_queue.c"
 var $1=((4000+((($idxprom)*(80))&-1)+24)|0); //@line 118 "dda_queue.c"
 var $allflags=(($1)|0); //@line 118 "dda_queue.c"
 HEAP16[(($allflags)>>1)]=0; //@line 118 "dda_queue.c"
 var $cmp=($t|0)==0; //@line 120 "dda_queue.c"
 if($cmp){label=5;break;}else{label=4;break;} //@line 120 "dda_queue.c"
 case 4: 
 var $endstop_check5=((4000+((($idxprom)*(80))&-1)+77)|0); //@line 121 "dda_queue.c"
 HEAP8[($endstop_check5)]=$endstop_check; //@line 121 "dda_queue.c"
 var $endstop_stop_cond6=((4000+((($idxprom)*(80))&-1)+78)|0); //@line 122 "dda_queue.c"
 HEAP8[($endstop_stop_cond6)]=$endstop_stop_cond; //@line 122 "dda_queue.c"
 label=6;break; //@line 123 "dda_queue.c"
 case 5: 
 var $2=$1; //@line 126 "dda_queue.c"
 HEAP8[($2)]=8; //@line 126 "dda_queue.c"
 label=6;break;
 case 6: 
 _dda_create($arrayidx,$t); //@line 128 "dda_queue.c"
 HEAP8[(4688)]=$and; //@line 134 "dda_queue.c"
 var $3=HEAP8[(3824)]; //@line 138 "dda_queue.c"
 var $4=$3&1; //@line 138 "dda_queue.c"
 var $tobool7=(($4<<24)>>24)==0; //@line 138 "dda_queue.c"
 _cli(); //@line 138 "dda_queue.c"
 var $5=HEAP8[(4680)]; //@line 139 "dda_queue.c"
 var $idxprom9=($5&255); //@line 139 "dda_queue.c"
 var $6=((4000+((($idxprom9)*(80))&-1)+24)|0); //@line 139 "dda_queue.c"
 var $7=$6; //@line 139 "dda_queue.c"
 var $bf_load11=HEAP8[($7)]; //@line 139 "dda_queue.c"
 var $bf_clear12_lobit=$bf_load11&2; //@line 139 "dda_queue.c"
 if($tobool7){label=8;break;}else{label=7;break;} //@line 140 "dda_queue.c"
 case 7: 
 _sei(); //@line 140 "dda_queue.c"
 label=8;break; //@line 140 "dda_queue.c"
 case 8: 
 var $tobool20=(($bf_clear12_lobit<<24)>>24)==0; //@line 142 "dda_queue.c"
 if($tobool20){label=9;break;}else{label=10;break;} //@line 142 "dda_queue.c"
 case 9: 
 _next_move(); //@line 143 "dda_queue.c"
 _sei(); //@line 145 "dda_queue.c"
 label=10;break; //@line 146 "dda_queue.c"
 case 10: 
 return; //@line 147 "dda_queue.c"
  default: assert(0, "bad label: " + label);
 }

}


function _queue_flush(){
 var label=0;


 var $0=HEAP8[(4688)]; //@line 192 "dda_queue.c"
 HEAP8[(4680)]=$0; //@line 192 "dda_queue.c"
 var $idxprom=($0&255); //@line 193 "dda_queue.c"
 var $1=((4000+((($idxprom)*(80))&-1)+24)|0); //@line 193 "dda_queue.c"
 var $2=$1; //@line 193 "dda_queue.c"
 var $bf_load=HEAP8[($2)]; //@line 193 "dda_queue.c"
 var $bf_clear=$bf_load&-3; //@line 193 "dda_queue.c"
 HEAP8[($2)]=$bf_clear; //@line 193 "dda_queue.c"
 return; //@line 194 "dda_queue.c"
}


function _queue_wait(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $call1=_queue_empty(); //@line 198 "dda_queue.c"
 var $cmp2=(($call1<<24)>>24)==0; //@line 198 "dda_queue.c"
 if($cmp2){label=2;break;}else{label=3;break;} //@line 198 "dda_queue.c"
 case 2: 
 _clock(); //@line 199 "dda_queue.c"
 var $call=_queue_empty(); //@line 198 "dda_queue.c"
 var $cmp=(($call<<24)>>24)==0; //@line 198 "dda_queue.c"
 if($cmp){label=2;break;}else{label=3;break;} //@line 198 "dda_queue.c"
 case 3: 
 return; //@line 200 "dda_queue.c"
  default: assert(0, "bad label: " + label);
 }

}


function _muldivQR($multiplicand,$qn,$rn,$divisor){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=($multiplicand|0)<0; //@line 55 "dda_maths.c"
 var $sub=(((-$multiplicand))|0); //@line 57 "dda_maths.c"
 var $sub_multiplicand=($cmp?$sub:$multiplicand); //@line 55 "dda_maths.c"
 var $tobool21=($sub_multiplicand|0)==0; //@line 60 "dda_maths.c"
 if($tobool21){var $quotient_0_lcssa=0;var $remainder_0_lcssa=0;label=8;break;}else{var $qn_addr_022=$qn;var $rn_addr_023=$rn;var $multiplicand_addr_024=$sub_multiplicand;var $quotient_025=0;var $remainder_026=0;label=2;break;} //@line 60 "dda_maths.c"
 case 2: 
 var $remainder_026;
 var $quotient_025;
 var $multiplicand_addr_024;
 var $rn_addr_023;
 var $qn_addr_022;
 var $and=$multiplicand_addr_024&1; //@line 61 "dda_maths.c"
 var $tobool1=($and|0)==0; //@line 61 "dda_maths.c"
 if($tobool1){var $remainder_1=$remainder_026;var $quotient_1=$quotient_025;label=5;break;}else{label=3;break;} //@line 61 "dda_maths.c"
 case 3: 
 var $add=((($quotient_025)+($qn_addr_022))|0); //@line 62 "dda_maths.c"
 var $add3=((($remainder_026)+($rn_addr_023))|0); //@line 63 "dda_maths.c"
 var $cmp4=($add3>>>0)<($divisor>>>0); //@line 64 "dda_maths.c"
 if($cmp4){var $remainder_1=$add3;var $quotient_1=$add;label=5;break;}else{label=4;break;} //@line 64 "dda_maths.c"
 case 4: 
 var $inc=((($add)+(1))|0); //@line 65 "dda_maths.c"
 var $sub6=((($add3)-($divisor))|0); //@line 66 "dda_maths.c"
 var $remainder_1=$sub6;var $quotient_1=$inc;label=5;break; //@line 67 "dda_maths.c"
 case 5: 
 var $quotient_1;
 var $remainder_1;
 var $shr=$multiplicand_addr_024>>1; //@line 69 "dda_maths.c"
 var $shl=$qn_addr_022<<1; //@line 70 "dda_maths.c"
 var $shl9=$rn_addr_023<<1; //@line 71 "dda_maths.c"
 var $cmp10=($shl9>>>0)<($divisor>>>0); //@line 72 "dda_maths.c"
 if($cmp10){var $rn_addr_0_be=$shl9;var $qn_addr_0_be=$shl;label=7;break;}else{label=6;break;} //@line 72 "dda_maths.c"
 case 6: 
 var $inc1220=$shl|1; //@line 73 "dda_maths.c"
 var $sub13=((($shl9)-($divisor))|0); //@line 74 "dda_maths.c"
 var $rn_addr_0_be=$sub13;var $qn_addr_0_be=$inc1220;label=7;break; //@line 75 "dda_maths.c"
 case 7: 
 var $qn_addr_0_be;
 var $rn_addr_0_be;
 var $tobool=($shr|0)==0; //@line 60 "dda_maths.c"
 if($tobool){var $quotient_0_lcssa=$quotient_1;var $remainder_0_lcssa=$remainder_1;label=8;break;}else{var $qn_addr_022=$qn_addr_0_be;var $rn_addr_023=$rn_addr_0_be;var $multiplicand_addr_024=$shr;var $quotient_025=$quotient_1;var $remainder_026=$remainder_1;label=2;break;} //@line 60 "dda_maths.c"
 case 8: 
 var $remainder_0_lcssa;
 var $quotient_0_lcssa;
 var $div=$divisor>>>1; //@line 79 "dda_maths.c"
 var $cmp15=($remainder_0_lcssa>>>0)>($div>>>0); //@line 79 "dda_maths.c"
 var $inc17=($cmp15&1); //@line 79 "dda_maths.c"
 var $inc17_quotient_0=((($inc17)+($quotient_0_lcssa))|0); //@line 79 "dda_maths.c"
 var $sub20=(((-$inc17_quotient_0))|0); //@line 83 "dda_maths.c"
 var $cond=($cmp?$sub20:$inc17_quotient_0); //@line 83 "dda_maths.c"
 return $cond; //@line 83 "dda_maths.c"
  default: assert(0, "bad label: " + label);
 }

}


function _approx_distance($dx,$dy){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=($dx|0)==0; //@line 98 "dda_maths.c"
 var $cmp1=($dy|0)==0; //@line 98 "dda_maths.c"
 var $or_cond=$cmp|$cmp1; //@line 98 "dda_maths.c"
 if($or_cond){label=2;break;}else{label=3;break;} //@line 98 "dda_maths.c"
 case 2: 
 var $add=((($dy)+($dx))|0); //@line 98 "dda_maths.c"
 var $retval_0=$add;label=6;break; //@line 98 "dda_maths.c"
 case 3: 
 var $cmp2=($dx>>>0)<($dy>>>0); //@line 100 "dda_maths.c"
 var $dx_dy=($cmp2?$dx:$dy); //@line 103 "dda_maths.c"
 var $dy_dx=($cmp2?$dy:$dx); //@line 103 "dda_maths.c"
 var $mul=((($dy_dx)*(1007))&-1); //@line 108 "dda_maths.c"
 var $mul5=((($dx_dy)*(441))&-1); //@line 108 "dda_maths.c"
 var $add6=((($mul)+($mul5))|0); //@line 108 "dda_maths.c"
 var $shl=$dx_dy<<4; //@line 109 "dda_maths.c"
 var $cmp7=($dy_dx>>>0)<($shl>>>0); //@line 109 "dda_maths.c"
 if($cmp7){label=4;break;}else{var $approx_0=$add6;label=5;break;} //@line 109 "dda_maths.c"
 case 4: 
 var $0=((($dy_dx)*(-40))&-1); //@line 110 "dda_maths.c"
 var $sub=((($add6)+($0))|0); //@line 110 "dda_maths.c"
 var $approx_0=$sub;label=5;break; //@line 110 "dda_maths.c"
 case 5: 
 var $approx_0;
 var $add11=((($approx_0)+(512))|0); //@line 113 "dda_maths.c"
 var $shr=$add11>>>10; //@line 113 "dda_maths.c"
 var $retval_0=$shr;label=6;break; //@line 113 "dda_maths.c"
 case 6: 
 var $retval_0;
 return $retval_0; //@line 114 "dda_maths.c"
  default: assert(0, "bad label: " + label);
 }

}


function _approx_distance_3($dx,$dy,$dz){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=($dx>>>0)<($dy>>>0); //@line 128 "dda_maths.c"
 var $dy_dx=($cmp?$dy:$dx); //@line 131 "dda_maths.c"
 var $dx_dy=($cmp?$dx:$dy); //@line 131 "dda_maths.c"
 var $cmp1=($dy_dx>>>0)>($dz>>>0); //@line 136 "dda_maths.c"
 if($cmp1){var $max_0=$dx_dy;var $med_1=$dy_dx;var $min_1=$dz;label=3;break;}else{label=2;break;} //@line 136 "dda_maths.c"
 case 2: 
 var $cmp4=($dx_dy>>>0)>($dz>>>0); //@line 140 "dda_maths.c"
 var $dz_dx_dy=($cmp4?$dz:$dx_dy); //@line 143 "dda_maths.c"
 var $dx_dy_dz=($cmp4?$dx_dy:$dz); //@line 143 "dda_maths.c"
 var $max_0=$dx_dy_dz;var $med_1=$dz_dx_dy;var $min_1=$dy_dx;label=3;break; //@line 143 "dda_maths.c"
 case 3: 
 var $min_1;
 var $med_1;
 var $max_0;
 var $mul=((($max_0)*(860))&-1); //@line 147 "dda_maths.c"
 var $mul9=((($med_1)*(851))&-1); //@line 147 "dda_maths.c"
 var $mul10=((($min_1)*(520))&-1); //@line 147 "dda_maths.c"
 var $add=((($mul9)+($mul10))|0); //@line 147 "dda_maths.c"
 var $add11=((($add)+($mul))|0); //@line 147 "dda_maths.c"
 var $shl=$med_1<<1; //@line 148 "dda_maths.c"
 var $cmp12=($max_0>>>0)<($shl>>>0); //@line 148 "dda_maths.c"
 if($cmp12){label=4;break;}else{var $approx_0=$add11;label=5;break;} //@line 148 "dda_maths.c"
 case 4: 
 var $0=((($max_0)*(-294))&-1); //@line 148 "dda_maths.c"
 var $sub=((($add11)+($0))|0); //@line 148 "dda_maths.c"
 var $approx_0=$sub;label=5;break; //@line 148 "dda_maths.c"
 case 5: 
 var $approx_0;
 var $shl16=$min_1<<2; //@line 149 "dda_maths.c"
 var $cmp17=($max_0>>>0)<($shl16>>>0); //@line 149 "dda_maths.c"
 if($cmp17){label=6;break;}else{var $approx_1=$approx_0;label=7;break;} //@line 149 "dda_maths.c"
 case 6: 
 var $1=((($max_0)*(-113))&-1); //@line 149 "dda_maths.c"
 var $sub20=((($approx_0)+($1))|0); //@line 149 "dda_maths.c"
 var $approx_1=$sub20;label=7;break; //@line 149 "dda_maths.c"
 case 7: 
 var $approx_1;
 var $cmp23=($med_1>>>0)<($shl16>>>0); //@line 150 "dda_maths.c"
 if($cmp23){label=8;break;}else{var $approx_2=$approx_1;label=9;break;} //@line 150 "dda_maths.c"
 case 8: 
 var $2=((($med_1)*(-40))&-1); //@line 150 "dda_maths.c"
 var $sub26=((($approx_1)+($2))|0); //@line 150 "dda_maths.c"
 var $approx_2=$sub26;label=9;break; //@line 150 "dda_maths.c"
 case 9: 
 var $approx_2;
 var $add28=((($approx_2)+(512))|0); //@line 153 "dda_maths.c"
 var $shr=$add28>>>10; //@line 153 "dda_maths.c"
 return $shr; //@line 153 "dda_maths.c"
  default: assert(0, "bad label: " + label);
 }

}


function _int_inv_sqrt($a){
 var label=0;


 var $conv=($a&65535); //@line 218 "dda_maths.c"
 var $div=(((65535)/(($conv>>>0)))&-1); //@line 218 "dda_maths.c"
 var $cmp=($div>>>0)<16384; //@line 225 "dda_maths.c"
 var $or19_1=($cmp?64:-64); //@line 223 "dda_maths.c"
 var $conv5_1=($or19_1&255); //@line 224 "dda_maths.c"
 var $mul_1=(Math_imul($conv5_1,$conv5_1)|0); //@line 224 "dda_maths.c"
 var $cmp_1=($mul_1>>>0)>($div>>>0); //@line 225 "dda_maths.c"
 var $xor21_1=($cmp_1?64:0); //@line 225 "dda_maths.c"
 var $xor21_or19_1=$xor21_1^$or19_1; //@line 225 "dda_maths.c"
 var $or19_2=$xor21_or19_1|32; //@line 223 "dda_maths.c"
 var $conv5_2=($or19_2&255); //@line 224 "dda_maths.c"
 var $mul_2=(Math_imul($conv5_2,$conv5_2)|0); //@line 224 "dda_maths.c"
 var $cmp_2=($mul_2>>>0)>($div>>>0); //@line 225 "dda_maths.c"
 var $xor21_2=($cmp_2?32:0); //@line 225 "dda_maths.c"
 var $xor21_or19_2=$xor21_2^$or19_2; //@line 225 "dda_maths.c"
 var $or19_3=$xor21_or19_2|16; //@line 223 "dda_maths.c"
 var $conv5_3=($or19_3&255); //@line 224 "dda_maths.c"
 var $mul_3=(Math_imul($conv5_3,$conv5_3)|0); //@line 224 "dda_maths.c"
 var $cmp_3=($mul_3>>>0)>($div>>>0); //@line 225 "dda_maths.c"
 var $xor21_3=($cmp_3?16:0); //@line 225 "dda_maths.c"
 var $xor21_or19_3=$xor21_3^$or19_3; //@line 225 "dda_maths.c"
 var $or19_4=$xor21_or19_3|8; //@line 223 "dda_maths.c"
 var $conv5_4=($or19_4&255); //@line 224 "dda_maths.c"
 var $mul_4=(Math_imul($conv5_4,$conv5_4)|0); //@line 224 "dda_maths.c"
 var $cmp_4=($mul_4>>>0)>($div>>>0); //@line 225 "dda_maths.c"
 var $xor21_4=($cmp_4?8:0); //@line 225 "dda_maths.c"
 var $xor21_or19_4=$xor21_4^$or19_4; //@line 225 "dda_maths.c"
 var $or19_5=$xor21_or19_4|4; //@line 223 "dda_maths.c"
 var $conv5_5=($or19_5&255); //@line 224 "dda_maths.c"
 var $mul_5=(Math_imul($conv5_5,$conv5_5)|0); //@line 224 "dda_maths.c"
 var $cmp_5=($mul_5>>>0)>($div>>>0); //@line 225 "dda_maths.c"
 var $xor21_5=($cmp_5?4:0); //@line 225 "dda_maths.c"
 var $xor21_or19_5=$xor21_5^$or19_5; //@line 225 "dda_maths.c"
 var $or19_6=$xor21_or19_5|2; //@line 223 "dda_maths.c"
 var $conv5_6=($or19_6&255); //@line 224 "dda_maths.c"
 var $mul_6=(Math_imul($conv5_6,$conv5_6)|0); //@line 224 "dda_maths.c"
 var $cmp_6=($mul_6>>>0)>($div>>>0); //@line 225 "dda_maths.c"
 var $xor21_6=($cmp_6?2:0); //@line 225 "dda_maths.c"
 var $xor21_or19_6=$xor21_6^$or19_6; //@line 225 "dda_maths.c"
 var $or19_7=$xor21_or19_6|1; //@line 223 "dda_maths.c"
 var $conv5_7=($or19_7&255); //@line 224 "dda_maths.c"
 var $mul_7=(Math_imul($conv5_7,$conv5_7)|0); //@line 224 "dda_maths.c"
 var $cmp_7=($mul_7>>>0)>($div>>>0); //@line 225 "dda_maths.c"
 var $xor21_7=($cmp_7&1); //@line 225 "dda_maths.c"
 var $xor21_or19_7=$xor21_7^$or19_7; //@line 225 "dda_maths.c"
 var $shl=$div<<8; //@line 218 "dda_maths.c"
 var $conv16=($xor21_or19_7&255); //@line 229 "dda_maths.c"
 var $shl17=$conv16<<4; //@line 229 "dda_maths.c"
 var $or2516=$shl17|8; //@line 233 "dda_maths.c"
 var $conv27=($or2516&65535); //@line 234 "dda_maths.c"
 var $mul29=(Math_imul($conv27,$conv27)|0); //@line 234 "dda_maths.c"
 var $cmp30=($mul29>>>0)>($shl>>>0); //@line 235 "dda_maths.c"
 var $xor3518=($cmp30?8:0); //@line 235 "dda_maths.c"
 var $xor3518_or2516=$xor3518^$or2516; //@line 235 "dda_maths.c"
 var $or2516_1=$xor3518_or2516|4; //@line 233 "dda_maths.c"
 var $conv27_1=($or2516_1&65535); //@line 234 "dda_maths.c"
 var $mul29_1=(Math_imul($conv27_1,$conv27_1)|0); //@line 234 "dda_maths.c"
 var $cmp30_1=($mul29_1>>>0)>($shl>>>0); //@line 235 "dda_maths.c"
 var $xor3518_1=($cmp30_1?4:0); //@line 235 "dda_maths.c"
 var $xor3518_or2516_1=$xor3518_1^$or2516_1; //@line 235 "dda_maths.c"
 var $or2516_2=$xor3518_or2516_1|2; //@line 233 "dda_maths.c"
 var $conv27_2=($or2516_2&65535); //@line 234 "dda_maths.c"
 var $mul29_2=(Math_imul($conv27_2,$conv27_2)|0); //@line 234 "dda_maths.c"
 var $cmp30_2=($mul29_2>>>0)>($shl>>>0); //@line 235 "dda_maths.c"
 var $xor3518_2=($cmp30_2?2:0); //@line 235 "dda_maths.c"
 var $xor3518_or2516_2=$xor3518_2^$or2516_2; //@line 235 "dda_maths.c"
 var $or2516_3=$xor3518_or2516_2|1; //@line 233 "dda_maths.c"
 var $conv27_3=($or2516_3&65535); //@line 234 "dda_maths.c"
 var $mul29_3=(Math_imul($conv27_3,$conv27_3)|0); //@line 234 "dda_maths.c"
 var $cmp30_3=($mul29_3>>>0)>($shl>>>0); //@line 235 "dda_maths.c"
 var $xor3518_3=($cmp30_3&1); //@line 235 "dda_maths.c"
 var $xor3518_or2516_3=$xor3518_3^$or2516_3; //@line 235 "dda_maths.c"
 return $xor3518_or2516_3; //@line 239 "dda_maths.c"
}


function _acc_ramp_len($feedrate,$steps_per_m){
 var label=0;


 var $mul=(Math_imul($feedrate,$feedrate)|0); //@line 272 "dda_maths.c"
 var $conv=($mul>>>0); //@line 272 "dda_maths.c"
 var $conv1=($steps_per_m>>>0); //@line 272 "dda_maths.c"
 var $div=(7200000000)/($conv1); //@line 272 "dda_maths.c"
 var $div2=($conv)/($div); //@line 272 "dda_maths.c"
 var $conv3=($div2>=0 ? Math_floor($div2) : Math_ceil($div2)); //@line 272 "dda_maths.c"
 return $conv3; //@line 272 "dda_maths.c"
}


function _carthesian_to_carthesian($startpoint,$target,$delta_um,$steps){
 var label=0;


 var $arrayidx=(($target)|0); //@line 17 "dda_kinematics.c"
 var $0=HEAP32[(($arrayidx)>>2)]; //@line 17 "dda_kinematics.c"
 var $arrayidx4=(($startpoint)|0); //@line 17 "dda_kinematics.c"
 var $1=HEAP32[(($arrayidx4)>>2)]; //@line 17 "dda_kinematics.c"
 var $sub=((($0)-($1))|0); //@line 17 "dda_kinematics.c"
 var $ispos=($sub|0)>-1; //@line 17 "dda_kinematics.c"
 var $neg=(((-$sub))|0); //@line 17 "dda_kinematics.c"
 var $2=($ispos?$sub:$neg); //@line 17 "dda_kinematics.c"
 HEAP32[(($delta_um)>>2)]=$2; //@line 17 "dda_kinematics.c"
 var $3=HEAP32[(($arrayidx)>>2)]; //@line 18 "dda_kinematics.c"
 var $call_i=_pgm_read_dword(848); //@line 35 "./dda_maths.h"
 var $call3_i=_pgm_read_dword(832); //@line 36 "./dda_maths.h"
 var $call4_i=_muldivQR($3,$call_i,$call3_i,1000000); //@line 35 "./dda_maths.h"
 HEAP32[(($steps)>>2)]=$call4_i; //@line 18 "dda_kinematics.c"
 var $arrayidx_1=(($target+4)|0); //@line 17 "dda_kinematics.c"
 var $4=HEAP32[(($arrayidx_1)>>2)]; //@line 17 "dda_kinematics.c"
 var $arrayidx4_1=(($startpoint+4)|0); //@line 17 "dda_kinematics.c"
 var $5=HEAP32[(($arrayidx4_1)>>2)]; //@line 17 "dda_kinematics.c"
 var $sub_1=((($4)-($5))|0); //@line 17 "dda_kinematics.c"
 var $ispos_1=($sub_1|0)>-1; //@line 17 "dda_kinematics.c"
 var $neg_1=(((-$sub_1))|0); //@line 17 "dda_kinematics.c"
 var $6=($ispos_1?$sub_1:$neg_1); //@line 17 "dda_kinematics.c"
 var $arrayidx6_1=(($delta_um+4)|0); //@line 17 "dda_kinematics.c"
 HEAP32[(($arrayidx6_1)>>2)]=$6; //@line 17 "dda_kinematics.c"
 var $7=HEAP32[(($arrayidx_1)>>2)]; //@line 18 "dda_kinematics.c"
 var $call_i_1=_pgm_read_dword(852); //@line 35 "./dda_maths.h"
 var $call3_i_1=_pgm_read_dword(836); //@line 36 "./dda_maths.h"
 var $call4_i_1=_muldivQR($7,$call_i_1,$call3_i_1,1000000); //@line 35 "./dda_maths.h"
 var $arrayidx12_1=(($steps+4)|0); //@line 18 "dda_kinematics.c"
 HEAP32[(($arrayidx12_1)>>2)]=$call4_i_1; //@line 18 "dda_kinematics.c"
 var $arrayidx_2=(($target+8)|0); //@line 17 "dda_kinematics.c"
 var $8=HEAP32[(($arrayidx_2)>>2)]; //@line 17 "dda_kinematics.c"
 var $arrayidx4_2=(($startpoint+8)|0); //@line 17 "dda_kinematics.c"
 var $9=HEAP32[(($arrayidx4_2)>>2)]; //@line 17 "dda_kinematics.c"
 var $sub_2=((($8)-($9))|0); //@line 17 "dda_kinematics.c"
 var $ispos_2=($sub_2|0)>-1; //@line 17 "dda_kinematics.c"
 var $neg_2=(((-$sub_2))|0); //@line 17 "dda_kinematics.c"
 var $10=($ispos_2?$sub_2:$neg_2); //@line 17 "dda_kinematics.c"
 var $arrayidx6_2=(($delta_um+8)|0); //@line 17 "dda_kinematics.c"
 HEAP32[(($arrayidx6_2)>>2)]=$10; //@line 17 "dda_kinematics.c"
 var $11=HEAP32[(($arrayidx_2)>>2)]; //@line 18 "dda_kinematics.c"
 var $call_i_2=_pgm_read_dword(856); //@line 35 "./dda_maths.h"
 var $call3_i_2=_pgm_read_dword(840); //@line 36 "./dda_maths.h"
 var $call4_i_2=_muldivQR($11,$call_i_2,$call3_i_2,1000000); //@line 35 "./dda_maths.h"
 var $arrayidx12_2=(($steps+8)|0); //@line 18 "dda_kinematics.c"
 HEAP32[(($arrayidx12_2)>>2)]=$call4_i_2; //@line 18 "dda_kinematics.c"
 return; //@line 20 "dda_kinematics.c"
}


function _TIMER1_COMPB_vect(){
 var label=0;


 var $0=HEAP16[((5680)>>1)]; //@line 39 "timer.c"
 var $add=((($0)+(32000))&65535); //@line 39 "timer.c"
 HEAP16[((5680)>>1)]=$add; //@line 39 "timer.c"
 _clock_tick(); //@line 41 "timer.c"
 _dda_clock(); //@line 42 "timer.c"
 return; //@line 43 "timer.c"
}


function _TIMER1_COMPA_vect(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((3968)>>2)]; //@line 50 "timer.c"
 var $cmp=($0>>>0)<65536; //@line 50 "timer.c"
 if($cmp){label=2;break;}else{label=3;break;} //@line 50 "timer.c"
 case 2: 
 var $1=HEAP8[(5656)]; //@line 57 "timer.c"
 var $and=$1&-3; //@line 57 "timer.c"
 HEAP8[(5656)]=$and; //@line 57 "timer.c"
 _queue_step(); //@line 60 "timer.c"
 label=7;break; //@line 67 "timer.c"
 case 3: 
 var $sub=((($0)-(65536))|0); //@line 70 "timer.c"
 HEAP32[((3968)>>2)]=$sub; //@line 70 "timer.c"
 var $cmp2=($sub>>>0)<65536; //@line 73 "timer.c"
 if($cmp2){label=4;break;}else{label=5;break;} //@line 73 "timer.c"
 case 4: 
 var $2=HEAP16[((5688)>>1)]; //@line 74 "timer.c"
 var $conv5=($2&65535); //@line 74 "timer.c"
 var $add=((($conv5)+($sub))|0); //@line 74 "timer.c"
 var $conv7=(($add)&65535); //@line 74 "timer.c"
 HEAP16[((5688)>>1)]=$conv7; //@line 74 "timer.c"
 label=7;break; //@line 75 "timer.c"
 case 5: 
 var $cmp8=($sub>>>0)<75536; //@line 75 "timer.c"
 if($cmp8){label=6;break;}else{label=7;break;} //@line 75 "timer.c"
 case 6: 
 var $3=HEAP16[((5688)>>1)]; //@line 76 "timer.c"
 var $sub12=((($3)-(10000))&65535); //@line 76 "timer.c"
 HEAP16[((5688)>>1)]=$sub12; //@line 76 "timer.c"
 var $add15=((($0)-(55536))|0); //@line 77 "timer.c"
 HEAP32[((3968)>>2)]=$add15; //@line 77 "timer.c"
 label=7;break; //@line 78 "timer.c"
 case 7: 
 return; //@line 80 "timer.c"
  default: assert(0, "bad label: " + label);
 }

}


function _timer_init(){
 var label=0;


 HEAP16[((5672)>>1)]=0; //@line 88 "timer.c"
 HEAP16[((5664)>>1)]=2; //@line 90 "timer.c"
 HEAP16[((5680)>>1)]=32000; //@line 92 "timer.c"
 HEAP8[(5656)]=8; //@line 94 "timer.c"
 _sim_setTimer(); //@line 97 "timer.c"
 return; //@line 99 "timer.c"
}


function _setTimer($delay){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 _cli(); //@line 120 "timer.c"
 var $0=HEAP16[((5688)>>1)]; //@line 127 "timer.c"
 HEAP32[((3968)>>2)]=$delay; //@line 128 "timer.c"
 var $cmp=($delay>>>0)<65536; //@line 158 "timer.c"
 if($cmp){label=2;break;}else{label=3;break;} //@line 158 "timer.c"
 case 2: 
 var $conv=($0&65535); //@line 160 "timer.c"
 var $add=((($conv)+($delay))|0); //@line 160 "timer.c"
 var $conv1=(($add)&65535); //@line 160 "timer.c"
 HEAP16[((5688)>>1)]=$conv1; //@line 160 "timer.c"
 label=6;break; //@line 161 "timer.c"
 case 3: 
 var $cmp2=($delay>>>0)<75536; //@line 162 "timer.c"
 if($cmp2){label=4;break;}else{label=5;break;} //@line 162 "timer.c"
 case 4: 
 var $sub=((($0)-(10000))&65535); //@line 166 "timer.c"
 HEAP16[((5688)>>1)]=$sub; //@line 166 "timer.c"
 var $add8=((($delay)+(10000))|0); //@line 167 "timer.c"
 HEAP32[((3968)>>2)]=$add8; //@line 167 "timer.c"
 label=6;break; //@line 168 "timer.c"
 case 5: 
 HEAP16[((5688)>>1)]=$0; //@line 170 "timer.c"
 label=6;break;
 case 6: 
 var $1=HEAP8[(5656)]; //@line 177 "timer.c"
 var $or=$1|2; //@line 177 "timer.c"
 HEAP8[(5656)]=$or; //@line 177 "timer.c"
 _sim_setTimer(); //@line 180 "timer.c"
 return; //@line 182 "timer.c"
  default: assert(0, "bad label: " + label);
 }

}


function _timer_stop(){
 var label=0;


 HEAP8[(5656)]=0; //@line 187 "timer.c"
 _sim_timer_stop(); //@line 190 "timer.c"
 return; //@line 192 "timer.c"
}


function _io_init(){
 var label=0;


 HEAP8[(5696)]=-128; //@line 81 "mendel.c"
 _WRITE(0,0); //@line 86 "mendel.c"
 _SET_OUTPUT(0); //@line 86 "mendel.c"
 _WRITE(1,0); //@line 87 "mendel.c"
 _SET_OUTPUT(1); //@line 87 "mendel.c"
 _WRITE(4,0); //@line 98 "mendel.c"
 _SET_OUTPUT(4); //@line 98 "mendel.c"
 _WRITE(5,0); //@line 99 "mendel.c"
 _SET_OUTPUT(5); //@line 99 "mendel.c"
 return; //@line 193 "mendel.c"
}


function _init(){
 var label=0;


 _serial_init(); //@line 201 "mendel.c"
 _gcode_init(); //@line 204 "mendel.c"
 _io_init(); //@line 207 "mendel.c"
 _timer_init(); //@line 210 "mendel.c"
 _heater_init(); //@line 213 "mendel.c"
 _dda_init(); //@line 216 "mendel.c"
 _analog_init(); //@line 220 "mendel.c"
 _temp_init(); //@line 223 "mendel.c"
 _sei(); //@line 226 "mendel.c"
 _serial_writestr_P(2320); //@line 235 "mendel.c"
 return; //@line 237 "mendel.c"
}


function _main($argc,$argv){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 _sim_start($argc,$argv); //@line 245 "mendel.c"
 _init(); //@line 250 "mendel.c"
 label=2;break; //@line 253 "mendel.c"
 case 2: 
 var $call=_queue_full(); //@line 256 "mendel.c"
 var $cmp=(($call<<24)>>24)==0; //@line 256 "mendel.c"
 if($cmp){label=3;break;}else{label=5;break;} //@line 256 "mendel.c"
 case 3: 
 var $call2=_serial_rxchars(); //@line 257 "mendel.c"
 var $cmp4=(($call2<<24)>>24)==0; //@line 257 "mendel.c"
 if($cmp4){label=5;break;}else{label=4;break;} //@line 257 "mendel.c"
 case 4: 
 var $call7=_serial_popchar(); //@line 258 "mendel.c"
 _gcode_parse_char($call7); //@line 259 "mendel.c"
 label=5;break; //@line 260 "mendel.c"
 case 5: 
 _clock(); //@line 291 "mendel.c"
 label=2;break; //@line 292 "mendel.c"
  default: assert(0, "bad label: " + label);
 }

}
Module["_main"] = _main;

function _dda_init(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((3816)>>2)]; //@line 114 "dda.c"
 var $cmp=($0|0)==0; //@line 114 "dda.c"
 if($cmp){label=2;break;}else{label=3;break;} //@line 114 "dda.c"
 case 2: 
 HEAP32[((3936)>>2)]=1; //@line 115 "dda.c"
 HEAP32[((3816)>>2)]=1; //@line 115 "dda.c"
 label=3;break; //@line 115 "dda.c"
 case 3: 
 return; //@line 116 "dda.c"
  default: assert(0, "bad label: " + label);
 }

}


function _dda_new_startpoint(){
 var label=0;


 var $0=HEAP32[((3800)>>2)]; //@line 126 "dda.c"
 var $call_i=_pgm_read_dword(848); //@line 35 "./dda_maths.h"
 var $call3_i=_pgm_read_dword(832); //@line 36 "./dda_maths.h"
 var $call4_i=_muldivQR($0,$call_i,$call3_i,1000000); //@line 35 "./dda_maths.h"
 HEAP32[((3776)>>2)]=$call4_i; //@line 126 "dda.c"
 var $1=HEAP32[((3804)>>2)]; //@line 126 "dda.c"
 var $call_i_1=_pgm_read_dword(852); //@line 35 "./dda_maths.h"
 var $call3_i_1=_pgm_read_dword(836); //@line 36 "./dda_maths.h"
 var $call4_i_1=_muldivQR($1,$call_i_1,$call3_i_1,1000000); //@line 35 "./dda_maths.h"
 HEAP32[((3780)>>2)]=$call4_i_1; //@line 126 "dda.c"
 var $2=HEAP32[((3808)>>2)]; //@line 126 "dda.c"
 var $call_i_2=_pgm_read_dword(856); //@line 35 "./dda_maths.h"
 var $call3_i_2=_pgm_read_dword(840); //@line 36 "./dda_maths.h"
 var $call4_i_2=_muldivQR($2,$call_i_2,$call3_i_2,1000000); //@line 35 "./dda_maths.h"
 HEAP32[((3784)>>2)]=$call4_i_2; //@line 126 "dda.c"
 var $3=HEAP32[((3812)>>2)]; //@line 126 "dda.c"
 var $call_i_3=_pgm_read_dword(860); //@line 35 "./dda_maths.h"
 var $call3_i_3=_pgm_read_dword(844); //@line 36 "./dda_maths.h"
 var $call4_i_3=_muldivQR($3,$call_i_3,$call3_i_3,1000000); //@line 35 "./dda_maths.h"
 HEAP32[((3788)>>2)]=$call4_i_3; //@line 126 "dda.c"
 return; //@line 127 "dda.c"
}


function _dda_create($dda,$target){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+32)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $delta_um=sp;
 var $steps=(sp)+(16);
 var $0=(($dda+24)|0); //@line 172 "dda.c"
 var $1=$0; //@line 172 "dda.c"
 var $bf_load=HEAP8[($1)]; //@line 172 "dda.c"
 var $bf_clear=$bf_load&8; //@line 172 "dda.c"
 var $tobool=(($bf_clear<<24)>>24)==0; //@line 172 "dda.c"
 if($tobool){label=2;break;}else{label=17;break;} //@line 172 "dda.c"
 case 2: 
 var $2=$dda; //@line 176 "dda.c"
 var $3=$target; //@line 176 "dda.c"
 assert(24 % 1 === 0);HEAP32[(($2)>>2)]=HEAP32[(($3)>>2)];HEAP32[((($2)+(4))>>2)]=HEAP32[((($3)+(4))>>2)];HEAP32[((($2)+(8))>>2)]=HEAP32[((($3)+(8))>>2)];HEAP32[((($2)+(12))>>2)]=HEAP32[((($3)+(12))>>2)];HEAP32[((($2)+(16))>>2)]=HEAP32[((($3)+(16))>>2)];HEAP32[((($2)+(20))>>2)]=HEAP32[((($3)+(20))>>2)]; //@line 176 "dda.c"
 var $arraydecay=(($delta_um)|0); //@line 193 "dda.c"
 var $arraydecay1=(($steps)|0); //@line 193 "dda.c"
 _carthesian_to_carthesian(3800,$target,$arraydecay,$arraydecay1); //@line 31 "./dda_kinematics.h"
 var $4=HEAP32[(($arraydecay1)>>2)]; //@line 197 "dda.c"
 var $5=HEAP32[((3776)>>2)]; //@line 197 "dda.c"
 var $sub=((($4)-($5))|0); //@line 197 "dda.c"
 var $ispos87=($sub|0)>-1; //@line 198 "dda.c"
 var $neg88=(((-$sub))|0); //@line 198 "dda.c"
 var $6=($ispos87?$sub:$neg88); //@line 198 "dda.c"
 var $arrayidx6=(($dda+28)|0); //@line 198 "dda.c"
 HEAP32[(($arrayidx6)>>2)]=$6; //@line 198 "dda.c"
 HEAP32[((3776)>>2)]=$4; //@line 199 "dda.c"
 _set_direction($dda,0,$sub); //@line 201 "dda.c"
 var $arrayidx_1=(($steps+4)|0); //@line 197 "dda.c"
 var $7=HEAP32[(($arrayidx_1)>>2)]; //@line 197 "dda.c"
 var $8=HEAP32[((3780)>>2)]; //@line 197 "dda.c"
 var $sub_1=((($7)-($8))|0); //@line 197 "dda.c"
 var $ispos87_1=($sub_1|0)>-1; //@line 198 "dda.c"
 var $neg88_1=(((-$sub_1))|0); //@line 198 "dda.c"
 var $9=($ispos87_1?$sub_1:$neg88_1); //@line 198 "dda.c"
 var $arrayidx6_1=(($dda+32)|0); //@line 198 "dda.c"
 HEAP32[(($arrayidx6_1)>>2)]=$9; //@line 198 "dda.c"
 HEAP32[((3780)>>2)]=$7; //@line 199 "dda.c"
 _set_direction($dda,1,$sub_1); //@line 201 "dda.c"
 var $arrayidx_2=(($steps+8)|0); //@line 197 "dda.c"
 var $10=HEAP32[(($arrayidx_2)>>2)]; //@line 197 "dda.c"
 var $11=HEAP32[((3784)>>2)]; //@line 197 "dda.c"
 var $sub_2=((($10)-($11))|0); //@line 197 "dda.c"
 var $ispos87_2=($sub_2|0)>-1; //@line 198 "dda.c"
 var $neg88_2=(((-$sub_2))|0); //@line 198 "dda.c"
 var $12=($ispos87_2?$sub_2:$neg88_2); //@line 198 "dda.c"
 var $arrayidx6_2=(($dda+36)|0); //@line 198 "dda.c"
 HEAP32[(($arrayidx6_2)>>2)]=$12; //@line 198 "dda.c"
 HEAP32[((3784)>>2)]=$10; //@line 199 "dda.c"
 _set_direction($dda,2,$sub_2); //@line 201 "dda.c"
 var $e_relative=(($target+20)|0); //@line 221 "dda.c"
 var $bf_load11=HEAP8[($e_relative)]; //@line 221 "dda.c"
 var $bf_clear12=$bf_load11&1; //@line 221 "dda.c"
 var $tobool13=(($bf_clear12<<24)>>24)==0; //@line 221 "dda.c"
 var $arrayidx31=(($target+12)|0); //@line 245 "dda.c"
 var $13=HEAP32[(($arrayidx31)>>2)]; //@line 245 "dda.c"
 if($tobool13){label=3;break;}else{label=4;break;} //@line 221 "dda.c"
 case 3: 
 var $14=HEAP32[((3812)>>2)]; //@line 224 "dda.c"
 var $sub17=((($13)-($14))|0); //@line 224 "dda.c"
 var $ispos=($sub17|0)>-1; //@line 224 "dda.c"
 var $neg=(((-$sub17))|0); //@line 224 "dda.c"
 var $15=($ispos?$sub17:$neg); //@line 224 "dda.c"
 var $arrayidx19=(($delta_um+12)|0); //@line 224 "dda.c"
 HEAP32[(($arrayidx19)>>2)]=$15; //@line 224 "dda.c"
 var $call_i=_pgm_read_dword(860); //@line 35 "./dda_maths.h"
 var $call3_i=_pgm_read_dword(844); //@line 36 "./dda_maths.h"
 var $call4_i=_muldivQR($13,$call_i,$call3_i,1000000); //@line 35 "./dda_maths.h"
 var $arrayidx23=(($steps+12)|0); //@line 225 "dda.c"
 HEAP32[(($arrayidx23)>>2)]=$call4_i; //@line 225 "dda.c"
 var $16=HEAP32[((3788)>>2)]; //@line 227 "dda.c"
 var $sub25=((($call4_i)-($16))|0); //@line 227 "dda.c"
 var $ispos80=($sub25|0)>-1; //@line 228 "dda.c"
 var $neg81=(((-$sub25))|0); //@line 228 "dda.c"
 var $17=($ispos80?$sub25:$neg81); //@line 228 "dda.c"
 var $arrayidx28=(($dda+40)|0); //@line 228 "dda.c"
 HEAP32[(($arrayidx28)>>2)]=$17; //@line 228 "dda.c"
 HEAP32[((3788)>>2)]=$call4_i; //@line 229 "dda.c"
 _set_direction($dda,3,$sub25); //@line 231 "dda.c"
 label=18;break; //@line 241 "dda.c"
 case 4: 
 var $ispos82=($13|0)>-1; //@line 245 "dda.c"
 var $neg83=(((-$13))|0); //@line 245 "dda.c"
 var $18=($ispos82?$13:$neg83); //@line 245 "dda.c"
 var $arrayidx33=(($delta_um+12)|0); //@line 245 "dda.c"
 HEAP32[(($arrayidx33)>>2)]=$18; //@line 245 "dda.c"
 var $call_i188=_pgm_read_dword(860); //@line 35 "./dda_maths.h"
 var $call3_i191=_pgm_read_dword(844); //@line 36 "./dda_maths.h"
 var $call4_i192=_muldivQR($13,$call_i188,$call3_i191,1000000); //@line 35 "./dda_maths.h"
 var $ispos84=($call4_i192|0)>-1; //@line 246 "dda.c"
 var $neg85=(((-$call4_i192))|0); //@line 246 "dda.c"
 var $19=($ispos84?$call4_i192:$neg85); //@line 246 "dda.c"
 var $arrayidx39=(($dda+40)|0); //@line 246 "dda.c"
 HEAP32[(($arrayidx39)>>2)]=$19; //@line 246 "dda.c"
 var $20=HEAP32[(($arrayidx31)>>2)]; //@line 250 "dda.c"
 var $bf_load45=HEAP8[($1)]; //@line 250 "dda.c"
 var $21=$20>>>24; //@line 250 "dda.c"
 var $_tr=(($21)&255); //@line 250 "dda.c"
 var $bf_value=$_tr&-128; //@line 250 "dda.c"
 var $22=$bf_load45&127; //@line 250 "dda.c"
 var $bf_clear46=$bf_value|$22; //@line 250 "dda.c"
 var $bf_set=$bf_clear46^-128; //@line 250 "dda.c"
 HEAP8[($1)]=$bf_set; //@line 250 "dda.c"
 label=18;break;
 case 5: 
 var $bf_load79=HEAP8[($1)]; //@line 276 "dda.c"
 var $bf_set81=$bf_load79|1; //@line 276 "dda.c"
 HEAP8[($1)]=$bf_set81; //@line 276 "dda.c"
 label=16;break; //@line 277 "dda.c"
 case 6: 
 _power_on(); //@line 280 "dda.c"
 var $arrayidx89=(($delta_um+8)|0); //@line 288 "dda.c"
 var $23=HEAP32[(($arrayidx89)>>2)]; //@line 288 "dda.c"
 var $cmp90=($23|0)==0; //@line 288 "dda.c"
 var $24=HEAP32[(($arraydecay)>>2)]; //@line 289 "dda.c"
 var $arrayidx94=(($delta_um+4)|0); //@line 289 "dda.c"
 var $25=HEAP32[(($arrayidx94)>>2)]; //@line 289 "dda.c"
 if($cmp90){label=7;break;}else{label=8;break;} //@line 288 "dda.c"
 case 7: 
 var $call95=_approx_distance($24,$25); //@line 289 "dda.c"
 var $distance_0=$call95;label=10;break; //@line 289 "dda.c"
 case 8: 
 var $26=$24|$25; //@line 290 "dda.c"
 var $27=($26|0)==0; //@line 290 "dda.c"
 if($27){var $distance_0=$23;label=10;break;}else{label=9;break;} //@line 290 "dda.c"
 case 9: 
 var $call109=_approx_distance_3($24,$25,$23); //@line 293 "dda.c"
 var $distance_0=$call109;label=10;break;
 case 10: 
 var $distance_0;
 var $cmp112=($distance_0>>>0)<2; //@line 295 "dda.c"
 var $arrayidx115=(($delta_um+12)|0); //@line 296 "dda.c"
 var $28=HEAP32[(($arrayidx115)>>2)]; //@line 296 "dda.c"
 var $distance_1=($cmp112?$28:$distance_0); //@line 295 "dda.c"
 var $mul=((($distance_1)*(2400))&-1); //@line 329 "dda.c"
 var $29=HEAP32[(($total_steps65)>>2)]; //@line 329 "dda.c"
 var $div=(((($mul>>>0))/(($29>>>0)))&-1); //@line 329 "dda.c"
 var $30=HEAP32[(($arraydecay)>>2)]; //@line 340 "dda.c"
 var $mul126=((($30)*(2400))&-1); //@line 340 "dda.c"
 var $div128=(((($mul126>>>0))/(($29>>>0)))&-1); //@line 340 "dda.c"
 var $mul129=((($div128)*(400))&-1); //@line 340 "dda.c"
 var $call132=_pgm_read_dword(800); //@line 342 "dda.c"
 var $div133=(((($mul129>>>0))/(($call132>>>0)))&-1); //@line 342 "dda.c"
 var $arrayidx125_1=(($delta_um+4)|0); //@line 340 "dda.c"
 var $31=HEAP32[(($arrayidx125_1)>>2)]; //@line 340 "dda.c"
 var $mul126_1=((($31)*(2400))&-1); //@line 340 "dda.c"
 var $32=HEAP32[(($total_steps65)>>2)]; //@line 340 "dda.c"
 var $div128_1=(((($mul126_1>>>0))/(($32>>>0)))&-1); //@line 340 "dda.c"
 var $mul129_1=((($div128_1)*(400))&-1); //@line 340 "dda.c"
 var $call132_1=_pgm_read_dword(804); //@line 342 "dda.c"
 var $div133_1=(((($mul129_1>>>0))/(($call132_1>>>0)))&-1); //@line 342 "dda.c"
 var $cmp134_1=($div133_1>>>0)>($div133>>>0); //@line 343 "dda.c"
 var $div133_c_limit_0_1=($cmp134_1?$div133_1:$div133); //@line 343 "dda.c"
 var $33=HEAP32[(($arrayidx89)>>2)]; //@line 340 "dda.c"
 var $mul126_2=((($33)*(2400))&-1); //@line 340 "dda.c"
 var $34=HEAP32[(($total_steps65)>>2)]; //@line 340 "dda.c"
 var $div128_2=(((($mul126_2>>>0))/(($34>>>0)))&-1); //@line 340 "dda.c"
 var $mul129_2=((($div128_2)*(400))&-1); //@line 340 "dda.c"
 var $call132_2=_pgm_read_dword(808); //@line 342 "dda.c"
 var $div133_2=(((($mul129_2>>>0))/(($call132_2>>>0)))&-1); //@line 342 "dda.c"
 var $cmp134_2=($div133_2>>>0)>($div133_c_limit_0_1>>>0); //@line 343 "dda.c"
 var $div133_c_limit_0_2=($cmp134_2?$div133_2:$div133_c_limit_0_1); //@line 343 "dda.c"
 var $35=HEAP32[(($arrayidx115)>>2)]; //@line 340 "dda.c"
 var $mul126_3=((($35)*(2400))&-1); //@line 340 "dda.c"
 var $36=HEAP32[(($total_steps65)>>2)]; //@line 340 "dda.c"
 var $div128_3=(((($mul126_3>>>0))/(($36>>>0)))&-1); //@line 340 "dda.c"
 var $mul129_3=((($div128_3)*(400))&-1); //@line 340 "dda.c"
 var $call132_3=_pgm_read_dword(812); //@line 342 "dda.c"
 var $div133_3=(((($mul129_3>>>0))/(($call132_3>>>0)))&-1); //@line 342 "dda.c"
 var $cmp134_3=($div133_3>>>0)>($div133_c_limit_0_2>>>0); //@line 343 "dda.c"
 var $div133_c_limit_0_3=($cmp134_3?$div133_3:$div133_c_limit_0_2); //@line 343 "dda.c"
 var $mul118=((($div)*(400))&-1); //@line 329 "dda.c"
 var $F=(($target+16)|0); //@line 402 "dda.c"
 var $37=HEAP32[(($F)>>2)]; //@line 402 "dda.c"
 var $div141=(((($mul118>>>0))/(($37>>>0)))&-1); //@line 402 "dda.c"
 var $c_min=(($dda+72)|0); //@line 402 "dda.c"
 HEAP32[(($c_min)>>2)]=$div141; //@line 402 "dda.c"
 var $cmp143=($div141>>>0)<($div133_c_limit_0_3>>>0); //@line 403 "dda.c"
 if($cmp143){label=12;break;}else{label=11;break;} //@line 403 "dda.c"
 case 11: 
 var $F153_phi_trans_insert=(($dda+16)|0);
 var $_pre100=HEAP32[(($F153_phi_trans_insert)>>2)]; //@line 409 "dda.c"
 var $38=$_pre100;label=13;break; //@line 403 "dda.c"
 case 12: 
 HEAP32[(($c_min)>>2)]=$div133_c_limit_0_3; //@line 404 "dda.c"
 var $div148=(((($mul118>>>0))/(($div133_c_limit_0_3>>>0)))&-1); //@line 405 "dda.c"
 var $F150=(($dda+16)|0); //@line 405 "dda.c"
 HEAP32[(($F150)>>2)]=$div148; //@line 405 "dda.c"
 var $38=$div148;label=13;break; //@line 406 "dda.c"
 case 13: 
 var $38;
 var $cmp154=($38>>>0)>65535; //@line 409 "dda.c"
 if($cmp154){label=14;break;}else{var $39=$38;label=15;break;} //@line 409 "dda.c"
 case 14: 
 var $F153=(($dda+16)|0); //@line 409 "dda.c"
 HEAP32[(($F153)>>2)]=65535; //@line 410 "dda.c"
 var $39=65535;label=15;break; //@line 410 "dda.c"
 case 15: 
 var $39;
 var $40=HEAP32[(($fast_um)>>2)]; //@line 414 "dda.c"
 var $div_i=(((($39>>>0))/(($distance_1>>>0)))&-1); //@line 18 "./dda_maths.h"
 var $rem_i=(((($39>>>0))%(($distance_1>>>0)))&-1); //@line 18 "./dda_maths.h"
 var $call_i193=_muldivQR($40,$div_i,$rem_i,$distance_1); //@line 18 "./dda_maths.h"
 var $41=HEAP32[(($fast_spm)>>2)]; //@line 414 "dda.c"
 var $call165=_acc_ramp_len($call_i193,$41); //@line 414 "dda.c"
 var $rampup_steps=(($dda+64)|0); //@line 414 "dda.c"
 var $42=HEAP32[(($total_steps65)>>2)]; //@line 417 "dda.c"
 var $div168=$42>>>1; //@line 417 "dda.c"
 var $cmp169=($call165>>>0)>($div168>>>0); //@line 417 "dda.c"
 var $div168_call165=($cmp169?$div168:$call165); //@line 417 "dda.c"
 HEAP32[(($rampup_steps)>>2)]=$div168_call165; //@line 418 "dda.c"
 var $sub178=((($42)-($div168_call165))|0); //@line 419 "dda.c"
 var $rampdown_steps=(($dda+68)|0); //@line 419 "dda.c"
 HEAP32[(($rampdown_steps)>>2)]=$sub178; //@line 419 "dda.c"
 var $n=(($dda+60)|0); //@line 437 "dda.c"
 HEAP32[(($n)>>2)]=0; //@line 437 "dda.c"
 var $43=HEAP8[($fast_axis)]; //@line 438 "dda.c"
 var $idxprom180=($43&255); //@line 438 "dda.c"
 var $arrayidx181=((816+($idxprom180<<2))|0); //@line 438 "dda.c"
 var $call182=_pgm_read_dword($arrayidx181); //@line 438 "dda.c"
 var $c=(($dda+56)|0); //@line 438 "dda.c"
 HEAP32[(($c)>>2)]=$call182; //@line 438 "dda.c"
 label=16;break;
 case 16: 
 assert(24 % 1 === 0);HEAP32[((3800)>>2)]=HEAP32[(($3)>>2)];HEAP32[((3804)>>2)]=HEAP32[((($3)+(4))>>2)];HEAP32[((3808)>>2)]=HEAP32[((($3)+(8))>>2)];HEAP32[((3812)>>2)]=HEAP32[((($3)+(12))>>2)];HEAP32[((3816)>>2)]=HEAP32[((($3)+(16))>>2)];HEAP32[((3820)>>2)]=HEAP32[((($3)+(20))>>2)]; //@line 469 "dda.c"
 label=17;break; //@line 473 "dda.c"
 case 17: 
 STACKTOP=sp;return; //@line 473 "dda.c"
 case 18: 
 var $fast_axis=(($dda+76)|0); //@line 265 "dda.c"
 var $total_steps65=(($dda+44)|0); //@line 266 "dda.c"
 var $fast_um=(($dda+48)|0); //@line 267 "dda.c"
 var $fast_spm=(($dda+52)|0); //@line 268 "dda.c"
 var $_pre=HEAP32[(($arrayidx6)>>2)]; //@line 266 "dda.c"
 HEAP8[($fast_axis)]=0; //@line 265 "dda.c"
 HEAP32[(($total_steps65)>>2)]=$_pre; //@line 266 "dda.c"
 var $44=HEAP32[(($arraydecay)>>2)]; //@line 267 "dda.c"
 HEAP32[(($fast_um)>>2)]=$44; //@line 267 "dda.c"
 var $call70=_pgm_read_dword(592); //@line 268 "dda.c"
 HEAP32[(($fast_spm)>>2)]=$call70; //@line 268 "dda.c"
 var $45=HEAP32[(($arrayidx6_1)>>2)]; //@line 264 "dda.c"
 var $46=HEAP32[(($total_steps65)>>2)]; //@line 264 "dda.c"
 var $cmp59_1=($45>>>0)>($46>>>0); //@line 264 "dda.c"
 if($cmp59_1){label=19;break;}else{label=20;break;} //@line 264 "dda.c"
 case 19: 
 HEAP8[($fast_axis)]=1; //@line 265 "dda.c"
 HEAP32[(($total_steps65)>>2)]=$45; //@line 266 "dda.c"
 var $arrayidx67_1=(($delta_um+4)|0); //@line 267 "dda.c"
 var $47=HEAP32[(($arrayidx67_1)>>2)]; //@line 267 "dda.c"
 HEAP32[(($fast_um)>>2)]=$47; //@line 267 "dda.c"
 var $call70_1=_pgm_read_dword(596); //@line 268 "dda.c"
 HEAP32[(($fast_spm)>>2)]=$call70_1; //@line 268 "dda.c"
 label=20;break; //@line 269 "dda.c"
 case 20: 
 var $48=HEAP32[(($arrayidx6_2)>>2)]; //@line 264 "dda.c"
 var $49=HEAP32[(($total_steps65)>>2)]; //@line 264 "dda.c"
 var $cmp59_2=($48>>>0)>($49>>>0); //@line 264 "dda.c"
 if($cmp59_2){label=21;break;}else{label=22;break;} //@line 264 "dda.c"
 case 21: 
 HEAP8[($fast_axis)]=2; //@line 265 "dda.c"
 HEAP32[(($total_steps65)>>2)]=$48; //@line 266 "dda.c"
 var $arrayidx67_2=(($delta_um+8)|0); //@line 267 "dda.c"
 var $50=HEAP32[(($arrayidx67_2)>>2)]; //@line 267 "dda.c"
 HEAP32[(($fast_um)>>2)]=$50; //@line 267 "dda.c"
 var $call70_2=_pgm_read_dword(600); //@line 268 "dda.c"
 HEAP32[(($fast_spm)>>2)]=$call70_2; //@line 268 "dda.c"
 label=22;break; //@line 269 "dda.c"
 case 22: 
 var $arrayidx58_3=(($dda+40)|0); //@line 264 "dda.c"
 var $51=HEAP32[(($arrayidx58_3)>>2)]; //@line 264 "dda.c"
 var $52=HEAP32[(($total_steps65)>>2)]; //@line 264 "dda.c"
 var $cmp59_3=($51>>>0)>($52>>>0); //@line 264 "dda.c"
 if($cmp59_3){label=23;break;}else{var $54=$52;label=24;break;} //@line 264 "dda.c"
 case 23: 
 HEAP8[($fast_axis)]=3; //@line 265 "dda.c"
 HEAP32[(($total_steps65)>>2)]=$51; //@line 266 "dda.c"
 var $arrayidx67_3=(($delta_um+12)|0); //@line 267 "dda.c"
 var $53=HEAP32[(($arrayidx67_3)>>2)]; //@line 267 "dda.c"
 HEAP32[(($fast_um)>>2)]=$53; //@line 267 "dda.c"
 var $call70_3=_pgm_read_dword(604); //@line 268 "dda.c"
 HEAP32[(($fast_spm)>>2)]=$call70_3; //@line 268 "dda.c"
 var $_pre99=HEAP32[(($total_steps65)>>2)]; //@line 275 "dda.c"
 var $54=$_pre99;label=24;break; //@line 269 "dda.c"
 case 24: 
 var $54;
 var $cmp76=($54|0)==0; //@line 275 "dda.c"
 if($cmp76){label=5;break;}else{label=6;break;} //@line 275 "dda.c"
  default: assert(0, "bad label: " + label);
 }

}


function _dda_start($dda){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=(($dda+24)|0); //@line 494 "dda.c"
 var $1=$0; //@line 494 "dda.c"
 var $bf_load=HEAP8[($1)]; //@line 494 "dda.c"
 var $bf_clear=$bf_load&1; //@line 494 "dda.c"
 var $tobool=(($bf_clear<<24)>>24)==0; //@line 494 "dda.c"
 if($tobool){label=2;break;}else{label=3;break;} //@line 494 "dda.c"
 case 2: 
 HEAP8[(3848)]=0; //@line 496 "dda.c"
 var $bf_load6=HEAP8[($1)]; //@line 503 "dda.c"
 var $bf_clear7=$bf_load6&16; //@line 503 "dda.c"
 var $tobool8=(($bf_clear7<<24)>>24)!=0; //@line 503 "dda.c"
 _WRITE(1,$tobool8); //@line 503 "dda.c"
 var $bf_load9=HEAP8[($1)]; //@line 504 "dda.c"
 var $bf_clear11=$bf_load9&32; //@line 504 "dda.c"
 var $tobool12=(($bf_clear11<<24)>>24)==0; //@line 504 "dda.c"
 _WRITE(5,$tobool12); //@line 504 "dda.c"
 var $total_steps=(($dda+44)|0); //@line 514 "dda.c"
 var $2=HEAP32[(($total_steps)>>2)]; //@line 514 "dda.c"
 var $shr=$2>>>1; //@line 514 "dda.c"
 var $sub=(((-$shr))|0); //@line 514 "dda.c"
 var $3=SIMD.int32x4.withX(int32x4.splat(0),$sub); //@line 514 "dda.c"
 var $4=SIMD.int32x4.withY($3,$sub); //@line 514 "dda.c"
 var $5=SIMD.int32x4.withZ($4,$sub); //@line 514 "dda.c"
 var $6=SIMD.int32x4.withW($5,$sub); //@line 514 "dda.c"
 (HEAP32[((_move_state)>>2)]=$6.x,HEAP32[(((_move_state)+(4))>>2)]=$6.y,HEAP32[(((_move_state)+(8))>>2)]=$6.z,HEAP32[(((_move_state)+(12))>>2)]=$6.w); //@line 514 "dda.c"
 var $arrayidx18=(($dda+28)|0); //@line 516 "dda.c"
 var $7=$arrayidx18; //@line 516 "dda.c"
 assert(16 % 1 === 0);HEAP32[((4656)>>2)]=HEAP32[(($7)>>2)];HEAP32[((4660)>>2)]=HEAP32[((($7)+(4))>>2)];HEAP32[((4664)>>2)]=HEAP32[((($7)+(8))>>2)];HEAP32[((4668)>>2)]=HEAP32[((($7)+(12))>>2)]; //@line 516 "dda.c"
 HEAP8[(4676)]=0; //@line 517 "dda.c"
 HEAP32[((4672)>>2)]=0; //@line 519 "dda.c"
 var $bf_load19=HEAP8[($1)]; //@line 527 "dda.c"
 var $bf_set=$bf_load19|2; //@line 527 "dda.c"
 HEAP8[($1)]=$bf_set; //@line 527 "dda.c"
 var $c=(($dda+56)|0); //@line 530 "dda.c"
 var $8=HEAP32[(($c)>>2)]; //@line 530 "dda.c"
 _setTimer($8); //@line 530 "dda.c"
 label=3;break; //@line 531 "dda.c"
 case 3: 
 var $F=(($dda+16)|0); //@line 534 "dda.c"
 var $9=HEAP32[(($F)>>2)]; //@line 534 "dda.c"
 HEAP32[((5104)>>2)]=$9; //@line 534 "dda.c"
 return; //@line 535 "dda.c"
  default: assert(0, "bad label: " + label);
 }

}


function _dda_step($dda){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((4656)>>2)]; //@line 560 "dda.c"
 var $tobool=($0|0)==0; //@line 560 "dda.c"
 if($tobool){label=4;break;}else{label=2;break;} //@line 560 "dda.c"
 case 2: 
 var $arrayidx=(($dda+28)|0); //@line 561 "dda.c"
 var $1=HEAP32[(($arrayidx)>>2)]; //@line 561 "dda.c"
 var $2=HEAP32[((4640)>>2)]; //@line 561 "dda.c"
 var $sub=((($2)-($1))|0); //@line 561 "dda.c"
 HEAP32[((4640)>>2)]=$sub; //@line 561 "dda.c"
 var $cmp=($sub|0)<0; //@line 562 "dda.c"
 if($cmp){label=3;break;}else{label=4;break;} //@line 562 "dda.c"
 case 3: 
 _WRITE(0,1); //@line 563 "dda.c"
 var $3=HEAP32[((4656)>>2)]; //@line 564 "dda.c"
 var $dec=((($3)-(1))|0); //@line 564 "dda.c"
 HEAP32[((4656)>>2)]=$dec; //@line 564 "dda.c"
 var $total_steps=(($dda+44)|0); //@line 565 "dda.c"
 var $4=HEAP32[(($total_steps)>>2)]; //@line 565 "dda.c"
 var $5=HEAP32[((4640)>>2)]; //@line 565 "dda.c"
 var $add=((($5)+($4))|0); //@line 565 "dda.c"
 HEAP32[((4640)>>2)]=$add; //@line 565 "dda.c"
 label=4;break; //@line 566 "dda.c"
 case 4: 
 var $6=HEAP32[((4660)>>2)]; //@line 578 "dda.c"
 var $tobool3=($6|0)==0; //@line 578 "dda.c"
 if($tobool3){var $12=0;label=7;break;}else{label=5;break;} //@line 578 "dda.c"
 case 5: 
 var $arrayidx6=(($dda+32)|0); //@line 579 "dda.c"
 var $7=HEAP32[(($arrayidx6)>>2)]; //@line 579 "dda.c"
 var $8=HEAP32[((4644)>>2)]; //@line 579 "dda.c"
 var $sub7=((($8)-($7))|0); //@line 579 "dda.c"
 HEAP32[((4644)>>2)]=$sub7; //@line 579 "dda.c"
 var $cmp8=($sub7|0)<0; //@line 580 "dda.c"
 if($cmp8){label=6;break;}else{var $12=$6;label=7;break;} //@line 580 "dda.c"
 case 6: 
 _WRITE(4,1); //@line 581 "dda.c"
 var $9=HEAP32[((4660)>>2)]; //@line 582 "dda.c"
 var $dec10=((($9)-(1))|0); //@line 582 "dda.c"
 HEAP32[((4660)>>2)]=$dec10; //@line 582 "dda.c"
 var $total_steps11=(($dda+44)|0); //@line 583 "dda.c"
 var $10=HEAP32[(($total_steps11)>>2)]; //@line 583 "dda.c"
 var $11=HEAP32[((4644)>>2)]; //@line 583 "dda.c"
 var $add12=((($11)+($10))|0); //@line 583 "dda.c"
 HEAP32[((4644)>>2)]=$add12; //@line 583 "dda.c"
 var $12=$dec10;label=7;break; //@line 584 "dda.c"
 case 7: 
 var $12;
 var $13=HEAP32[((4664)>>2)]; //@line 596 "dda.c"
 var $tobool15=($13|0)==0; //@line 596 "dda.c"
 if($tobool15){var $17=0;label=10;break;}else{label=8;break;} //@line 596 "dda.c"
 case 8: 
 var $arrayidx18=(($dda+36)|0); //@line 597 "dda.c"
 var $14=HEAP32[(($arrayidx18)>>2)]; //@line 597 "dda.c"
 var $15=HEAP32[((4648)>>2)]; //@line 597 "dda.c"
 var $sub19=((($15)-($14))|0); //@line 597 "dda.c"
 HEAP32[((4648)>>2)]=$sub19; //@line 597 "dda.c"
 var $cmp20=($sub19|0)<0; //@line 598 "dda.c"
 if($cmp20){label=9;break;}else{var $17=$13;label=10;break;} //@line 598 "dda.c"
 case 9: 
 var $dec22=((($13)-(1))|0); //@line 600 "dda.c"
 HEAP32[((4664)>>2)]=$dec22; //@line 600 "dda.c"
 var $total_steps23=(($dda+44)|0); //@line 601 "dda.c"
 var $16=HEAP32[(($total_steps23)>>2)]; //@line 601 "dda.c"
 var $add24=((($sub19)+($16))|0); //@line 601 "dda.c"
 HEAP32[((4648)>>2)]=$add24; //@line 601 "dda.c"
 var $17=$dec22;label=10;break; //@line 602 "dda.c"
 case 10: 
 var $17;
 var $18=HEAP32[((4668)>>2)]; //@line 614 "dda.c"
 var $tobool27=($18|0)==0; //@line 614 "dda.c"
 if($tobool27){var $22=0;label=13;break;}else{label=11;break;} //@line 614 "dda.c"
 case 11: 
 var $arrayidx30=(($dda+40)|0); //@line 615 "dda.c"
 var $19=HEAP32[(($arrayidx30)>>2)]; //@line 615 "dda.c"
 var $20=HEAP32[((4652)>>2)]; //@line 615 "dda.c"
 var $sub31=((($20)-($19))|0); //@line 615 "dda.c"
 HEAP32[((4652)>>2)]=$sub31; //@line 615 "dda.c"
 var $cmp32=($sub31|0)<0; //@line 616 "dda.c"
 if($cmp32){label=12;break;}else{var $22=$18;label=13;break;} //@line 616 "dda.c"
 case 12: 
 var $dec36=((($18)-(1))|0); //@line 618 "dda.c"
 HEAP32[((4668)>>2)]=$dec36; //@line 618 "dda.c"
 var $total_steps37=(($dda+44)|0); //@line 619 "dda.c"
 var $21=HEAP32[(($total_steps37)>>2)]; //@line 619 "dda.c"
 var $add38=((($sub31)+($21))|0); //@line 619 "dda.c"
 HEAP32[((4652)>>2)]=$add38; //@line 619 "dda.c"
 var $22=$dec36;label=13;break; //@line 620 "dda.c"
 case 13: 
 var $22;
 var $23=HEAP32[((4672)>>2)]; //@line 669 "dda.c"
 var $inc=((($23)+(1))|0); //@line 669 "dda.c"
 HEAP32[((4672)>>2)]=$inc; //@line 669 "dda.c"
 var $24=HEAP32[((4656)>>2)]; //@line 708 "dda.c"
 var $25=$12|$24; //@line 708 "dda.c"
 var $26=$25|$17; //@line 708 "dda.c"
 var $27=$26|$22; //@line 708 "dda.c"
 var $28=($27|0)==0; //@line 708 "dda.c"
 if($28){label=16;break;}else{label=14;break;} //@line 708 "dda.c"
 case 14: 
 var $29=HEAP8[(4676)]; //@line 708 "dda.c"
 var $tobool47=(($29<<24)>>24)==0; //@line 708 "dda.c"
 if($tobool47){label=17;break;}else{label=15;break;} //@line 708 "dda.c"
 case 15: 
 var $n=(($dda+60)|0); //@line 708 "dda.c"
 var $30=HEAP32[(($n)>>2)]; //@line 708 "dda.c"
 var $cmp49=($30|0)<1; //@line 708 "dda.c"
 if($cmp49){label=16;break;}else{label=17;break;} //@line 708 "dda.c"
 case 16: 
 var $31=(($dda+24)|0); //@line 714 "dda.c"
 var $32=$31; //@line 714 "dda.c"
 var $bf_load=HEAP8[($32)]; //@line 714 "dda.c"
 var $bf_clear53=$bf_load&-7; //@line 715 "dda.c"
 var $bf_set=$bf_clear53|4; //@line 715 "dda.c"
 HEAP8[($32)]=$bf_set; //@line 715 "dda.c"
 label=18;break; //@line 729 "dda.c"
 case 17: 
 HEAP8[(3848)]=0; //@line 731 "dda.c"
 var $c=(($dda+56)|0); //@line 732 "dda.c"
 var $33=HEAP32[(($c)>>2)]; //@line 732 "dda.c"
 _setTimer($33); //@line 732 "dda.c"
 label=18;break;
 case 18: 
 _WRITE(0,0); //@line 738 "dda.c"
 _WRITE(4,0); //@line 738 "dda.c"
 return; //@line 739 "dda.c"
  default: assert(0, "bad label: " + label);
 }

}


function _dda_clock(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $call=_queue_current_movement(); //@line 765 "dda.c"
 var $0=HEAP32[((5072)>>2)]; //@line 766 "dda.c"
 var $cmp=($call|0)==($0|0); //@line 766 "dda.c"
 if($cmp){label=3;break;}else{label=2;break;} //@line 766 "dda.c"
 case 2: 
 HEAP8[(4678)]=0; //@line 767 "dda.c"
 HEAP8[(4679)]=0; //@line 767 "dda.c"
 HEAP8[(4677)]=0; //@line 767 "dda.c"
 HEAP32[((5072)>>2)]=$call; //@line 770 "dda.c"
 label=3;break; //@line 771 "dda.c"
 case 3: 
 var $cmp1=($call|0)==0; //@line 773 "dda.c"
 if($cmp1){label=18;break;}else{label=4;break;} //@line 773 "dda.c"
 case 4: 
 var $1=HEAP8[(5080)]; //@line 778 "dda.c"
 var $tobool=(($1<<24)>>24)==0; //@line 778 "dda.c"
 if($tobool){label=5;break;}else{label=18;break;} //@line 778 "dda.c"
 case 5: 
 HEAP8[(5080)]=1; //@line 780 "dda.c"
 _sei(); //@line 781 "dda.c"
 var $2=HEAP8[(3824)]; //@line 874 "dda.c"
 var $3=$2&1; //@line 874 "dda.c"
 var $tobool27=(($3<<24)>>24)==0; //@line 874 "dda.c"
 _cli(); //@line 874 "dda.c"
 var $4=HEAP32[((4672)>>2)]; //@line 875 "dda.c"
 if($tobool27){label=7;break;}else{label=6;break;} //@line 878 "dda.c"
 case 6: 
 _sei(); //@line 878 "dda.c"
 label=7;break; //@line 878 "dda.c"
 case 7: 
 var $rampup_steps32=(($call+64)|0); //@line 881 "dda.c"
 var $5=HEAP32[(($rampup_steps32)>>2)]; //@line 881 "dda.c"
 var $cmp33=($4>>>0)<($5>>>0); //@line 881 "dda.c"
 if($cmp33){label=8;break;}else{label=9;break;} //@line 881 "dda.c"
 case 8: 
 var $n=(($call+60)|0); //@line 885 "dda.c"
 HEAP32[(($n)>>2)]=$4; //@line 885 "dda.c"
 var $8=$4;label=11;break;
 case 9: 
 var $rampdown_steps37=(($call+68)|0); //@line 889 "dda.c"
 var $6=HEAP32[(($rampdown_steps37)>>2)]; //@line 889 "dda.c"
 var $cmp38=($4>>>0)<($6>>>0); //@line 889 "dda.c"
 if($cmp38){label=17;break;}else{label=10;break;} //@line 889 "dda.c"
 case 10: 
 var $total_steps41=(($call+44)|0); //@line 893 "dda.c"
 var $7=HEAP32[(($total_steps41)>>2)]; //@line 893 "dda.c"
 var $sub42=((($7)-($4))|0); //@line 893 "dda.c"
 var $n43=(($call+60)|0); //@line 893 "dda.c"
 HEAP32[(($n43)>>2)]=$sub42; //@line 893 "dda.c"
 var $8=$sub42;label=11;break;
 case 11: 
 var $8;
 var $cmp49=($8|0)==0; //@line 898 "dda.c"
 var $fast_axis=(($call+76)|0); //@line 899 "dda.c"
 var $9=HEAP8[($fast_axis)]; //@line 899 "dda.c"
 var $idxprom=($9&255); //@line 899 "dda.c"
 var $arrayidx=((816+($idxprom<<2))|0); //@line 899 "dda.c"
 var $call52=_pgm_read_dword($arrayidx); //@line 899 "dda.c"
 if($cmp49){var $move_c_0=$call52;label=13;break;}else{label=12;break;} //@line 898 "dda.c"
 case 12: 
 var $n48=(($call+60)|0); //@line 898 "dda.c"
 var $10=HEAP32[(($n48)>>2)]; //@line 905 "dda.c"
 var $conv59=(($10)&65535); //@line 905 "dda.c"
 var $call60=_int_inv_sqrt($conv59); //@line 905 "dda.c"
 var $conv61=($call60&65535); //@line 905 "dda.c"
 var $mul62=(Math_imul($conv61,$call52)|0); //@line 905 "dda.c"
 var $shr=$mul62>>13; //@line 905 "dda.c"
 var $move_c_0=$shr;label=13;break;
 case 13: 
 var $move_c_0;
 var $c_min=(($call+72)|0); //@line 910 "dda.c"
 var $11=HEAP32[(($c_min)>>2)]; //@line 910 "dda.c"
 var $cmp64=($move_c_0>>>0)<($11>>>0); //@line 910 "dda.c"
 if($cmp64){label=14;break;}else{var $move_c_1=$move_c_0;label=15;break;} //@line 910 "dda.c"
 case 14: 
 HEAP32[(($rampup_steps32)>>2)]=$4; //@line 919 "dda.c"
 var $total_steps69=(($call+44)|0); //@line 920 "dda.c"
 var $12=HEAP32[(($total_steps69)>>2)]; //@line 920 "dda.c"
 var $sub71=((($12)-($4))|0); //@line 920 "dda.c"
 var $rampdown_steps72=(($call+68)|0); //@line 920 "dda.c"
 HEAP32[(($rampdown_steps72)>>2)]=$sub71; //@line 920 "dda.c"
 var $move_c_1=$11;label=15;break; //@line 922 "dda.c"
 case 15: 
 var $move_c_1;
 var $13=HEAP8[(3824)]; //@line 925 "dda.c"
 var $14=$13&1; //@line 925 "dda.c"
 var $tobool75=(($14<<24)>>24)==0; //@line 925 "dda.c"
 _cli(); //@line 925 "dda.c"
 var $c=(($call+56)|0); //@line 926 "dda.c"
 HEAP32[(($c)>>2)]=$move_c_1; //@line 926 "dda.c"
 if($tobool75){label=17;break;}else{label=16;break;} //@line 927 "dda.c"
 case 16: 
 _sei(); //@line 927 "dda.c"
 label=17;break; //@line 927 "dda.c"
 case 17: 
 _cli(); //@line 931 "dda.c"
 HEAP8[(5080)]=0; //@line 932 "dda.c"
 label=18;break; //@line 933 "dda.c"
 case 18: 
 return; //@line 933 "dda.c"
  default: assert(0, "bad label: " + label);
 }

}


function _update_current_position(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP8[(4680)]; //@line 937 "dda.c"
 var $idxprom=($0&255); //@line 937 "dda.c"
 var $arrayidx=((4000+((($idxprom)*(80))&-1))|0); //@line 937 "dda.c"
 var $call=_queue_empty(); //@line 949 "dda.c"
 var $tobool=(($call<<24)>>24)==0; //@line 949 "dda.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 949 "dda.c"
 case 2: 
 assert(16 % 1 === 0);HEAP32[((5088)>>2)]=HEAP32[((3800)>>2)];HEAP32[((5092)>>2)]=HEAP32[((3804)>>2)];HEAP32[((5096)>>2)]=HEAP32[((3808)>>2)];HEAP32[((5100)>>2)]=HEAP32[((3812)>>2)]; //@line 951 "dda.c"
 label=7;break;
 case 3: 
 var $1=((4000+((($idxprom)*(80))&-1)+24)|0); //@line 954 "dda.c"
 var $2=$1; //@line 954 "dda.c"
 var $bf_load=HEAP8[($2)]; //@line 954 "dda.c"
 var $bf_clear=$bf_load&2; //@line 954 "dda.c"
 var $tobool6=(($bf_clear<<24)>>24)==0; //@line 954 "dda.c"
 if($tobool6){label=7;break;}else{var $i_114=0;var $conv915=0;label=4;break;} //@line 954 "dda.c"
 case 4: 
 var $conv915;
 var $i_114;
 var $arrayidx14=((4000+((($idxprom)*(80))&-1)+($conv915<<2))|0); //@line 956 "dda.c"
 var $3=HEAP32[(($arrayidx14)>>2)]; //@line 956 "dda.c"
 var $call15=_get_direction($arrayidx,$i_114); //@line 957 "dda.c"
 var $conv16=(($call15<<24)>>24); //@line 957 "dda.c"
 var $arrayidx18=((4656+($conv915<<2))|0); //@line 957 "dda.c"
 var $4=HEAP32[(($arrayidx18)>>2)]; //@line 957 "dda.c"
 var $mul=((($4)*(1000))&-1); //@line 957 "dda.c"
 var $arrayidx20=((16+($conv915<<2))|0); //@line 962 "dda.c"
 var $call21=_pgm_read_dword($arrayidx20); //@line 962 "dda.c"
 var $div=(((($mul>>>0))/(($call21>>>0)))&-1); //@line 962 "dda.c"
 var $mul22=(Math_imul($div,$conv16)|0); //@line 962 "dda.c"
 var $sub=((($3)-($mul22))|0); //@line 962 "dda.c"
 var $arrayidx24=((5088+($conv915<<2))|0); //@line 962 "dda.c"
 HEAP32[(($arrayidx24)>>2)]=$sub; //@line 962 "dda.c"
 var $inc26=((($i_114)+(1))&255); //@line 955 "dda.c"
 var $conv9=($inc26&255); //@line 955 "dda.c"
 var $cmp10=($inc26&255)<4; //@line 955 "dda.c"
 if($cmp10){var $i_114=$inc26;var $conv915=$conv9;label=4;break;}else{label=5;break;} //@line 955 "dda.c"
 case 5: 
 var $e_relative=((4000+((($idxprom)*(80))&-1)+20)|0); //@line 965 "dda.c"
 var $bf_load29=HEAP8[($e_relative)]; //@line 965 "dda.c"
 var $bf_clear30=$bf_load29&1; //@line 965 "dda.c"
 var $tobool31=(($bf_clear30<<24)>>24)==0; //@line 965 "dda.c"
 if($tobool31){label=7;break;}else{label=6;break;} //@line 965 "dda.c"
 case 6: 
 var $5=HEAP32[((4668)>>2)]; //@line 966 "dda.c"
 var $mul33=((($5)*(1000))&-1); //@line 966 "dda.c"
 var $call34=_pgm_read_dword(28); //@line 967 "dda.c"
 var $div35=(((($mul33>>>0))/(($call34>>>0)))&-1); //@line 967 "dda.c"
 HEAP32[((5100)>>2)]=$div35; //@line 967 "dda.c"
 label=7;break; //@line 967 "dda.c"
 case 7: 
 return; //@line 971 "dda.c"
  default: assert(0, "bad label: " + label);
 }

}


function _set_direction($dda,$n,$delta){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $delta_lobit=$delta>>>31; //@line 86 "dda.c"
 var $0=(($delta_lobit)&255); //@line 86 "dda.c"
 var $_not=$0^1; //@line 86 "dda.c"
 if((($n<<24)>>24)==0){ label=2;break;}else if((($n<<24)>>24)==1){ label=3;break;}else if((($n<<24)>>24)==2){ label=4;break;}else if((($n<<24)>>24)==3){ label=5;break;}else{label=6;break;}
 case 2: 
 var $1=(($dda+24)|0); //@line 89 "dda.c"
 var $2=$1; //@line 89 "dda.c"
 var $bf_load=HEAP8[($2)]; //@line 89 "dda.c"
 var $bf_shl=$_not<<4; //@line 89 "dda.c"
 var $bf_clear=$bf_load&-17; //@line 89 "dda.c"
 var $bf_set=$bf_clear|$bf_shl; //@line 89 "dda.c"
 HEAP8[($2)]=$bf_set; //@line 89 "dda.c"
 label=6;break; //@line 89 "dda.c"
 case 3: 
 var $3=(($dda+24)|0); //@line 91 "dda.c"
 var $4=$3; //@line 91 "dda.c"
 var $bf_load8=HEAP8[($4)]; //@line 91 "dda.c"
 var $bf_shl10=$_not<<5; //@line 91 "dda.c"
 var $bf_clear11=$bf_load8&-33; //@line 91 "dda.c"
 var $bf_set12=$bf_clear11|$bf_shl10; //@line 91 "dda.c"
 HEAP8[($4)]=$bf_set12; //@line 91 "dda.c"
 label=6;break; //@line 91 "dda.c"
 case 4: 
 var $5=(($dda+24)|0); //@line 93 "dda.c"
 var $6=$5; //@line 93 "dda.c"
 var $bf_load18=HEAP8[($6)]; //@line 93 "dda.c"
 var $bf_shl20=$_not<<6; //@line 93 "dda.c"
 var $bf_clear21=$bf_load18&-65; //@line 93 "dda.c"
 var $bf_set22=$bf_clear21|$bf_shl20; //@line 93 "dda.c"
 HEAP8[($6)]=$bf_set22; //@line 93 "dda.c"
 label=6;break; //@line 93 "dda.c"
 case 5: 
 var $7=(($dda+24)|0); //@line 95 "dda.c"
 var $8=$7; //@line 95 "dda.c"
 var $bf_load28=HEAP8[($8)]; //@line 95 "dda.c"
 var $bf_shl30=$_not<<7; //@line 95 "dda.c"
 var $bf_clear31=$bf_load28&127; //@line 95 "dda.c"
 var $bf_set32=$bf_clear31|$bf_shl30; //@line 95 "dda.c"
 HEAP8[($8)]=$bf_set32; //@line 95 "dda.c"
 label=6;break; //@line 95 "dda.c"
 case 6: 
 return; //@line 96 "dda.c"
  default: assert(0, "bad label: " + label);
 }

}


function _get_direction($dda,$n){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 if((($n<<24)>>24)==0){ label=2;break;}else if((($n<<24)>>24)==1){ label=3;break;}else if((($n<<24)>>24)==2){ label=4;break;}else if((($n<<24)>>24)==3){ label=5;break;}else{label=6;break;}
 case 2: 
 var $0=(($dda+24)|0); //@line 101 "dda.c"
 var $1=$0; //@line 101 "dda.c"
 var $bf_load=HEAP8[($1)]; //@line 101 "dda.c"
 var $bf_clear=$bf_load&16; //@line 101 "dda.c"
 var $tobool=(($bf_clear<<24)>>24)==0; //@line 101 "dda.c"
 if($tobool){label=6;break;}else{var $retval_0=1;label=7;break;} //@line 101 "dda.c"
 case 3: 
 var $2=(($dda+24)|0); //@line 101 "dda.c"
 var $3=$2; //@line 101 "dda.c"
 var $bf_load7=HEAP8[($3)]; //@line 101 "dda.c"
 var $bf_clear9=$bf_load7&32; //@line 101 "dda.c"
 var $tobool11=(($bf_clear9<<24)>>24)==0; //@line 101 "dda.c"
 if($tobool11){label=6;break;}else{var $retval_0=1;label=7;break;} //@line 101 "dda.c"
 case 4: 
 var $4=(($dda+24)|0); //@line 101 "dda.c"
 var $5=$4; //@line 101 "dda.c"
 var $bf_load17=HEAP8[($5)]; //@line 101 "dda.c"
 var $bf_clear19=$bf_load17&64; //@line 101 "dda.c"
 var $tobool21=(($bf_clear19<<24)>>24)==0; //@line 101 "dda.c"
 if($tobool21){label=6;break;}else{var $retval_0=1;label=7;break;} //@line 101 "dda.c"
 case 5: 
 var $6=(($dda+24)|0); //@line 101 "dda.c"
 var $7=$6; //@line 101 "dda.c"
 var $bf_load27=HEAP8[($7)]; //@line 101 "dda.c"
 var $tobool30=(($bf_load27<<24)>>24)<0; //@line 101 "dda.c"
 if($tobool30){var $retval_0=1;label=7;break;}else{label=6;break;} //@line 101 "dda.c"
 case 6: 
 var $retval_0=-1;label=7;break; //@line 107 "dda.c"
 case 7: 
 var $retval_0;
 return $retval_0; //@line 108 "dda.c"
  default: assert(0, "bad label: " + label);
 }

}


function _power_on(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $_b=HEAP8[(632)];
 if($_b){label=3;break;}else{label=2;break;} //@line 11 "pinio.c"
 case 2: 
 HEAP8[(632)]=1;
 label=3;break; //@line 22 "pinio.c"
 case 3: 
 HEAP8[(3848)]=0; //@line 24 "pinio.c"
 return; //@line 25 "pinio.c"
  default: assert(0, "bad label: " + label);
 }

}


function _power_off(){
 var label=0;


 HEAP8[(632)]=0;
 return; //@line 44 "pinio.c"
}


function _home(){
 var label=0;


 return; //@line 68 "home.c"
}


function _home_x_negative(){
 var label=0;


 return; //@line 98 "home.c"
}


function _home_y_negative(){
 var label=0;


 return; //@line 156 "home.c"
}


function _home_z_negative(){
 var label=0;


 return; //@line 214 "home.c"
}


function _clock_tick(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP8[(5152)]; //@line 41 "clock.c"
 var $add=((($0)+(2))&255); //@line 41 "clock.c"
 HEAP8[(5152)]=$add; //@line 41 "clock.c"
 var $cmp=($add&255)>9; //@line 42 "clock.c"
 if($cmp){label=2;break;}else{label=5;break;} //@line 42 "clock.c"
 case 2: 
 var $sub=((($0)-(8))&255); //@line 43 "clock.c"
 HEAP8[(5152)]=$sub; //@line 43 "clock.c"
 HEAP8[(5128)]=1; //@line 44 "clock.c"
 var $1=HEAP8[(5136)]; //@line 46 "clock.c"
 var $inc=((($1)+(1))&255); //@line 46 "clock.c"
 HEAP8[(5136)]=$inc; //@line 46 "clock.c"
 var $cmp7=($inc&255)>24; //@line 47 "clock.c"
 if($cmp7){label=3;break;}else{label=5;break;} //@line 47 "clock.c"
 case 3: 
 HEAP8[(5136)]=0; //@line 48 "clock.c"
 HEAP8[(5112)]=1; //@line 49 "clock.c"
 var $2=HEAP8[(5144)]; //@line 51 "clock.c"
 var $inc10=((($2)+(1))&255); //@line 51 "clock.c"
 HEAP8[(5144)]=$inc10; //@line 51 "clock.c"
 var $cmp12=($inc10&255)>3; //@line 52 "clock.c"
 if($cmp12){label=4;break;}else{label=5;break;} //@line 52 "clock.c"
 case 4: 
 HEAP8[(5144)]=0; //@line 53 "clock.c"
 HEAP8[(5120)]=1; //@line 54 "clock.c"
 label=5;break; //@line 55 "clock.c"
 case 5: 
 return; //@line undefined "clock.c"
  default: assert(0, "bad label: " + label);
 }

}


function _clock(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP8[(5128)]; //@line 120 "clock.c"
 var $tobool1=(($0<<24)>>24)==0; //@line 120 "clock.c"
 if($tobool1){label=3;break;}else{label=2;break;} //@line 120 "clock.c"
 case 2: 
 _clock_10ms(); //@line 121 "clock.c"
 HEAP8[(5128)]=0; //@line 120 "clock.c"
 var $1=HEAP8[(5128)]; //@line 120 "clock.c"
 var $tobool=(($1<<24)>>24)==0; //@line 120 "clock.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 120 "clock.c"
 case 3: 
 _sim_time_warp(); //@line 124 "clock.c"
 return; //@line 126 "clock.c"
  default: assert(0, "bad label: " + label);
 }

}


function _clock_10ms(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 _temp_sensor_tick(); //@line 108 "clock.c"
 var $0=HEAP8[(5112)]; //@line 110 "clock.c"
 var $tobool1=(($0<<24)>>24)==0; //@line 110 "clock.c"
 if($tobool1){label=3;break;}else{label=2;break;} //@line 110 "clock.c"
 case 2: 
 _clock_250ms(); //@line 111 "clock.c"
 HEAP8[(5112)]=0; //@line 110 "clock.c"
 var $1=HEAP8[(5112)]; //@line 110 "clock.c"
 var $tobool=(($1<<24)>>24)==0; //@line 110 "clock.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 110 "clock.c"
 case 3: 
 return; //@line 113 "clock.c"
  default: assert(0, "bad label: " + label);
 }

}


function _clock_250ms(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $call=_heaters_all_zero(); //@line 65 "clock.c"
 var $tobool=(($call<<24)>>24)==0; //@line 65 "clock.c"
 if($tobool){label=6;break;}else{label=2;break;} //@line 65 "clock.c"
 case 2: 
 var $0=HEAP8[(3848)]; //@line 66 "clock.c"
 var $cmp=($0&255)>120; //@line 66 "clock.c"
 if($cmp){label=3;break;}else{label=4;break;} //@line 66 "clock.c"
 case 3: 
 _power_off(); //@line 67 "clock.c"
 label=6;break; //@line 68 "clock.c"
 case 4: 
 var $1=HEAP8[(3824)]; //@line 70 "clock.c"
 var $2=$1&1; //@line 70 "clock.c"
 var $tobool3=(($2<<24)>>24)==0; //@line 70 "clock.c"
 _cli(); //@line 70 "clock.c"
 var $3=HEAP8[(3848)]; //@line 71 "clock.c"
 var $inc=((($3)+(1))&255); //@line 71 "clock.c"
 HEAP8[(3848)]=$inc; //@line 71 "clock.c"
 if($tobool3){label=6;break;}else{label=5;break;} //@line 72 "clock.c"
 case 5: 
 _sei(); //@line 72 "clock.c"
 label=6;break; //@line 72 "clock.c"
 case 6: 
 var $4=HEAP8[(5120)]; //@line 76 "clock.c"
 var $tobool91=(($4<<24)>>24)==0; //@line 76 "clock.c"
 if($tobool91){label=8;break;}else{label=7;break;} //@line 76 "clock.c"
 case 7: 
 HEAP8[(5120)]=0; //@line 76 "clock.c"
 var $5=HEAP8[(5120)]; //@line 76 "clock.c"
 var $tobool9=(($5<<24)>>24)==0; //@line 76 "clock.c"
 if($tobool9){label=8;break;}else{label=7;break;} //@line 76 "clock.c"
 case 8: 
 return; //@line 98 "clock.c"
  default: assert(0, "bad label: " + label);
 }

}


function _process_gcode_command(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $$etemp$0=3912;
 var $ld$1$0=(($$etemp$0)|0);
 var $bf_load$0$preadd$=HEAP32[(($ld$1$0)>>2)];
 var $bf_load$0=$bf_load$0$preadd$&16777215;
 var $$etemp$2$0=16384;
 var $bf_cast$0=((($bf_load$0<<8)>>8))&$$etemp$2$0;
 var $bf_cast=$bf_cast$0&16777215;
 var $$etemp$3$0=0;
 var $tobool$0=((((($bf_cast$0<<8)>>8)))|0)==(($$etemp$3$0<<8)>>8);
 var $tobool=$tobool$0&16777215;
 if($tobool){label=3;break;}else{label=2;break;} //@line 51 "gcode_process.c"
 case 2: 
 var $0=HEAP32[((3800)>>2)]; //@line 52 "gcode_process.c"
 var $1=HEAP32[((3920)>>2)]; //@line 52 "gcode_process.c"
 var $add=((($1)+($0))|0); //@line 52 "gcode_process.c"
 HEAP32[((3920)>>2)]=$add; //@line 52 "gcode_process.c"
 var $2=HEAP32[((3804)>>2)]; //@line 53 "gcode_process.c"
 var $3=HEAP32[((3924)>>2)]; //@line 53 "gcode_process.c"
 var $add1=((($3)+($2))|0); //@line 53 "gcode_process.c"
 HEAP32[((3924)>>2)]=$add1; //@line 53 "gcode_process.c"
 var $4=HEAP32[((3808)>>2)]; //@line 54 "gcode_process.c"
 var $5=HEAP32[((3928)>>2)]; //@line 54 "gcode_process.c"
 var $add2=((($5)+($4))|0); //@line 54 "gcode_process.c"
 HEAP32[((3928)>>2)]=$add2; //@line 54 "gcode_process.c"
 label=3;break; //@line 55 "gcode_process.c"
 case 3: 
 var $$etemp$4$0=49152;
 var $6$0=((($bf_load$0<<8)>>8))&$$etemp$4$0;
 var $6=$6$0&16777215;
 var $$etemp$5$0=0;
 var $7$0=((((($6$0<<8)>>8)))|0)==(($$etemp$5$0<<8)>>8);
 var $7=$7$0&16777215;
 var $bf_load17=HEAP8[(3940)]; //@line 62 "gcode_process.c"
 var $bf_clear18=$bf_load17&-2; //@line 62 "gcode_process.c"
 var $bf_set=$bf_load17|1; //@line 60 "gcode_process.c"
 var $storemerge=($7?$bf_clear18:$bf_set); //@line 59 "gcode_process.c"
 HEAP8[(3940)]=$storemerge; //@line 60 "gcode_process.c"
 var $$etemp$6$0=512;
 var $bf_cast23$0=((($bf_load$0<<8)>>8))&$$etemp$6$0;
 var $bf_cast23=$bf_cast23$0&16777215;
 var $$etemp$7$0=0;
 var $tobool24$0=((((($bf_cast23$0<<8)>>8)))|0)==(($$etemp$7$0<<8)>>8);
 var $tobool24=$tobool24$0&16777215;
 if($tobool24){label=5;break;}else{label=4;break;} //@line 93 "gcode_process.c"
 case 4: 
 var $8=HEAP8[(3950)]; //@line 100 "gcode_process.c"
 HEAP8[(3904)]=$8; //@line 100 "gcode_process.c"
 label=5;break; //@line 101 "gcode_process.c"
 case 5: 
 var $$etemp$8$0=1;
 var $bf_cast29$0=((($bf_load$0<<8)>>8))&$$etemp$8$0;
 var $bf_cast29=$bf_cast29$0&16777215;
 var $$etemp$9$0=0;
 var $tobool30$0=((((($bf_cast29$0<<8)>>8)))|0)==(($$etemp$9$0<<8)>>8);
 var $tobool30=$tobool30$0&16777215;
 if($tobool30){label=42;break;}else{label=6;break;} //@line 103 "gcode_process.c"
 case 6: 
 var $9=HEAP8[(3915)]; //@line 105 "gcode_process.c"
 var $conv32=($9&255); //@line 105 "gcode_process.c"
 switch(($conv32|0)){case 20:{ label=11;break;}case 21:{ label=12;break;}case 30:{ label=13;break;}case 28:{ label=14;break;}case 90:{ label=22;break;}case 91:{ label=23;break;}case 92:{ label=24;break;}case 161:{ label=35;break;}case 0:{ label=7;break;}case 1:{ label=8;break;}case 162:{ label=85;break;}case 4:{ label=9;break;}default:{label=41;break;}}break;
 case 7: 
 var $10=HEAP32[((3936)>>2)]; //@line 113 "gcode_process.c"
 HEAP32[((3936)>>2)]=400; //@line 114 "gcode_process.c"
 _enqueue_home(3920,0,0); //@line 36 "./dda_queue.h"
 HEAP32[((3936)>>2)]=$10; //@line 116 "gcode_process.c"
 label=85;break; //@line 117 "gcode_process.c"
 case 8: 
 _enqueue_home(3920,0,0); //@line 36 "./dda_queue.h"
 label=85;break; //@line 127 "gcode_process.c"
 case 9: 
 _queue_wait(); //@line 142 "gcode_process.c"
 var $$etemp$10=3912;
 var $ld$11$0=(($$etemp$10)|0);
 var $bf_load35$0$preadd$=HEAP32[(($ld$11$0)>>2)];
 var $bf_load35$0=$bf_load35$0$preadd$&16777215;
 var $$etemp$12$0=256;
 var $bf_cast38$0=((($bf_load35$0<<8)>>8))&$$etemp$12$0;
 var $bf_cast38=$bf_cast38$0&16777215;
 var $$etemp$13$0=0;
 var $tobool39$0=((((($bf_cast38$0<<8)>>8)))|0)==(($$etemp$13$0<<8)>>8);
 var $tobool39=$tobool39$0&16777215;
 var $11=HEAP16[((3948)>>1)];
 var $cmp=(($11<<16)>>16)==0; //@line 145 "gcode_process.c"
 var $or_cond6=$tobool39|$cmp; //@line 144 "gcode_process.c"
 if($or_cond6){label=85;break;}else{label=10;break;} //@line 144 "gcode_process.c"
 case 10: 
 _clock(); //@line 146 "gcode_process.c"
 _delay_ms(1); //@line 147 "gcode_process.c"
 var $12=HEAP16[((3948)>>1)]; //@line 145 "gcode_process.c"
 var $dec=((($12)-(1))&65535); //@line 145 "gcode_process.c"
 HEAP16[((3948)>>1)]=$dec; //@line 145 "gcode_process.c"
 var $cmp_old=(($dec<<16)>>16)==0; //@line 145 "gcode_process.c"
 if($cmp_old){label=85;break;}else{label=10;break;} //@line 145 "gcode_process.c"
 case 11: 
 var $$etemp$14$0=65536;
 var $bf_set47$0=((($bf_load$0<<8)>>8))|$$etemp$14$0;
 var $bf_set47=$bf_set47$0&16777215;
 var $$etemp$15=3912;
 var $st$16$0=(($$etemp$15)|0);
 tempBigInt=$bf_set47$0;HEAP8[($st$16$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$16$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$16$0)+(2))|0)]=tempBigInt&0xff;
 label=85;break; //@line 160 "gcode_process.c"
 case 12: 
 var $$etemp$17$0=16711679;
 var $bf_clear50$0=((($bf_load$0<<8)>>8))&$$etemp$17$0;
 var $bf_clear50=$bf_clear50$0&16777215;
 var $$etemp$18=3912;
 var $st$19$0=(($$etemp$18)|0);
 tempBigInt=$bf_clear50$0;HEAP8[($st$19$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$19$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$19$0)+(2))|0)]=tempBigInt&0xff;
 label=85;break; //@line 170 "gcode_process.c"
 case 13: 
 _enqueue_home(3920,0,0); //@line 36 "./dda_queue.h"
 label=14;break; //@line 176 "gcode_process.c"
 case 14: 
 _queue_wait(); //@line 196 "gcode_process.c"
 var $$etemp$20=3912;
 var $ld$21$0=(($$etemp$20)|0);
 var $bf_load53$0$preadd$=HEAP32[(($ld$21$0)>>2)];
 var $bf_load53$0=$bf_load53$0$preadd$&16777215;
 var $$etemp$22$0=4;
 var $bf_cast56$0=((($bf_load53$0<<8)>>8))&$$etemp$22$0;
 var $bf_cast56=$bf_cast56$0&16777215;
 var $$etemp$23$0=0;
 var $tobool57$0=((((($bf_cast56$0<<8)>>8)))|0)==(($$etemp$23$0<<8)>>8);
 var $tobool57=$tobool57$0&16777215;
 if($tobool57){var $axisSelected_0=0;var $bf_load60$0=$bf_load53$0;label=16;break;}else{label=15;break;} //@line 198 "gcode_process.c"
 case 15: 
 _home_x_negative(); //@line 200 "gcode_process.c"
 var $$etemp$24=3912;
 var $ld$25$0=(($$etemp$24)|0);
 var $bf_load60_pre$0$preadd$=HEAP32[(($ld$25$0)>>2)];
 var $bf_load60_pre$0=$bf_load60_pre$0$preadd$&16777215;
 var $axisSelected_0=1;var $bf_load60$0=$bf_load60_pre$0;label=16;break; //@line 205 "gcode_process.c"
 case 16: 
 var $bf_load60$0;
 var $axisSelected_0;
 var $$etemp$26$0=8;
 var $bf_cast63$0=((($bf_load60$0<<8)>>8))&$$etemp$26$0;
 var $bf_cast63=$bf_cast63$0&16777215;
 var $$etemp$27$0=0;
 var $tobool64$0=((((($bf_cast63$0<<8)>>8)))|0)==(($$etemp$27$0<<8)>>8);
 var $tobool64=$tobool64$0&16777215;
 if($tobool64){var $axisSelected_1=$axisSelected_0;var $bf_load67$0=$bf_load60$0;label=18;break;}else{label=17;break;} //@line 206 "gcode_process.c"
 case 17: 
 _home_y_negative(); //@line 208 "gcode_process.c"
 var $$etemp$28=3912;
 var $ld$29$0=(($$etemp$28)|0);
 var $bf_load67_pre$0$preadd$=HEAP32[(($ld$29$0)>>2)];
 var $bf_load67_pre$0=$bf_load67_pre$0$preadd$&16777215;
 var $axisSelected_1=1;var $bf_load67$0=$bf_load67_pre$0;label=18;break; //@line 213 "gcode_process.c"
 case 18: 
 var $bf_load67$0;
 var $axisSelected_1;
 var $$etemp$30$0=16;
 var $bf_cast70$0=((($bf_load67$0<<8)>>8))&$$etemp$30$0;
 var $bf_cast70=$bf_cast70$0&16777215;
 var $$etemp$31$0=0;
 var $tobool71$0=((((($bf_cast70$0<<8)>>8)))|0)==(($$etemp$31$0<<8)>>8);
 var $tobool71=$tobool71$0&16777215;
 if($tobool71){label=20;break;}else{label=19;break;} //@line 214 "gcode_process.c"
 case 19: 
 _home_z_negative(); //@line 216 "gcode_process.c"
 label=85;break; //@line 224 "gcode_process.c"
 case 20: 
 var $tobool74=(($axisSelected_1<<24)>>24)==0; //@line 224 "gcode_process.c"
 if($tobool74){label=21;break;}else{label=85;break;} //@line 224 "gcode_process.c"
 case 21: 
 _home(); //@line 225 "gcode_process.c"
 label=85;break; //@line 226 "gcode_process.c"
 case 22: 
 var $$etemp$32$0=16760831;
 var $bf_clear79$0=((($bf_load$0<<8)>>8))&$$etemp$32$0;
 var $bf_clear79=$bf_clear79$0&16777215;
 var $$etemp$33=3912;
 var $st$34$0=(($$etemp$33)|0);
 tempBigInt=$bf_clear79$0;HEAP8[($st$34$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$34$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$34$0)+(2))|0)]=tempBigInt&0xff;
 label=85;break; //@line 245 "gcode_process.c"
 case 23: 
 var $$etemp$35$0=16384;
 var $bf_set83$0=((($bf_load$0<<8)>>8))|$$etemp$35$0;
 var $bf_set83=$bf_set83$0&16777215;
 var $$etemp$36=3912;
 var $st$37$0=(($$etemp$36)|0);
 tempBigInt=$bf_set83$0;HEAP8[($st$37$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$37$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$37$0)+(2))|0)]=tempBigInt&0xff;
 label=85;break; //@line 257 "gcode_process.c"
 case 24: 
 _queue_wait(); //@line 267 "gcode_process.c"
 var $$etemp$38=3912;
 var $ld$39$0=(($$etemp$38)|0);
 var $bf_load85$0$preadd$=HEAP32[(($ld$39$0)>>2)];
 var $bf_load85$0=$bf_load85$0$preadd$&16777215;
 var $$etemp$40$0=4;
 var $bf_cast88$0=((($bf_load85$0<<8)>>8))&$$etemp$40$0;
 var $bf_cast88=$bf_cast88$0&16777215;
 var $$etemp$41$0=0;
 var $tobool89$0=((((($bf_cast88$0<<8)>>8)))|0)==(($$etemp$41$0<<8)>>8);
 var $tobool89=$tobool89$0&16777215;
 if($tobool89){var $axisSelected_3=0;label=26;break;}else{label=25;break;} //@line 269 "gcode_process.c"
 case 25: 
 var $13=HEAP32[((3920)>>2)]; //@line 270 "gcode_process.c"
 HEAP32[((3800)>>2)]=$13; //@line 270 "gcode_process.c"
 var $axisSelected_3=1;label=26;break; //@line 272 "gcode_process.c"
 case 26: 
 var $axisSelected_3;
 var $$etemp$42$0=8;
 var $bf_cast95$0=((($bf_load85$0<<8)>>8))&$$etemp$42$0;
 var $bf_cast95=$bf_cast95$0&16777215;
 var $$etemp$43$0=0;
 var $tobool96$0=((((($bf_cast95$0<<8)>>8)))|0)==(($$etemp$43$0<<8)>>8);
 var $tobool96=$tobool96$0&16777215;
 if($tobool96){var $axisSelected_4=$axisSelected_3;label=28;break;}else{label=27;break;} //@line 273 "gcode_process.c"
 case 27: 
 var $14=HEAP32[((3924)>>2)]; //@line 274 "gcode_process.c"
 HEAP32[((3804)>>2)]=$14; //@line 274 "gcode_process.c"
 var $axisSelected_4=1;label=28;break; //@line 276 "gcode_process.c"
 case 28: 
 var $axisSelected_4;
 var $$etemp$44$0=16;
 var $bf_cast102$0=((($bf_load85$0<<8)>>8))&$$etemp$44$0;
 var $bf_cast102=$bf_cast102$0&16777215;
 var $$etemp$45$0=0;
 var $tobool103$0=((((($bf_cast102$0<<8)>>8)))|0)==(($$etemp$45$0<<8)>>8);
 var $tobool103=$tobool103$0&16777215;
 if($tobool103){var $axisSelected_5=$axisSelected_4;label=30;break;}else{label=29;break;} //@line 277 "gcode_process.c"
 case 29: 
 var $15=HEAP32[((3928)>>2)]; //@line 278 "gcode_process.c"
 HEAP32[((3808)>>2)]=$15; //@line 278 "gcode_process.c"
 var $axisSelected_5=1;label=30;break; //@line 280 "gcode_process.c"
 case 30: 
 var $axisSelected_5;
 var $$etemp$46$0=32;
 var $bf_cast109$0=((($bf_load85$0<<8)>>8))&$$etemp$46$0;
 var $bf_cast109=$bf_cast109$0&16777215;
 var $$etemp$47$0=0;
 var $tobool110$0=((((($bf_cast109$0<<8)>>8)))|0)==(($$etemp$47$0<<8)>>8);
 var $tobool110=$tobool110$0&16777215;
 if($tobool110){label=32;break;}else{label=31;break;} //@line 281 "gcode_process.c"
 case 31: 
 var $16=HEAP32[((3932)>>2)]; //@line 282 "gcode_process.c"
 HEAP32[((3812)>>2)]=$16; //@line 282 "gcode_process.c"
 label=34;break; //@line 286 "gcode_process.c"
 case 32: 
 var $cmp114=(($axisSelected_5<<24)>>24)==0; //@line 286 "gcode_process.c"
 if($cmp114){label=33;break;}else{label=34;break;} //@line 286 "gcode_process.c"
 case 33: 
 (HEAP32[((_next_target)>>2)]=int32x4.splat(0).x,HEAP32[(((_next_target)+(4))>>2)]=int32x4.splat(0).y,HEAP32[(((_next_target)+(8))>>2)]=int32x4.splat(0).z,HEAP32[(((_next_target)+(12))>>2)]=int32x4.splat(0).w); //@line 287 "gcode_process.c"
 (HEAP32[((_startpoint)>>2)]=int32x4.splat(0).x,HEAP32[(((_startpoint)+(4))>>2)]=int32x4.splat(0).y,HEAP32[(((_startpoint)+(8))>>2)]=int32x4.splat(0).z,HEAP32[(((_startpoint)+(12))>>2)]=int32x4.splat(0).w); //@line 287 "gcode_process.c"
 label=34;break; //@line 291 "gcode_process.c"
 case 34: 
 _dda_new_startpoint(); //@line 293 "gcode_process.c"
 label=85;break; //@line 294 "gcode_process.c"
 case 35: 
 var $$etemp$48$0=4;
 var $bf_cast122$0=((($bf_load$0<<8)>>8))&$$etemp$48$0;
 var $bf_cast122=$bf_cast122$0&16777215;
 var $$etemp$49$0=0;
 var $tobool123$0=((((($bf_cast122$0<<8)>>8)))|0)==(($$etemp$49$0<<8)>>8);
 var $tobool123=$tobool123$0&16777215;
 if($tobool123){var $bf_load126$0=$bf_load$0;label=37;break;}else{label=36;break;} //@line 302 "gcode_process.c"
 case 36: 
 _home_x_negative(); //@line 303 "gcode_process.c"
 var $$etemp$50=3912;
 var $ld$51$0=(($$etemp$50)|0);
 var $bf_load126_pre$0$preadd$=HEAP32[(($ld$51$0)>>2)];
 var $bf_load126_pre$0=$bf_load126_pre$0$preadd$&16777215;
 var $bf_load126$0=$bf_load126_pre$0;label=37;break; //@line 303 "gcode_process.c"
 case 37: 
 var $bf_load126$0;
 var $$etemp$52$0=8;
 var $bf_cast129$0=((($bf_load126$0<<8)>>8))&$$etemp$52$0;
 var $bf_cast129=$bf_cast129$0&16777215;
 var $$etemp$53$0=0;
 var $tobool130$0=((((($bf_cast129$0<<8)>>8)))|0)==(($$etemp$53$0<<8)>>8);
 var $tobool130=$tobool130$0&16777215;
 if($tobool130){var $bf_load133$0=$bf_load126$0;label=39;break;}else{label=38;break;} //@line 306 "gcode_process.c"
 case 38: 
 _home_y_negative(); //@line 307 "gcode_process.c"
 var $$etemp$54=3912;
 var $ld$55$0=(($$etemp$54)|0);
 var $bf_load133_pre$0$preadd$=HEAP32[(($ld$55$0)>>2)];
 var $bf_load133_pre$0=$bf_load133_pre$0$preadd$&16777215;
 var $bf_load133$0=$bf_load133_pre$0;label=39;break; //@line 307 "gcode_process.c"
 case 39: 
 var $bf_load133$0;
 var $$etemp$56$0=16;
 var $bf_cast136$0=((($bf_load133$0<<8)>>8))&$$etemp$56$0;
 var $bf_cast136=$bf_cast136$0&16777215;
 var $$etemp$57$0=0;
 var $tobool137$0=((((($bf_cast136$0<<8)>>8)))|0)==(($$etemp$57$0<<8)>>8);
 var $tobool137=$tobool137$0&16777215;
 if($tobool137){label=85;break;}else{label=40;break;} //@line 310 "gcode_process.c"
 case 40: 
 _home_z_negative(); //@line 311 "gcode_process.c"
 label=85;break; //@line 311 "gcode_process.c"
 case 41: 
 _sersendf_P(2632,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$conv32,tempVarArgs)); STACKTOP=tempVarArgs; //@line 336 "gcode_process.c"
 label=85;break; //@line 338 "gcode_process.c"
 case 42: 
 var $$etemp$58$0=2;
 var $bf_cast146$0=((($bf_load$0<<8)>>8))&$$etemp$58$0;
 var $bf_cast146=$bf_cast146$0&16777215;
 var $$etemp$59$0=0;
 var $tobool147$0=((((($bf_cast146$0<<8)>>8)))|0)==(($$etemp$59$0<<8)>>8);
 var $tobool147=$tobool147$0&16777215;
 if($tobool147){label=85;break;}else{label=43;break;} //@line 341 "gcode_process.c"
 case 43: 
 var $17=HEAP8[(3916)]; //@line 344 "gcode_process.c"
 var $conv149=($17&255); //@line 344 "gcode_process.c"
 switch(($conv149|0)){case 0:case 2:case 84:{ label=44;break;}case 6:{ label=45;break;}case 82:{ label=46;break;}case 83:{ label=47;break;}case 3:case 101:{ label=48;break;}case 104:{ label=50;break;}case 105:{ label=55;break;}case 7:case 106:{ label=59;break;}case 112:{ label=61;break;}case 114:{ label=63;break;}case 115:{ label=64;break;}case 116:{ label=65;break;}case 119:{ label=66;break;}case 130:{ label=67;break;}case 131:{ label=71;break;}case 132:{ label=75;break;}case 133:{ label=79;break;}case 134:{ label=83;break;}case 5:case 103:case 110:case 140:{ label=85;break;}default:{label=84;break;}}break;
 case 44: 
 _queue_wait(); //@line 362 "gcode_process.c"
 _temp_set(0,0); //@line 364 "gcode_process.c"
 _power_off(); //@line 365 "gcode_process.c"
 _serial_writestr_P(3048); //@line 366 "gcode_process.c"
 label=85;break; //@line 367 "gcode_process.c"
 case 45: 
 var $18=HEAP8[(3904)]; //@line 373 "gcode_process.c"
 HEAP8[(3712)]=$18; //@line 373 "gcode_process.c"
 label=85;break; //@line 374 "gcode_process.c"
 case 46: 
 var $$etemp$60$0=16744447;
 var $bf_clear161$0=((($bf_load$0<<8)>>8))&$$etemp$60$0;
 var $bf_clear161=$bf_clear161$0&16777215;
 var $$etemp$61=3912;
 var $st$62$0=(($$etemp$61)|0);
 tempBigInt=$bf_clear161$0;HEAP8[($st$62$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$62$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$62$0)+(2))|0)]=tempBigInt&0xff;
 label=85;break; //@line 389 "gcode_process.c"
 case 47: 
 var $$etemp$63$0=32768;
 var $bf_set165$0=((($bf_load$0<<8)>>8))|$$etemp$63$0;
 var $bf_set165=$bf_set165$0&16777215;
 var $$etemp$64=3912;
 var $st$65$0=(($$etemp$64)|0);
 tempBigInt=$bf_set165$0;HEAP8[($st$65$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$65$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$65$0)+(2))|0)]=tempBigInt&0xff;
 label=85;break; //@line 399 "gcode_process.c"
 case 48: 
 var $call=_temp_achieved(); //@line 407 "gcode_process.c"
 var $cmp168=(($call<<24)>>24)==0; //@line 407 "gcode_process.c"
 if($cmp168){label=49;break;}else{label=85;break;} //@line 407 "gcode_process.c"
 case 49: 
 _enqueue_home(0,0,0); //@line 36 "./dda_queue.h"
 label=85;break; //@line 409 "gcode_process.c"
 case 50: 
 var $$etemp$66$0=128;
 var $bf_cast177$0=((($bf_load$0<<8)>>8))&$$etemp$66$0;
 var $bf_cast177=$bf_cast177$0&16777215;
 var $$etemp$67$0=0;
 var $tobool178$0=((((($bf_cast177$0<<8)>>8)))|0)==(($$etemp$67$0<<8)>>8);
 var $tobool178=$tobool178$0&16777215;
 if($tobool178){label=85;break;}else{label=51;break;} //@line 440 "gcode_process.c"
 case 51: 
 var $$etemp$68$0=256;
 var $bf_cast184$0=((($bf_load$0<<8)>>8))&$$etemp$68$0;
 var $bf_cast184=$bf_cast184$0&16777215;
 var $$etemp$69$0=0;
 var $tobool185$0=((((($bf_cast184$0<<8)>>8)))|0)==(($$etemp$69$0<<8)>>8);
 var $tobool185=$tobool185$0&16777215;
 if($tobool185){label=53;break;}else{label=52;break;} //@line 443 "gcode_process.c"
 case 52: 
 var $_pre=HEAP16[((3948)>>1)]; //@line 447 "gcode_process.c"
 var $extract_t16=(($_pre)&255);
 var $_off015=$extract_t16;label=54;break; //@line 443 "gcode_process.c"
 case 53: 
 HEAP16[((3948)>>1)]=0; //@line 444 "gcode_process.c"
 var $_off015=0;label=54;break; //@line 444 "gcode_process.c"
 case 54: 
 var $_off015;
 var $19=HEAP32[((3944)>>2)]; //@line 447 "gcode_process.c"
 var $conv189=(($19)&65535); //@line 447 "gcode_process.c"
 _temp_set($_off015,$conv189); //@line 447 "gcode_process.c"
 label=85;break; //@line 448 "gcode_process.c"
 case 55: 
 var $$etemp$70$0=256;
 var $bf_cast194$0=((($bf_load$0<<8)>>8))&$$etemp$70$0;
 var $bf_cast194=$bf_cast194$0&16777215;
 var $$etemp$71$0=0;
 var $tobool195$0=((((($bf_cast194$0<<8)>>8)))|0)==(($$etemp$71$0<<8)>>8);
 var $tobool195=$tobool195$0&16777215;
 if($tobool195){label=57;break;}else{label=56;break;} //@line 467 "gcode_process.c"
 case 56: 
 var $_pre10=HEAP16[((3948)>>1)]; //@line 469 "gcode_process.c"
 var $extract_t=(($_pre10)&255);
 var $_off0=$extract_t;label=58;break; //@line 467 "gcode_process.c"
 case 57: 
 HEAP16[((3948)>>1)]=2; //@line 468 "gcode_process.c"
 var $_off0=2;label=58;break; //@line 468 "gcode_process.c"
 case 58: 
 var $_off0;
 _temp_print($_off0); //@line 469 "gcode_process.c"
 label=85;break; //@line 470 "gcode_process.c"
 case 59: 
 var $$etemp$72$0=128;
 var $bf_cast203$0=((($bf_load$0<<8)>>8))&$$etemp$72$0;
 var $bf_cast203=$bf_cast203$0&16777215;
 var $$etemp$73$0=0;
 var $tobool204$0=((((($bf_cast203$0<<8)>>8)))|0)==(($$etemp$73$0<<8)>>8);
 var $tobool204=$tobool204$0&16777215;
 if($tobool204){label=85;break;}else{label=60;break;} //@line 493 "gcode_process.c"
 case 60: 
 var $20=HEAP16[((3948)>>1)]; //@line 495 "gcode_process.c"
 var $conv207=(($20)&255); //@line 495 "gcode_process.c"
 var $21=HEAP32[((3944)>>2)]; //@line 495 "gcode_process.c"
 var $conv208=(($21)&255); //@line 495 "gcode_process.c"
 _heater_set($conv207,$conv208); //@line 495 "gcode_process.c"
 label=85;break; //@line 496 "gcode_process.c"
 case 61: 
 _timer_stop(); //@line 540 "gcode_process.c"
 _queue_flush(); //@line 541 "gcode_process.c"
 _power_off(); //@line 542 "gcode_process.c"
 _cli(); //@line 543 "gcode_process.c"
 label=62;break; //@line 544 "gcode_process.c"
 case 62: 
 label=62;break; //@line 544 "gcode_process.c"
 case 63: 
 _update_current_position(); //@line 563 "gcode_process.c"
 var $22=HEAP32[((5088)>>2)]; //@line 564 "gcode_process.c"
 var $23=HEAP32[((5092)>>2)]; //@line 564 "gcode_process.c"
 var $24=HEAP32[((5096)>>2)]; //@line 564 "gcode_process.c"
 var $25=HEAP32[((5100)>>2)]; //@line 564 "gcode_process.c"
 var $26=HEAP32[((5104)>>2)]; //@line 564 "gcode_process.c"
 _sersendf_P(2584,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 40)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$22,HEAP32[(((tempVarArgs)+(8))>>2)]=$23,HEAP32[(((tempVarArgs)+(16))>>2)]=$24,HEAP32[(((tempVarArgs)+(24))>>2)]=$25,HEAP32[(((tempVarArgs)+(32))>>2)]=$26,tempVarArgs)); STACKTOP=tempVarArgs; //@line 564 "gcode_process.c"
 label=85;break; //@line 586 "gcode_process.c"
 case 64: 
 _sersendf_P(2064,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 24)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=1,HEAP32[(((tempVarArgs)+(8))>>2)]=1,HEAP32[(((tempVarArgs)+(16))>>2)]=1,tempVarArgs)); STACKTOP=tempVarArgs; //@line 600 "gcode_process.c"
 label=85;break; //@line 602 "gcode_process.c"
 case 65: 
 _enqueue_home(0,0,0); //@line 36 "./dda_queue.h"
 label=85;break; //@line 612 "gcode_process.c"
 case 66: 
 _power_on(); //@line 618 "gcode_process.c"
 _delay_ms(10); //@line 620 "gcode_process.c"
 _sersendf_P(1512,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 626 "gcode_process.c"
 _sersendf_P(1912,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 627 "gcode_process.c"
 _sersendf_P(1360,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 634 "gcode_process.c"
 _sersendf_P(1912,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 635 "gcode_process.c"
 _sersendf_P(1152,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 642 "gcode_process.c"
 _sersendf_P(1912,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 643 "gcode_process.c"
 label=85;break; //@line 656 "gcode_process.c"
 case 67: 
 var $$etemp$74$0=256;
 var $bf_cast220$0=((($bf_load$0<<8)>>8))&$$etemp$74$0;
 var $bf_cast220=$bf_cast220$0&16777215;
 var $$etemp$75$0=0;
 var $tobool221$0=((((($bf_cast220$0<<8)>>8)))|0)==(($$etemp$75$0<<8)>>8);
 var $tobool221=$tobool221$0&16777215;
 if($tobool221){label=68;break;}else{label=69;break;} //@line 664 "gcode_process.c"
 case 68: 
 HEAP16[((3948)>>1)]=0; //@line 665 "gcode_process.c"
 label=69;break; //@line 665 "gcode_process.c"
 case 69: 
 var $$etemp$76$0=128;
 var $bf_cast227$0=((($bf_load$0<<8)>>8))&$$etemp$76$0;
 var $bf_cast227=$bf_cast227$0&16777215;
 var $$etemp$77$0=0;
 var $tobool228$0=((((($bf_cast227$0<<8)>>8)))|0)==(($$etemp$77$0<<8)>>8);
 var $tobool228=$tobool228$0&16777215;
 if($tobool228){label=85;break;}else{label=70;break;} //@line 668 "gcode_process.c"
 case 70: 
 var $27=HEAP16[((3948)>>1)]; //@line 669 "gcode_process.c"
 var $conv230=(($27)&255); //@line 669 "gcode_process.c"
 var $28=HEAP32[((3944)>>2)]; //@line 669 "gcode_process.c"
 _pid_set_p($conv230,$28); //@line 669 "gcode_process.c"
 label=85;break; //@line 669 "gcode_process.c"
 case 71: 
 var $$etemp$78$0=256;
 var $bf_cast236$0=((($bf_load$0<<8)>>8))&$$etemp$78$0;
 var $bf_cast236=$bf_cast236$0&16777215;
 var $$etemp$79$0=0;
 var $tobool237$0=((((($bf_cast236$0<<8)>>8)))|0)==(($$etemp$79$0<<8)>>8);
 var $tobool237=$tobool237$0&16777215;
 if($tobool237){label=72;break;}else{label=73;break;} //@line 677 "gcode_process.c"
 case 72: 
 HEAP16[((3948)>>1)]=0; //@line 678 "gcode_process.c"
 label=73;break; //@line 678 "gcode_process.c"
 case 73: 
 var $$etemp$80$0=128;
 var $bf_cast243$0=((($bf_load$0<<8)>>8))&$$etemp$80$0;
 var $bf_cast243=$bf_cast243$0&16777215;
 var $$etemp$81$0=0;
 var $tobool244$0=((((($bf_cast243$0<<8)>>8)))|0)==(($$etemp$81$0<<8)>>8);
 var $tobool244=$tobool244$0&16777215;
 if($tobool244){label=85;break;}else{label=74;break;} //@line 680 "gcode_process.c"
 case 74: 
 var $29=HEAP16[((3948)>>1)]; //@line 681 "gcode_process.c"
 var $conv246=(($29)&255); //@line 681 "gcode_process.c"
 var $30=HEAP32[((3944)>>2)]; //@line 681 "gcode_process.c"
 _pid_set_i($conv246,$30); //@line 681 "gcode_process.c"
 label=85;break; //@line 681 "gcode_process.c"
 case 75: 
 var $$etemp$82$0=256;
 var $bf_cast252$0=((($bf_load$0<<8)>>8))&$$etemp$82$0;
 var $bf_cast252=$bf_cast252$0&16777215;
 var $$etemp$83$0=0;
 var $tobool253$0=((((($bf_cast252$0<<8)>>8)))|0)==(($$etemp$83$0<<8)>>8);
 var $tobool253=$tobool253$0&16777215;
 if($tobool253){label=76;break;}else{label=77;break;} //@line 689 "gcode_process.c"
 case 76: 
 HEAP16[((3948)>>1)]=0; //@line 690 "gcode_process.c"
 label=77;break; //@line 690 "gcode_process.c"
 case 77: 
 var $$etemp$84$0=128;
 var $bf_cast259$0=((($bf_load$0<<8)>>8))&$$etemp$84$0;
 var $bf_cast259=$bf_cast259$0&16777215;
 var $$etemp$85$0=0;
 var $tobool260$0=((((($bf_cast259$0<<8)>>8)))|0)==(($$etemp$85$0<<8)>>8);
 var $tobool260=$tobool260$0&16777215;
 if($tobool260){label=85;break;}else{label=78;break;} //@line 692 "gcode_process.c"
 case 78: 
 var $31=HEAP16[((3948)>>1)]; //@line 693 "gcode_process.c"
 var $conv262=(($31)&255); //@line 693 "gcode_process.c"
 var $32=HEAP32[((3944)>>2)]; //@line 693 "gcode_process.c"
 _pid_set_d($conv262,$32); //@line 693 "gcode_process.c"
 label=85;break; //@line 693 "gcode_process.c"
 case 79: 
 var $$etemp$86$0=256;
 var $bf_cast268$0=((($bf_load$0<<8)>>8))&$$etemp$86$0;
 var $bf_cast268=$bf_cast268$0&16777215;
 var $$etemp$87$0=0;
 var $tobool269$0=((((($bf_cast268$0<<8)>>8)))|0)==(($$etemp$87$0<<8)>>8);
 var $tobool269=$tobool269$0&16777215;
 if($tobool269){label=80;break;}else{label=81;break;} //@line 700 "gcode_process.c"
 case 80: 
 HEAP16[((3948)>>1)]=0; //@line 701 "gcode_process.c"
 label=81;break; //@line 701 "gcode_process.c"
 case 81: 
 var $$etemp$88$0=128;
 var $bf_cast275$0=((($bf_load$0<<8)>>8))&$$etemp$88$0;
 var $bf_cast275=$bf_cast275$0&16777215;
 var $$etemp$89$0=0;
 var $tobool276$0=((((($bf_cast275$0<<8)>>8)))|0)==(($$etemp$89$0<<8)>>8);
 var $tobool276=$tobool276$0&16777215;
 if($tobool276){label=85;break;}else{label=82;break;} //@line 703 "gcode_process.c"
 case 82: 
 var $33=HEAP16[((3948)>>1)]; //@line 704 "gcode_process.c"
 var $conv278=(($33)&255); //@line 704 "gcode_process.c"
 var $34=HEAP32[((3944)>>2)]; //@line 704 "gcode_process.c"
 _pid_set_i_limit($conv278,$34); //@line 704 "gcode_process.c"
 label=85;break; //@line 704 "gcode_process.c"
 case 83: 
 _heater_save_settings(); //@line 710 "gcode_process.c"
 label=85;break; //@line 711 "gcode_process.c"
 case 84: 
 _sersendf_P(1016,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$conv149,tempVarArgs)); STACKTOP=tempVarArgs; //@line 760 "gcode_process.c"
 label=85;break; //@line 762 "gcode_process.c"
 case 85: 
 STACKTOP=sp;return; //@line 764 "gcode_process.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serwrite_hex4($v){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $and=$v&15; //@line 13 "sermsg.c"
 var $cmp=($and&255)<10; //@line 14 "sermsg.c"
 if($cmp){label=2;break;}else{label=3;break;} //@line 14 "sermsg.c"
 case 2: 
 var $add3=$and|48; //@line 15 "sermsg.c"
 _serial_writechar($add3); //@line 15 "sermsg.c"
 label=4;break; //@line 15 "sermsg.c"
 case 3: 
 var $add7=((($and)+(55))&255); //@line 17 "sermsg.c"
 _serial_writechar($add7); //@line 17 "sermsg.c"
 label=4;break;
 case 4: 
 return; //@line 18 "sermsg.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serwrite_hex8($v){
 var label=0;


 var $shr2=($v&255)>>>4; //@line 24 "sermsg.c"
 _serwrite_hex4($shr2); //@line 24 "sermsg.c"
 var $and=$v&15; //@line 25 "sermsg.c"
 _serwrite_hex4($and); //@line 25 "sermsg.c"
 return; //@line 26 "sermsg.c"
}


function _serwrite_hex16($v){
 var label=0;


 var $shr2=($v&65535)>>>8; //@line 32 "sermsg.c"
 var $conv1=(($shr2)&255); //@line 32 "sermsg.c"
 _serwrite_hex8($conv1); //@line 32 "sermsg.c"
 var $conv3=(($v)&255); //@line 33 "sermsg.c"
 _serwrite_hex8($conv3); //@line 33 "sermsg.c"
 return; //@line 34 "sermsg.c"
}


function _serwrite_hex32($v){
 var label=0;


 var $shr=$v>>>16; //@line 40 "sermsg.c"
 var $conv=(($shr)&65535); //@line 40 "sermsg.c"
 _serwrite_hex16($conv); //@line 40 "sermsg.c"
 var $conv1=(($v)&65535); //@line 41 "sermsg.c"
 _serwrite_hex16($conv1); //@line 41 "sermsg.c"
 return; //@line 42 "sermsg.c"
}


function _serwrite_uint32($v){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $e_013=9;label=3;break; //@line 53 "sermsg.c"
 case 2: 
 var $cmp=(($dec<<24)>>24)==0; //@line 53 "sermsg.c"
 if($cmp){var $e_1=0;var $v_addr_0=$v;label=4;break;}else{var $e_013=$dec;label=3;break;} //@line 53 "sermsg.c"
 case 3: 
 var $e_013;
 var $conv=($e_013&255); //@line 53 "sermsg.c"
 var $arrayidx=((640+($conv<<2))|0); //@line 54 "sermsg.c"
 var $0=HEAP32[(($arrayidx)>>2)]; //@line 54 "sermsg.c"
 var $cmp2=($0>>>0)>($v>>>0); //@line 54 "sermsg.c"
 var $dec=((($e_013)-(1))&255); //@line 53 "sermsg.c"
 if($cmp2){label=2;break;}else{var $e_1=$e_013;var $v_addr_0=$v;label=4;break;} //@line 54 "sermsg.c"
 case 4: 
 var $v_addr_0;
 var $e_1;
 var $idxprom5=($e_1&255); //@line 60 "sermsg.c"
 var $arrayidx6=((640+($idxprom5<<2))|0); //@line 60 "sermsg.c"
 var $1=HEAP32[(($arrayidx6)>>2)]; //@line 60 "sermsg.c"
 var $cmp79=($v_addr_0>>>0)<($1>>>0); //@line 60 "sermsg.c"
 if($cmp79){var $v_addr_1_lcssa=$v_addr_0;var $t_0_lcssa=48;label=7;break;}else{var $v_addr_110=$v_addr_0;var $t_011=0;label=5;break;} //@line 60 "sermsg.c"
 case 5: 
 var $t_011;
 var $v_addr_110;
 var $sub=((($v_addr_110)-($1))|0); //@line 60 "sermsg.c"
 var $inc=((($t_011)+(1))&255); //@line 60 "sermsg.c"
 var $cmp7=($sub>>>0)<($1>>>0); //@line 60 "sermsg.c"
 if($cmp7){label=6;break;}else{var $v_addr_110=$sub;var $t_011=$inc;label=5;break;} //@line 60 "sermsg.c"
 case 6: 
 var $phitmp=((($t_011)+(49))&255); //@line 60 "sermsg.c"
 var $v_addr_1_lcssa=$sub;var $t_0_lcssa=$phitmp;label=7;break; //@line 60 "sermsg.c"
 case 7: 
 var $t_0_lcssa;
 var $v_addr_1_lcssa;
 _serial_writechar($t_0_lcssa); //@line 61 "sermsg.c"
 var $dec16=((($e_1)-(1))&255); //@line 62 "sermsg.c"
 var $tobool=(($e_1<<24)>>24)==0; //@line 62 "sermsg.c"
 if($tobool){label=8;break;}else{var $e_1=$dec16;var $v_addr_0=$v_addr_1_lcssa;label=4;break;} //@line 62 "sermsg.c"
 case 8: 
 return; //@line 64 "sermsg.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serwrite_int32($v){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=($v|0)<0; //@line 70 "sermsg.c"
 if($cmp){label=2;break;}else{var $v_addr_0=$v;label=3;break;} //@line 70 "sermsg.c"
 case 2: 
 _serial_writechar(45); //@line 71 "sermsg.c"
 var $sub=(((-$v))|0); //@line 72 "sermsg.c"
 var $v_addr_0=$sub;label=3;break; //@line 73 "sermsg.c"
 case 3: 
 var $v_addr_0;
 _serwrite_uint32($v_addr_0); //@line 75 "sermsg.c"
 return; //@line 76 "sermsg.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serwrite_uint32_vf($v,$fp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $e_017=9;label=3;break; //@line 85 "sermsg.c"
 case 2: 
 var $cmp=(($dec<<24)>>24)==0; //@line 85 "sermsg.c"
 if($cmp){var $e_0_lcssa=0;label=4;break;}else{var $e_017=$dec;label=3;break;} //@line 85 "sermsg.c"
 case 3: 
 var $e_017;
 var $conv=($e_017&255); //@line 85 "sermsg.c"
 var $arrayidx=((640+($conv<<2))|0); //@line 86 "sermsg.c"
 var $0=HEAP32[(($arrayidx)>>2)]; //@line 86 "sermsg.c"
 var $cmp2=($0>>>0)>($v>>>0); //@line 86 "sermsg.c"
 var $dec=((($e_017)-(1))&255); //@line 85 "sermsg.c"
 if($cmp2){label=2;break;}else{var $e_0_lcssa=$e_017;label=4;break;} //@line 86 "sermsg.c"
 case 4: 
 var $e_0_lcssa;
 var $cmp6=($e_0_lcssa&255)<($fp&255); //@line 90 "sermsg.c"
 var $fp_e_0=($cmp6?$fp:$e_0_lcssa); //@line 90 "sermsg.c"
 var $e_1=$fp_e_0;var $v_addr_0=$v;label=5;break; //@line 90 "sermsg.c"
 case 5: 
 var $v_addr_0;
 var $e_1;
 var $idxprom11=($e_1&255); //@line 95 "sermsg.c"
 var $arrayidx12=((640+($idxprom11<<2))|0); //@line 95 "sermsg.c"
 var $1=HEAP32[(($arrayidx12)>>2)]; //@line 95 "sermsg.c"
 var $cmp1313=($v_addr_0>>>0)<($1>>>0); //@line 95 "sermsg.c"
 if($cmp1313){var $v_addr_1_lcssa=$v_addr_0;var $t_0_lcssa=48;label=8;break;}else{var $v_addr_114=$v_addr_0;var $t_015=0;label=6;break;} //@line 95 "sermsg.c"
 case 6: 
 var $t_015;
 var $v_addr_114;
 var $sub=((($v_addr_114)-($1))|0); //@line 95 "sermsg.c"
 var $inc=((($t_015)+(1))&255); //@line 95 "sermsg.c"
 var $cmp13=($sub>>>0)<($1>>>0); //@line 95 "sermsg.c"
 if($cmp13){label=7;break;}else{var $v_addr_114=$sub;var $t_015=$inc;label=6;break;} //@line 95 "sermsg.c"
 case 7: 
 var $phitmp=((($t_015)+(49))&255); //@line 95 "sermsg.c"
 var $v_addr_1_lcssa=$sub;var $t_0_lcssa=$phitmp;label=8;break; //@line 95 "sermsg.c"
 case 8: 
 var $t_0_lcssa;
 var $v_addr_1_lcssa;
 _serial_writechar($t_0_lcssa); //@line 96 "sermsg.c"
 var $cmp24=(($e_1<<24)>>24)==(($fp<<24)>>24); //@line 97 "sermsg.c"
 if($cmp24){label=9;break;}else{label=10;break;} //@line 97 "sermsg.c"
 case 9: 
 _serial_writechar(46); //@line 98 "sermsg.c"
 label=10;break; //@line 98 "sermsg.c"
 case 10: 
 var $dec28=((($e_1)-(1))&255); //@line 99 "sermsg.c"
 var $tobool=(($e_1<<24)>>24)==0; //@line 99 "sermsg.c"
 if($tobool){label=11;break;}else{var $e_1=$dec28;var $v_addr_0=$v_addr_1_lcssa;label=5;break;} //@line 99 "sermsg.c"
 case 11: 
 return; //@line 101 "sermsg.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serwrite_int32_vf($v,$fp){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=($v|0)<0; //@line 108 "sermsg.c"
 if($cmp){label=2;break;}else{var $v_addr_0=$v;label=3;break;} //@line 108 "sermsg.c"
 case 2: 
 _serial_writechar(45); //@line 109 "sermsg.c"
 var $sub=(((-$v))|0); //@line 110 "sermsg.c"
 var $v_addr_0=$sub;label=3;break; //@line 111 "sermsg.c"
 case 3: 
 var $v_addr_0;
 _serwrite_uint32_vf($v_addr_0,$fp); //@line 113 "sermsg.c"
 return; //@line 114 "sermsg.c"
  default: assert(0, "bad label: " + label);
 }

}


function _temp_init(){
 var label=0;


 return; //@line 117 "temp.c"
}


function _temp_sensor_tick(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP16[((3744)>>1)]; //@line 123 "temp.c"
 var $tobool=(($0<<16)>>16)==0; //@line 123 "temp.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 123 "temp.c"
 case 2: 
 var $dec=((($0)-(1))&65535); //@line 124 "temp.c"
 HEAP16[((3744)>>1)]=$dec; //@line 124 "temp.c"
 var $_pre=HEAP16[((3738)>>1)]; //@line 298 "temp.c"
 var $7=$_pre;label=8;break; //@line 125 "temp.c"
 case 3: 
 var $call=_analog_read(0); //@line 184 "temp.c"
 var $j_042=1;var $conv1143=1;label=5;break; //@line 189 "temp.c"
 case 4: 
 var $conv11=($inc&255); //@line 189 "temp.c"
 var $cmp12=($inc&255)<20; //@line 189 "temp.c"
 if($cmp12){var $j_042=$inc;var $conv1143=$conv11;label=5;break;}else{var $temp_0=$call;var $j_040=$inc;label=7;break;} //@line 189 "temp.c"
 case 5: 
 var $conv1143;
 var $j_042;
 var $arrayidx19=((48+($conv1143<<2))|0); //@line 190 "temp.c"
 var $1=HEAP16[(($arrayidx19)>>1)]; //@line 190 "temp.c"
 var $cmp22=($1&65535)>($call&65535); //@line 190 "temp.c"
 var $inc=((($j_042)+(1))&255); //@line 189 "temp.c"
 if($cmp22){label=6;break;}else{label=4;break;} //@line 190 "temp.c"
 case 6: 
 var $conv20_le=($1&65535); //@line 190 "temp.c"
 var $conv21_le=($call&65535); //@line 190 "temp.c"
 var $sub=((($conv1143)-(1))|0); //@line 206 "temp.c"
 var $arrayidx30=((48+($sub<<2))|0); //@line 206 "temp.c"
 var $2=HEAP16[(($arrayidx30)>>1)]; //@line 206 "temp.c"
 var $conv31=($2&65535); //@line 206 "temp.c"
 var $sub32=((($conv21_le)-($conv31))|0); //@line 206 "temp.c"
 var $arrayidx37=((48+($conv1143<<2)+2)|0); //@line 206 "temp.c"
 var $3=HEAP16[(($arrayidx37)>>1)]; //@line 206 "temp.c"
 var $conv38=($3&65535); //@line 206 "temp.c"
 var $mul=(Math_imul($sub32,$conv38)|0); //@line 206 "temp.c"
 var $sub46=((($conv20_le)-($conv21_le))|0); //@line 206 "temp.c"
 var $arrayidx52=((48+($sub<<2)+2)|0); //@line 206 "temp.c"
 var $4=HEAP16[(($arrayidx52)>>1)]; //@line 206 "temp.c"
 var $conv53=($4&65535); //@line 206 "temp.c"
 var $mul54=(Math_imul($conv53,$sub46)|0); //@line 206 "temp.c"
 var $add=((($mul54)+($mul))|0); //@line 206 "temp.c"
 var $sub68=((($conv20_le)-($conv31))|0); //@line 206 "temp.c"
 var $div=(((($add>>>0))/(($sub68>>>0)))&-1); //@line 206 "temp.c"
 var $conv69=(($div)&65535); //@line 206 "temp.c"
 var $temp_0=$conv69;var $j_040=$j_042;label=7;break; //@line 223 "temp.c"
 case 7: 
 var $j_040;
 var $temp_0;
 var $cmp71=(($j_040<<24)>>24)==20; //@line 233 "temp.c"
 HEAP16[((3744)>>1)]=0; //@line 236 "temp.c"
 var $5=($temp_0&65535); //@line 294 "temp.c"
 var $_op=((($5)*(102))&-1); //@line 294 "temp.c"
 var $mul83=($cmp71?102:$_op); //@line 294 "temp.c"
 var $6=HEAP16[((3738)>>1)]; //@line 294 "temp.c"
 var $conv86=($6&65535); //@line 294 "temp.c"
 var $mul87=((($conv86)*(922))&-1); //@line 294 "temp.c"
 var $add88=((($mul87)+($mul83))|0); //@line 294 "temp.c"
 var $div89=$add88>>>10; //@line 294 "temp.c"
 var $conv90=(($div89)&65535); //@line 294 "temp.c"
 HEAP16[((3738)>>1)]=$conv90; //@line 294 "temp.c"
 var $7=$conv90;label=8;break;
 case 8: 
 var $7;
 var $8=HEAP16[((3740)>>1)]; //@line 298 "temp.c"
 var $sub102=((($7)-($8))&65535); //@line 298 "temp.c"
 var $conv104=(($sub102<<16)>>16); //@line 298 "temp.c"
 var $ispos=(($sub102<<16)>>16)>-1; //@line 298 "temp.c"
 var $neg=(((-$conv104))|0); //@line 298 "temp.c"
 var $9=($ispos?$conv104:$neg); //@line 298 "temp.c"
 var $cmp106=($9|0)<40; //@line 298 "temp.c"
 var $10=HEAP16[((3742)>>1)]; //@line 299 "temp.c"
 if($cmp106){label=9;break;}else{label=11;break;} //@line 298 "temp.c"
 case 9: 
 var $cmp112=($10&65535)<7200; //@line 299 "temp.c"
 if($cmp112){label=10;break;}else{label=14;break;} //@line 299 "temp.c"
 case 10: 
 var $inc118=((($10)+(1))&65535); //@line 300 "temp.c"
 HEAP16[((3742)>>1)]=$inc118; //@line 300 "temp.c"
 label=14;break; //@line 300 "temp.c"
 case 11: 
 var $cmp125=($10&65535)>10; //@line 305 "temp.c"
 if($cmp125){label=12;break;}else{label=13;break;} //@line 305 "temp.c"
 case 12: 
 var $sub132=((($10)-(10))&65535); //@line 306 "temp.c"
 HEAP16[((3742)>>1)]=$sub132; //@line 306 "temp.c"
 label=14;break; //@line 306 "temp.c"
 case 13: 
 HEAP16[((3742)>>1)]=0; //@line 308 "temp.c"
 label=14;break;
 case 14: 
 _heater_tick(0,0,$7,$8); //@line 312 "temp.c"
 return; //@line 323 "temp.c"
  default: assert(0, "bad label: " + label);
 }

}


function _temp_achieved(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP16[((3740)>>1)]; //@line 334 "temp.c"
 var $cmp3=(($0<<16)>>16)==0; //@line 334 "temp.c"
 if($cmp3){var $all_ok_1=-1;label=3;break;}else{label=2;break;} //@line 334 "temp.c"
 case 2: 
 var $1=HEAP16[((3742)>>1)]; //@line 334 "temp.c"
 var $not_cmp8=($1&65535)>5999; //@line 334 "temp.c"
 var $_all_ok_0=(($not_cmp8<<31)>>31); //@line 334 "temp.c"
 var $all_ok_1=$_all_ok_0;label=3;break; //@line 334 "temp.c"
 case 3: 
 var $all_ok_1;
 return $all_ok_1; //@line 338 "temp.c"
  default: assert(0, "bad label: " + label);
 }

}


function _temp_set($index,$temperature){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=(($index<<24)>>24)!=0; //@line 345 "temp.c"
 var $0=HEAP16[((3740)>>1)];
 var $cmp4=(($0<<16)>>16)==(($temperature<<16)>>16); //@line 349 "temp.c"
 var $or_cond=$cmp|$cmp4; //@line 345 "temp.c"
 if($or_cond){label=3;break;}else{label=2;break;} //@line 345 "temp.c"
 case 2: 
 HEAP16[((3740)>>1)]=$temperature; //@line 350 "temp.c"
 HEAP16[((3742)>>1)]=0; //@line 351 "temp.c"
 label=3;break; //@line 356 "temp.c"
 case 3: 
 return; //@line 357 "temp.c"
  default: assert(0, "bad label: " + label);
 }

}


function _temp_print($index){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 if((($index<<24)>>24)==2){ label=2;break;}else if((($index<<24)>>24)==0){ label=3;break;}else{label=4;break;}
 case 2: 
 _sersendf_P(2448,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 381 "temp.c"
 _single_temp_print(0); //@line 382 "temp.c"
 label=4;break; //@line 388 "temp.c"
 case 3: 
 _sersendf_P(3040,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 392 "temp.c"
 _single_temp_print(0); //@line 393 "temp.c"
 label=4;break;
 case 4: 
 STACKTOP=sp;return; //@line 395 "temp.c"
  default: assert(0, "bad label: " + label);
 }

}


function _single_temp_print($index){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $idxprom=($index&255); //@line 371 "temp.c"
 var $last_read_temp=((3736+((($idxprom)*(10))&-1)+2)|0); //@line 371 "temp.c"
 var $0=HEAP16[(($last_read_temp)>>1)]; //@line 371 "temp.c"
 var $conv=($0&65535); //@line 371 "temp.c"
 var $and=$conv&3; //@line 371 "temp.c"
 var $mul=((($and)*(25))&-1); //@line 371 "temp.c"
 var $shr2=$conv>>>2; //@line 372 "temp.c"
 _sersendf_P(2576,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$shr2,HEAP32[(((tempVarArgs)+(8))>>2)]=$mul,tempVarArgs)); STACKTOP=tempVarArgs; //@line 372 "temp.c"
 STACKTOP=sp;return; //@line 373 "temp.c"
}


function _gcode_init(){
 var label=0;


 var $$etemp$0=3912;
 var $ld$1$0=(($$etemp$0)|0);
 var $bf_load$0$preadd$=HEAP32[(($ld$1$0)>>2)];
 var $bf_load$0=$bf_load$0$preadd$&16777215;
 var $$etemp$2$0=32768;
 var $bf_set$0=((($bf_load$0<<8)>>8))|$$etemp$2$0;
 var $bf_set=$bf_set$0&16777215;
 var $$etemp$3=3912;
 var $st$4$0=(($$etemp$3)|0);
 tempBigInt=$bf_set$0;HEAP8[($st$4$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$4$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$4$0)+(2))|0)]=tempBigInt&0xff;
 return; //@line 94 "gcode_parse.c"
}


function _gcode_parse_char($c){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $c_off=((($c)-(97))&255); //@line 102 "gcode_parse.c"
 var $0=($c_off&255)<26; //@line 102 "gcode_parse.c"
 var $and=$c&-33; //@line 103 "gcode_parse.c"
 var $c_addr_0=($0?$and:$c); //@line 102 "gcode_parse.c"
 _sim_gcode_ch($c_addr_0); //@line 105 "gcode_parse.c"
 var $1=HEAP8[(4696)]; //@line 108 "gcode_parse.c"
 var $tobool=(($1<<24)>>24)==0; //@line 108 "gcode_parse.c"
 if($tobool){label=32;break;}else{label=2;break;} //@line 108 "gcode_parse.c"
 case 2: 
 var $c_addr_0_off=((($c_addr_0)-(65))&255); //@line 111 "gcode_parse.c"
 var $2=($c_addr_0_off&255)<26; //@line 111 "gcode_parse.c"
 if($2){label=4;break;}else{label=3;break;}
 case 3: 
 if((($c_addr_0<<24)>>24)==42|(($c_addr_0<<24)>>24)==13|(($c_addr_0<<24)>>24)==10){ label=4;break;}else{label=32;break;}
 case 4: 
 var $conv27=($1&255); //@line 112 "gcode_parse.c"
 switch(($conv27|0)){case 89:{ label=10;break;}case 90:{ label=13;break;}case 69:{ label=16;break;}case 70:{ label=19;break;}case 83:{ label=22;break;}case 80:{ label=27;break;}case 84:{ label=28;break;}case 78:{ label=29;break;}case 42:{ label=30;break;}case 71:{ label=5;break;}case 77:{ label=6;break;}case 88:{ label=7;break;}default:{label=31;break;}}break;
 case 5: 
 var $3=HEAP32[((3840)>>2)]; //@line 114 "gcode_parse.c"
 var $conv28=(($3)&255); //@line 114 "gcode_parse.c"
 HEAP8[(3915)]=$conv28; //@line 114 "gcode_parse.c"
 label=31;break; //@line 117 "gcode_parse.c"
 case 6: 
 var $4=HEAP32[((3840)>>2)]; //@line 119 "gcode_parse.c"
 var $conv30=(($4)&255); //@line 119 "gcode_parse.c"
 HEAP8[(3916)]=$conv30; //@line 119 "gcode_parse.c"
 label=31;break; //@line 122 "gcode_parse.c"
 case 7: 
 var $$etemp$0=3912; //@line 143 "dda_maths.c"
 var $ld$1$0=(($$etemp$0)|0);
 var $bf_load$0$preadd$=HEAP32[(($ld$1$0)>>2)];
 var $bf_load$0=$bf_load$0$preadd$&16777215;
 var $$etemp$2$0=65536;
 var $bf_cast$0=((($bf_load$0<<8)>>8))&$$etemp$2$0;
 var $bf_cast=$bf_cast$0&16777215;
 var $$etemp$3$0=0;
 var $tobool32$0=((((($bf_cast$0<<8)>>8)))|0)==(($$etemp$3$0<<8)>>8);
 var $tobool32=$tobool32$0&16777215;
 if($tobool32){label=9;break;}else{label=8;break;} //@line 124 "gcode_parse.c"
 case 8: 
 var $call=_decfloat_to_int(25400); //@line 125 "gcode_parse.c"
 HEAP32[((3920)>>2)]=$call; //@line 125 "gcode_parse.c"
 label=31;break; //@line 125 "gcode_parse.c"
 case 9: 
 var $call34=_decfloat_to_int(1000); //@line 127 "gcode_parse.c"
 HEAP32[((3920)>>2)]=$call34; //@line 127 "gcode_parse.c"
 label=31;break;
 case 10: 
 var $$etemp$4=3912;
 var $ld$5$0=(($$etemp$4)|0);
 var $bf_load37$0$preadd$=HEAP32[(($ld$5$0)>>2)];
 var $bf_load37$0=$bf_load37$0$preadd$&16777215;
 var $$etemp$6$0=65536;
 var $bf_cast40$0=((($bf_load37$0<<8)>>8))&$$etemp$6$0;
 var $bf_cast40=$bf_cast40$0&16777215;
 var $$etemp$7$0=0;
 var $tobool41$0=((((($bf_cast40$0<<8)>>8)))|0)==(($$etemp$7$0<<8)>>8);
 var $tobool41=$tobool41$0&16777215;
 if($tobool41){label=12;break;}else{label=11;break;} //@line 132 "gcode_parse.c"
 case 11: 
 var $call43=_decfloat_to_int(25400); //@line 133 "gcode_parse.c"
 HEAP32[((3924)>>2)]=$call43; //@line 133 "gcode_parse.c"
 label=31;break; //@line 133 "gcode_parse.c"
 case 12: 
 var $call45=_decfloat_to_int(1000); //@line 135 "gcode_parse.c"
 HEAP32[((3924)>>2)]=$call45; //@line 135 "gcode_parse.c"
 label=31;break;
 case 13: 
 var $$etemp$8=3912;
 var $ld$9$0=(($$etemp$8)|0);
 var $bf_load48$0$preadd$=HEAP32[(($ld$9$0)>>2)];
 var $bf_load48$0=$bf_load48$0$preadd$&16777215;
 var $$etemp$10$0=65536;
 var $bf_cast51$0=((($bf_load48$0<<8)>>8))&$$etemp$10$0;
 var $bf_cast51=$bf_cast51$0&16777215;
 var $$etemp$11$0=0;
 var $tobool52$0=((((($bf_cast51$0<<8)>>8)))|0)==(($$etemp$11$0<<8)>>8);
 var $tobool52=$tobool52$0&16777215;
 if($tobool52){label=15;break;}else{label=14;break;} //@line 140 "gcode_parse.c"
 case 14: 
 var $call54=_decfloat_to_int(25400); //@line 141 "gcode_parse.c"
 HEAP32[((3928)>>2)]=$call54; //@line 141 "gcode_parse.c"
 label=31;break; //@line 141 "gcode_parse.c"
 case 15: 
 var $call56=_decfloat_to_int(1000); //@line 143 "gcode_parse.c"
 HEAP32[((3928)>>2)]=$call56; //@line 143 "gcode_parse.c"
 label=31;break;
 case 16: 
 var $$etemp$12=3912;
 var $ld$13$0=(($$etemp$12)|0);
 var $bf_load59$0$preadd$=HEAP32[(($ld$13$0)>>2)];
 var $bf_load59$0=$bf_load59$0$preadd$&16777215;
 var $$etemp$14$0=65536;
 var $bf_cast62$0=((($bf_load59$0<<8)>>8))&$$etemp$14$0;
 var $bf_cast62=$bf_cast62$0&16777215;
 var $$etemp$15$0=0;
 var $tobool63$0=((((($bf_cast62$0<<8)>>8)))|0)==(($$etemp$15$0<<8)>>8);
 var $tobool63=$tobool63$0&16777215;
 if($tobool63){label=18;break;}else{label=17;break;} //@line 148 "gcode_parse.c"
 case 17: 
 var $call65=_decfloat_to_int(25400); //@line 149 "gcode_parse.c"
 HEAP32[((3932)>>2)]=$call65; //@line 149 "gcode_parse.c"
 label=31;break; //@line 149 "gcode_parse.c"
 case 18: 
 var $call67=_decfloat_to_int(1000); //@line 151 "gcode_parse.c"
 HEAP32[((3932)>>2)]=$call67; //@line 151 "gcode_parse.c"
 label=31;break;
 case 19: 
 var $$etemp$16=3912;
 var $ld$17$0=(($$etemp$16)|0);
 var $bf_load70$0$preadd$=HEAP32[(($ld$17$0)>>2)];
 var $bf_load70$0=$bf_load70$0$preadd$&16777215;
 var $$etemp$18$0=65536;
 var $bf_cast73$0=((($bf_load70$0<<8)>>8))&$$etemp$18$0;
 var $bf_cast73=$bf_cast73$0&16777215;
 var $$etemp$19$0=0;
 var $tobool74$0=((((($bf_cast73$0<<8)>>8)))|0)==(($$etemp$19$0<<8)>>8);
 var $tobool74=$tobool74$0&16777215;
 if($tobool74){label=21;break;}else{label=20;break;} //@line 157 "gcode_parse.c"
 case 20: 
 var $call76=_decfloat_to_int(25400); //@line 158 "gcode_parse.c"
 HEAP32[((3936)>>2)]=$call76; //@line 158 "gcode_parse.c"
 label=31;break; //@line 158 "gcode_parse.c"
 case 21: 
 var $call78=_decfloat_to_int(1); //@line 160 "gcode_parse.c"
 HEAP32[((3936)>>2)]=$call78; //@line 160 "gcode_parse.c"
 label=31;break;
 case 22: 
 var $5=HEAP8[(3916)]; //@line 168 "gcode_parse.c"
 if((($5<<24)>>24)==104|(($5<<24)>>24)==109|(($5<<24)>>24)==-116){ label=23;break;}else{label=24;break;}
 case 23: 
 var $call93=_decfloat_to_int(4); //@line 169 "gcode_parse.c"
 HEAP32[((3944)>>2)]=$call93; //@line 169 "gcode_parse.c"
 label=31;break; //@line 169 "gcode_parse.c"
 case 24: 
 var $_off=((($5)+(126))&255); //@line 171 "gcode_parse.c"
 var $6=($_off&255)<3; //@line 171 "gcode_parse.c"
 if($6){label=25;break;}else{label=26;break;} //@line 171 "gcode_parse.c"
 case 25: 
 var $call103=_decfloat_to_int(1024); //@line 172 "gcode_parse.c"
 HEAP32[((3944)>>2)]=$call103; //@line 172 "gcode_parse.c"
 label=31;break; //@line 172 "gcode_parse.c"
 case 26: 
 var $call105=_decfloat_to_int(1); //@line 174 "gcode_parse.c"
 HEAP32[((3944)>>2)]=$call105; //@line 174 "gcode_parse.c"
 label=31;break;
 case 27: 
 var $call109=_decfloat_to_int(1); //@line 179 "gcode_parse.c"
 var $conv110=(($call109)&65535); //@line 179 "gcode_parse.c"
 HEAP16[((3948)>>1)]=$conv110; //@line 179 "gcode_parse.c"
 label=31;break; //@line 182 "gcode_parse.c"
 case 28: 
 var $7=HEAP32[((3840)>>2)]; //@line 184 "gcode_parse.c"
 var $conv112=(($7)&255); //@line 184 "gcode_parse.c"
 HEAP8[(3950)]=$conv112; //@line 184 "gcode_parse.c"
 label=31;break; //@line 187 "gcode_parse.c"
 case 29: 
 var $call114=_decfloat_to_int(1); //@line 189 "gcode_parse.c"
 HEAP32[((3952)>>2)]=$call114; //@line 189 "gcode_parse.c"
 label=31;break; //@line 192 "gcode_parse.c"
 case 30: 
 var $call116=_decfloat_to_int(1); //@line 194 "gcode_parse.c"
 var $conv117=(($call116)&255); //@line 194 "gcode_parse.c"
 HEAP8[(3960)]=$conv117; //@line 194 "gcode_parse.c"
 label=31;break; //@line 197 "gcode_parse.c"
 case 31: 
 HEAP8[(4696)]=0; //@line 200 "gcode_parse.c"
 HEAP32[((3840)>>2)]=0; //@line 201 "gcode_parse.c"
 HEAP8[(3844)]=0; //@line 201 "gcode_parse.c"
 label=32;break; //@line 202 "gcode_parse.c"
 case 32: 
 var $$etemp$20=3912;
 var $ld$21$0=(($$etemp$20)|0);
 var $bf_load124$0$preadd$=HEAP32[(($ld$21$0)>>2)];
 var $bf_load124$0=$bf_load124$0$preadd$&16777215;
 var $$etemp$22$0=12288;
 var $8$0=((($bf_load124$0<<8)>>8))&$$etemp$22$0;
 var $8=$8$0&16777215;
 var $$etemp$23$0=0;
 var $9$0=((((($8$0<<8)>>8)))|0)==(($$etemp$23$0<<8)>>8);
 var $9=$9$0&16777215;
 if($9){label=33;break;}else{label=59;break;} //@line 206 "gcode_parse.c"
 case 33: 
 var $conv140=($c_addr_0&255); //@line 208 "gcode_parse.c"
 var $c_addr_0_off41=((($c_addr_0)-(65))&255); //@line 208 "gcode_parse.c"
 var $10=($c_addr_0_off41&255)<26; //@line 208 "gcode_parse.c"
 var $cmp149=(($c_addr_0<<24)>>24)==42; //@line 208 "gcode_parse.c"
 var $or_cond31=$10|$cmp149; //@line 208 "gcode_parse.c"
 if($or_cond31){label=34;break;}else{label=35;break;} //@line 208 "gcode_parse.c"
 case 34: 
 HEAP8[(4696)]=$c_addr_0; //@line 209 "gcode_parse.c"
 label=35;break; //@line 212 "gcode_parse.c"
 case 35: 
 var $c_addr_0_off42=((($c_addr_0)-(48))&255); //@line 217 "gcode_parse.c"
 var $11=($c_addr_0_off42&255)<10; //@line 217 "gcode_parse.c"
 if($11){label=36;break;}else{label=41;break;} //@line 217 "gcode_parse.c"
 case 36: 
 var $bf_load161=HEAP8[(3844)]; //@line 218 "gcode_parse.c"
 var $bf_clear162=$bf_load161&124; //@line 218 "gcode_parse.c"
 var $cmp164=($bf_clear162&255)<4; //@line 218 "gcode_parse.c"
 if($cmp164){label=37;break;}else{var $bf_load319$0=$bf_load124$0;label=61;break;} //@line 218 "gcode_parse.c"
 case 37: 
 var $bf_lshr168$0=(($bf_load124$0&16777215)>>>16)|(0<<16);
 var $bf_lshr168=$bf_lshr168$0&16777215;
 var $bf_lshr168_tr$0=(($bf_lshr168$0<<8)>>8);
 var $bf_lshr168_tr=$bf_lshr168_tr$0&255;
 var $bf_cast170=$bf_lshr168_tr&1; //@line 218 "gcode_parse.c"
 var $cmp172=(($bf_cast170<<24)>>24)==0; //@line 218 "gcode_parse.c"
 var $12=HEAP32[((3840)>>2)];
 var $cmp175=($12>>>0)<4289967; //@line 218 "gcode_parse.c"
 var $or_cond=$cmp172&$cmp175; //@line 218 "gcode_parse.c"
 if($or_cond){label=39;break;}else{label=38;break;} //@line 218 "gcode_parse.c"
 case 38: 
 var $tobool183=(($bf_cast170<<24)>>24)!=0; //@line 218 "gcode_parse.c"
 var $cmp185=($12>>>0)<164093; //@line 218 "gcode_parse.c"
 var $or_cond1=$tobool183&$cmp185; //@line 218 "gcode_parse.c"
 if($or_cond1){label=39;break;}else{var $bf_load319$0=$bf_load124$0;label=61;break;} //@line 218 "gcode_parse.c"
 case 39: 
 var $add=((($12)*(10))&-1); //@line 224 "gcode_parse.c"
 var $sub=((($conv140)-(48))|0); //@line 224 "gcode_parse.c"
 var $add190=((($sub)+($add))|0); //@line 224 "gcode_parse.c"
 HEAP32[((3840)>>2)]=$add190; //@line 224 "gcode_parse.c"
 var $bf_clear192=$bf_load161&127; //@line 226 "gcode_parse.c"
 var $tobool193=(($bf_clear192<<24)>>24)==0; //@line 226 "gcode_parse.c"
 if($tobool193){var $bf_load319$0=$bf_load124$0;label=61;break;}else{label=40;break;} //@line 226 "gcode_parse.c"
 case 40: 
 var $inc=((($bf_load161)+(1))&255); //@line 227 "gcode_parse.c"
 var $bf_value=$inc&127; //@line 227 "gcode_parse.c"
 var $bf_clear198=$bf_load161&-128; //@line 227 "gcode_parse.c"
 var $bf_set=$bf_value|$bf_clear198; //@line 227 "gcode_parse.c"
 HEAP8[(3844)]=$bf_set; //@line 227 "gcode_parse.c"
 var $bf_load319$0=$bf_load124$0;label=61;break; //@line 227 "gcode_parse.c"
 case 41: 
 switch(($conv140|0)){case 71:{ label=42;break;}case 77:{ label=43;break;}case 88:{ label=44;break;}case 89:{ label=45;break;}case 90:{ label=46;break;}case 69:{ label=47;break;}case 70:{ label=48;break;}case 83:{ label=49;break;}case 80:{ label=50;break;}case 84:{ label=51;break;}case 78:{ label=52;break;}case 42:{ label=53;break;}case 59:{ label=54;break;}case 40:{ label=55;break;}case 45:{ label=56;break;}case 46:{ label=57;break;}default:{var $bf_load319$0=$bf_load124$0;label=61;break;}}break;
 case 42: 
 var $$etemp$24$0=16777212;
 var $bf_set206$0=((($bf_load124$0<<8)>>8))&$$etemp$24$0;
 var $bf_set206=$bf_set206$0&16777215;
 var $$etemp$25$0=1;
 var $bf_clear208$0=((($bf_set206$0<<8)>>8))|$$etemp$25$0;
 var $bf_clear208=$bf_clear208$0&16777215;
 var $$etemp$26=3912;
 var $st$27$0=(($$etemp$26)|0);
 tempBigInt=$bf_clear208$0;HEAP8[($st$27$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$27$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$27$0)+(2))|0)]=tempBigInt&0xff;
 HEAP8[(3916)]=0; //@line 238 "gcode_parse.c"
 var $bf_load319$0=$bf_clear208$0;label=61;break; //@line 239 "gcode_parse.c"
 case 43: 
 var $$etemp$28$0=16777212;
 var $bf_set212$0=((($bf_load124$0<<8)>>8))&$$etemp$28$0;
 var $bf_set212=$bf_set212$0&16777215;
 var $$etemp$29$0=2;
 var $bf_clear214$0=((($bf_set212$0<<8)>>8))|$$etemp$29$0;
 var $bf_clear214=$bf_clear214$0&16777215;
 var $$etemp$30=3912;
 var $st$31$0=(($$etemp$30)|0);
 tempBigInt=$bf_clear214$0;HEAP8[($st$31$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$31$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$31$0)+(2))|0)]=tempBigInt&0xff;
 HEAP8[(3915)]=0; //@line 243 "gcode_parse.c"
 var $bf_load319$0=$bf_clear214$0;label=61;break; //@line 244 "gcode_parse.c"
 case 44: 
 var $$etemp$32$0=4;
 var $bf_set218$0=((($bf_load124$0<<8)>>8))|$$etemp$32$0;
 var $bf_set218=$bf_set218$0&16777215;
 var $$etemp$33=3912;
 var $st$34$0=(($$etemp$33)|0);
 tempBigInt=$bf_set218$0;HEAP8[($st$34$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$34$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$34$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set218$0;label=61;break; //@line 247 "gcode_parse.c"
 case 45: 
 var $$etemp$35$0=8; //@line 116 "dda.c"
 var $bf_set222$0=((($bf_load124$0<<8)>>8))|$$etemp$35$0;
 var $bf_set222=$bf_set222$0&16777215;
 var $$etemp$36=3912;
 var $st$37$0=(($$etemp$36)|0);
 tempBigInt=$bf_set222$0;HEAP8[($st$37$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$37$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$37$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set222$0;label=61;break; //@line 250 "gcode_parse.c"
 case 46: 
 var $$etemp$38$0=16;
 var $bf_set226$0=((($bf_load124$0<<8)>>8))|$$etemp$38$0;
 var $bf_set226=$bf_set226$0&16777215;
 var $$etemp$39=3912;
 var $st$40$0=(($$etemp$39)|0);
 tempBigInt=$bf_set226$0;HEAP8[($st$40$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$40$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$40$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set226$0;label=61;break; //@line 253 "gcode_parse.c"
 case 47: 
 var $$etemp$41$0=32;
 var $bf_set230$0=((($bf_load124$0<<8)>>8))|$$etemp$41$0;
 var $bf_set230=$bf_set230$0&16777215;
 var $$etemp$42=3912;
 var $st$43$0=(($$etemp$42)|0);
 tempBigInt=$bf_set230$0;HEAP8[($st$43$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$43$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$43$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set230$0;label=61;break; //@line 256 "gcode_parse.c"
 case 48: 
 var $$etemp$44$0=64;
 var $bf_set234$0=((($bf_load124$0<<8)>>8))|$$etemp$44$0;
 var $bf_set234=$bf_set234$0&16777215;
 var $$etemp$45=3912;
 var $st$46$0=(($$etemp$45)|0);
 tempBigInt=$bf_set234$0;HEAP8[($st$46$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$46$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$46$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set234$0;label=61;break; //@line 259 "gcode_parse.c"
 case 49: 
 var $$etemp$47$0=128;
 var $bf_set238$0=((($bf_load124$0<<8)>>8))|$$etemp$47$0;
 var $bf_set238=$bf_set238$0&16777215;
 var $$etemp$48=3912;
 var $st$49$0=(($$etemp$48)|0);
 tempBigInt=$bf_set238$0;HEAP8[($st$49$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$49$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$49$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set238$0;label=61;break; //@line 262 "gcode_parse.c"
 case 50: 
 var $$etemp$50$0=256;
 var $bf_set242$0=((($bf_load124$0<<8)>>8))|$$etemp$50$0;
 var $bf_set242=$bf_set242$0&16777215;
 var $$etemp$51=3912;
 var $st$52$0=(($$etemp$51)|0);
 tempBigInt=$bf_set242$0;HEAP8[($st$52$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$52$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$52$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set242$0;label=61;break; //@line 265 "gcode_parse.c"
 case 51: 
 var $$etemp$53$0=512;
 var $bf_set246$0=((($bf_load124$0<<8)>>8))|$$etemp$53$0;
 var $bf_set246=$bf_set246$0&16777215;
 var $$etemp$54=3912;
 var $st$55$0=(($$etemp$54)|0);
 tempBigInt=$bf_set246$0;HEAP8[($st$55$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$55$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$55$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set246$0;label=61;break; //@line 268 "gcode_parse.c"
 case 52: 
 var $$etemp$56$0=1024;
 var $bf_set250$0=((($bf_load124$0<<8)>>8))|$$etemp$56$0;
 var $bf_set250=$bf_set250$0&16777215;
 var $$etemp$57=3912;
 var $st$58$0=(($$etemp$57)|0);
 tempBigInt=$bf_set250$0;HEAP8[($st$58$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$58$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$58$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set250$0;label=61;break; //@line 271 "gcode_parse.c"
 case 53: 
 var $$etemp$59$0=2048;
 var $bf_set254$0=((($bf_load124$0<<8)>>8))|$$etemp$59$0;
 var $bf_set254=$bf_set254$0&16777215;
 var $$etemp$60=3912;
 var $st$61$0=(($$etemp$60)|0);
 tempBigInt=$bf_set254$0;HEAP8[($st$61$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$61$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$61$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set254$0;label=61;break; //@line 274 "gcode_parse.c"
 case 54: 
 var $$etemp$62$0=4096;
 var $bf_set258$0=((($bf_load124$0<<8)>>8))|$$etemp$62$0;
 var $bf_set258=$bf_set258$0&16777215;
 var $$etemp$63=3912;
 var $st$64$0=(($$etemp$63)|0);
 tempBigInt=$bf_set258$0;HEAP8[($st$64$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$64$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$64$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set258$0;label=61;break; //@line 279 "gcode_parse.c"
 case 55: 
 var $$etemp$65$0=8192;
 var $bf_set262$0=((($bf_load124$0<<8)>>8))|$$etemp$65$0;
 var $bf_set262=$bf_set262$0&16777215;
 var $$etemp$66=3912;
 var $st$67$0=(($$etemp$66)|0);
 tempBigInt=$bf_set262$0;HEAP8[($st$67$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$67$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$67$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_set262$0;label=61;break; //@line 282 "gcode_parse.c"
 case 56: 
 HEAP8[(3844)]=-128; //@line 288 "gcode_parse.c"
 HEAP32[((3840)>>2)]=0; //@line 289 "gcode_parse.c"
 var $bf_load319$0=$bf_load124$0;label=61;break; //@line 290 "gcode_parse.c"
 case 57: 
 var $bf_load270=HEAP8[(3844)]; //@line 292 "gcode_parse.c"
 var $bf_clear271=$bf_load270&127; //@line 292 "gcode_parse.c"
 var $cmp273=(($bf_clear271<<24)>>24)==0; //@line 292 "gcode_parse.c"
 if($cmp273){label=58;break;}else{var $bf_load319$0=$bf_load124$0;label=61;break;} //@line 292 "gcode_parse.c"
 case 58: 
 var $bf_clear277=$bf_load270&-128; //@line 293 "gcode_parse.c"
 var $bf_set278=$bf_clear277|1; //@line 293 "gcode_parse.c"
 HEAP8[(3844)]=$bf_set278; //@line 293 "gcode_parse.c"
 var $bf_load319$0=$bf_load124$0;label=61;break; //@line 293 "gcode_parse.c"
 case 59: 
 var $$etemp$68$0=8192;
 var $bf_cast135$0=((($bf_load124$0<<8)>>8))&$$etemp$68$0;
 var $bf_cast135=$bf_cast135$0&16777215;
 var $$etemp$69$0=0;
 var $cmp288$0=((((($bf_cast135$0<<8)>>8)))|0)!=(($$etemp$69$0<<8)>>8);
 var $cmp288=$cmp288$0&16777215;
 var $cmp292=(($c_addr_0<<24)>>24)==41; //@line 314 "gcode_parse.c"
 var $or_cond33=$cmp288&$cmp292; //@line 314 "gcode_parse.c"
 if($or_cond33){label=60;break;}else{var $bf_load319$0=$bf_load124$0;label=61;break;} //@line 314 "gcode_parse.c"
 case 60: 
 var $$etemp$70$0=16769023;
 var $bf_clear296$0=((($bf_load124$0<<8)>>8))&$$etemp$70$0;
 var $bf_clear296=$bf_clear296$0&16777215;
 var $$etemp$71=3912;
 var $st$72$0=(($$etemp$71)|0);
 tempBigInt=$bf_clear296$0;HEAP8[($st$72$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$72$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$72$0)+(2))|0)]=tempBigInt&0xff;
 var $bf_load319$0=$bf_clear296$0;label=61;break; //@line 315 "gcode_parse.c"
 case 61: 
 var $bf_load319$0;
 var $$etemp$73$0=2048;
 var $bf_cast302$0=((($bf_load319$0<<8)>>8))&$$etemp$73$0;
 var $bf_cast302=$bf_cast302$0&16777215;
 var $$etemp$74$0=0;
 var $cmp304$0=((((($bf_cast302$0<<8)>>8)))|0)==(($$etemp$74$0<<8)>>8);
 var $cmp304=$cmp304$0&16777215;
 if($cmp304){label=62;break;}else{label=63;break;} //@line 317 "gcode_parse.c"
 case 62: 
 var $13=HEAP8[(3961)]; //@line 318 "gcode_parse.c"
 var $xor22=$13^$c; //@line 318 "gcode_parse.c"
 HEAP8[(3961)]=$xor22; //@line 318 "gcode_parse.c"
 label=63;break; //@line 318 "gcode_parse.c"
 case 63: 
 if((($c_addr_0<<24)>>24)==10|(($c_addr_0<<24)>>24)==13){ label=64;break;}else{label=74;break;}
 case 64: 
 var $$etemp$75$0=515;
 var $14$0=((($bf_load319$0<<8)>>8))&$$etemp$75$0;
 var $14=$14$0&16777215;
 var $$etemp$76$0=0;
 var $15$0=((((($14$0<<8)>>8)))|0)!=(($$etemp$76$0<<8)>>8);
 var $15=$15$0&16777215;
 var $$etemp$77$0=124;
 var $16$0=((($bf_load319$0<<8)>>8))&$$etemp$77$0;
 var $16=$16$0&16777215;
 var $$etemp$78$0=0;
 var $17$0=((((($16$0<<8)>>8)))|0)==(($$etemp$78$0<<8)>>8);
 var $17=$17$0&16777215;
 var $or_cond44=$15|$17; //@line 327 "gcode_parse.c"
 if($or_cond44){var $bf_load380$0=$bf_load319$0;label=66;break;}else{label=65;break;} //@line 327 "gcode_parse.c"
 case 65: 
 var $$etemp$79$0=1;
 var $bf_set373$0=((($bf_load319$0<<8)>>8))|$$etemp$79$0;
 var $bf_set373=$bf_set373$0&16777215;
 var $$etemp$80=3912;
 var $st$81$0=(($$etemp$80)|0);
 tempBigInt=$bf_set373$0;HEAP8[($st$81$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$81$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$81$0)+(2))|0)]=tempBigInt&0xff;
 HEAP8[(3915)]=1; //@line 331 "gcode_parse.c"
 var $bf_load380$0=$bf_set373$0;label=66;break; //@line 332 "gcode_parse.c"
 case 66: 
 var $bf_load380$0;
 var $18=HEAP8[(3961)]; //@line 342 "gcode_parse.c"
 var $19=HEAP8[(3960)]; //@line 342 "gcode_parse.c"
 var $cmp377=(($18<<24)>>24)==(($19<<24)>>24); //@line 342 "gcode_parse.c"
 var $$etemp$82$0=2048;
 var $bf_cast383$0=((($bf_load380$0<<8)>>8))&$$etemp$82$0;
 var $bf_cast383=$bf_cast383$0&16777215;
 var $$etemp$83$0=0;
 var $cmp385$0=((((($bf_cast383$0<<8)>>8)))|0)==(($$etemp$83$0<<8)>>8);
 var $cmp385=$cmp385$0&16777215;
 var $or_cond48=$cmp377|$cmp385; //@line 342 "gcode_parse.c"
 if($or_cond48){label=67;break;}else{label=69;break;} //@line 342 "gcode_parse.c"
 case 67: 
 _serial_writestr_P(1880); //@line 350 "gcode_parse.c"
 _process_gcode_command(); //@line 351 "gcode_parse.c"
 _serial_writechar(10); //@line 352 "gcode_parse.c"
 var $$etemp$84=3912;
 var $ld$85$0=(($$etemp$84)|0);
 var $bf_load388$0$preadd$=HEAP32[(($ld$85$0)>>2)];
 var $bf_load388$0=$bf_load388$0$preadd$&16777215;
 var $$etemp$86$0=1024;
 var $bf_cast391$0=((($bf_load388$0<<8)>>8))&$$etemp$86$0;
 var $bf_cast391=$bf_cast391$0&16777215;
 var $$etemp$87$0=0;
 var $cmp393$0=((((($bf_cast391$0<<8)>>8)))|0)==(($$etemp$87$0<<8)>>8);
 var $cmp393=$cmp393$0&16777215;
 if($cmp393){var $bf_load401$0=$bf_load388$0;label=70;break;}else{label=68;break;} //@line 355 "gcode_parse.c"
 case 68: 
 var $20=HEAP32[((3952)>>2)]; //@line 356 "gcode_parse.c"
 var $add396=((($20)+(1))|0); //@line 356 "gcode_parse.c"
 HEAP32[((3956)>>2)]=$add396; //@line 356 "gcode_parse.c"
 var $bf_load401$0=$bf_load388$0;label=70;break; //@line 356 "gcode_parse.c"
 case 69: 
 var $conv375=($18&255); //@line 342 "gcode_parse.c"
 var $21=HEAP32[((3956)>>2)]; //@line 359 "gcode_parse.c"
 _sersendf_P(2960,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$21,HEAP32[(((tempVarArgs)+(8))>>2)]=$conv375,tempVarArgs)); STACKTOP=tempVarArgs; //@line 359 "gcode_parse.c"
 var $$etemp$88=3912;
 var $ld$89$0=(($$etemp$88)|0);
 var $bf_load401_pre$0$preadd$=HEAP32[(($ld$89$0)>>2)];
 var $bf_load401_pre$0=$bf_load401_pre$0$preadd$&16777215;
 var $bf_load401$0=$bf_load401_pre$0;label=70;break;
 case 70: 
 var $bf_load401$0;
 HEAP8[(3961)]=0; //@line 369 "gcode_parse.c"
 HEAP8[(3960)]=0; //@line 369 "gcode_parse.c"
 var $$etemp$90$0=16760832;
 var $bf_clear428$0=((($bf_load401$0<<8)>>8))&$$etemp$90$0;
 var $bf_clear428=$bf_clear428$0&16777215;
 var $$etemp$91=3912;
 var $st$92$0=(($$etemp$91)|0);
 tempBigInt=$bf_clear428$0;HEAP8[($st$92$0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$92$0)+(1))|0)]=tempBigInt&0xff;tempBigInt = tempBigInt>>8;HEAP8[((($st$92$0)+(2))|0)]=tempBigInt&0xff;
 var $$etemp$93$0=16384;
 var $bf_cast432$0=((($bf_load401$0<<8)>>8))&$$etemp$93$0;
 var $bf_cast432=$bf_cast432$0&16777215;
 var $$etemp$94$0=0;
 var $tobool433$0=((((($bf_cast432$0<<8)>>8)))|0)==(($$etemp$94$0<<8)>>8);
 var $tobool433=$tobool433$0&16777215;
 if($tobool433){label=72;break;}else{label=71;break;} //@line 377 "gcode_parse.c"
 case 71: 
 HEAP32[((3928)>>2)]=0; //@line 378 "gcode_parse.c"
 HEAP32[((3924)>>2)]=0; //@line 378 "gcode_parse.c"
 HEAP32[((3920)>>2)]=0; //@line 378 "gcode_parse.c"
 label=72;break; //@line 379 "gcode_parse.c"
 case 72: 
 var $$etemp$95$0=49152;
 var $22$0=((($bf_load401$0<<8)>>8))&$$etemp$95$0;
 var $22=$22$0&16777215;
 var $$etemp$96$0=0;
 var $23$0=((((($22$0<<8)>>8)))|0)==(($$etemp$96$0<<8)>>8);
 var $23=$23$0&16777215;
 if($23){label=74;break;}else{label=73;break;} //@line 380 "gcode_parse.c"
 case 73: 
 HEAP32[((3932)>>2)]=0; //@line 381 "gcode_parse.c"
 label=74;break; //@line 382 "gcode_parse.c"
 case 74: 
 STACKTOP=sp;return; //@line 384 "gcode_parse.c"
  default: assert(0, "bad label: " + label);
 }

}


function _decfloat_to_int($multiplicand){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((3840)>>2)]; //@line 67 "gcode_parse.c"
 var $bf_load=HEAP8[(3844)]; //@line 68 "gcode_parse.c"
 var $bf_clear=$bf_load&127; //@line 68 "gcode_parse.c"
 var $tobool=(($bf_clear<<24)>>24)==0; //@line 71 "gcode_parse.c"
 var $dec=((($bf_clear)-(1))&255); //@line 72 "gcode_parse.c"
 var $bf_clear_dec=($tobool?0:$dec); //@line 71 "gcode_parse.c"
 var $tobool13=(($bf_clear_dec<<24)>>24)!=0; //@line 76 "gcode_parse.c"
 var $1=(((($multiplicand&65535))%(10))&-1);
 var $cmp4=(($1<<16)>>16)==0; //@line 76 "gcode_parse.c"
 var $or_cond5=$tobool13&$cmp4; //@line 76 "gcode_parse.c"
 if($or_cond5){var $multiplicand_addr_06=$multiplicand;var $e_07=$bf_clear_dec;label=2;break;}else{var $multiplicand_addr_0_lcssa=$multiplicand;var $conv_lcssa_in=$bf_clear_dec;label=3;break;} //@line 76 "gcode_parse.c"
 case 2: 
 var $e_07;
 var $multiplicand_addr_06;
 var $div1=(((($multiplicand_addr_06&65535))/(10))&-1); //@line 77 "gcode_parse.c"
 var $dec6=((($e_07)-(1))&255); //@line 78 "gcode_parse.c"
 var $tobool1=(($dec6<<24)>>24)!=0; //@line 76 "gcode_parse.c"
 var $2=(((($div1&65535))%(10))&-1);
 var $cmp=(($2<<16)>>16)==0; //@line 76 "gcode_parse.c"
 var $or_cond=$tobool1&$cmp; //@line 76 "gcode_parse.c"
 if($or_cond){var $multiplicand_addr_06=$div1;var $e_07=$dec6;label=2;break;}else{var $multiplicand_addr_0_lcssa=$div1;var $conv_lcssa_in=$dec6;label=3;break;} //@line 76 "gcode_parse.c"
 case 3: 
 var $conv_lcssa_in;
 var $multiplicand_addr_0_lcssa;
 var $conv4=($multiplicand_addr_0_lcssa&65535); //@line 77 "gcode_parse.c"
 var $mul=(Math_imul($conv4,$0)|0); //@line 81 "gcode_parse.c"
 var $tobool8=(($conv_lcssa_in<<24)>>24)==0; //@line 82 "gcode_parse.c"
 if($tobool8){var $r_0=$mul;label=5;break;}else{label=4;break;} //@line 82 "gcode_parse.c"
 case 4: 
 var $conv_lcssa=($conv_lcssa_in&255); //@line 76 "gcode_parse.c"
 var $arrayidx=((640+($conv_lcssa<<2))|0); //@line 83 "gcode_parse.c"
 var $3=HEAP32[(($arrayidx)>>2)]; //@line 83 "gcode_parse.c"
 var $div10=$3>>>1; //@line 83 "gcode_parse.c"
 var $add=((($div10)+($mul))|0); //@line 83 "gcode_parse.c"
 var $div13=(((($add>>>0))/(($3>>>0)))&-1); //@line 83 "gcode_parse.c"
 var $r_0=$div13;label=5;break; //@line 83 "gcode_parse.c"
 case 5: 
 var $r_0;
 var $tobool17=(($bf_load<<24)>>24)<0; //@line 85 "gcode_parse.c"
 var $sub=(((-$r_0))|0); //@line 85 "gcode_parse.c"
 var $cond=($tobool17?$sub:$r_0); //@line 85 "gcode_parse.c"
 return $cond; //@line 85 "gcode_parse.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sersendf_P($format_P,varrp){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $args=sp;
 var $arraydecay=(($args)|0); //@line 108 "sersendf.c"
 var $arraydecay1=$args; //@line 108 "sersendf.c"
 HEAP32[(($arraydecay1)>>2)]=varrp;HEAP32[((($arraydecay1)+(4))>>2)]=0; //@line 108 "sersendf.c"
 var $0=HEAP8[($format_P)]; //@line 112 "sersendf.c"
 var $tobool5=(($0<<24)>>24)==0; //@line 112 "sersendf.c"
 if($tobool5){label=18;break;}else{var $j_06=0;var $inc7=1;var $1=$0;label=2;break;} //@line 112 "sersendf.c"
 case 2: 
 var $1;
 var $inc7;
 var $j_06;
 var $tobool2=(($j_06<<24)>>24)==0; //@line 113 "sersendf.c"
 if($tobool2){label=15;break;}else{label=3;break;} //@line 113 "sersendf.c"
 case 3: 
 var $conv=($1&255); //@line 114 "sersendf.c"
 switch(($conv|0)){case 113:{ label=13;break;}case 115:{ var $j_0_be=1;label=17;break;}case 108:{ label=4;break;}case 117:{ label=5;break;}case 100:{ label=6;break;}case 99:{ label=7;break;}case 120:{ label=8;break;}default:{label=14;break;}}break;
 case 4: 
 var $j_0_be=4;label=17;break; //@line 120 "sersendf.c"
 case 5: 
 var $2=(tempInt=HEAP32[((($arraydecay)+(4))>>2)],HEAP32[((($arraydecay)+(4))>>2)]=tempInt + 8,HEAP32[(((HEAP32[(($arraydecay)>>2)])+(tempInt))>>2)]); //@line 123 "sersendf.c"
 _serwrite_uint32($2); //@line 123 "sersendf.c"
 var $j_0_be=0;label=17;break; //@line 127 "sersendf.c"
 case 6: 
 var $3=(tempInt=HEAP32[((($arraydecay)+(4))>>2)],HEAP32[((($arraydecay)+(4))>>2)]=tempInt + 8,HEAP32[(((HEAP32[(($arraydecay)>>2)])+(tempInt))>>2)]); //@line 130 "sersendf.c"
 _serwrite_int32($3); //@line 130 "sersendf.c"
 var $j_0_be=0;label=17;break; //@line 134 "sersendf.c"
 case 7: 
 var $4=(tempInt=HEAP32[((($arraydecay)+(4))>>2)],HEAP32[((($arraydecay)+(4))>>2)]=tempInt + 8,HEAP32[(((HEAP32[(($arraydecay)>>2)])+(tempInt))>>2)]); //@line 136 "sersendf.c"
 var $conv21=(($4)&255); //@line 136 "sersendf.c"
 _serial_writechar($conv21); //@line 136 "sersendf.c"
 var $j_0_be=0;label=17;break; //@line 138 "sersendf.c"
 case 8: 
 _serial_writestr_P(1648); //@line 140 "sersendf.c"
 var $cmp24=(($j_06<<24)>>24)==4; //@line 141 "sersendf.c"
 if($cmp24){label=9;break;}else{label=10;break;} //@line 141 "sersendf.c"
 case 9: 
 var $5=(tempInt=HEAP32[((($arraydecay)+(4))>>2)],HEAP32[((($arraydecay)+(4))>>2)]=tempInt + 8,HEAP32[(((HEAP32[(($arraydecay)>>2)])+(tempInt))>>2)]); //@line 142 "sersendf.c"
 _serwrite_hex32($5); //@line 142 "sersendf.c"
 var $j_0_be=0;label=17;break; //@line 142 "sersendf.c"
 case 10: 
 var $cmp30=(($j_06<<24)>>24)==1; //@line 143 "sersendf.c"
 var $6=(tempInt=HEAP32[((($arraydecay)+(4))>>2)],HEAP32[((($arraydecay)+(4))>>2)]=tempInt + 8,HEAP32[(((HEAP32[(($arraydecay)>>2)])+(tempInt))>>2)]); //@line 144 "sersendf.c"
 if($cmp30){label=11;break;}else{label=12;break;} //@line 143 "sersendf.c"
 case 11: 
 var $conv34=(($6)&255); //@line 144 "sersendf.c"
 _serwrite_hex8($conv34); //@line 144 "sersendf.c"
 var $j_0_be=0;label=17;break; //@line 144 "sersendf.c"
 case 12: 
 var $conv37=(($6)&65535); //@line 146 "sersendf.c"
 _serwrite_hex16($conv37); //@line 146 "sersendf.c"
 var $j_0_be=0;label=17;break;
 case 13: 
 var $7=(tempInt=HEAP32[((($arraydecay)+(4))>>2)],HEAP32[((($arraydecay)+(4))>>2)]=tempInt + 8,HEAP32[(((HEAP32[(($arraydecay)>>2)])+(tempInt))>>2)]); //@line 152 "sersendf.c"
 _serwrite_int32_vf($7,3); //@line 152 "sersendf.c"
 var $j_0_be=0;label=17;break; //@line 154 "sersendf.c"
 case 14: 
 _serial_writechar($1); //@line 156 "sersendf.c"
 var $j_0_be=0;label=17;break; //@line 158 "sersendf.c"
 case 15: 
 var $cmp44=(($1<<24)>>24)==37; //@line 162 "sersendf.c"
 if($cmp44){var $j_0_be=2;label=17;break;}else{label=16;break;} //@line 162 "sersendf.c"
 case 16: 
 _serial_writechar($1); //@line 166 "sersendf.c"
 var $j_0_be=0;label=17;break;
 case 17: 
 var $j_0_be;
 var $inc=((($inc7)+(1))&65535); //@line 112 "sersendf.c"
 var $idxprom=($inc7&65535); //@line 112 "sersendf.c"
 var $arrayidx=(($format_P+$idxprom)|0); //@line 112 "sersendf.c"
 var $8=HEAP8[($arrayidx)]; //@line 112 "sersendf.c"
 var $tobool=(($8<<24)>>24)==0; //@line 112 "sersendf.c"
 if($tobool){label=18;break;}else{var $j_06=$j_0_be;var $inc7=$inc;var $1=$8;label=2;break;} //@line 112 "sersendf.c"
 case 18: 
 //@line 170 "sersendf.c"
 STACKTOP=sp;return; //@line 171 "sersendf.c"
  default: assert(0, "bad label: " + label);
 }

}


function _recorder_init($filename){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $t=sp;
 var $0=HEAP32[((5040)>>2)]; //@line 31 "simulator/data_recorder.c"
 var $lnot=($0|0)==0; //@line 31 "simulator/data_recorder.c"
 _sim_assert($lnot,1600); //@line 31 "simulator/data_recorder.c"
 var $call=_fopen($filename,2936); //@line 33 "simulator/data_recorder.c"
 HEAP32[((5040)>>2)]=$call; //@line 33 "simulator/data_recorder.c"
 var $tobool1=($call|0)!=0; //@line 34 "simulator/data_recorder.c"
 _sim_assert($tobool1,2456); //@line 34 "simulator/data_recorder.c"
 var $call2=_time(0); //@line 36 "simulator/data_recorder.c"
 HEAP32[(($t)>>2)]=$call2; //@line 36 "simulator/data_recorder.c"
 var $1=HEAP32[((5040)>>2)]; //@line 37 "simulator/data_recorder.c"
 var $2=_fwrite(2008,33,1,$1); //@line 37 "simulator/data_recorder.c"
 var $3=HEAP32[((5040)>>2)]; //@line 38 "simulator/data_recorder.c"
 var $call4=_localtime($t); //@line 38 "simulator/data_recorder.c"
 var $call5=_asctime($call4); //@line 38 "simulator/data_recorder.c"
 var $call6=_fprintf($3,1768,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$call5,tempVarArgs)); STACKTOP=tempVarArgs; //@line 38 "simulator/data_recorder.c"
 var $4=HEAP32[((5040)>>2)]; //@line 39 "simulator/data_recorder.c"
 var $5=_fwrite(1632,10,1,$4); //@line 39 "simulator/data_recorder.c"
 var $6=HEAP32[((5040)>>2)]; //@line 40 "simulator/data_recorder.c"
 var $7=_fwrite(1400,49,1,$6); //@line 40 "simulator/data_recorder.c"
 var $8=HEAP32[((5040)>>2)]; //@line 41 "simulator/data_recorder.c"
 var $call9=_fprintf($8,1240,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$filename,tempVarArgs)); STACKTOP=tempVarArgs; //@line 41 "simulator/data_recorder.c"
 var $9=HEAP32[((5040)>>2)]; //@line 42 "simulator/data_recorder.c"
 var $10=_fwrite(1072,2,1,$9); //@line 42 "simulator/data_recorder.c"
 var $11=HEAP32[((5040)>>2)]; //@line 44 "simulator/data_recorder.c"
 var $call11=_fflush($11); //@line 44 "simulator/data_recorder.c"
 var $call12=_atexit(2); //@line 45 "simulator/data_recorder.c"
 STACKTOP=sp;return; //@line 46 "simulator/data_recorder.c"
}


function _add_trace_var($name,$pin){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=($pin|0)<100; //@line 49 "simulator/data_recorder.c"
 _sim_assert($cmp,936); //@line 49 "simulator/data_recorder.c"
 var $0=HEAP32[((5040)>>2)]; //@line 51 "simulator/data_recorder.c"
 var $tobool=($0|0)==0; //@line 51 "simulator/data_recorder.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 51 "simulator/data_recorder.c"
 case 2: 
 var $add=((($pin)+(1))|0); //@line 52 "simulator/data_recorder.c"
 var $call=_fprintf($0,3224,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$add,HEAP32[(((tempVarArgs)+(8))>>2)]=$name,tempVarArgs)); STACKTOP=tempVarArgs; //@line 52 "simulator/data_recorder.c"
 var $1=HEAP32[((5040)>>2)]; //@line 53 "simulator/data_recorder.c"
 var $call1=_fflush($1); //@line 53 "simulator/data_recorder.c"
 label=3;break; //@line 54 "simulator/data_recorder.c"
 case 3: 
 var $2=HEAP32[((3880)>>2)]; //@line 56 "simulator/data_recorder.c"
 var $cmp2=($2|0)>($pin|0); //@line 56 "simulator/data_recorder.c"
 if($cmp2){label=5;break;}else{label=4;break;} //@line 56 "simulator/data_recorder.c"
 case 4: 
 var $add4=((($pin)+(1))|0); //@line 57 "simulator/data_recorder.c"
 HEAP32[((3880)>>2)]=$add4; //@line 57 "simulator/data_recorder.c"
 label=5;break; //@line 57 "simulator/data_recorder.c"
 case 5: 
 STACKTOP=sp;return; //@line undefined "simulator/data_recorder.c"
  default: assert(0, "bad label: " + label);
 }

}


function _record_pin($pin,$state,$t$0,$t$1){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $arrayidx=((3296+($pin<<2))|0); //@line 73 "simulator/data_recorder.c"
 var $0=HEAP32[(($arrayidx)>>2)]; //@line 73 "simulator/data_recorder.c"
 var $cmp=($0|0)==($state|0); //@line 73 "simulator/data_recorder.c"
 var $ld$0$0=3856;
 var $1$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=3860;
 var $1$1=HEAP32[(($ld$1$1)>>2)];
 var $cmp1=(($1$0|0) == ($t$0|0)) & (($1$1|0) == ($t$1|0)); //@line 73 "simulator/data_recorder.c"
 var $or_cond=$cmp&$cmp1; //@line 73 "simulator/data_recorder.c"
 if($or_cond){label=3;break;}else{label=2;break;} //@line 73 "simulator/data_recorder.c"
 case 2: 
 var $cmp2=($pin|0)<100; //@line 75 "simulator/data_recorder.c"
 _sim_assert($cmp2,936); //@line 75 "simulator/data_recorder.c"
 _emit_log_data(); //@line 77 "simulator/data_recorder.c"
 var $st$2$0=3856;
 HEAP32[(($st$2$0)>>2)]=$t$0;
 var $st$3$1=3860;
 HEAP32[(($st$3$1)>>2)]=$t$1;
 HEAP32[(($arrayidx)>>2)]=$state; //@line 79 "simulator/data_recorder.c"
 label=3;break; //@line 80 "simulator/data_recorder.c"
 case 3: 
 return; //@line 80 "simulator/data_recorder.c"
  default: assert(0, "bad label: " + label);
 }

}


function _record_comment($msg){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((5040)>>2)]; //@line 83 "simulator/data_recorder.c"
 var $tobool=($0|0)==0; //@line 83 "simulator/data_recorder.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 83 "simulator/data_recorder.c"
 case 2: 
 var $call=_fprintf($0,3152,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$msg,tempVarArgs)); STACKTOP=tempVarArgs; //@line 84 "simulator/data_recorder.c"
 var $1=HEAP32[((5040)>>2)]; //@line 85 "simulator/data_recorder.c"
 var $call1=_fflush($1); //@line 85 "simulator/data_recorder.c"
 label=3;break; //@line 86 "simulator/data_recorder.c"
 case 3: 
 STACKTOP=sp;return; //@line 86 "simulator/data_recorder.c"
  default: assert(0, "bad label: " + label);
 }

}


function _record_raw($msg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((5040)>>2)]; //@line 89 "simulator/data_recorder.c"
 var $tobool=($0|0)==0; //@line 89 "simulator/data_recorder.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 89 "simulator/data_recorder.c"
 case 2: 
 var $fputs=_fputs($msg,$0); //@line 90 "simulator/data_recorder.c"
 var $1=HEAP32[((5040)>>2)]; //@line 91 "simulator/data_recorder.c"
 var $call1=_fflush($1); //@line 91 "simulator/data_recorder.c"
 label=3;break; //@line 92 "simulator/data_recorder.c"
 case 3: 
 return; //@line 92 "simulator/data_recorder.c"
  default: assert(0, "bad label: " + label);
 }

}


function _recorder_close(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((5040)>>2)]; //@line 22 "simulator/data_recorder.c"
 var $tobool=($0|0)==0; //@line 22 "simulator/data_recorder.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 22 "simulator/data_recorder.c"
 case 2: 
 _emit_log_data(); //@line 24 "simulator/data_recorder.c"
 var $1=HEAP32[((5040)>>2)]; //@line 25 "simulator/data_recorder.c"
 var $call=_fflush($1); //@line 25 "simulator/data_recorder.c"
 var $2=HEAP32[((5040)>>2)]; //@line 26 "simulator/data_recorder.c"
 var $call1=_fclose($2); //@line 26 "simulator/data_recorder.c"
 HEAP32[((5040)>>2)]=0; //@line 27 "simulator/data_recorder.c"
 label=3;break; //@line 28 "simulator/data_recorder.c"
 case 3: 
 return; //@line 28 "simulator/data_recorder.c"
  default: assert(0, "bad label: " + label);
 }

}


function _emit_log_data(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((5040)>>2)]; //@line 62 "simulator/data_recorder.c"
 var $tobool=($0|0)==0; //@line 62 "simulator/data_recorder.c"
 if($tobool){label=5;break;}else{label=2;break;} //@line 62 "simulator/data_recorder.c"
 case 2: 
 var $ld$0$0=3856;
 var $1$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=3860;
 var $1$1=HEAP32[(($ld$1$1)>>2)];
 var $$etemp$2$0=1000;
 var $$etemp$2$1=0;
 var $div$0=___udivdi3($1$0,$1$1,$$etemp$2$0,$$etemp$2$1);var $div$1=tempRet0; //@line 64 "simulator/data_recorder.c"
 var $$etemp$3=3032;
 var $call=_fprintf($0,$$etemp$3,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$div$0,HEAP32[(((tempVarArgs)+(8))>>2)]=$div$1,tempVarArgs)); STACKTOP=tempVarArgs;
 var $2=HEAP32[((3880)>>2)]; //@line 65 "simulator/data_recorder.c"
 var $cmp3=($2|0)>0; //@line 65 "simulator/data_recorder.c"
 var $3=HEAP32[((5040)>>2)]; //@line 66 "simulator/data_recorder.c"
 if($cmp3){var $i_04=0;var $4=$3;label=3;break;}else{var $_lcssa=$3;label=4;break;} //@line 65 "simulator/data_recorder.c"
 case 3: 
 var $4;
 var $i_04;
 var $arrayidx=((3296+($i_04<<2))|0); //@line 66 "simulator/data_recorder.c"
 var $5=HEAP32[(($arrayidx)>>2)]; //@line 66 "simulator/data_recorder.c"
 var $call1=_fprintf($4,3000,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$5,tempVarArgs)); STACKTOP=tempVarArgs; //@line 66 "simulator/data_recorder.c"
 var $inc=((($i_04)+(1))|0); //@line 65 "simulator/data_recorder.c"
 var $6=HEAP32[((3880)>>2)]; //@line 65 "simulator/data_recorder.c"
 var $cmp=($inc|0)<($6|0); //@line 65 "simulator/data_recorder.c"
 var $7=HEAP32[((5040)>>2)]; //@line 66 "simulator/data_recorder.c"
 if($cmp){var $i_04=$inc;var $4=$7;label=3;break;}else{var $_lcssa=$7;label=4;break;} //@line 65 "simulator/data_recorder.c"
 case 4: 
 var $_lcssa;
 var $fputc=_fputc(10,$_lcssa); //@line 67 "simulator/data_recorder.c"
 var $8=HEAP32[((5040)>>2)]; //@line 68 "simulator/data_recorder.c"
 var $call3=_fflush($8); //@line 68 "simulator/data_recorder.c"
 label=5;break; //@line 69 "simulator/data_recorder.c"
 case 5: 
 STACKTOP=sp;return; //@line 69 "simulator/data_recorder.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_time_warp(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP16[((40)>>1)]; //@line 71 "simulator/timer_ext.c"
 var $tobool=(($0<<16)>>16)==0; //@line 71 "simulator/timer_ext.c"
 if($tobool){label=2;break;}else{label=4;break;} //@line 71 "simulator/timer_ext.c"
 case 2: 
 var $1=HEAP8[(3720)]; //@line 71 "simulator/timer_ext.c"
 var $cmp=(($1<<24)>>24)==0; //@line 71 "simulator/timer_ext.c"
 if($cmp){label=4;break;}else{label=3;break;} //@line 71 "simulator/timer_ext.c"
 case 3: 
 var $2=HEAP32[((3288)>>2)]; //@line 74 "simulator/timer_ext.c"
 var $conv3$0=$2;
 var $conv3$1=0;
 var $ld$0$0=3728;
 var $3$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=3732;
 var $3$1=HEAP32[(($ld$1$1)>>2)];
 var $add$0=_i64Add($3$0,$3$1,$conv3$0,$conv3$1);var $add$1=tempRet0; //@line 74 "simulator/timer_ext.c"
 var $st$2$0=3728;
 HEAP32[(($st$2$0)>>2)]=$add$0;
 var $st$3$1=3732;
 HEAP32[(($st$3$1)>>2)]=$add$1;
 HEAP32[((3288)>>2)]=0; //@line 75 "simulator/timer_ext.c"
 _timer1_isr(); //@line 77 "simulator/timer_ext.c"
 label=4;break; //@line 78 "simulator/timer_ext.c"
 case 4: 
 return; //@line 78 "simulator/timer_ext.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_tick_counter(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP16[((40)>>1)]; //@line 81 "simulator/timer_ext.c"
 var $tobool=(($0<<16)>>16)==0; //@line 81 "simulator/timer_ext.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 81 "simulator/timer_ext.c"
 case 2: 
 var $call$0=_now_us();
 var $call$1=tempRet0;
 var $1=HEAP16[((40)>>1)]; //@line 83 "simulator/timer_ext.c"
 var $conv$0=($1&65535);
 var $conv$1=0;
 var $div$0=___udivdi3($call$0,$call$1,$conv$0,$conv$1);var $div$1=tempRet0; //@line 83 "simulator/timer_ext.c"
 var $mul$0=($div$0<<4)|(0>>>28);
 var $mul$1=($div$1<<4)|($div$0>>>28);
 var $mul_sink$1=$mul$1;var $mul_sink$0=$mul$0;label=4;break; //@line 83 "simulator/timer_ext.c"
 case 3: 
 var $ld$0$0=3728;
 var $2$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=3732;
 var $2$1=HEAP32[(($ld$1$1)>>2)];
 var $$etemp$2$0=65535;
 var $$etemp$2$1=0;
 var $rem$0=___uremdi3($2$0,$2$1,$$etemp$2$0,$$etemp$2$1);var $rem$1=tempRet0; //@line 85 "simulator/timer_ext.c"
 var $mul_sink$1=$rem$1;var $mul_sink$0=$rem$0;label=4;break; //@line 85 "simulator/timer_ext.c"
 case 4: 
 var $mul_sink$0;
 var $mul_sink$1;
 var $extract_t$0=$mul_sink$0;
 var $extract_t=$extract_t$0&65535;
 return $extract_t; //@line 86 "simulator/timer_ext.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_timer_init($scale){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $conv=($scale&255); //@line 95 "simulator/timer_ext.c"
 HEAP16[((40)>>1)]=$conv; //@line 95 "simulator/timer_ext.c"
 var $call$0=_now_ns();
 var $call$1=tempRet0;
 var $st$0$0=5160;
 HEAP32[(($st$0$0)>>2)]=$call$0;
 var $st$1$1=5164;
 HEAP32[(($st$1$1)>>2)]=$call$1;
 if((($scale<<24)>>24)==0){ label=2;break;}else if((($scale<<24)>>24)==1){ label=3;break;}else{label=4;break;}
 case 2: 
 _sim_info(1488,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 98 "simulator/timer_ext.c"
 label=5;break; //@line 98 "simulator/timer_ext.c"
 case 3: 
 _sim_info(2824,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 100 "simulator/timer_ext.c"
 label=5;break; //@line 100 "simulator/timer_ext.c"
 case 4: 
 var $conv1=($scale&255); //@line 97 "simulator/timer_ext.c"
 _sim_info(2408,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$conv1,tempVarArgs)); STACKTOP=tempVarArgs; //@line 102 "simulator/timer_ext.c"
 label=5;break;
 case 5: 
 HEAP8[(32)]=1;
 STACKTOP=sp;return; //@line 104 "simulator/timer_ext.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_timer_stop(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 _sim_info(1960,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 107 "simulator/timer_ext.c"
 HEAP8[(3720)]=0; //@line 108 "simulator/timer_ext.c"
 STACKTOP=sp;return; //@line 109 "simulator/timer_ext.c"
}


function _sim_runtime_ns(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP16[((40)>>1)]; //@line 112 "simulator/timer_ext.c"
 var $tobool=(($0<<16)>>16)==0; //@line 112 "simulator/timer_ext.c"
 if($tobool){label=3;break;}else{label=2;break;} //@line 112 "simulator/timer_ext.c"
 case 2: 
 var $call$0=_now_ns();
 var $call$1=tempRet0;
 var $ld$0$0=5160;
 var $1$0=HEAP32[(($ld$0$0)>>2)];
 var $ld$1$1=5164;
 var $1$1=HEAP32[(($ld$1$1)>>2)];
 var $sub$0=_i64Subtract($call$0,$call$1,$1$0,$1$1);var $sub$1=tempRet0; //@line 113 "simulator/timer_ext.c"
 var $2=HEAP16[((40)>>1)]; //@line 113 "simulator/timer_ext.c"
 var $conv$0=($2&65535);
 var $conv$1=0;
 var $div$0=___udivdi3($sub$0,$sub$1,$conv$0,$conv$1);var $div$1=tempRet0; //@line 113 "simulator/timer_ext.c"
 var $retval_0$1=$div$1;var $retval_0$0=$div$0;label=4;break; //@line 113 "simulator/timer_ext.c"
 case 3: 
 var $ld$2$0=3728;
 var $3$0=HEAP32[(($ld$2$0)>>2)];
 var $ld$3$1=3732;
 var $3$1=HEAP32[(($ld$3$1)>>2)];
 var $div1$0=($3$0>>>4)|($3$1<<28);
 var $div1$1=($3$1>>>4)|(0<<28);
 var $$etemp$4$0=1000;
 var $$etemp$4$1=0;
 var $mul$0=___muldi3($div1$0,$div1$1,$$etemp$4$0,$$etemp$4$1);var $mul$1=tempRet0; //@line 114 "simulator/timer_ext.c"
 var $retval_0$1=$mul$1;var $retval_0$0=$mul$0;label=4;break; //@line 114 "simulator/timer_ext.c"
 case 4: 
 var $retval_0$0;
 var $retval_0$1;
 return (tempRet0=$retval_0$1,$retval_0$0); //@line 115 "simulator/timer_ext.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_setTimer(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $call=_sim_tick_counter(); //@line 170 "simulator/timer_ext.c"
 var $_b=HEAP8[(32)];
 _sim_assert($_b,1712); //@line 172 "simulator/timer_ext.c"
 var $0=HEAP8[(5656)]; //@line 175 "simulator/timer_ext.c"
 var $and=$0&2; //@line 175 "simulator/timer_ext.c"
 var $tobool1=(($and<<24)>>24)==0; //@line 175 "simulator/timer_ext.c"
 if($tobool1){var $nextA_0=0;var $2=$0;label=3;break;}else{label=2;break;} //@line 175 "simulator/timer_ext.c"
 case 2: 
 _sim_debug(1520,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 176 "simulator/timer_ext.c"
 var $1=HEAP16[((5688)>>1)]; //@line 177 "simulator/timer_ext.c"
 var $conv2=($1&65535); //@line 177 "simulator/timer_ext.c"
 var $conv3=($call&65535); //@line 177 "simulator/timer_ext.c"
 var $sub=((($conv2)-($conv3))|0); //@line 177 "simulator/timer_ext.c"
 var $and4=$sub&65535; //@line 177 "simulator/timer_ext.c"
 var $tobool5=($and4|0)!=0; //@line 179 "simulator/timer_ext.c"
 var $and4_=($tobool5?$and4:65536); //@line 179 "simulator/timer_ext.c"
 var $_pre=HEAP8[(5656)]; //@line 182 "simulator/timer_ext.c"
 var $nextA_0=$and4_;var $2=$_pre;label=3;break; //@line 180 "simulator/timer_ext.c"
 case 3: 
 var $2;
 var $nextA_0;
 var $and9=$2&8; //@line 182 "simulator/timer_ext.c"
 var $tobool10=(($and9<<24)>>24)==0; //@line 182 "simulator/timer_ext.c"
 if($tobool10){var $next_0=$nextA_0;var $nextB_027=0;label=5;break;}else{label=4;break;} //@line 182 "simulator/timer_ext.c"
 case 4: 
 _sim_debug(1368,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 183 "simulator/timer_ext.c"
 var $3=HEAP16[((5680)>>1)]; //@line 184 "simulator/timer_ext.c"
 var $conv12=($3&65535); //@line 184 "simulator/timer_ext.c"
 var $conv13=($call&65535); //@line 184 "simulator/timer_ext.c"
 var $sub14=((($conv12)-($conv13))|0); //@line 184 "simulator/timer_ext.c"
 var $and15=$sub14&65535; //@line 184 "simulator/timer_ext.c"
 var $tobool16=($and15|0)!=0; //@line 186 "simulator/timer_ext.c"
 var $and15_=($tobool16?$and15:65536);
 var $4=((($nextA_0)-(1))|0); //@line 191 "simulator/timer_ext.c"
 var $5=($4>>>0)>=($and15_>>>0); //@line 191 "simulator/timer_ext.c"
 var $nextB_0_nextA_0=($5?$and15_:$nextA_0); //@line 191 "simulator/timer_ext.c"
 var $next_0=$nextB_0_nextA_0;var $nextB_027=$and15_;label=5;break; //@line 191 "simulator/timer_ext.c"
 case 5: 
 var $nextB_027;
 var $next_0;
 HEAP8[(3720)]=0; //@line 195 "simulator/timer_ext.c"
 var $tobool25=($next_0|0)!=0; //@line 196 "simulator/timer_ext.c"
 var $cmp27=($next_0|0)==($nextA_0|0); //@line 196 "simulator/timer_ext.c"
 var $or_cond23=$tobool25&$cmp27; //@line 196 "simulator/timer_ext.c"
 if($or_cond23){label=6;break;}else{label=7;break;} //@line 196 "simulator/timer_ext.c"
 case 6: 
 var $6=HEAP8[(3720)]; //@line 196 "simulator/timer_ext.c"
 var $or=$6|1; //@line 196 "simulator/timer_ext.c"
 HEAP8[(3720)]=$or; //@line 196 "simulator/timer_ext.c"
 label=7;break; //@line 196 "simulator/timer_ext.c"
 case 7: 
 var $cmp35=($next_0|0)==($nextB_027|0); //@line 197 "simulator/timer_ext.c"
 var $or_cond24=$tobool25&$cmp35; //@line 197 "simulator/timer_ext.c"
 if($or_cond24){label=8;break;}else{label=9;break;} //@line 197 "simulator/timer_ext.c"
 case 8: 
 var $7=HEAP8[(3720)]; //@line 197 "simulator/timer_ext.c"
 var $or39=$7|2; //@line 197 "simulator/timer_ext.c"
 HEAP8[(3720)]=$or39; //@line 197 "simulator/timer_ext.c"
 label=9;break; //@line 197 "simulator/timer_ext.c"
 case 9: 
 HEAP32[((3288)>>2)]=$next_0; //@line 199 "simulator/timer_ext.c"
 var $8=HEAP16[((40)>>1)]; //@line 201 "simulator/timer_ext.c"
 var $tobool42=(($8<<16)>>16)==0; //@line 201 "simulator/timer_ext.c"
 if($tobool42){label=13;break;}else{label=10;break;} //@line 201 "simulator/timer_ext.c"
 case 10: 
 var $conv44=($8&65535); //@line 212 "simulator/timer_ext.c"
 var $mul=(Math_imul($conv44,$next_0)|0); //@line 212 "simulator/timer_ext.c"
 var $div=$mul>>>4; //@line 212 "simulator/timer_ext.c"
 var $tobool45=($next_0|0)==0; //@line 213 "simulator/timer_ext.c"
 var $tobool47=($div|0)!=0; //@line 213 "simulator/timer_ext.c"
 var $or_cond=$tobool45|$tobool47; //@line 213 "simulator/timer_ext.c"
 var $9=($or_cond&1); //@line 213 "simulator/timer_ext.c"
 var $inc=$9^1; //@line 213 "simulator/timer_ext.c"
 var $div_inc=((($inc)+($div))|0); //@line 213 "simulator/timer_ext.c"
 if($tobool25){label=11;break;}else{label=12;break;} //@line 217 "simulator/timer_ext.c"
 case 11: 
 var $10=HEAP16[((5688)>>1)]; //@line 218 "simulator/timer_ext.c"
 var $conv52=($10&65535); //@line 218 "simulator/timer_ext.c"
 var $11=HEAP16[((5680)>>1)]; //@line 218 "simulator/timer_ext.c"
 var $conv53=($11&65535); //@line 218 "simulator/timer_ext.c"
 var $conv54=($call&65535); //@line 218 "simulator/timer_ext.c"
 _sim_debug(1200,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 24)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$conv52,HEAP32[(((tempVarArgs)+(8))>>2)]=$conv53,HEAP32[(((tempVarArgs)+(16))>>2)]=$conv54,tempVarArgs)); STACKTOP=tempVarArgs; //@line 218 "simulator/timer_ext.c"
 _sim_debug(1040,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$next_0,HEAP32[(((tempVarArgs)+(8))>>2)]=$div_inc,tempVarArgs)); STACKTOP=tempVarArgs; //@line 219 "simulator/timer_ext.c"
 label=12;break; //@line 220 "simulator/timer_ext.c"
 case 12: 
 _schedule_timer($div_inc); //@line 223 "simulator/timer_ext.c"
 label=13;break; //@line 224 "simulator/timer_ext.c"
 case 13: 
 STACKTOP=sp;return; //@line 225 "simulator/timer_ext.c"
  default: assert(0, "bad label: " + label);
 }

}


function _timer1_isr(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP8[(3720)]; //@line 122 "simulator/timer_ext.c"
 var $1=HEAP8[(3824)]; //@line 123 "simulator/timer_ext.c"
 var $2=$1&1; //@line 123 "simulator/timer_ext.c"
 var $tobool=(($2<<24)>>24)==0; //@line 123 "simulator/timer_ext.c"
 if($tobool){label=2;break;}else{label=3;break;} //@line 123 "simulator/timer_ext.c"
 case 2: 
 _schedule_timer(10); //@line 125 "simulator/timer_ext.c"
 label=8;break; //@line 126 "simulator/timer_ext.c"
 case 3: 
 HEAP8[(3720)]=0; //@line 128 "simulator/timer_ext.c"
 _cli(); //@line 130 "simulator/timer_ext.c"
 var $conv=($0&255); //@line 158 "simulator/timer_ext.c"
 var $and=$conv&1; //@line 158 "simulator/timer_ext.c"
 var $tobool1=($and|0)==0; //@line 158 "simulator/timer_ext.c"
 if($tobool1){label=5;break;}else{label=4;break;} //@line 158 "simulator/timer_ext.c"
 case 4: 
 _TIMER1_COMPA_vect(); //@line 158 "simulator/timer_ext.c"
 label=5;break; //@line 158 "simulator/timer_ext.c"
 case 5: 
 var $and5=$conv&2; //@line 159 "simulator/timer_ext.c"
 var $tobool6=($and5|0)==0; //@line 159 "simulator/timer_ext.c"
 if($tobool6){label=7;break;}else{label=6;break;} //@line 159 "simulator/timer_ext.c"
 case 6: 
 _TIMER1_COMPB_vect(); //@line 159 "simulator/timer_ext.c"
 label=7;break; //@line 159 "simulator/timer_ext.c"
 case 7: 
 _sei(); //@line 161 "simulator/timer_ext.c"
 _sim_setTimer(); //@line 164 "simulator/timer_ext.c"
 label=8;break; //@line 165 "simulator/timer_ext.c"
 case 8: 
 return; //@line 165 "simulator/timer_ext.c"
  default: assert(0, "bad label: " + label);
 }

}


function _now_us(){
 var label=0;


 var $call$0=_now_ns();
 var $call$1=tempRet0;
 var $$etemp$0$0=1000;
 var $$etemp$0$1=0;
 var $div$0=___udivdi3($call$0,$call$1,$$etemp$0$0,$$etemp$0$1);var $div$1=tempRet0; //@line 67 "simulator/timer_ext.c"
 return (tempRet0=$div$1,$div$0); //@line 67 "simulator/timer_ext.c"
}


function _now_ns(){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $tv=sp;
 var $call=_clock_gettime(1,$tv); //@line 55 "simulator/timer_ext.c"
 var $cmp=($call|0)==0; //@line 56 "simulator/timer_ext.c"
 _sim_assert($cmp,3176); //@line 56 "simulator/timer_ext.c"
 var $tv_sec=(($tv)|0); //@line 59 "simulator/timer_ext.c"
 var $0=HEAP32[(($tv_sec)>>2)]; //@line 59 "simulator/timer_ext.c"
 var $conv$0=$0;
 var $conv$1=((((($0|0)<0))|0)?-1:0);
 var $$etemp$0$0=1000000000;
 var $$etemp$0$1=0;
 var $mul$0=___muldi3($conv$0,$conv$1,$$etemp$0$0,$$etemp$0$1);var $mul$1=tempRet0; //@line 60 "simulator/timer_ext.c"
 var $tv_nsec=(($tv+4)|0); //@line 61 "simulator/timer_ext.c"
 var $1=HEAP32[(($tv_nsec)>>2)]; //@line 61 "simulator/timer_ext.c"
 var $conv1$0=$1;
 var $conv1$1=((((($1|0)<0))|0)?-1:0);
 var $add$0=_i64Add($mul$0,$mul$1,$conv1$0,$conv1$1);var $add$1=tempRet0; //@line 61 "simulator/timer_ext.c"
 STACKTOP=sp;return (tempRet0=$add$1,$add$0); //@line 62 "simulator/timer_ext.c"
}


function _schedule_timer($useconds){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+160)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $itimer=sp;
 var $sa=(sp)+(16);
 var $0=HEAP16[((40)>>1)]; //@line 233 "simulator/timer_ext.c"
 var $tobool=(($0<<16)>>16)==0; //@line 233 "simulator/timer_ext.c"
 if($tobool){label=5;break;}else{label=2;break;} //@line 233 "simulator/timer_ext.c"
 case 2: 
 var $1=(($sa)|0); //@line 234 "simulator/timer_ext.c"
 HEAP32[(($1)>>2)]=(4); //@line 234 "simulator/timer_ext.c"
 var $sa_mask=(($sa+4)|0); //@line 235 "simulator/timer_ext.c"
 var $call=_sigemptyset($sa_mask); //@line 235 "simulator/timer_ext.c"
 var $sa_flags=(($sa+132)|0); //@line 236 "simulator/timer_ext.c"
 HEAP32[(($sa_flags)>>2)]=4; //@line 236 "simulator/timer_ext.c"
 var $call1=_sigaction(14,$sa,0); //@line 237 "simulator/timer_ext.c"
 var $tobool2=($call1|0)==0; //@line 237 "simulator/timer_ext.c"
 if($tobool2){label=4;break;}else{label=3;break;} //@line 237 "simulator/timer_ext.c"
 case 3: 
 _sim_error(872); //@line 238 "simulator/timer_ext.c"
 label=4;break; //@line 239 "simulator/timer_ext.c"
 case 4: 
 var $tv_sec=(($itimer)|0); //@line 240 "simulator/timer_ext.c"
 HEAP32[(($tv_sec)>>2)]=0; //@line 240 "simulator/timer_ext.c"
 var $tv_usec=(($itimer+4)|0); //@line 241 "simulator/timer_ext.c"
 HEAP32[(($tv_usec)>>2)]=0; //@line 241 "simulator/timer_ext.c"
 var $div=(((($useconds>>>0))/(1000000))&-1); //@line 242 "simulator/timer_ext.c"
 var $tv_sec5=(($itimer+8)|0); //@line 242 "simulator/timer_ext.c"
 HEAP32[(($tv_sec5)>>2)]=$div; //@line 242 "simulator/timer_ext.c"
 var $rem=(((($useconds>>>0))%(1000000))&-1); //@line 243 "simulator/timer_ext.c"
 var $tv_usec7=(($itimer+12)|0); //@line 243 "simulator/timer_ext.c"
 HEAP32[(($tv_usec7)>>2)]=$rem; //@line 243 "simulator/timer_ext.c"
 var $call8=_setitimer(0,$itimer,0); //@line 244 "simulator/timer_ext.c"
 label=5;break; //@line 245 "simulator/timer_ext.c"
 case 5: 
 STACKTOP=sp;return; //@line 246 "simulator/timer_ext.c"
  default: assert(0, "bad label: " + label);
 }

}


function _timer1_callback($cause,$HowCome,$ucontext){
 var label=0;


 _timer1_isr(); //@line 118 "simulator/timer_ext.c"
 return; //@line 119 "simulator/timer_ext.c"
}


function _heater_init(){
 var label=0;


 return; //@line 5 "simulator/heater_sim.c"
}


function _heater_set($index,$value){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 _sim_info(1160,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line undefined "simulator/heater_sim.c"
 STACKTOP=sp;return; //@line 9 "simulator/heater_sim.c"
}


function _heater_tick($h,$type,$current_temp,$target_temp){
 var label=0;


 return; //@line 12 "simulator/heater_sim.c"
}


function _heaters_all_zero(){
 var label=0;


 return 1; //@line 15 "simulator/heater_sim.c"
}


function _pid_set_p($index,$p){
 var label=0;


 return; //@line 19 "simulator/heater_sim.c"
}


function _pid_set_i($index,$i){
 var label=0;


 return; //@line 20 "simulator/heater_sim.c"
}


function _pid_set_d($index,$d){
 var label=0;


 return; //@line 21 "simulator/heater_sim.c"
}


function _pid_set_i_limit($index,$i_limit){
 var label=0;


 return; //@line 22 "simulator/heater_sim.c"
}


function _heater_save_settings(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 _sim_info(1160,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 24 "simulator/heater_sim.c"
 STACKTOP=sp;return; //@line 25 "simulator/heater_sim.c"
}


function _analog_init(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 _sim_info(888,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 7 "simulator/analog_sim.c"
 HEAP8[(864)]=1;
 STACKTOP=sp;return; //@line 9 "simulator/analog_sim.c"
}


function _analog_read($channel){
 var label=0;


 var $_b=HEAP8[(864)];
 _sim_assert($_b,2720); //@line 12 "simulator/analog_sim.c"
 var $0=HEAP8[(3824)]; //@line 13 "simulator/analog_sim.c"
 var $1=$0&1; //@line 13 "simulator/analog_sim.c"
 var $tobool1=(($1<<24)>>24)!=0; //@line 13 "simulator/analog_sim.c"
 _sim_assert($tobool1,2336); //@line 13 "simulator/analog_sim.c"
 return 0; //@line 14 "simulator/analog_sim.c"
}


function _delay_ms($ms){
 var label=0;


 var $mul=((($ms)*(1000))&-1); //@line 7 "simulator/delay_sim.c"
 var $call=_usleep($mul); //@line 7 "simulator/delay_sim.c"
 return; //@line undefined "simulator/delay_sim.c"
}


function _delay_us($us){
 var label=0;


 var $conv=($us&65535); //@line 11 "simulator/delay_sim.c"
 var $call=_usleep($conv); //@line 11 "simulator/delay_sim.c"
 return; //@line 12 "simulator/delay_sim.c"
}


function _sim_start($argc,$argv){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $index=sp;
 var $time_scale_0_ph=10;label=2;break; //@line 76 "simulator/simulator.c"
 case 2: 
 var $time_scale_0_ph;
 label=3;break;
 case 3: 
 var $0=HEAP32[((608)>>2)]; //@line 76 "simulator/simulator.c"
 var $call=_getopt_long($argc,$argv,$0,680,$index); //@line 76 "simulator/simulator.c"
 switch(($call|0)){case -1:{ label=11;break;}case 113:{ label=4;break;}case 103:{ label=5;break;}case 112:{ label=6;break;}case 118:{ label=7;break;}case 116:{ label=8;break;}case 111:{ label=9;break;}default:{label=10;break;}}break;
 case 4: 
 HEAP32[((8)>>2)]=0; //@line 79 "simulator/simulator.c"
 label=3;break; //@line 80 "simulator/simulator.c"
 case 5: 
 HEAP32[((3704)>>2)]=1; //@line 82 "simulator/simulator.c"
 label=3;break; //@line 83 "simulator/simulator.c"
 case 6: 
 HEAP32[((3696)>>2)]=1; //@line 85 "simulator/simulator.c"
 label=3;break; //@line 86 "simulator/simulator.c"
 case 7: 
 var $1=HEAP32[((8)>>2)]; //@line 88 "simulator/simulator.c"
 var $add=((($1)+(1))|0); //@line 88 "simulator/simulator.c"
 HEAP32[((8)>>2)]=$add; //@line 88 "simulator/simulator.c"
 label=3;break; //@line 89 "simulator/simulator.c"
 case 8: 
 var $2=HEAP32[((3896)>>2)]; //@line 91 "simulator/simulator.c"
 var $call5=_atoi($2); //@line 91 "simulator/simulator.c"
 var $conv=(($call5)&255); //@line 91 "simulator/simulator.c"
 var $time_scale_0_ph=$conv;label=2;break; //@line 92 "simulator/simulator.c"
 case 9: 
 var $3=HEAP32[((3896)>>2)]; //@line 94 "simulator/simulator.c"
 var $tobool=($3|0)!=0; //@line 94 "simulator/simulator.c"
 var $cond=($tobool?$3:1344); //@line 94 "simulator/simulator.c"
 _recorder_init($cond); //@line 94 "simulator/simulator.c"
 label=3;break; //@line 95 "simulator/simulator.c"
 case 10: 
 _sim_error(1104); //@line 97 "simulator/simulator.c"
 throw "Reached an unreachable!";
 case 11: 
 _record_raw(992); //@line 101 "simulator/simulator.c"
 HEAP32[(($index)>>2)]=0; //@line 102 "simulator/simulator.c"
 var $cmp78=($argc|0)>0; //@line 102 "simulator/simulator.c"
 if($cmp78){var $storemerge9=0;label=12;break;}else{label=13;break;} //@line 102 "simulator/simulator.c"
 case 12: 
 var $storemerge9;
 var $arrayidx=(($argv+($storemerge9<<2))|0); //@line 103 "simulator/simulator.c"
 var $4=HEAP32[(($arrayidx)>>2)]; //@line 103 "simulator/simulator.c"
 _record_raw($4); //@line 103 "simulator/simulator.c"
 _record_raw(3216); //@line 104 "simulator/simulator.c"
 var $5=HEAP32[(($index)>>2)]; //@line 102 "simulator/simulator.c"
 var $inc=((($5)+(1))|0); //@line 102 "simulator/simulator.c"
 HEAP32[(($index)>>2)]=$inc; //@line 102 "simulator/simulator.c"
 var $cmp7=($inc|0)<($argc|0); //@line 102 "simulator/simulator.c"
 if($cmp7){var $storemerge9=$inc;label=12;break;}else{label=13;break;} //@line 102 "simulator/simulator.c"
 case 13: 
 _record_raw(584); //@line 106 "simulator/simulator.c"
 var $6=HEAP32[((776)>>2)]; //@line 109 "simulator/simulator.c"
 var $sub=((($argc)+(1))|0); //@line 109 "simulator/simulator.c"
 var $add9=((($sub)-($6))|0); //@line 109 "simulator/simulator.c"
 HEAP32[((5032)>>2)]=$add9; //@line 109 "simulator/simulator.c"
 var $add_ptr_sum=((($6)-(1))|0); //@line 110 "simulator/simulator.c"
 var $add_ptr10=(($argv+($add_ptr_sum<<2))|0); //@line 110 "simulator/simulator.c"
 HEAP32[((5024)>>2)]=$add_ptr10; //@line 110 "simulator/simulator.c"
 var $cmp11=($argc|0)<2; //@line 112 "simulator/simulator.c"
 if($cmp11){label=14;break;}else{label=15;break;} //@line 112 "simulator/simulator.c"
 case 14: 
 var $7=HEAP32[(($argv)>>2)]; //@line 112 "simulator/simulator.c"
 _usage($7); //@line 112 "simulator/simulator.c"
 throw "Reached an unreachable!";
 case 15: 
 _sim_timer_init($time_scale_0_ph); //@line 115 "simulator/simulator.c"
 _add_trace_var(3072,0); //@line 123 "simulator/simulator.c"
 _add_trace_var(3024,1); //@line 123 "simulator/simulator.c"
 _add_trace_var(2992,2); //@line 123 "simulator/simulator.c"
 _add_trace_var(2944,3); //@line 123 "simulator/simulator.c"
 _add_trace_var(2848,4); //@line 126 "simulator/simulator.c"
 _add_trace_var(2808,5); //@line 127 "simulator/simulator.c"
 _add_trace_var(2792,6); //@line 128 "simulator/simulator.c"
 _add_trace_var(2776,7); //@line 129 "simulator/simulator.c"
 _add_trace_var(2704,8); //@line 130 "simulator/simulator.c"
 _add_trace_var(2688,9); //@line 131 "simulator/simulator.c"
 _add_trace_var(2616,10); //@line 132 "simulator/simulator.c"
 _add_trace_var(2560,11); //@line 133 "simulator/simulator.c"
 _add_trace_var(2544,12); //@line 134 "simulator/simulator.c"
 _add_trace_var(2496,13); //@line 135 "simulator/simulator.c"
 _add_trace_var(2432,14); //@line 136 "simulator/simulator.c"
 _add_trace_var(2392,15); //@line 137 "simulator/simulator.c"
 _add_trace_var(2376,16); //@line 138 "simulator/simulator.c"
 _add_trace_var(2360,17); //@line 139 "simulator/simulator.c"
 _add_trace_var(2304,18); //@line 140 "simulator/simulator.c"
 _add_trace_var(2280,19); //@line 142 "simulator/simulator.c"
 STACKTOP=sp;return; //@line 143 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_error($msg){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 _clearline(); //@line 245 "simulator/simulator.c"
 _fred(); //@line 246 "simulator/simulator.c"
 var $call=_printf(2048,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$msg,tempVarArgs)); STACKTOP=tempVarArgs; //@line 247 "simulator/simulator.c"
 var $0=HEAP32[((_stdout)>>2)]; //@line 248 "simulator/simulator.c"
 var $call1=_fputc(10,$0); //@line 248 "simulator/simulator.c"
 _fbreset(); //@line 249 "simulator/simulator.c"
 _exit(-1); //@line 250 "simulator/simulator.c"
 throw "Reached an unreachable!"; //@line 250 "simulator/simulator.c"
}


function _sim_info($fmt,varrp){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $ap=sp;
 _clearline(); //@line 179 "simulator/simulator.c"
 var $arraydecay=(($ap)|0); //@line 180 "simulator/simulator.c"
 var $arraydecay1=$ap; //@line 180 "simulator/simulator.c"
 HEAP32[(($arraydecay1)>>2)]=varrp;HEAP32[((($arraydecay1)+(4))>>2)]=0; //@line 180 "simulator/simulator.c"
 _vsim_info_cont($fmt,$arraydecay); //@line 181 "simulator/simulator.c"
 //@line 182 "simulator/simulator.c"
 var $0=HEAP32[((8)>>2)]; //@line 183 "simulator/simulator.c"
 var $cmp=($0|0)<1; //@line 183 "simulator/simulator.c"
 if($cmp){label=3;break;}else{label=2;break;} //@line 183 "simulator/simulator.c"
 case 2: 
 var $1=HEAP32[((_stdout)>>2)]; //@line 184 "simulator/simulator.c"
 var $call=_fputc(10,$1); //@line 184 "simulator/simulator.c"
 label=3;break; //@line 185 "simulator/simulator.c"
 case 3: 
 STACKTOP=sp;return; //@line 185 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_debug($fmt,varrp){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $ap=sp;
 var $0=HEAP32[((8)>>2)]; //@line 189 "simulator/simulator.c"
 var $cmp=($0|0)<3; //@line 189 "simulator/simulator.c"
 if($cmp){label=3;break;}else{label=2;break;} //@line 189 "simulator/simulator.c"
 case 2: 
 _clearline(); //@line 190 "simulator/simulator.c"
 _fcyan(); //@line 191 "simulator/simulator.c"
 var $arraydecay=(($ap)|0); //@line 192 "simulator/simulator.c"
 var $arraydecay1=$ap; //@line 192 "simulator/simulator.c"
 HEAP32[(($arraydecay1)>>2)]=varrp;HEAP32[((($arraydecay1)+(4))>>2)]=0; //@line 192 "simulator/simulator.c"
 var $call=_vprintf($fmt,$arraydecay); //@line 193 "simulator/simulator.c"
 //@line 194 "simulator/simulator.c"
 var $1=HEAP32[((_stdout)>>2)]; //@line 195 "simulator/simulator.c"
 var $call5=_fputc(10,$1); //@line 195 "simulator/simulator.c"
 _fbreset(); //@line 196 "simulator/simulator.c"
 label=3;break; //@line 197 "simulator/simulator.c"
 case 3: 
 STACKTOP=sp;return; //@line 197 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_tick($ch){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((8)>>2)]; //@line 200 "simulator/simulator.c"
 var $cmp=($0|0)<2; //@line 200 "simulator/simulator.c"
 if($cmp){label=3;break;}else{label=2;break;} //@line 200 "simulator/simulator.c"
 case 2: 
 _fcyan(); //@line 201 "simulator/simulator.c"
 var $1=HEAP32[((_stdout)>>2)]; //@line 202 "simulator/simulator.c"
 var $conv=($ch&255); //@line 202 "simulator/simulator.c"
 var $fputc=_fputc($conv,$1); //@line 202 "simulator/simulator.c"
 _fbreset(); //@line 203 "simulator/simulator.c"
 var $call1=_fflush($1); //@line 204 "simulator/simulator.c"
 label=3;break; //@line 205 "simulator/simulator.c"
 case 3: 
 return; //@line 205 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_gcode_ch($ch){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((4712)>>2)]; //@line 211 "simulator/simulator.c"
 var $cmp=($0|0)==299; //@line 211 "simulator/simulator.c"
 var $cmp1=(($ch<<24)>>24)==13; //@line 211 "simulator/simulator.c"
 var $or_cond=$cmp|$cmp1; //@line 211 "simulator/simulator.c"
 var $cmp5=(($ch<<24)>>24)==10; //@line 211 "simulator/simulator.c"
 var $or_cond7=$or_cond|$cmp5; //@line 211 "simulator/simulator.c"
 var $cmp9=(($ch<<24)>>24)==0; //@line 211 "simulator/simulator.c"
 var $or_cond8=$or_cond7|$cmp9; //@line 211 "simulator/simulator.c"
 if($or_cond8){label=2;break;}else{var $3=$0;label=8;break;} //@line 211 "simulator/simulator.c"
 case 2: 
 var $tobool=($0|0)==0; //@line 215 "simulator/simulator.c"
 if($tobool){label=6;break;}else{label=3;break;} //@line 215 "simulator/simulator.c"
 case 3: 
 var $arrayidx=((4720+$0)|0); //@line 216 "simulator/simulator.c"
 HEAP8[($arrayidx)]=0; //@line 216 "simulator/simulator.c"
 HEAP32[((4712)>>2)]=0; //@line 217 "simulator/simulator.c"
 var $1=HEAP32[((3704)>>2)]; //@line 219 "simulator/simulator.c"
 var $tobool12=($1|0)==0; //@line 219 "simulator/simulator.c"
 if($tobool12){label=5;break;}else{label=4;break;} //@line 219 "simulator/simulator.c"
 case 4: 
 _clearline(); //@line 220 "simulator/simulator.c"
 _fyellow(); //@line 221 "simulator/simulator.c"
 var $puts=_puts(4720); //@line 222 "simulator/simulator.c"
 _fbreset(); //@line 223 "simulator/simulator.c"
 var $2=HEAP32[((_stdout)>>2)]; //@line 224 "simulator/simulator.c"
 var $call14=_fflush($2); //@line 224 "simulator/simulator.c"
 label=5;break; //@line 225 "simulator/simulator.c"
 case 5: 
 _record_comment(4720); //@line 228 "simulator/simulator.c"
 label=6;break; //@line 229 "simulator/simulator.c"
 case 6: 
 if((($ch<<24)>>24)==13|(($ch<<24)>>24)==10|(($ch<<24)>>24)==0){ label=9;break;}else{label=7;break;}
 case 7: 
 var $_pre=HEAP32[((4712)>>2)]; //@line 236 "simulator/simulator.c"
 var $3=$_pre;label=8;break; //@line 231 "simulator/simulator.c"
 case 8: 
 var $3;
 var $inc=((($3)+(1))|0); //@line 236 "simulator/simulator.c"
 HEAP32[((4712)>>2)]=$inc; //@line 236 "simulator/simulator.c"
 var $arrayidx30=((4720+$3)|0); //@line 236 "simulator/simulator.c"
 HEAP8[($arrayidx30)]=$ch; //@line 236 "simulator/simulator.c"
 label=9;break; //@line 237 "simulator/simulator.c"
 case 9: 
 return; //@line 237 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_gcode($msg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP8[($msg)]; //@line 240 "simulator/simulator.c"
 var $tobool3=(($0<<24)>>24)==0; //@line 240 "simulator/simulator.c"
 if($tobool3){label=3;break;}else{var $msg_addr_04=$msg;var $1=$0;label=2;break;} //@line 240 "simulator/simulator.c"
 case 2: 
 var $1;
 var $msg_addr_04;
 _sim_gcode_ch($1); //@line 240 "simulator/simulator.c"
 var $incdec_ptr=(($msg_addr_04+1)|0); //@line 240 "simulator/simulator.c"
 var $2=HEAP8[($incdec_ptr)]; //@line 240 "simulator/simulator.c"
 var $tobool=(($2<<24)>>24)==0; //@line 240 "simulator/simulator.c"
 if($tobool){label=3;break;}else{var $msg_addr_04=$incdec_ptr;var $1=$2;label=2;break;} //@line 240 "simulator/simulator.c"
 case 3: 
 _sim_gcode_ch(0); //@line 241 "simulator/simulator.c"
 return; //@line 242 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_assert($cond,$msg){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 if($cond){label=3;break;}else{label=2;break;} //@line 254 "simulator/simulator.c"
 case 2: 
 _sim_error($msg); //@line 255 "simulator/simulator.c"
 throw "Reached an unreachable!";
 case 3: 
 return; //@line 257 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sei(){
 var label=0;


 HEAP8[(3824)]=1; //@line 265 "simulator/simulator.c"
 return; //@line 266 "simulator/simulator.c"
}


function _cli(){
 var label=0;


 HEAP8[(3824)]=0; //@line 269 "simulator/simulator.c"
 return; //@line 270 "simulator/simulator.c"
}


function _WRITE($pin,$s){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $idxprom=($pin&255); //@line 309 "simulator/simulator.c"
 var $arrayidx=((3752+$idxprom)|0); //@line 309 "simulator/simulator.c"
 var $0=HEAP8[($arrayidx)]; //@line 309 "simulator/simulator.c"
 var $1=$0&1; //@line 309 "simulator/simulator.c"
 var $call$0=_sim_runtime_ns();
 var $call$1=tempRet0;
 var $cmp=($pin&255)<22; //@line 311 "simulator/simulator.c"
 _sim_assert($cmp,1976); //@line 311 "simulator/simulator.c"
 var $arrayidx4=((5048+$idxprom)|0); //@line 313 "simulator/simulator.c"
 var $2=HEAP8[($arrayidx4)]; //@line 313 "simulator/simulator.c"
 var $3=$2&1; //@line 313 "simulator/simulator.c"
 var $tobool5=(($3<<24)>>24)==0; //@line 313 "simulator/simulator.c"
 if($tobool5){label=3;break;}else{label=2;break;} //@line 313 "simulator/simulator.c"
 case 2: 
 var $frombool12=($s&1); //@line 314 "simulator/simulator.c"
 HEAP8[($arrayidx)]=$frombool12; //@line 314 "simulator/simulator.c"
 label=3;break; //@line 315 "simulator/simulator.c"
 case 3: 
 var $conv14=($1&255); //@line 317 "simulator/simulator.c"
 var $conv16=($s&1); //@line 317 "simulator/simulator.c"
 var $cmp17=($conv14|0)==($conv16|0); //@line 317 "simulator/simulator.c"
 if($cmp17){label=8;break;}else{label=4;break;} //@line 317 "simulator/simulator.c"
 case 4: 
 var $add=((($idxprom)+(4))|0); //@line 318 "simulator/simulator.c"
 _record_pin($add,$conv16,$call$0,$call$1);
 _bred(); //@line 328 "simulator/simulator.c"
 if($s){label=5;break;}else{label=6;break;} //@line 329 "simulator/simulator.c"
 case 5: 
 var $add26=((($pin)+(65))&255); //@line 330 "simulator/simulator.c"
 _sim_tick($add26); //@line 330 "simulator/simulator.c"
 label=7;break; //@line 330 "simulator/simulator.c"
 case 6: 
 var $add29=((($pin)+(97))&255); //@line 332 "simulator/simulator.c"
 _sim_tick($add29); //@line 332 "simulator/simulator.c"
 label=7;break;
 case 7: 
 _fbreset(); //@line 333 "simulator/simulator.c"
 label=8;break; //@line 335 "simulator/simulator.c"
 case 8: 
 var $s_not=$s^1; //@line 337 "simulator/simulator.c"
 var $tobool_not=(($1<<24)>>24)!=0; //@line 337 "simulator/simulator.c"
 var $brmerge=$tobool_not|$s_not; //@line 337 "simulator/simulator.c"
 if($brmerge){label=14;break;}else{label=9;break;} //@line 337 "simulator/simulator.c"
 case 9: 
 if(($idxprom|0)==4){ label=10;break;}else if(($idxprom|0)==8){ label=11;break;}else if(($idxprom|0)==12){ label=12;break;}else if(($idxprom|0)==0){ var $dir_0_ph_in_in_in_in_in=3753;var $axis_0_ph=0;label=13;break;}else{label=14;break;}
 case 10: 
 var $dir_0_ph_in_in_in_in_in=3757;var $axis_0_ph=1;label=13;break; //@line 354 "simulator/simulator.c"
 case 11: 
 var $dir_0_ph_in_in_in_in_in=3761;var $axis_0_ph=2;label=13;break; //@line 361 "simulator/simulator.c"
 case 12: 
 var $dir_0_ph_in_in_in_in_in=3765;var $axis_0_ph=3;label=13;break; //@line 368 "simulator/simulator.c"
 case 13: 
 var $axis_0_ph;
 var $dir_0_ph_in_in_in_in_in;
 var $dir_0_ph_in_in_in_in=HEAP8[($dir_0_ph_in_in_in_in_in)]; //@line 363 "simulator/simulator.c"
 var $dir_0_ph_in_in_in=$dir_0_ph_in_in_in_in&1; //@line 363 "simulator/simulator.c"
 var $dir_0_ph_in_in=($dir_0_ph_in_in_in&255); //@line 363 "simulator/simulator.c"
 var $dir_0_ph_in=$dir_0_ph_in_in<<1; //@line 363 "simulator/simulator.c"
 var $arrayidx55=((3864+($axis_0_ph<<2))|0); //@line 373 "simulator/simulator.c"
 var $4=HEAP32[(($arrayidx55)>>2)]; //@line 373 "simulator/simulator.c"
 var $dir_0_ph=((($4)-(1))|0); //@line 363 "simulator/simulator.c"
 var $add56=((($dir_0_ph)+($dir_0_ph_in))|0); //@line 373 "simulator/simulator.c"
 HEAP32[(($arrayidx55)>>2)]=$add56; //@line 373 "simulator/simulator.c"
 _record_pin($axis_0_ph,$add56,$call$0,$call$1);
 _print_pos(); //@line 375 "simulator/simulator.c"
 label=14;break; //@line 376 "simulator/simulator.c"
 case 14: 
 return; //@line 378 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _SET_OUTPUT($pin){
 var label=0;


 var $conv=($pin&255); //@line 381 "simulator/simulator.c"
 var $cmp=($pin&255)<22; //@line 381 "simulator/simulator.c"
 _sim_assert($cmp,1936); //@line 381 "simulator/simulator.c"
 var $arrayidx=((5048+$conv)|0); //@line 382 "simulator/simulator.c"
 HEAP8[($arrayidx)]=1; //@line 382 "simulator/simulator.c"
 return; //@line 383 "simulator/simulator.c"
}


function _usage($name){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $call=_printf(1656,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$name,tempVarArgs)); STACKTOP=tempVarArgs; //@line 57 "simulator/simulator.c"
 var $puts=_puts(584); //@line undefined "simulator/simulator.c"
 var $puts1=_puts(528); //@line 59 "simulator/simulator.c"
 var $puts2=_puts(472); //@line 60 "simulator/simulator.c"
 var $puts3=_puts(392); //@line 61 "simulator/simulator.c"
 var $puts4=_puts(328); //@line 62 "simulator/simulator.c"
 var $puts5=_puts(232); //@line 63 "simulator/simulator.c"
 var $puts6=_puts(128); //@line 64 "simulator/simulator.c"
 var $putchar=_putchar(10); //@line 65 "simulator/simulator.c"
 _exit(1); //@line 66 "simulator/simulator.c"
 throw "Reached an unreachable!"; //@line 66 "simulator/simulator.c"
}


function _clearline(){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $_b=HEAP8[(624)];
 if($_b){label=2;break;}else{label=3;break;} //@line 164 "simulator/simulator.c"
 case 2: 
 var $0=HEAP32[((_stdout)>>2)]; //@line 165 "simulator/simulator.c"
 var $call=_fputc(10,$0); //@line 165 "simulator/simulator.c"
 label=3;break; //@line 165 "simulator/simulator.c"
 case 3: 
 HEAP8[(624)]=0;
 return; //@line 167 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _fred(){
 var label=0;


 var $0=HEAP32[((_stdout)>>2)]; //@line 148 "simulator/simulator.c"
 var $1=_fwrite(1816,7,1,$0); //@line 148 "simulator/simulator.c"
 return; //@line 148 "simulator/simulator.c"
}


function _fbreset(){
 var label=0;


 var $0=HEAP32[((_stdout)>>2)]; //@line 151 "simulator/simulator.c"
 var $1=_fwrite(1792,3,1,$0); //@line 151 "simulator/simulator.c"
 return; //@line 151 "simulator/simulator.c"
}


function _vsim_info_cont($fmt,$ap){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((8)>>2)]; //@line 156 "simulator/simulator.c"
 var $cmp=($0|0)<1; //@line 156 "simulator/simulator.c"
 if($cmp){label=3;break;}else{label=2;break;} //@line 156 "simulator/simulator.c"
 case 2: 
 _fgreen(); //@line 157 "simulator/simulator.c"
 var $call=_vprintf($fmt,$ap); //@line 158 "simulator/simulator.c"
 _fbreset(); //@line 159 "simulator/simulator.c"
 label=3;break; //@line 160 "simulator/simulator.c"
 case 3: 
 return; //@line 160 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _fcyan(){
 var label=0;


 var $0=HEAP32[((_stdout)>>2)]; //@line 149 "simulator/simulator.c"
 var $1=_fwrite(1784,7,1,$0); //@line 149 "simulator/simulator.c"
 return; //@line 149 "simulator/simulator.c"
}


function _fyellow(){
 var label=0;


 var $0=HEAP32[((_stdout)>>2)]; //@line 150 "simulator/simulator.c"
 var $1=_fwrite(1800,9,1,$0); //@line 150 "simulator/simulator.c"
 return; //@line 150 "simulator/simulator.c"
}


function _bred(){
 var label=0;


 var $0=HEAP32[((_stdout)>>2)]; //@line 153 "simulator/simulator.c"
 var $1=_fwrite(1864,7,1,$0); //@line 153 "simulator/simulator.c"
 return; //@line 153 "simulator/simulator.c"
}


function _print_pos(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((3696)>>2)]; //@line 291 "simulator/simulator.c"
 var $tobool=($0|0)==0; //@line 291 "simulator/simulator.c"
 if($tobool){label=5;break;}else{label=2;break;} //@line 291 "simulator/simulator.c"
 case 2: 
 var $1=HEAP32[((3864)>>2)]; //@line 293 "simulator/simulator.c"
 _sim_info_cont(1920,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=120,HEAP32[(((tempVarArgs)+(8))>>2)]=$1,tempVarArgs)); STACKTOP=tempVarArgs; //@line 293 "simulator/simulator.c"
 var $2=HEAP32[((3868)>>2)]; //@line 293 "simulator/simulator.c"
 _sim_info_cont(1920,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=121,HEAP32[(((tempVarArgs)+(8))>>2)]=$2,tempVarArgs)); STACKTOP=tempVarArgs; //@line 293 "simulator/simulator.c"
 var $3=HEAP32[((3872)>>2)]; //@line 293 "simulator/simulator.c"
 _sim_info_cont(1920,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=122,HEAP32[(((tempVarArgs)+(8))>>2)]=$3,tempVarArgs)); STACKTOP=tempVarArgs; //@line 293 "simulator/simulator.c"
 var $4=HEAP32[((3876)>>2)]; //@line 293 "simulator/simulator.c"
 _sim_info_cont(1920,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 16)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=101,HEAP32[(((tempVarArgs)+(8))>>2)]=$4,tempVarArgs)); STACKTOP=tempVarArgs; //@line 293 "simulator/simulator.c"
 var $5=HEAP32[((8)>>2)]; //@line 295 "simulator/simulator.c"
 var $cmp2=($5|0)>1; //@line 295 "simulator/simulator.c"
 if($cmp2){label=3;break;}else{label=4;break;} //@line 295 "simulator/simulator.c"
 case 3: 
 _clearline(); //@line 296 "simulator/simulator.c"
 label=5;break; //@line 296 "simulator/simulator.c"
 case 4: 
 _sim_info_cont(1888,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 298 "simulator/simulator.c"
 label=5;break;
 case 5: 
 STACKTOP=sp;return; //@line 300 "simulator/simulator.c"
  default: assert(0, "bad label: " + label);
 }

}


function _sim_info_cont($fmt,varrp){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);

 var $ap=sp;
 var $arraydecay=(($ap)|0); //@line 171 "simulator/simulator.c"
 var $arraydecay1=$ap; //@line 171 "simulator/simulator.c"
 HEAP32[(($arraydecay1)>>2)]=varrp;HEAP32[((($arraydecay1)+(4))>>2)]=0; //@line 171 "simulator/simulator.c"
 _vsim_info_cont($fmt,$arraydecay); //@line 172 "simulator/simulator.c"
 //@line 173 "simulator/simulator.c"
 HEAP8[(624)]=1;
 STACKTOP=sp;return; //@line 175 "simulator/simulator.c"
}


function _fgreen(){
 var label=0;


 var $0=HEAP32[((_stdout)>>2)]; //@line 147 "simulator/simulator.c"
 var $1=_fwrite(1760,7,1,$0); //@line 147 "simulator/simulator.c"
 return; //@line 147 "simulator/simulator.c"
}


function _serial_init(){
 var label=0;


 var $0=HEAP32[((5032)>>2)]; //@line 25 "simulator/serial_sim.c"
 var $cmp=($0|0)>1; //@line 25 "simulator/serial_sim.c"
 _sim_assert($cmp,2864); //@line 25 "simulator/serial_sim.c"
 _open_file(); //@line 27 "simulator/serial_sim.c"
 HEAP8[(616)]=1;
 return; //@line 29 "simulator/serial_sim.c"
}


function _serial_rxchars(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $rx_chars_nb=sp;
 var $_b=HEAP8[(616)];
 _sim_assert($_b,3080); //@line 92 "simulator/serial_sim.c"
 var $0=HEAP32[((3832)>>2)]; //@line 93 "simulator/serial_sim.c"
 var $tobool1=($0|0)==0; //@line 93 "simulator/serial_sim.c"
 if($tobool1){var $retval_0=1;label=3;break;}else{label=2;break;} //@line 93 "simulator/serial_sim.c"
 case 2: 
 var $call=_ioctl($0,21531,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$rx_chars_nb,tempVarArgs)); STACKTOP=tempVarArgs; //@line 96 "simulator/serial_sim.c"
 var $1=HEAP32[(($rx_chars_nb)>>2)]; //@line 97 "simulator/serial_sim.c"
 var $conv=(($1)&255); //@line 97 "simulator/serial_sim.c"
 var $retval_0=$conv;label=3;break; //@line 97 "simulator/serial_sim.c"
 case 3: 
 var $retval_0;
 STACKTOP=sp;return $retval_0; //@line 101 "simulator/serial_sim.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serial_popchar(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $c=sp;
 var $0=HEAP32[((3832)>>2)]; //@line 107 "simulator/serial_sim.c"
 var $tobool=($0|0)!=0; //@line 107 "simulator/serial_sim.c"
 var $1=HEAP32[((4704)>>2)]; //@line 107 "simulator/serial_sim.c"
 var $cond=($tobool?$0:$1); //@line 107 "simulator/serial_sim.c"
 var $_b=HEAP8[(616)];
 _sim_assert($_b,3080); //@line 109 "simulator/serial_sim.c"
 var $call=_serial_rxchars(); //@line 110 "simulator/serial_sim.c"
 var $cmp=(($call<<24)>>24)!=0; //@line 110 "simulator/serial_sim.c"
 _sim_assert($cmp,2656); //@line 110 "simulator/serial_sim.c"
 var $call3=_read($cond,$c,1); //@line 111 "simulator/serial_sim.c"
 var $2=HEAP32[((4704)>>2)]; //@line 112 "simulator/serial_sim.c"
 var $tobool4=($2|0)==0; //@line 112 "simulator/serial_sim.c"
 var $tobool5=($call3|0)!=0; //@line 112 "simulator/serial_sim.c"
 var $or_cond=$tobool4|$tobool5; //@line 112 "simulator/serial_sim.c"
 if($or_cond){label=5;break;}else{label=2;break;} //@line 112 "simulator/serial_sim.c"
 case 2: 
 _open_file(); //@line 114 "simulator/serial_sim.c"
 var $3=HEAP32[((4704)>>2)]; //@line 115 "simulator/serial_sim.c"
 var $4=HEAP32[((3832)>>2)];
 var $5=$4|$3; //@line 115 "simulator/serial_sim.c"
 var $6=($5|0)==0; //@line 115 "simulator/serial_sim.c"
 if($6){label=4;break;}else{label=3;break;} //@line 115 "simulator/serial_sim.c"
 case 3: 
 var $call9=_serial_popchar(); //@line 116 "simulator/serial_sim.c"
 var $retval_0=$call9;label=6;break; //@line 116 "simulator/serial_sim.c"
 case 4: 
 _sim_info(2240,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 118 "simulator/serial_sim.c"
 _exit(0); //@line 119 "simulator/serial_sim.c"
 throw "Reached an unreachable!"; //@line 119 "simulator/serial_sim.c"
 case 5: 
 var $cmp11=($call3|0)==1; //@line 121 "simulator/serial_sim.c"
 _sim_assert($cmp11,1824); //@line 121 "simulator/serial_sim.c"
 var $7=HEAP8[($c)]; //@line 122 "simulator/serial_sim.c"
 var $retval_0=$7;label=6;break; //@line 122 "simulator/serial_sim.c"
 case 6: 
 var $retval_0;
 STACKTOP=sp;return $retval_0; //@line 123 "simulator/serial_sim.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serial_writechar($data){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $data_addr=sp;
 HEAP8[($data_addr)]=$data;
 var $_b=HEAP8[(616)];
 _sim_assert($_b,3080); //@line 127 "simulator/serial_sim.c"
 _sim_gcode_ch($data); //@line 128 "simulator/serial_sim.c"
 var $0=HEAP32[((3832)>>2)]; //@line 129 "simulator/serial_sim.c"
 var $tobool1=($0|0)==0; //@line 129 "simulator/serial_sim.c"
 if($tobool1){label=3;break;}else{label=2;break;} //@line 129 "simulator/serial_sim.c"
 case 2: 
 var $call=_write($0,$data_addr,1); //@line 131 "simulator/serial_sim.c"
 var $cmp=($call|0)==1; //@line 132 "simulator/serial_sim.c"
 _sim_assert($cmp,1552); //@line 132 "simulator/serial_sim.c"
 label=3;break; //@line 133 "simulator/serial_sim.c"
 case 3: 
 STACKTOP=sp;return; //@line 134 "simulator/serial_sim.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serial_writestr($data){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $_b=HEAP8[(616)];
 _sim_assert($_b,3080); //@line 139 "simulator/serial_sim.c"
 _sim_gcode($data); //@line 140 "simulator/serial_sim.c"
 var $0=HEAP32[((3832)>>2)]; //@line 141 "simulator/serial_sim.c"
 var $tobool1=($0|0)==0; //@line 141 "simulator/serial_sim.c"
 if($tobool1){label=3;break;}else{label=2;break;} //@line 141 "simulator/serial_sim.c"
 case 2: 
 var $call=_strlen($data); //@line 143 "simulator/serial_sim.c"
 var $call2=_write($0,$data,$call); //@line 143 "simulator/serial_sim.c"
 var $call3=_strlen($data); //@line 144 "simulator/serial_sim.c"
 var $cmp=($call2|0)==($call3|0); //@line 144 "simulator/serial_sim.c"
 _sim_assert($cmp,1552); //@line 144 "simulator/serial_sim.c"
 label=3;break; //@line 145 "simulator/serial_sim.c"
 case 3: 
 return; //@line 146 "simulator/serial_sim.c"
  default: assert(0, "bad label: " + label);
 }

}


function _serial_writestr_P($data){
 var label=0;


 _serial_writestr($data); //@line 150 "simulator/serial_sim.c"
 return; //@line 151 "simulator/serial_sim.c"
}


function _open_file(){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+80)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $st=sp;
 var $0=HEAP32[((792)>>2)]; //@line 34 "simulator/serial_sim.c"
 var $inc=((($0)+(1))|0); //@line 34 "simulator/serial_sim.c"
 HEAP32[((792)>>2)]=$inc; //@line 34 "simulator/serial_sim.c"
 var $1=HEAP32[((5024)>>2)]; //@line 34 "simulator/serial_sim.c"
 var $arrayidx=(($1+($0<<2))|0); //@line 34 "simulator/serial_sim.c"
 var $2=HEAP32[(($arrayidx)>>2)]; //@line 34 "simulator/serial_sim.c"
 var $3=HEAP32[((4704)>>2)]; //@line 37 "simulator/serial_sim.c"
 var $tobool=($3|0)==0; //@line 37 "simulator/serial_sim.c"
 if($tobool){var $4=$inc;label=3;break;}else{label=2;break;} //@line 37 "simulator/serial_sim.c"
 case 2: 
 var $call=_close($3); //@line 37 "simulator/serial_sim.c"
 var $_pre=HEAP32[((792)>>2)]; //@line 41 "simulator/serial_sim.c"
 var $4=$_pre;label=3;break; //@line 37 "simulator/serial_sim.c"
 case 3: 
 var $4;
 HEAP32[((4704)>>2)]=0; //@line 38 "simulator/serial_sim.c"
 var $5=HEAP32[((5032)>>2)]; //@line 41 "simulator/serial_sim.c"
 var $cmp=($4|0)>($5|0); //@line 41 "simulator/serial_sim.c"
 if($cmp){label=7;break;}else{label=4;break;} //@line 41 "simulator/serial_sim.c"
 case 4: 
 _sim_info(1456,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 8)|0,(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=$2,tempVarArgs)); STACKTOP=tempVarArgs; //@line 43 "simulator/serial_sim.c"
 var $call3=_stat($2,$st); //@line 44 "simulator/serial_sim.c"
 var $lnot=($call3|0)==0; //@line 44 "simulator/serial_sim.c"
 _sim_assert($lnot,1320); //@line 44 "simulator/serial_sim.c"
 var $st_rdev=(($st+28)|0); //@line 46 "simulator/serial_sim.c"
 var $6=HEAP32[(($st_rdev)>>2)]; //@line 46 "simulator/serial_sim.c"
 var $tobool5=($6|0)==0; //@line 46 "simulator/serial_sim.c"
 if($tobool5){label=5;break;}else{label=6;break;} //@line 46 "simulator/serial_sim.c"
 case 5: 
 var $call7=_open($2,0,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 48 "simulator/serial_sim.c"
 HEAP32[((4704)>>2)]=$call7; //@line 48 "simulator/serial_sim.c"
 var $tobool8=($call7|0)!=0; //@line 49 "simulator/serial_sim.c"
 _sim_assert($tobool8,1080); //@line 49 "simulator/serial_sim.c"
 label=7;break; //@line 50 "simulator/serial_sim.c"
 case 6: 
 _open_tty($2); //@line 52 "simulator/serial_sim.c"
 label=7;break;
 case 7: 
 STACKTOP=sp;return; //@line 54 "simulator/serial_sim.c"
  default: assert(0, "bad label: " + label);
 }

}


function _open_tty($devname){
 var label=0;
 var tempVarArgs=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+64)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $options=sp;
 var $call=_open($devname,2306,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 59 "simulator/serial_sim.c"
 HEAP32[((3832)>>2)]=$call; //@line 59 "simulator/serial_sim.c"
 var $cmp=($call|0)!=-1; //@line 60 "simulator/serial_sim.c"
 _sim_assert($cmp,960); //@line 60 "simulator/serial_sim.c"
 var $0=HEAP32[((3832)>>2)]; //@line 61 "simulator/serial_sim.c"
 var $call1=_isatty($0); //@line 61 "simulator/serial_sim.c"
 var $tobool=($call1|0)!=0; //@line 61 "simulator/serial_sim.c"
 _sim_assert($tobool,3200); //@line 61 "simulator/serial_sim.c"
 _sim_info(3120,(tempVarArgs=STACKTOP,STACKTOP = (STACKTOP + 1)|0,STACKTOP = (((STACKTOP)+7)&-8),(assert((STACKTOP|0) < (STACK_MAX|0))|0),HEAP32[((tempVarArgs)>>2)]=0,tempVarArgs)); STACKTOP=tempVarArgs; //@line 63 "simulator/serial_sim.c"
 var $1=HEAP32[((3832)>>2)]; //@line 65 "simulator/serial_sim.c"
 var $call2=_tcgetattr($1,$options); //@line 65 "simulator/serial_sim.c"
 var $cmp3=($call2|0)==0; //@line 65 "simulator/serial_sim.c"
 if($cmp3){label=3;break;}else{label=2;break;} //@line 65 "simulator/serial_sim.c"
 case 2: 
 _sim_error(3056); //@line 66 "simulator/serial_sim.c"
 label=3;break; //@line 67 "simulator/serial_sim.c"
 case 3: 
 var $call4=_cfsetispeed($options,4098); //@line 70 "simulator/serial_sim.c"
 var $call5=_cfsetospeed($options,4098); //@line 71 "simulator/serial_sim.c"
 var $c_cflag=(($options+8)|0); //@line 74 "simulator/serial_sim.c"
 var $2=HEAP32[(($c_cflag)>>2)]; //@line 74 "simulator/serial_sim.c"
 var $and=$2&-2545; //@line 78 "simulator/serial_sim.c"
 var $or12=$and|2224; //@line 79 "simulator/serial_sim.c"
 HEAP32[(($c_cflag)>>2)]=$or12; //@line 79 "simulator/serial_sim.c"
 var $3=HEAP32[((3832)>>2)]; //@line 82 "simulator/serial_sim.c"
 var $call13=_tcsetattr($3,0,$options); //@line 82 "simulator/serial_sim.c"
 var $cmp14=($call13|0)==0; //@line 82 "simulator/serial_sim.c"
 if($cmp14){label=5;break;}else{label=4;break;} //@line 82 "simulator/serial_sim.c"
 case 4: 
 _sim_error(3008); //@line 83 "simulator/serial_sim.c"
 label=5;break; //@line 84 "simulator/serial_sim.c"
 case 5: 
 var $4=HEAP32[((3832)>>2)]; //@line 87 "simulator/serial_sim.c"
 var $call17=_tcflush($4,2); //@line 87 "simulator/serial_sim.c"
 STACKTOP=sp;return; //@line 88 "simulator/serial_sim.c"
  default: assert(0, "bad label: " + label);
 }

}


function _getopt($argc,$argv,$optstring){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+16)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $c=sp;
 var $d=(sp)+(8);
 var $0=HEAP32[((776)>>2)];
 var $tobool=($0|0)==0;
 var $1=HEAP32[((5640)>>2)];
 var $tobool1=($1|0)!=0;
 var $or_cond=$tobool|$tobool1;
 if($or_cond){label=2;break;}else{var $2=$0;label=3;break;}
 case 2: 
 HEAP32[((5640)>>2)]=0;
 HEAP32[((5648)>>2)]=0;
 HEAP32[((776)>>2)]=1;
 var $2=1;label=3;break;
 case 3: 
 var $2;
 var $cmp=($2|0)<($argc|0);
 if($cmp){label=4;break;}else{var $retval_0=-1;label=28;break;}
 case 4: 
 var $arrayidx=(($argv+($2<<2))|0);
 var $3=HEAP32[(($arrayidx)>>2)];
 var $tobool3=($3|0)==0;
 if($tobool3){var $retval_0=-1;label=28;break;}else{label=5;break;}
 case 5: 
 var $4=HEAP8[($3)];
 var $cmp7=(($4<<24)>>24)==45;
 if($cmp7){label=6;break;}else{var $retval_0=-1;label=28;break;}
 case 6: 
 var $arrayidx11=(($3+1)|0);
 var $5=HEAP8[($arrayidx11)];
 if((($5<<24)>>24)==0){ var $retval_0=-1;label=28;break;}else if((($5<<24)>>24)==45){ label=7;break;}else{label=9;break;}
 case 7: 
 var $arrayidx21=(($3+2)|0);
 var $6=HEAP8[($arrayidx21)];
 var $tobool22=(($6<<24)>>24)==0;
 if($tobool22){label=8;break;}else{label=9;break;}
 case 8: 
 var $inc=((($2)+(1))|0);
 HEAP32[((776)>>2)]=$inc;
 var $retval_0=-1;label=28;break;
 case 9: 
 var $7=HEAP32[((5648)>>2)];
 var $tobool25=($7|0)==0;
 if($tobool25){label=10;break;}else{var $9=$3;var $8=$7;label=11;break;}
 case 10: 
 HEAP32[((5648)>>2)]=1;
 var $_pre=HEAP32[(($arrayidx)>>2)];
 var $9=$_pre;var $8=1;label=11;break;
 case 11: 
 var $8;
 var $9;
 var $add_ptr=(($9+$8)|0);
 var $call=_mbtowc($c,$add_ptr,4);
 var $cmp30=($call|0)<0;
 if($cmp30){label=13;break;}else{label=12;break;}
 case 12: 
 var $_pre30=HEAP32[(($c)>>2)];
 var $k_0=$call;var $10=$_pre30;label=14;break;
 case 13: 
 HEAP32[(($c)>>2)]=65533;
 var $k_0=1;var $10=65533;label=14;break;
 case 14: 
 var $10;
 var $k_0;
 var $11=HEAP32[((776)>>2)];
 var $arrayidx34=(($argv+($11<<2))|0);
 var $12=HEAP32[(($arrayidx34)>>2)];
 var $13=HEAP32[((5648)>>2)];
 var $add_ptr35=(($12+$13)|0);
 HEAP32[((3888)>>2)]=$10;
 var $add=((($13)+($k_0))|0);
 HEAP32[((5648)>>2)]=$add;
 var $14=HEAP32[(($arrayidx34)>>2)];
 var $arrayidx37=(($14+$add)|0);
 var $15=HEAP8[($arrayidx37)];
 var $tobool38=(($15<<24)>>24)==0;
 if($tobool38){label=15;break;}else{label=16;break;}
 case 15: 
 var $inc40=((($11)+(1))|0);
 HEAP32[((776)>>2)]=$inc40;
 HEAP32[((5648)>>2)]=0;
 label=16;break;
 case 16: 
 var $call4324=_mbtowc($d,$optstring,4);
 var $tobool4425=($call4324|0)==0;
 if($tobool4425){var $i_0_lcssa=0;label=19;break;}else{var $i_026=0;var $call4327=$call4324;label=17;break;}
 case 17: 
 var $call4327;
 var $i_026;
 var $16=HEAP32[(($d)>>2)];
 var $17=HEAP32[(($c)>>2)];
 var $cmp45=($16|0)==($17|0);
 if($cmp45){var $i_0_lcssa=$i_026;label=19;break;}else{label=18;break;}
 case 18: 
 var $cmp47=($call4327|0)<1;
 var $cond=($cmp47?1:$call4327);
 var $add49=((($cond)+($i_026))|0);
 var $add_ptr42=(($optstring+$add49)|0);
 var $call43=_mbtowc($d,$add_ptr42,4);
 var $tobool44=($call43|0)==0;
 if($tobool44){var $i_0_lcssa=$add49;label=19;break;}else{var $i_026=$add49;var $call4327=$call43;label=17;break;}
 case 19: 
 var $i_0_lcssa;
 var $18=HEAP32[(($d)>>2)];
 var $19=HEAP32[(($c)>>2)];
 var $cmp50=($18|0)==($19|0);
 if($cmp50){label=22;break;}else{label=20;break;}
 case 20: 
 var $20=HEAP8[($optstring)];
 var $cmp55=(($20<<24)>>24)!=58;
 var $21=HEAP32[((784)>>2)];
 var $tobool58=($21|0)!=0;
 var $or_cond1=$cmp55&$tobool58;
 if($or_cond1){label=21;break;}else{var $retval_0=63;label=28;break;}
 case 21: 
 var $22=HEAP32[(($argv)>>2)];
 var $call62=_strlen($22);
 var $call63=_write(2,$22,$call62);
 var $call64=_write(2,1736,18);
 var $call65=_write(2,$add_ptr35,$k_0);
 var $call66=_write(2,2952,1);
 var $retval_0=63;label=28;break;
 case 22: 
 var $add69=((($i_0_lcssa)+(1))|0);
 var $arrayidx70=(($optstring+$add69)|0);
 var $23=HEAP8[($arrayidx70)];
 var $cmp72=(($23<<24)>>24)==58;
 if($cmp72){label=23;break;}else{var $retval_0=$18;label=28;break;}
 case 23: 
 var $24=HEAP32[((776)>>2)];
 var $cmp75=($24|0)<($argc|0);
 if($cmp75){label=27;break;}else{label=24;break;}
 case 24: 
 var $25=HEAP8[($optstring)];
 var $cmp80=(($25<<24)>>24)==58;
 if($cmp80){var $retval_0=58;label=28;break;}else{label=25;break;}
 case 25: 
 var $26=HEAP32[((784)>>2)];
 var $tobool84=($26|0)==0;
 if($tobool84){var $retval_0=63;label=28;break;}else{label=26;break;}
 case 26: 
 var $27=HEAP32[(($argv)>>2)];
 var $call88=_strlen($27);
 var $call89=_write(2,$27,$call88);
 var $call90=_write(2,2512,31);
 var $call91=_write(2,$add_ptr35,$k_0);
 var $call92=_write(2,2952,1);
 var $retval_0=63;label=28;break;
 case 27: 
 var $inc95=((($24)+(1))|0);
 HEAP32[((776)>>2)]=$inc95;
 var $arrayidx96=(($argv+($24<<2))|0);
 var $28=HEAP32[(($arrayidx96)>>2)];
 var $29=HEAP32[((5648)>>2)];
 var $add_ptr97=(($28+$29)|0);
 HEAP32[((3896)>>2)]=$add_ptr97;
 HEAP32[((5648)>>2)]=0;
 var $retval_0=$18;label=28;break;
 case 28: 
 var $retval_0;
 STACKTOP=sp;return $retval_0;
  default: assert(0, "bad label: " + label);
 }

}


function _getopt_long($argc,$argv,$optstring,$longopts,$idx){
 var label=0;


 var $call=___getopt_long($argc,$argv,$optstring,$longopts,$idx,0);
 return $call;
}


function _mbtowc($wc,$src,$n){
 var label=0;
 var sp=STACKTOP;STACKTOP=(STACKTOP+8)|0; (assert((STACKTOP|0) < (STACK_MAX|0))|0);
 label = 1; 
 while(1)switch(label){
 case 1: 
 var $wc_addr=sp;
 HEAP32[(($wc_addr)>>2)]=$wc;
 var $tobool=($src|0)==0;
 if($tobool){var $retval_0=0;label=19;break;}else{label=2;break;}
 case 2: 
 var $tobool1=($n|0)==0;
 if($tobool1){label=18;break;}else{label=3;break;}
 case 3: 
 var $tobool4=($wc|0)==0;
 if($tobool4){label=4;break;}else{var $1=$wc;label=5;break;}
 case 4: 
 var $0=$wc_addr;
 HEAP32[(($wc_addr)>>2)]=$0;
 var $1=$0;label=5;break;
 case 5: 
 var $1;
 var $2=HEAP8[($src)];
 var $conv=($2&255);
 var $cmp=(($2<<24)>>24)>-1;
 if($cmp){label=6;break;}else{label=7;break;}
 case 6: 
 HEAP32[(($1)>>2)]=$conv;
 var $tobool10=(($2<<24)>>24)!=0;
 var $lnot_ext=($tobool10&1);
 var $retval_0=$lnot_ext;label=19;break;
 case 7: 
 var $sub=((($conv)-(194))|0);
 var $cmp14=($sub>>>0)>50;
 if($cmp14){label=18;break;}else{label=8;break;}
 case 8: 
 var $incdec_ptr=(($src+1)|0);
 var $arrayidx=((___fsmu8+($sub<<2))|0);
 var $3=HEAP32[(($arrayidx)>>2)];
 var $cmp20=($n>>>0)<4;
 if($cmp20){label=9;break;}else{label=10;break;}
 case 9: 
 var $mul=((($n)*(6))&-1);
 var $sub22=((($mul)-(6))|0);
 var $4=-2147483648>>>($sub22>>>0);
 var $and22=$3&$4;
 var $tobool23=($and22|0)==0;
 if($tobool23){label=10;break;}else{label=18;break;}
 case 10: 
 var $5=HEAP8[($incdec_ptr)];
 var $conv26=($5&255);
 var $shr21=$conv26>>>3;
 var $sub27=((($shr21)-(16))|0);
 var $shr30=$3>>26;
 var $add=((($shr21)+($shr30))|0);
 var $or=$sub27|$add;
 var $tobool32=($or>>>0)>7;
 if($tobool32){label=18;break;}else{label=11;break;}
 case 11: 
 var $shl35=$3<<6;
 var $sub38=((($conv26)-(128))|0);
 var $or39=$sub38|$shl35;
 var $tobool41=($or39|0)<0;
 if($tobool41){label=13;break;}else{label=12;break;}
 case 12: 
 HEAP32[(($1)>>2)]=$or39;
 var $retval_0=2;label=19;break;
 case 13: 
 var $incdec_ptr36=(($src+2)|0);
 var $6=HEAP8[($incdec_ptr36)];
 var $conv44=($6&255);
 var $7=$conv44&192;
 var $cmp46=($7|0)==128;
 if($cmp46){label=14;break;}else{label=18;break;}
 case 14: 
 var $shl50=$or39<<6;
 var $sub53=((($conv44)-(128))|0);
 var $or54=$sub53|$shl50;
 var $tobool56=($or54|0)<0;
 if($tobool56){label=16;break;}else{label=15;break;}
 case 15: 
 HEAP32[(($1)>>2)]=$or54;
 var $retval_0=3;label=19;break;
 case 16: 
 var $incdec_ptr51=(($src+3)|0);
 var $8=HEAP8[($incdec_ptr51)];
 var $conv59=($8&255);
 var $9=$conv59&192;
 var $cmp61=($9|0)==128;
 if($cmp61){label=17;break;}else{label=18;break;}
 case 17: 
 var $shl65=$or54<<6;
 var $sub68=((($conv59)-(128))|0);
 var $or69=$sub68|$shl65;
 HEAP32[(($1)>>2)]=$or69;
 var $retval_0=4;label=19;break;
 case 18: 
 var $call=___errno_location();
 HEAP32[(($call)>>2)]=84;
 var $retval_0=-1;label=19;break;
 case 19: 
 var $retval_0;
 STACKTOP=sp;return $retval_0;
  default: assert(0, "bad label: " + label);
 }

}


function ___getopt_long($argc,$argv,$optstring,$longopts,$idx,$longonly){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $0=HEAP32[((776)>>2)];
 var $tobool=($0|0)==0;
 var $1=HEAP32[((5640)>>2)];
 var $tobool1=($1|0)!=0;
 var $or_cond=$tobool|$tobool1;
 if($or_cond){label=2;break;}else{var $2=$0;label=3;break;}
 case 2: 
 HEAP32[((5640)>>2)]=0;
 HEAP32[((5648)>>2)]=0;
 HEAP32[((776)>>2)]=1;
 var $2=1;label=3;break;
 case 3: 
 var $2;
 var $cmp=($2|0)<($argc|0);
 if($cmp){label=4;break;}else{var $retval_0=-1;label=30;break;}
 case 4: 
 var $arrayidx=(($argv+($2<<2))|0);
 var $3=HEAP32[(($arrayidx)>>2)];
 var $tobool3=($3|0)==0;
 if($tobool3){var $retval_0=-1;label=30;break;}else{label=5;break;}
 case 5: 
 var $4=HEAP8[($3)];
 var $cmp7=(($4<<24)>>24)==45;
 if($cmp7){label=6;break;}else{var $retval_0=-1;label=30;break;}
 case 6: 
 var $tobool11=($longonly|0)==0;
 var $arrayidx18_phi_trans_insert=(($3+1)|0);
 var $_pre=HEAP8[($arrayidx18_phi_trans_insert)];
 if($tobool11){label=8;break;}else{label=7;break;}
 case 7: 
 var $tobool15=(($_pre<<24)>>24)==0;
 if($tobool15){label=29;break;}else{var $6=$_pre;label=10;break;}
 case 8: 
 var $phitmp=(($_pre<<24)>>24)==45;
 if($phitmp){label=9;break;}else{label=29;break;}
 case 9: 
 var $arrayidx24=(($3+2)|0);
 var $5=HEAP8[($arrayidx24)];
 var $tobool26=(($5<<24)>>24)==0;
 if($tobool26){label=29;break;}else{var $6=45;label=10;break;}
 case 10: 
 var $6;
 var $name50=(($longopts)|0);
 var $7=HEAP32[(($name50)>>2)];
 var $tobool2951=($7|0)==0;
 var $arrayidx9853=(($3+1)|0);
 var $cmp10054=(($6<<24)>>24)==45;
 if($tobool2951){label=27;break;}else{var $i_055=0;var $8=$7;label=11;break;}
 case 11: 
 var $8;
 var $i_055;
 var $incdec_ptr=(($3+2)|0);
 var $incdec_ptr_arrayidx98=($cmp10054?$incdec_ptr:$arrayidx9853);
 var $9=HEAP8[($8)];
 var $tobool4147=(($9<<24)>>24)==0;
 if($tobool4147){var $opt_036=$incdec_ptr_arrayidx98;label=15;break;}else{var $name30_048=$8;var $opt_049=$incdec_ptr_arrayidx98;var $_pr=$9;label=12;break;}
 case 12: 
 var $_pr;
 var $opt_049;
 var $name30_048;
 var $10=HEAP8[($opt_049)];
 var $cmp44=(($_pr<<24)>>24)==(($10<<24)>>24);
 if($cmp44){label=13;break;}else{label=14;break;}
 case 13: 
 var $incdec_ptr47=(($name30_048+1)|0);
 var $incdec_ptr48=(($opt_049+1)|0);
 var $11=HEAP8[($incdec_ptr47)];
 var $tobool41=(($11<<24)>>24)==0;
 if($tobool41){var $opt_036=$incdec_ptr48;label=15;break;}else{var $name30_048=$incdec_ptr47;var $opt_049=$incdec_ptr48;var $_pr=$11;label=12;break;}
 case 14: 
 var $tobool50=(($_pr<<24)>>24)==0;
 if($tobool50){var $opt_036=$opt_049;label=15;break;}else{label=26;break;}
 case 15: 
 var $opt_036;
 var $12=HEAP8[($opt_036)];
 if((($12<<24)>>24)==0|(($12<<24)>>24)==61){ label=16;break;}else{label=26;break;}
 case 16: 
 var $cmp61=(($12<<24)>>24)==61;
 var $has_arg=(($longopts+($i_055<<4)+4)|0);
 var $13=HEAP32[(($has_arg)>>2)];
 if($cmp61){label=17;break;}else{label=19;break;}
 case 17: 
 var $tobool65=($13|0)==0;
 if($tobool65){label=26;break;}else{label=18;break;}
 case 18: 
 var $add_ptr68=(($opt_036+1)|0);
 HEAP32[((3896)>>2)]=$add_ptr68;
 var $15=$2;label=22;break;
 case 19: 
 var $cmp71=($13|0)==1;
 if($cmp71){label=20;break;}else{label=21;break;}
 case 20: 
 var $inc=((($2)+(1))|0);
 HEAP32[((776)>>2)]=$inc;
 var $arrayidx74=(($argv+($inc<<2))|0);
 var $14=HEAP32[(($arrayidx74)>>2)];
 HEAP32[((3896)>>2)]=$14;
 var $tobool75=($14|0)==0;
 if($tobool75){var $retval_0=58;label=30;break;}else{var $15=$inc;label=22;break;}
 case 21: 
 HEAP32[((3896)>>2)]=0;
 var $15=$2;label=22;break;
 case 22: 
 var $15;
 var $inc81=((($15)+(1))|0);
 HEAP32[((776)>>2)]=$inc81;
 var $tobool82=($idx|0)==0;
 if($tobool82){label=24;break;}else{label=23;break;}
 case 23: 
 HEAP32[(($idx)>>2)]=$i_055;
 label=24;break;
 case 24: 
 var $flag=(($longopts+($i_055<<4)+8)|0);
 var $16=HEAP32[(($flag)>>2)];
 var $tobool86=($16|0)==0;
 var $val=(($longopts+($i_055<<4)+12)|0);
 var $17=HEAP32[(($val)>>2)];
 if($tobool86){var $retval_0=$17;label=30;break;}else{label=25;break;}
 case 25: 
 HEAP32[(($16)>>2)]=$17;
 var $retval_0=0;label=30;break;
 case 26: 
 var $inc95=((($i_055)+(1))|0);
 var $name=(($longopts+($inc95<<4))|0);
 var $18=HEAP32[(($name)>>2)];
 var $tobool29=($18|0)==0;
 if($tobool29){label=27;break;}else{var $i_055=$inc95;var $8=$18;label=11;break;}
 case 27: 
 if($cmp10054){label=28;break;}else{label=29;break;}
 case 28: 
 var $inc103=((($2)+(1))|0);
 HEAP32[((776)>>2)]=$inc103;
 var $retval_0=63;label=30;break;
 case 29: 
 var $call=_getopt($argc,$argv,$optstring);
 var $retval_0=$call;label=30;break;
 case 30: 
 var $retval_0;
 return $retval_0;
  default: assert(0, "bad label: " + label);
 }

}


function _malloc($bytes){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=($bytes>>>0)<245;
 if($cmp){label=2;break;}else{label=78;break;}
 case 2: 
 var $cmp1=($bytes>>>0)<11;
 if($cmp1){var $cond=16;label=4;break;}else{label=3;break;}
 case 3: 
 var $add2=((($bytes)+(11))|0);
 var $and=$add2&-8;
 var $cond=$and;label=4;break;
 case 4: 
 var $cond;
 var $shr=$cond>>>3;
 var $0=HEAP32[((5168)>>2)];
 var $shr3=$0>>>($shr>>>0);
 var $and4=$shr3&3;
 var $cmp5=($and4|0)==0;
 if($cmp5){label=12;break;}else{label=5;break;}
 case 5: 
 var $neg=$shr3&1;
 var $and7=$neg^1;
 var $add8=((($and7)+($shr))|0);
 var $shl=$add8<<1;
 var $arrayidx=((5208+($shl<<2))|0);
 var $1=$arrayidx;
 var $arrayidx_sum=((($shl)+(2))|0);
 var $2=((5208+($arrayidx_sum<<2))|0);
 var $3=HEAP32[(($2)>>2)];
 var $fd9=(($3+8)|0);
 var $4=HEAP32[(($fd9)>>2)];
 var $cmp10=($1|0)==($4|0);
 if($cmp10){label=6;break;}else{label=7;break;}
 case 6: 
 var $shl12=1<<$add8;
 var $neg13=$shl12^-1;
 var $and14=$0&$neg13;
 HEAP32[((5168)>>2)]=$and14;
 label=11;break;
 case 7: 
 var $5=$4;
 var $6=HEAP32[((5184)>>2)];
 var $cmp15=($5>>>0)<($6>>>0);
 if($cmp15){label=10;break;}else{label=8;break;}
 case 8: 
 var $bk=(($4+12)|0);
 var $7=HEAP32[(($bk)>>2)];
 var $cmp16=($7|0)==($3|0);
 if($cmp16){label=9;break;}else{label=10;break;}
 case 9: 
 HEAP32[(($bk)>>2)]=$1;
 HEAP32[(($2)>>2)]=$4;
 label=11;break;
 case 10: 
 _abort();
 throw "Reached an unreachable!";
 case 11: 
 var $shl22=$add8<<3;
 var $or23=$shl22|3;
 var $head=(($3+4)|0);
 HEAP32[(($head)>>2)]=$or23;
 var $8=$3;
 var $add_ptr_sum106=$shl22|4;
 var $head25=(($8+$add_ptr_sum106)|0);
 var $9=$head25;
 var $10=HEAP32[(($9)>>2)];
 var $or26=$10|1;
 HEAP32[(($9)>>2)]=$or26;
 var $11=$fd9;
 var $mem_0=$11;label=341;break;
 case 12: 
 var $12=HEAP32[((5176)>>2)];
 var $cmp29=($cond>>>0)>($12>>>0);
 if($cmp29){label=13;break;}else{var $nb_0=$cond;label=160;break;}
 case 13: 
 var $cmp31=($shr3|0)==0;
 if($cmp31){label=27;break;}else{label=14;break;}
 case 14: 
 var $shl35=$shr3<<$shr;
 var $shl37=2<<$shr;
 var $sub=(((-$shl37))|0);
 var $or40=$shl37|$sub;
 var $and41=$shl35&$or40;
 var $sub42=(((-$and41))|0);
 var $and43=$and41&$sub42;
 var $sub44=((($and43)-(1))|0);
 var $shr45=$sub44>>>12;
 var $and46=$shr45&16;
 var $shr47=$sub44>>>($and46>>>0);
 var $shr48=$shr47>>>5;
 var $and49=$shr48&8;
 var $add50=$and49|$and46;
 var $shr51=$shr47>>>($and49>>>0);
 var $shr52=$shr51>>>2;
 var $and53=$shr52&4;
 var $add54=$add50|$and53;
 var $shr55=$shr51>>>($and53>>>0);
 var $shr56=$shr55>>>1;
 var $and57=$shr56&2;
 var $add58=$add54|$and57;
 var $shr59=$shr55>>>($and57>>>0);
 var $shr60=$shr59>>>1;
 var $and61=$shr60&1;
 var $add62=$add58|$and61;
 var $shr63=$shr59>>>($and61>>>0);
 var $add64=((($add62)+($shr63))|0);
 var $shl65=$add64<<1;
 var $arrayidx66=((5208+($shl65<<2))|0);
 var $13=$arrayidx66;
 var $arrayidx66_sum=((($shl65)+(2))|0);
 var $14=((5208+($arrayidx66_sum<<2))|0);
 var $15=HEAP32[(($14)>>2)];
 var $fd69=(($15+8)|0);
 var $16=HEAP32[(($fd69)>>2)];
 var $cmp70=($13|0)==($16|0);
 if($cmp70){label=15;break;}else{label=16;break;}
 case 15: 
 var $shl72=1<<$add64;
 var $neg73=$shl72^-1;
 var $and74=$0&$neg73;
 HEAP32[((5168)>>2)]=$and74;
 label=20;break;
 case 16: 
 var $17=$16;
 var $18=HEAP32[((5184)>>2)];
 var $cmp76=($17>>>0)<($18>>>0);
 if($cmp76){label=19;break;}else{label=17;break;}
 case 17: 
 var $bk78=(($16+12)|0);
 var $19=HEAP32[(($bk78)>>2)];
 var $cmp79=($19|0)==($15|0);
 if($cmp79){label=18;break;}else{label=19;break;}
 case 18: 
 HEAP32[(($bk78)>>2)]=$13;
 HEAP32[(($14)>>2)]=$16;
 label=20;break;
 case 19: 
 _abort();
 throw "Reached an unreachable!";
 case 20: 
 var $shl90=$add64<<3;
 var $sub91=((($shl90)-($cond))|0);
 var $or93=$cond|3;
 var $head94=(($15+4)|0);
 HEAP32[(($head94)>>2)]=$or93;
 var $20=$15;
 var $add_ptr95=(($20+$cond)|0);
 var $21=$add_ptr95;
 var $or96=$sub91|1;
 var $add_ptr95_sum103=$cond|4;
 var $head97=(($20+$add_ptr95_sum103)|0);
 var $22=$head97;
 HEAP32[(($22)>>2)]=$or96;
 var $add_ptr98=(($20+$shl90)|0);
 var $prev_foot=$add_ptr98;
 HEAP32[(($prev_foot)>>2)]=$sub91;
 var $23=HEAP32[((5176)>>2)];
 var $cmp99=($23|0)==0;
 if($cmp99){label=26;break;}else{label=21;break;}
 case 21: 
 var $24=HEAP32[((5188)>>2)];
 var $shr101=$23>>>3;
 var $shl102=$shr101<<1;
 var $arrayidx103=((5208+($shl102<<2))|0);
 var $25=$arrayidx103;
 var $26=HEAP32[((5168)>>2)];
 var $shl105=1<<$shr101;
 var $and106=$26&$shl105;
 var $tobool107=($and106|0)==0;
 if($tobool107){label=22;break;}else{label=23;break;}
 case 22: 
 var $or110=$26|$shl105;
 HEAP32[((5168)>>2)]=$or110;
 var $arrayidx103_sum_pre=((($shl102)+(2))|0);
 var $_pre=((5208+($arrayidx103_sum_pre<<2))|0);
 var $F104_0=$25;var $_pre_phi=$_pre;label=25;break;
 case 23: 
 var $arrayidx103_sum104=((($shl102)+(2))|0);
 var $27=((5208+($arrayidx103_sum104<<2))|0);
 var $28=HEAP32[(($27)>>2)];
 var $29=$28;
 var $30=HEAP32[((5184)>>2)];
 var $cmp113=($29>>>0)<($30>>>0);
 if($cmp113){label=24;break;}else{var $F104_0=$28;var $_pre_phi=$27;label=25;break;}
 case 24: 
 _abort();
 throw "Reached an unreachable!";
 case 25: 
 var $_pre_phi;
 var $F104_0;
 HEAP32[(($_pre_phi)>>2)]=$24;
 var $bk122=(($F104_0+12)|0);
 HEAP32[(($bk122)>>2)]=$24;
 var $fd123=(($24+8)|0);
 HEAP32[(($fd123)>>2)]=$F104_0;
 var $bk124=(($24+12)|0);
 HEAP32[(($bk124)>>2)]=$25;
 label=26;break;
 case 26: 
 HEAP32[((5176)>>2)]=$sub91;
 HEAP32[((5188)>>2)]=$21;
 var $31=$fd69;
 var $mem_0=$31;label=341;break;
 case 27: 
 var $32=HEAP32[((5172)>>2)];
 var $cmp128=($32|0)==0;
 if($cmp128){var $nb_0=$cond;label=160;break;}else{label=28;break;}
 case 28: 
 var $sub_i=(((-$32))|0);
 var $and_i=$32&$sub_i;
 var $sub2_i=((($and_i)-(1))|0);
 var $shr_i=$sub2_i>>>12;
 var $and3_i=$shr_i&16;
 var $shr4_i=$sub2_i>>>($and3_i>>>0);
 var $shr5_i=$shr4_i>>>5;
 var $and6_i=$shr5_i&8;
 var $add_i=$and6_i|$and3_i;
 var $shr7_i=$shr4_i>>>($and6_i>>>0);
 var $shr8_i=$shr7_i>>>2;
 var $and9_i=$shr8_i&4;
 var $add10_i=$add_i|$and9_i;
 var $shr11_i=$shr7_i>>>($and9_i>>>0);
 var $shr12_i=$shr11_i>>>1;
 var $and13_i=$shr12_i&2;
 var $add14_i=$add10_i|$and13_i;
 var $shr15_i=$shr11_i>>>($and13_i>>>0);
 var $shr16_i=$shr15_i>>>1;
 var $and17_i=$shr16_i&1;
 var $add18_i=$add14_i|$and17_i;
 var $shr19_i=$shr15_i>>>($and17_i>>>0);
 var $add20_i=((($add18_i)+($shr19_i))|0);
 var $arrayidx_i=((5472+($add20_i<<2))|0);
 var $33=HEAP32[(($arrayidx_i)>>2)];
 var $head_i=(($33+4)|0);
 var $34=HEAP32[(($head_i)>>2)];
 var $and21_i=$34&-8;
 var $sub22_i=((($and21_i)-($cond))|0);
 var $t_0_i=$33;var $v_0_i=$33;var $rsize_0_i=$sub22_i;label=29;break;
 case 29: 
 var $rsize_0_i;
 var $v_0_i;
 var $t_0_i;
 var $arrayidx23_i=(($t_0_i+16)|0);
 var $35=HEAP32[(($arrayidx23_i)>>2)];
 var $cmp_i=($35|0)==0;
 if($cmp_i){label=30;break;}else{var $cond7_i=$35;label=31;break;}
 case 30: 
 var $arrayidx27_i=(($t_0_i+20)|0);
 var $36=HEAP32[(($arrayidx27_i)>>2)];
 var $cmp28_i=($36|0)==0;
 if($cmp28_i){label=32;break;}else{var $cond7_i=$36;label=31;break;}
 case 31: 
 var $cond7_i;
 var $head29_i=(($cond7_i+4)|0);
 var $37=HEAP32[(($head29_i)>>2)];
 var $and30_i=$37&-8;
 var $sub31_i=((($and30_i)-($cond))|0);
 var $cmp32_i=($sub31_i>>>0)<($rsize_0_i>>>0);
 var $sub31_rsize_0_i=($cmp32_i?$sub31_i:$rsize_0_i);
 var $cond_v_0_i=($cmp32_i?$cond7_i:$v_0_i);
 var $t_0_i=$cond7_i;var $v_0_i=$cond_v_0_i;var $rsize_0_i=$sub31_rsize_0_i;label=29;break;
 case 32: 
 var $38=$v_0_i;
 var $39=HEAP32[((5184)>>2)];
 var $cmp33_i=($38>>>0)<($39>>>0);
 if($cmp33_i){label=76;break;}else{label=33;break;}
 case 33: 
 var $add_ptr_i=(($38+$cond)|0);
 var $40=$add_ptr_i;
 var $cmp35_i=($38>>>0)<($add_ptr_i>>>0);
 if($cmp35_i){label=34;break;}else{label=76;break;}
 case 34: 
 var $parent_i=(($v_0_i+24)|0);
 var $41=HEAP32[(($parent_i)>>2)];
 var $bk_i=(($v_0_i+12)|0);
 var $42=HEAP32[(($bk_i)>>2)];
 var $cmp40_i=($42|0)==($v_0_i|0);
 if($cmp40_i){label=40;break;}else{label=35;break;}
 case 35: 
 var $fd_i=(($v_0_i+8)|0);
 var $43=HEAP32[(($fd_i)>>2)];
 var $44=$43;
 var $cmp45_i=($44>>>0)<($39>>>0);
 if($cmp45_i){label=39;break;}else{label=36;break;}
 case 36: 
 var $bk47_i=(($43+12)|0);
 var $45=HEAP32[(($bk47_i)>>2)];
 var $cmp48_i=($45|0)==($v_0_i|0);
 if($cmp48_i){label=37;break;}else{label=39;break;}
 case 37: 
 var $fd50_i=(($42+8)|0);
 var $46=HEAP32[(($fd50_i)>>2)];
 var $cmp51_i=($46|0)==($v_0_i|0);
 if($cmp51_i){label=38;break;}else{label=39;break;}
 case 38: 
 HEAP32[(($bk47_i)>>2)]=$42;
 HEAP32[(($fd50_i)>>2)]=$43;
 var $R_1_i=$42;label=47;break;
 case 39: 
 _abort();
 throw "Reached an unreachable!";
 case 40: 
 var $arrayidx61_i=(($v_0_i+20)|0);
 var $47=HEAP32[(($arrayidx61_i)>>2)];
 var $cmp62_i=($47|0)==0;
 if($cmp62_i){label=41;break;}else{var $R_0_i=$47;var $RP_0_i=$arrayidx61_i;label=42;break;}
 case 41: 
 var $arrayidx65_i=(($v_0_i+16)|0);
 var $48=HEAP32[(($arrayidx65_i)>>2)];
 var $cmp66_i=($48|0)==0;
 if($cmp66_i){var $R_1_i=0;label=47;break;}else{var $R_0_i=$48;var $RP_0_i=$arrayidx65_i;label=42;break;}
 case 42: 
 var $RP_0_i;
 var $R_0_i;
 var $arrayidx71_i=(($R_0_i+20)|0);
 var $49=HEAP32[(($arrayidx71_i)>>2)];
 var $cmp72_i=($49|0)==0;
 if($cmp72_i){label=43;break;}else{var $R_0_i=$49;var $RP_0_i=$arrayidx71_i;label=42;break;}
 case 43: 
 var $arrayidx75_i=(($R_0_i+16)|0);
 var $50=HEAP32[(($arrayidx75_i)>>2)];
 var $cmp76_i=($50|0)==0;
 if($cmp76_i){label=44;break;}else{var $R_0_i=$50;var $RP_0_i=$arrayidx75_i;label=42;break;}
 case 44: 
 var $51=$RP_0_i;
 var $cmp81_i=($51>>>0)<($39>>>0);
 if($cmp81_i){label=46;break;}else{label=45;break;}
 case 45: 
 HEAP32[(($RP_0_i)>>2)]=0;
 var $R_1_i=$R_0_i;label=47;break;
 case 46: 
 _abort();
 throw "Reached an unreachable!";
 case 47: 
 var $R_1_i;
 var $cmp90_i=($41|0)==0;
 if($cmp90_i){label=67;break;}else{label=48;break;}
 case 48: 
 var $index_i=(($v_0_i+28)|0);
 var $52=HEAP32[(($index_i)>>2)];
 var $arrayidx94_i=((5472+($52<<2))|0);
 var $53=HEAP32[(($arrayidx94_i)>>2)];
 var $cmp95_i=($v_0_i|0)==($53|0);
 if($cmp95_i){label=49;break;}else{label=51;break;}
 case 49: 
 HEAP32[(($arrayidx94_i)>>2)]=$R_1_i;
 var $cond5_i=($R_1_i|0)==0;
 if($cond5_i){label=50;break;}else{label=57;break;}
 case 50: 
 var $54=HEAP32[(($index_i)>>2)];
 var $shl_i=1<<$54;
 var $neg_i=$shl_i^-1;
 var $55=HEAP32[((5172)>>2)];
 var $and103_i=$55&$neg_i;
 HEAP32[((5172)>>2)]=$and103_i;
 label=67;break;
 case 51: 
 var $56=$41;
 var $57=HEAP32[((5184)>>2)];
 var $cmp107_i=($56>>>0)<($57>>>0);
 if($cmp107_i){label=55;break;}else{label=52;break;}
 case 52: 
 var $arrayidx113_i=(($41+16)|0);
 var $58=HEAP32[(($arrayidx113_i)>>2)];
 var $cmp114_i=($58|0)==($v_0_i|0);
 if($cmp114_i){label=53;break;}else{label=54;break;}
 case 53: 
 HEAP32[(($arrayidx113_i)>>2)]=$R_1_i;
 label=56;break;
 case 54: 
 var $arrayidx121_i=(($41+20)|0);
 HEAP32[(($arrayidx121_i)>>2)]=$R_1_i;
 label=56;break;
 case 55: 
 _abort();
 throw "Reached an unreachable!";
 case 56: 
 var $cmp126_i=($R_1_i|0)==0;
 if($cmp126_i){label=67;break;}else{label=57;break;}
 case 57: 
 var $59=$R_1_i;
 var $60=HEAP32[((5184)>>2)];
 var $cmp130_i=($59>>>0)<($60>>>0);
 if($cmp130_i){label=66;break;}else{label=58;break;}
 case 58: 
 var $parent135_i=(($R_1_i+24)|0);
 HEAP32[(($parent135_i)>>2)]=$41;
 var $arrayidx137_i=(($v_0_i+16)|0);
 var $61=HEAP32[(($arrayidx137_i)>>2)];
 var $cmp138_i=($61|0)==0;
 if($cmp138_i){label=62;break;}else{label=59;break;}
 case 59: 
 var $62=$61;
 var $63=HEAP32[((5184)>>2)];
 var $cmp142_i=($62>>>0)<($63>>>0);
 if($cmp142_i){label=61;break;}else{label=60;break;}
 case 60: 
 var $arrayidx148_i=(($R_1_i+16)|0);
 HEAP32[(($arrayidx148_i)>>2)]=$61;
 var $parent149_i=(($61+24)|0);
 HEAP32[(($parent149_i)>>2)]=$R_1_i;
 label=62;break;
 case 61: 
 _abort();
 throw "Reached an unreachable!";
 case 62: 
 var $arrayidx154_i=(($v_0_i+20)|0);
 var $64=HEAP32[(($arrayidx154_i)>>2)];
 var $cmp155_i=($64|0)==0;
 if($cmp155_i){label=67;break;}else{label=63;break;}
 case 63: 
 var $65=$64;
 var $66=HEAP32[((5184)>>2)];
 var $cmp159_i=($65>>>0)<($66>>>0);
 if($cmp159_i){label=65;break;}else{label=64;break;}
 case 64: 
 var $arrayidx165_i=(($R_1_i+20)|0);
 HEAP32[(($arrayidx165_i)>>2)]=$64;
 var $parent166_i=(($64+24)|0);
 HEAP32[(($parent166_i)>>2)]=$R_1_i;
 label=67;break;
 case 65: 
 _abort();
 throw "Reached an unreachable!";
 case 66: 
 _abort();
 throw "Reached an unreachable!";
 case 67: 
 var $cmp174_i=($rsize_0_i>>>0)<16;
 if($cmp174_i){label=68;break;}else{label=69;break;}
 case 68: 
 var $add177_i=((($rsize_0_i)+($cond))|0);
 var $or178_i=$add177_i|3;
 var $head179_i=(($v_0_i+4)|0);
 HEAP32[(($head179_i)>>2)]=$or178_i;
 var $add_ptr181_sum_i=((($add177_i)+(4))|0);
 var $head182_i=(($38+$add_ptr181_sum_i)|0);
 var $67=$head182_i;
 var $68=HEAP32[(($67)>>2)];
 var $or183_i=$68|1;
 HEAP32[(($67)>>2)]=$or183_i;
 label=77;break;
 case 69: 
 var $or186_i=$cond|3;
 var $head187_i=(($v_0_i+4)|0);
 HEAP32[(($head187_i)>>2)]=$or186_i;
 var $or188_i=$rsize_0_i|1;
 var $add_ptr_sum_i186=$cond|4;
 var $head189_i=(($38+$add_ptr_sum_i186)|0);
 var $69=$head189_i;
 HEAP32[(($69)>>2)]=$or188_i;
 var $add_ptr_sum1_i=((($rsize_0_i)+($cond))|0);
 var $add_ptr190_i=(($38+$add_ptr_sum1_i)|0);
 var $prev_foot_i=$add_ptr190_i;
 HEAP32[(($prev_foot_i)>>2)]=$rsize_0_i;
 var $70=HEAP32[((5176)>>2)];
 var $cmp191_i=($70|0)==0;
 if($cmp191_i){label=75;break;}else{label=70;break;}
 case 70: 
 var $71=HEAP32[((5188)>>2)];
 var $shr194_i=$70>>>3;
 var $shl195_i=$shr194_i<<1;
 var $arrayidx196_i=((5208+($shl195_i<<2))|0);
 var $72=$arrayidx196_i;
 var $73=HEAP32[((5168)>>2)];
 var $shl198_i=1<<$shr194_i;
 var $and199_i=$73&$shl198_i;
 var $tobool200_i=($and199_i|0)==0;
 if($tobool200_i){label=71;break;}else{label=72;break;}
 case 71: 
 var $or204_i=$73|$shl198_i;
 HEAP32[((5168)>>2)]=$or204_i;
 var $arrayidx196_sum_pre_i=((($shl195_i)+(2))|0);
 var $_pre_i=((5208+($arrayidx196_sum_pre_i<<2))|0);
 var $F197_0_i=$72;var $_pre_phi_i=$_pre_i;label=74;break;
 case 72: 
 var $arrayidx196_sum2_i=((($shl195_i)+(2))|0);
 var $74=((5208+($arrayidx196_sum2_i<<2))|0);
 var $75=HEAP32[(($74)>>2)];
 var $76=$75;
 var $77=HEAP32[((5184)>>2)];
 var $cmp208_i=($76>>>0)<($77>>>0);
 if($cmp208_i){label=73;break;}else{var $F197_0_i=$75;var $_pre_phi_i=$74;label=74;break;}
 case 73: 
 _abort();
 throw "Reached an unreachable!";
 case 74: 
 var $_pre_phi_i;
 var $F197_0_i;
 HEAP32[(($_pre_phi_i)>>2)]=$71;
 var $bk218_i=(($F197_0_i+12)|0);
 HEAP32[(($bk218_i)>>2)]=$71;
 var $fd219_i=(($71+8)|0);
 HEAP32[(($fd219_i)>>2)]=$F197_0_i;
 var $bk220_i=(($71+12)|0);
 HEAP32[(($bk220_i)>>2)]=$72;
 label=75;break;
 case 75: 
 HEAP32[((5176)>>2)]=$rsize_0_i;
 HEAP32[((5188)>>2)]=$40;
 label=77;break;
 case 76: 
 _abort();
 throw "Reached an unreachable!";
 case 77: 
 var $add_ptr225_i=(($v_0_i+8)|0);
 var $78=$add_ptr225_i;
 var $mem_0=$78;label=341;break;
 case 78: 
 var $cmp138=($bytes>>>0)>4294967231;
 if($cmp138){var $nb_0=-1;label=160;break;}else{label=79;break;}
 case 79: 
 var $add143=((($bytes)+(11))|0);
 var $and144=$add143&-8;
 var $79=HEAP32[((5172)>>2)];
 var $cmp145=($79|0)==0;
 if($cmp145){var $nb_0=$and144;label=160;break;}else{label=80;break;}
 case 80: 
 var $sub_i107=(((-$and144))|0);
 var $shr_i108=$add143>>>8;
 var $cmp_i109=($shr_i108|0)==0;
 if($cmp_i109){var $idx_0_i=0;label=83;break;}else{label=81;break;}
 case 81: 
 var $cmp1_i=($and144>>>0)>16777215;
 if($cmp1_i){var $idx_0_i=31;label=83;break;}else{label=82;break;}
 case 82: 
 var $sub4_i=((($shr_i108)+(1048320))|0);
 var $shr5_i111=$sub4_i>>>16;
 var $and_i112=$shr5_i111&8;
 var $shl_i113=$shr_i108<<$and_i112;
 var $sub6_i=((($shl_i113)+(520192))|0);
 var $shr7_i114=$sub6_i>>>16;
 var $and8_i=$shr7_i114&4;
 var $add_i115=$and8_i|$and_i112;
 var $shl9_i=$shl_i113<<$and8_i;
 var $sub10_i=((($shl9_i)+(245760))|0);
 var $shr11_i116=$sub10_i>>>16;
 var $and12_i=$shr11_i116&2;
 var $add13_i=$add_i115|$and12_i;
 var $sub14_i=(((14)-($add13_i))|0);
 var $shl15_i=$shl9_i<<$and12_i;
 var $shr16_i117=$shl15_i>>>15;
 var $add17_i=((($sub14_i)+($shr16_i117))|0);
 var $shl18_i=$add17_i<<1;
 var $add19_i=((($add17_i)+(7))|0);
 var $shr20_i=$and144>>>($add19_i>>>0);
 var $and21_i118=$shr20_i&1;
 var $add22_i=$and21_i118|$shl18_i;
 var $idx_0_i=$add22_i;label=83;break;
 case 83: 
 var $idx_0_i;
 var $arrayidx_i119=((5472+($idx_0_i<<2))|0);
 var $80=HEAP32[(($arrayidx_i119)>>2)];
 var $cmp24_i=($80|0)==0;
 if($cmp24_i){var $v_2_i=0;var $rsize_2_i=$sub_i107;var $t_1_i=0;label=90;break;}else{label=84;break;}
 case 84: 
 var $cmp26_i=($idx_0_i|0)==31;
 if($cmp26_i){var $cond_i=0;label=86;break;}else{label=85;break;}
 case 85: 
 var $shr27_i=$idx_0_i>>>1;
 var $sub30_i=(((25)-($shr27_i))|0);
 var $cond_i=$sub30_i;label=86;break;
 case 86: 
 var $cond_i;
 var $shl31_i=$and144<<$cond_i;
 var $v_0_i123=0;var $rsize_0_i122=$sub_i107;var $t_0_i121=$80;var $sizebits_0_i=$shl31_i;var $rst_0_i=0;label=87;break;
 case 87: 
 var $rst_0_i;
 var $sizebits_0_i;
 var $t_0_i121;
 var $rsize_0_i122;
 var $v_0_i123;
 var $head_i124=(($t_0_i121+4)|0);
 var $81=HEAP32[(($head_i124)>>2)];
 var $and32_i=$81&-8;
 var $sub33_i=((($and32_i)-($and144))|0);
 var $cmp34_i=($sub33_i>>>0)<($rsize_0_i122>>>0);
 if($cmp34_i){label=88;break;}else{var $v_1_i=$v_0_i123;var $rsize_1_i=$rsize_0_i122;label=89;break;}
 case 88: 
 var $cmp36_i=($and32_i|0)==($and144|0);
 if($cmp36_i){var $v_2_i=$t_0_i121;var $rsize_2_i=$sub33_i;var $t_1_i=$t_0_i121;label=90;break;}else{var $v_1_i=$t_0_i121;var $rsize_1_i=$sub33_i;label=89;break;}
 case 89: 
 var $rsize_1_i;
 var $v_1_i;
 var $arrayidx40_i=(($t_0_i121+20)|0);
 var $82=HEAP32[(($arrayidx40_i)>>2)];
 var $shr41_i=$sizebits_0_i>>>31;
 var $arrayidx44_i=(($t_0_i121+16+($shr41_i<<2))|0);
 var $83=HEAP32[(($arrayidx44_i)>>2)];
 var $cmp45_i125=($82|0)==0;
 var $cmp46_i=($82|0)==($83|0);
 var $or_cond18_i=$cmp45_i125|$cmp46_i;
 var $rst_1_i=($or_cond18_i?$rst_0_i:$82);
 var $cmp49_i=($83|0)==0;
 var $shl52_i=$sizebits_0_i<<1;
 if($cmp49_i){var $v_2_i=$v_1_i;var $rsize_2_i=$rsize_1_i;var $t_1_i=$rst_1_i;label=90;break;}else{var $v_0_i123=$v_1_i;var $rsize_0_i122=$rsize_1_i;var $t_0_i121=$83;var $sizebits_0_i=$shl52_i;var $rst_0_i=$rst_1_i;label=87;break;}
 case 90: 
 var $t_1_i;
 var $rsize_2_i;
 var $v_2_i;
 var $cmp54_i=($t_1_i|0)==0;
 var $cmp56_i=($v_2_i|0)==0;
 var $or_cond_i=$cmp54_i&$cmp56_i;
 if($or_cond_i){label=91;break;}else{var $t_2_ph_i=$t_1_i;label=93;break;}
 case 91: 
 var $shl59_i=2<<$idx_0_i;
 var $sub62_i=(((-$shl59_i))|0);
 var $or_i=$shl59_i|$sub62_i;
 var $and63_i=$79&$or_i;
 var $cmp64_i=($and63_i|0)==0;
 if($cmp64_i){var $nb_0=$and144;label=160;break;}else{label=92;break;}
 case 92: 
 var $sub66_i=(((-$and63_i))|0);
 var $and67_i=$and63_i&$sub66_i;
 var $sub69_i=((($and67_i)-(1))|0);
 var $shr71_i=$sub69_i>>>12;
 var $and72_i=$shr71_i&16;
 var $shr74_i=$sub69_i>>>($and72_i>>>0);
 var $shr75_i=$shr74_i>>>5;
 var $and76_i=$shr75_i&8;
 var $add77_i=$and76_i|$and72_i;
 var $shr78_i=$shr74_i>>>($and76_i>>>0);
 var $shr79_i=$shr78_i>>>2;
 var $and80_i=$shr79_i&4;
 var $add81_i=$add77_i|$and80_i;
 var $shr82_i=$shr78_i>>>($and80_i>>>0);
 var $shr83_i=$shr82_i>>>1;
 var $and84_i=$shr83_i&2;
 var $add85_i=$add81_i|$and84_i;
 var $shr86_i=$shr82_i>>>($and84_i>>>0);
 var $shr87_i=$shr86_i>>>1;
 var $and88_i=$shr87_i&1;
 var $add89_i=$add85_i|$and88_i;
 var $shr90_i=$shr86_i>>>($and88_i>>>0);
 var $add91_i=((($add89_i)+($shr90_i))|0);
 var $arrayidx93_i=((5472+($add91_i<<2))|0);
 var $84=HEAP32[(($arrayidx93_i)>>2)];
 var $t_2_ph_i=$84;label=93;break;
 case 93: 
 var $t_2_ph_i;
 var $cmp9629_i=($t_2_ph_i|0)==0;
 if($cmp9629_i){var $rsize_3_lcssa_i=$rsize_2_i;var $v_3_lcssa_i=$v_2_i;label=96;break;}else{var $t_230_i=$t_2_ph_i;var $rsize_331_i=$rsize_2_i;var $v_332_i=$v_2_i;label=94;break;}
 case 94: 
 var $v_332_i;
 var $rsize_331_i;
 var $t_230_i;
 var $head98_i=(($t_230_i+4)|0);
 var $85=HEAP32[(($head98_i)>>2)];
 var $and99_i=$85&-8;
 var $sub100_i=((($and99_i)-($and144))|0);
 var $cmp101_i=($sub100_i>>>0)<($rsize_331_i>>>0);
 var $sub100_rsize_3_i=($cmp101_i?$sub100_i:$rsize_331_i);
 var $t_2_v_3_i=($cmp101_i?$t_230_i:$v_332_i);
 var $arrayidx105_i=(($t_230_i+16)|0);
 var $86=HEAP32[(($arrayidx105_i)>>2)];
 var $cmp106_i=($86|0)==0;
 if($cmp106_i){label=95;break;}else{var $t_230_i=$86;var $rsize_331_i=$sub100_rsize_3_i;var $v_332_i=$t_2_v_3_i;label=94;break;}
 case 95: 
 var $arrayidx112_i=(($t_230_i+20)|0);
 var $87=HEAP32[(($arrayidx112_i)>>2)];
 var $cmp96_i=($87|0)==0;
 if($cmp96_i){var $rsize_3_lcssa_i=$sub100_rsize_3_i;var $v_3_lcssa_i=$t_2_v_3_i;label=96;break;}else{var $t_230_i=$87;var $rsize_331_i=$sub100_rsize_3_i;var $v_332_i=$t_2_v_3_i;label=94;break;}
 case 96: 
 var $v_3_lcssa_i;
 var $rsize_3_lcssa_i;
 var $cmp115_i=($v_3_lcssa_i|0)==0;
 if($cmp115_i){var $nb_0=$and144;label=160;break;}else{label=97;break;}
 case 97: 
 var $88=HEAP32[((5176)>>2)];
 var $sub117_i=((($88)-($and144))|0);
 var $cmp118_i=($rsize_3_lcssa_i>>>0)<($sub117_i>>>0);
 if($cmp118_i){label=98;break;}else{var $nb_0=$and144;label=160;break;}
 case 98: 
 var $89=$v_3_lcssa_i;
 var $90=HEAP32[((5184)>>2)];
 var $cmp120_i=($89>>>0)<($90>>>0);
 if($cmp120_i){label=158;break;}else{label=99;break;}
 case 99: 
 var $add_ptr_i128=(($89+$and144)|0);
 var $91=$add_ptr_i128;
 var $cmp122_i=($89>>>0)<($add_ptr_i128>>>0);
 if($cmp122_i){label=100;break;}else{label=158;break;}
 case 100: 
 var $parent_i129=(($v_3_lcssa_i+24)|0);
 var $92=HEAP32[(($parent_i129)>>2)];
 var $bk_i130=(($v_3_lcssa_i+12)|0);
 var $93=HEAP32[(($bk_i130)>>2)];
 var $cmp127_i=($93|0)==($v_3_lcssa_i|0);
 if($cmp127_i){label=106;break;}else{label=101;break;}
 case 101: 
 var $fd_i131=(($v_3_lcssa_i+8)|0);
 var $94=HEAP32[(($fd_i131)>>2)];
 var $95=$94;
 var $cmp132_i=($95>>>0)<($90>>>0);
 if($cmp132_i){label=105;break;}else{label=102;break;}
 case 102: 
 var $bk135_i=(($94+12)|0);
 var $96=HEAP32[(($bk135_i)>>2)];
 var $cmp136_i=($96|0)==($v_3_lcssa_i|0);
 if($cmp136_i){label=103;break;}else{label=105;break;}
 case 103: 
 var $fd138_i=(($93+8)|0);
 var $97=HEAP32[(($fd138_i)>>2)];
 var $cmp139_i=($97|0)==($v_3_lcssa_i|0);
 if($cmp139_i){label=104;break;}else{label=105;break;}
 case 104: 
 HEAP32[(($bk135_i)>>2)]=$93;
 HEAP32[(($fd138_i)>>2)]=$94;
 var $R_1_i139=$93;label=113;break;
 case 105: 
 _abort();
 throw "Reached an unreachable!";
 case 106: 
 var $arrayidx150_i=(($v_3_lcssa_i+20)|0);
 var $98=HEAP32[(($arrayidx150_i)>>2)];
 var $cmp151_i=($98|0)==0;
 if($cmp151_i){label=107;break;}else{var $R_0_i137=$98;var $RP_0_i136=$arrayidx150_i;label=108;break;}
 case 107: 
 var $arrayidx154_i133=(($v_3_lcssa_i+16)|0);
 var $99=HEAP32[(($arrayidx154_i133)>>2)];
 var $cmp155_i134=($99|0)==0;
 if($cmp155_i134){var $R_1_i139=0;label=113;break;}else{var $R_0_i137=$99;var $RP_0_i136=$arrayidx154_i133;label=108;break;}
 case 108: 
 var $RP_0_i136;
 var $R_0_i137;
 var $arrayidx160_i=(($R_0_i137+20)|0);
 var $100=HEAP32[(($arrayidx160_i)>>2)];
 var $cmp161_i=($100|0)==0;
 if($cmp161_i){label=109;break;}else{var $R_0_i137=$100;var $RP_0_i136=$arrayidx160_i;label=108;break;}
 case 109: 
 var $arrayidx164_i=(($R_0_i137+16)|0);
 var $101=HEAP32[(($arrayidx164_i)>>2)];
 var $cmp165_i=($101|0)==0;
 if($cmp165_i){label=110;break;}else{var $R_0_i137=$101;var $RP_0_i136=$arrayidx164_i;label=108;break;}
 case 110: 
 var $102=$RP_0_i136;
 var $cmp170_i=($102>>>0)<($90>>>0);
 if($cmp170_i){label=112;break;}else{label=111;break;}
 case 111: 
 HEAP32[(($RP_0_i136)>>2)]=0;
 var $R_1_i139=$R_0_i137;label=113;break;
 case 112: 
 _abort();
 throw "Reached an unreachable!";
 case 113: 
 var $R_1_i139;
 var $cmp179_i=($92|0)==0;
 if($cmp179_i){label=133;break;}else{label=114;break;}
 case 114: 
 var $index_i140=(($v_3_lcssa_i+28)|0);
 var $103=HEAP32[(($index_i140)>>2)];
 var $arrayidx183_i=((5472+($103<<2))|0);
 var $104=HEAP32[(($arrayidx183_i)>>2)];
 var $cmp184_i=($v_3_lcssa_i|0)==($104|0);
 if($cmp184_i){label=115;break;}else{label=117;break;}
 case 115: 
 HEAP32[(($arrayidx183_i)>>2)]=$R_1_i139;
 var $cond20_i=($R_1_i139|0)==0;
 if($cond20_i){label=116;break;}else{label=123;break;}
 case 116: 
 var $105=HEAP32[(($index_i140)>>2)];
 var $shl191_i=1<<$105;
 var $neg_i141=$shl191_i^-1;
 var $106=HEAP32[((5172)>>2)];
 var $and193_i=$106&$neg_i141;
 HEAP32[((5172)>>2)]=$and193_i;
 label=133;break;
 case 117: 
 var $107=$92;
 var $108=HEAP32[((5184)>>2)];
 var $cmp197_i=($107>>>0)<($108>>>0);
 if($cmp197_i){label=121;break;}else{label=118;break;}
 case 118: 
 var $arrayidx203_i=(($92+16)|0);
 var $109=HEAP32[(($arrayidx203_i)>>2)];
 var $cmp204_i=($109|0)==($v_3_lcssa_i|0);
 if($cmp204_i){label=119;break;}else{label=120;break;}
 case 119: 
 HEAP32[(($arrayidx203_i)>>2)]=$R_1_i139;
 label=122;break;
 case 120: 
 var $arrayidx211_i=(($92+20)|0);
 HEAP32[(($arrayidx211_i)>>2)]=$R_1_i139;
 label=122;break;
 case 121: 
 _abort();
 throw "Reached an unreachable!";
 case 122: 
 var $cmp216_i=($R_1_i139|0)==0;
 if($cmp216_i){label=133;break;}else{label=123;break;}
 case 123: 
 var $110=$R_1_i139;
 var $111=HEAP32[((5184)>>2)];
 var $cmp220_i=($110>>>0)<($111>>>0);
 if($cmp220_i){label=132;break;}else{label=124;break;}
 case 124: 
 var $parent225_i=(($R_1_i139+24)|0);
 HEAP32[(($parent225_i)>>2)]=$92;
 var $arrayidx227_i=(($v_3_lcssa_i+16)|0);
 var $112=HEAP32[(($arrayidx227_i)>>2)];
 var $cmp228_i=($112|0)==0;
 if($cmp228_i){label=128;break;}else{label=125;break;}
 case 125: 
 var $113=$112;
 var $114=HEAP32[((5184)>>2)];
 var $cmp232_i=($113>>>0)<($114>>>0);
 if($cmp232_i){label=127;break;}else{label=126;break;}
 case 126: 
 var $arrayidx238_i=(($R_1_i139+16)|0);
 HEAP32[(($arrayidx238_i)>>2)]=$112;
 var $parent239_i=(($112+24)|0);
 HEAP32[(($parent239_i)>>2)]=$R_1_i139;
 label=128;break;
 case 127: 
 _abort();
 throw "Reached an unreachable!";
 case 128: 
 var $arrayidx244_i=(($v_3_lcssa_i+20)|0);
 var $115=HEAP32[(($arrayidx244_i)>>2)];
 var $cmp245_i=($115|0)==0;
 if($cmp245_i){label=133;break;}else{label=129;break;}
 case 129: 
 var $116=$115;
 var $117=HEAP32[((5184)>>2)];
 var $cmp249_i=($116>>>0)<($117>>>0);
 if($cmp249_i){label=131;break;}else{label=130;break;}
 case 130: 
 var $arrayidx255_i=(($R_1_i139+20)|0);
 HEAP32[(($arrayidx255_i)>>2)]=$115;
 var $parent256_i=(($115+24)|0);
 HEAP32[(($parent256_i)>>2)]=$R_1_i139;
 label=133;break;
 case 131: 
 _abort();
 throw "Reached an unreachable!";
 case 132: 
 _abort();
 throw "Reached an unreachable!";
 case 133: 
 var $cmp264_i=($rsize_3_lcssa_i>>>0)<16;
 if($cmp264_i){label=134;break;}else{label=135;break;}
 case 134: 
 var $add267_i=((($rsize_3_lcssa_i)+($and144))|0);
 var $or269_i=$add267_i|3;
 var $head270_i=(($v_3_lcssa_i+4)|0);
 HEAP32[(($head270_i)>>2)]=$or269_i;
 var $add_ptr272_sum_i=((($add267_i)+(4))|0);
 var $head273_i=(($89+$add_ptr272_sum_i)|0);
 var $118=$head273_i;
 var $119=HEAP32[(($118)>>2)];
 var $or274_i=$119|1;
 HEAP32[(($118)>>2)]=$or274_i;
 label=159;break;
 case 135: 
 var $or277_i=$and144|3;
 var $head278_i=(($v_3_lcssa_i+4)|0);
 HEAP32[(($head278_i)>>2)]=$or277_i;
 var $or279_i=$rsize_3_lcssa_i|1;
 var $add_ptr_sum_i143185=$and144|4;
 var $head280_i=(($89+$add_ptr_sum_i143185)|0);
 var $120=$head280_i;
 HEAP32[(($120)>>2)]=$or279_i;
 var $add_ptr_sum1_i144=((($rsize_3_lcssa_i)+($and144))|0);
 var $add_ptr281_i=(($89+$add_ptr_sum1_i144)|0);
 var $prev_foot_i145=$add_ptr281_i;
 HEAP32[(($prev_foot_i145)>>2)]=$rsize_3_lcssa_i;
 var $shr282_i=$rsize_3_lcssa_i>>>3;
 var $cmp283_i=($rsize_3_lcssa_i>>>0)<256;
 if($cmp283_i){label=136;break;}else{label=141;break;}
 case 136: 
 var $shl287_i=$shr282_i<<1;
 var $arrayidx288_i=((5208+($shl287_i<<2))|0);
 var $121=$arrayidx288_i;
 var $122=HEAP32[((5168)>>2)];
 var $shl290_i=1<<$shr282_i;
 var $and291_i=$122&$shl290_i;
 var $tobool292_i=($and291_i|0)==0;
 if($tobool292_i){label=137;break;}else{label=138;break;}
 case 137: 
 var $or296_i=$122|$shl290_i;
 HEAP32[((5168)>>2)]=$or296_i;
 var $arrayidx288_sum_pre_i=((($shl287_i)+(2))|0);
 var $_pre_i146=((5208+($arrayidx288_sum_pre_i<<2))|0);
 var $F289_0_i=$121;var $_pre_phi_i147=$_pre_i146;label=140;break;
 case 138: 
 var $arrayidx288_sum16_i=((($shl287_i)+(2))|0);
 var $123=((5208+($arrayidx288_sum16_i<<2))|0);
 var $124=HEAP32[(($123)>>2)];
 var $125=$124;
 var $126=HEAP32[((5184)>>2)];
 var $cmp300_i=($125>>>0)<($126>>>0);
 if($cmp300_i){label=139;break;}else{var $F289_0_i=$124;var $_pre_phi_i147=$123;label=140;break;}
 case 139: 
 _abort();
 throw "Reached an unreachable!";
 case 140: 
 var $_pre_phi_i147;
 var $F289_0_i;
 HEAP32[(($_pre_phi_i147)>>2)]=$91;
 var $bk310_i=(($F289_0_i+12)|0);
 HEAP32[(($bk310_i)>>2)]=$91;
 var $add_ptr_sum14_i=((($and144)+(8))|0);
 var $fd311_i=(($89+$add_ptr_sum14_i)|0);
 var $127=$fd311_i;
 HEAP32[(($127)>>2)]=$F289_0_i;
 var $add_ptr_sum15_i=((($and144)+(12))|0);
 var $bk312_i=(($89+$add_ptr_sum15_i)|0);
 var $128=$bk312_i;
 HEAP32[(($128)>>2)]=$121;
 label=159;break;
 case 141: 
 var $129=$add_ptr_i128;
 var $shr317_i=$rsize_3_lcssa_i>>>8;
 var $cmp318_i=($shr317_i|0)==0;
 if($cmp318_i){var $I315_0_i=0;label=144;break;}else{label=142;break;}
 case 142: 
 var $cmp322_i=($rsize_3_lcssa_i>>>0)>16777215;
 if($cmp322_i){var $I315_0_i=31;label=144;break;}else{label=143;break;}
 case 143: 
 var $sub328_i=((($shr317_i)+(1048320))|0);
 var $shr329_i=$sub328_i>>>16;
 var $and330_i=$shr329_i&8;
 var $shl332_i=$shr317_i<<$and330_i;
 var $sub333_i=((($shl332_i)+(520192))|0);
 var $shr334_i=$sub333_i>>>16;
 var $and335_i=$shr334_i&4;
 var $add336_i=$and335_i|$and330_i;
 var $shl337_i=$shl332_i<<$and335_i;
 var $sub338_i=((($shl337_i)+(245760))|0);
 var $shr339_i=$sub338_i>>>16;
 var $and340_i=$shr339_i&2;
 var $add341_i=$add336_i|$and340_i;
 var $sub342_i=(((14)-($add341_i))|0);
 var $shl343_i=$shl337_i<<$and340_i;
 var $shr344_i=$shl343_i>>>15;
 var $add345_i=((($sub342_i)+($shr344_i))|0);
 var $shl346_i=$add345_i<<1;
 var $add347_i=((($add345_i)+(7))|0);
 var $shr348_i=$rsize_3_lcssa_i>>>($add347_i>>>0);
 var $and349_i=$shr348_i&1;
 var $add350_i=$and349_i|$shl346_i;
 var $I315_0_i=$add350_i;label=144;break;
 case 144: 
 var $I315_0_i;
 var $arrayidx354_i=((5472+($I315_0_i<<2))|0);
 var $add_ptr_sum2_i=((($and144)+(28))|0);
 var $index355_i=(($89+$add_ptr_sum2_i)|0);
 var $130=$index355_i;
 HEAP32[(($130)>>2)]=$I315_0_i;
 var $add_ptr_sum3_i=((($and144)+(16))|0);
 var $child356_i=(($89+$add_ptr_sum3_i)|0);
 var $child356_sum_i=((($and144)+(20))|0);
 var $arrayidx357_i=(($89+$child356_sum_i)|0);
 var $131=$arrayidx357_i;
 HEAP32[(($131)>>2)]=0;
 var $arrayidx359_i=$child356_i;
 HEAP32[(($arrayidx359_i)>>2)]=0;
 var $132=HEAP32[((5172)>>2)];
 var $shl361_i=1<<$I315_0_i;
 var $and362_i=$132&$shl361_i;
 var $tobool363_i=($and362_i|0)==0;
 if($tobool363_i){label=145;break;}else{label=146;break;}
 case 145: 
 var $or367_i=$132|$shl361_i;
 HEAP32[((5172)>>2)]=$or367_i;
 HEAP32[(($arrayidx354_i)>>2)]=$129;
 var $133=$arrayidx354_i;
 var $add_ptr_sum4_i=((($and144)+(24))|0);
 var $parent368_i=(($89+$add_ptr_sum4_i)|0);
 var $134=$parent368_i;
 HEAP32[(($134)>>2)]=$133;
 var $add_ptr_sum5_i=((($and144)+(12))|0);
 var $bk369_i=(($89+$add_ptr_sum5_i)|0);
 var $135=$bk369_i;
 HEAP32[(($135)>>2)]=$129;
 var $add_ptr_sum6_i=((($and144)+(8))|0);
 var $fd370_i=(($89+$add_ptr_sum6_i)|0);
 var $136=$fd370_i;
 HEAP32[(($136)>>2)]=$129;
 label=159;break;
 case 146: 
 var $137=HEAP32[(($arrayidx354_i)>>2)];
 var $cmp373_i=($I315_0_i|0)==31;
 if($cmp373_i){var $cond382_i=0;label=148;break;}else{label=147;break;}
 case 147: 
 var $shr377_i=$I315_0_i>>>1;
 var $sub380_i=(((25)-($shr377_i))|0);
 var $cond382_i=$sub380_i;label=148;break;
 case 148: 
 var $cond382_i;
 var $head38524_i=(($137+4)|0);
 var $138=HEAP32[(($head38524_i)>>2)];
 var $and38625_i=$138&-8;
 var $cmp38726_i=($and38625_i|0)==($rsize_3_lcssa_i|0);
 if($cmp38726_i){var $T_0_lcssa_i=$137;label=155;break;}else{label=149;break;}
 case 149: 
 var $shl383_i=$rsize_3_lcssa_i<<$cond382_i;
 var $T_027_i=$137;var $K372_028_i=$shl383_i;label=151;break;
 case 150: 
 var $shl394_i=$K372_028_i<<1;
 var $head385_i=(($140+4)|0);
 var $139=HEAP32[(($head385_i)>>2)];
 var $and386_i=$139&-8;
 var $cmp387_i=($and386_i|0)==($rsize_3_lcssa_i|0);
 if($cmp387_i){var $T_0_lcssa_i=$140;label=155;break;}else{var $T_027_i=$140;var $K372_028_i=$shl394_i;label=151;break;}
 case 151: 
 var $K372_028_i;
 var $T_027_i;
 var $shr390_i=$K372_028_i>>>31;
 var $arrayidx393_i=(($T_027_i+16+($shr390_i<<2))|0);
 var $140=HEAP32[(($arrayidx393_i)>>2)];
 var $cmp395_i=($140|0)==0;
 if($cmp395_i){label=152;break;}else{label=150;break;}
 case 152: 
 var $141=$arrayidx393_i;
 var $142=HEAP32[((5184)>>2)];
 var $cmp400_i=($141>>>0)<($142>>>0);
 if($cmp400_i){label=154;break;}else{label=153;break;}
 case 153: 
 HEAP32[(($arrayidx393_i)>>2)]=$129;
 var $add_ptr_sum11_i=((($and144)+(24))|0);
 var $parent405_i=(($89+$add_ptr_sum11_i)|0);
 var $143=$parent405_i;
 HEAP32[(($143)>>2)]=$T_027_i;
 var $add_ptr_sum12_i=((($and144)+(12))|0);
 var $bk406_i=(($89+$add_ptr_sum12_i)|0);
 var $144=$bk406_i;
 HEAP32[(($144)>>2)]=$129;
 var $add_ptr_sum13_i=((($and144)+(8))|0);
 var $fd407_i=(($89+$add_ptr_sum13_i)|0);
 var $145=$fd407_i;
 HEAP32[(($145)>>2)]=$129;
 label=159;break;
 case 154: 
 _abort();
 throw "Reached an unreachable!";
 case 155: 
 var $T_0_lcssa_i;
 var $fd412_i=(($T_0_lcssa_i+8)|0);
 var $146=HEAP32[(($fd412_i)>>2)];
 var $147=$T_0_lcssa_i;
 var $148=HEAP32[((5184)>>2)];
 var $cmp414_i=($147>>>0)>=($148>>>0);
 var $149=$146;
 var $cmp418_i=($149>>>0)>=($148>>>0);
 var $or_cond21_i=$cmp414_i&$cmp418_i;
 if($or_cond21_i){label=156;break;}else{label=157;break;}
 case 156: 
 var $bk425_i=(($146+12)|0);
 HEAP32[(($bk425_i)>>2)]=$129;
 HEAP32[(($fd412_i)>>2)]=$129;
 var $add_ptr_sum8_i=((($and144)+(8))|0);
 var $fd427_i=(($89+$add_ptr_sum8_i)|0);
 var $150=$fd427_i;
 HEAP32[(($150)>>2)]=$146;
 var $add_ptr_sum9_i=((($and144)+(12))|0);
 var $bk428_i=(($89+$add_ptr_sum9_i)|0);
 var $151=$bk428_i;
 HEAP32[(($151)>>2)]=$T_0_lcssa_i;
 var $add_ptr_sum10_i=((($and144)+(24))|0);
 var $parent429_i=(($89+$add_ptr_sum10_i)|0);
 var $152=$parent429_i;
 HEAP32[(($152)>>2)]=0;
 label=159;break;
 case 157: 
 _abort();
 throw "Reached an unreachable!";
 case 158: 
 _abort();
 throw "Reached an unreachable!";
 case 159: 
 var $add_ptr436_i=(($v_3_lcssa_i+8)|0);
 var $153=$add_ptr436_i;
 var $mem_0=$153;label=341;break;
 case 160: 
 var $nb_0;
 var $154=HEAP32[((5176)>>2)];
 var $cmp155=($154>>>0)<($nb_0>>>0);
 if($cmp155){label=165;break;}else{label=161;break;}
 case 161: 
 var $sub159=((($154)-($nb_0))|0);
 var $155=HEAP32[((5188)>>2)];
 var $cmp161=($sub159>>>0)>15;
 if($cmp161){label=162;break;}else{label=163;break;}
 case 162: 
 var $156=$155;
 var $add_ptr165=(($156+$nb_0)|0);
 var $157=$add_ptr165;
 HEAP32[((5188)>>2)]=$157;
 HEAP32[((5176)>>2)]=$sub159;
 var $or166=$sub159|1;
 var $add_ptr165_sum=((($nb_0)+(4))|0);
 var $head167=(($156+$add_ptr165_sum)|0);
 var $158=$head167;
 HEAP32[(($158)>>2)]=$or166;
 var $add_ptr168=(($156+$154)|0);
 var $prev_foot169=$add_ptr168;
 HEAP32[(($prev_foot169)>>2)]=$sub159;
 var $or171=$nb_0|3;
 var $head172=(($155+4)|0);
 HEAP32[(($head172)>>2)]=$or171;
 label=164;break;
 case 163: 
 HEAP32[((5176)>>2)]=0;
 HEAP32[((5188)>>2)]=0;
 var $or175=$154|3;
 var $head176=(($155+4)|0);
 HEAP32[(($head176)>>2)]=$or175;
 var $159=$155;
 var $add_ptr177_sum=((($154)+(4))|0);
 var $head178=(($159+$add_ptr177_sum)|0);
 var $160=$head178;
 var $161=HEAP32[(($160)>>2)];
 var $or179=$161|1;
 HEAP32[(($160)>>2)]=$or179;
 label=164;break;
 case 164: 
 var $add_ptr181=(($155+8)|0);
 var $162=$add_ptr181;
 var $mem_0=$162;label=341;break;
 case 165: 
 var $163=HEAP32[((5180)>>2)];
 var $cmp183=($163>>>0)>($nb_0>>>0);
 if($cmp183){label=166;break;}else{label=167;break;}
 case 166: 
 var $sub187=((($163)-($nb_0))|0);
 HEAP32[((5180)>>2)]=$sub187;
 var $164=HEAP32[((5192)>>2)];
 var $165=$164;
 var $add_ptr190=(($165+$nb_0)|0);
 var $166=$add_ptr190;
 HEAP32[((5192)>>2)]=$166;
 var $or191=$sub187|1;
 var $add_ptr190_sum=((($nb_0)+(4))|0);
 var $head192=(($165+$add_ptr190_sum)|0);
 var $167=$head192;
 HEAP32[(($167)>>2)]=$or191;
 var $or194=$nb_0|3;
 var $head195=(($164+4)|0);
 HEAP32[(($head195)>>2)]=$or194;
 var $add_ptr196=(($164+8)|0);
 var $168=$add_ptr196;
 var $mem_0=$168;label=341;break;
 case 167: 
 var $169=HEAP32[((3976)>>2)];
 var $cmp_i148=($169|0)==0;
 if($cmp_i148){label=168;break;}else{label=171;break;}
 case 168: 
 var $call_i_i=_sysconf(30);
 var $sub_i_i=((($call_i_i)-(1))|0);
 var $and_i_i=$sub_i_i&$call_i_i;
 var $cmp1_i_i=($and_i_i|0)==0;
 if($cmp1_i_i){label=170;break;}else{label=169;break;}
 case 169: 
 _abort();
 throw "Reached an unreachable!";
 case 170: 
 HEAP32[((3984)>>2)]=$call_i_i;
 HEAP32[((3980)>>2)]=$call_i_i;
 HEAP32[((3988)>>2)]=-1;
 HEAP32[((3992)>>2)]=-1;
 HEAP32[((3996)>>2)]=0;
 HEAP32[((5612)>>2)]=0;
 var $call6_i_i=_time(0);
 var $xor_i_i=$call6_i_i&-16;
 var $and7_i_i=$xor_i_i^1431655768;
 HEAP32[((3976)>>2)]=$and7_i_i;
 label=171;break;
 case 171: 
 var $add_i149=((($nb_0)+(48))|0);
 var $170=HEAP32[((3984)>>2)];
 var $sub_i150=((($nb_0)+(47))|0);
 var $add9_i=((($170)+($sub_i150))|0);
 var $neg_i151=(((-$170))|0);
 var $and11_i=$add9_i&$neg_i151;
 var $cmp12_i=($and11_i>>>0)>($nb_0>>>0);
 if($cmp12_i){label=172;break;}else{var $mem_0=0;label=341;break;}
 case 172: 
 var $171=HEAP32[((5608)>>2)];
 var $cmp15_i=($171|0)==0;
 if($cmp15_i){label=174;break;}else{label=173;break;}
 case 173: 
 var $172=HEAP32[((5600)>>2)];
 var $add17_i152=((($172)+($and11_i))|0);
 var $cmp19_i=($add17_i152>>>0)<=($172>>>0);
 var $cmp21_i=($add17_i152>>>0)>($171>>>0);
 var $or_cond4_i=$cmp19_i|$cmp21_i;
 if($or_cond4_i){var $mem_0=0;label=341;break;}else{label=174;break;}
 case 174: 
 var $173=HEAP32[((5612)>>2)];
 var $and26_i=$173&4;
 var $tobool27_i=($and26_i|0)==0;
 if($tobool27_i){label=175;break;}else{var $tsize_1_i=0;label=198;break;}
 case 175: 
 var $174=HEAP32[((5192)>>2)];
 var $cmp29_i=($174|0)==0;
 if($cmp29_i){label=181;break;}else{label=176;break;}
 case 176: 
 var $175=$174;
 var $sp_0_i_i=5616;label=177;break;
 case 177: 
 var $sp_0_i_i;
 var $base_i_i=(($sp_0_i_i)|0);
 var $176=HEAP32[(($base_i_i)>>2)];
 var $cmp_i9_i=($176>>>0)>($175>>>0);
 if($cmp_i9_i){label=179;break;}else{label=178;break;}
 case 178: 
 var $size_i_i=(($sp_0_i_i+4)|0);
 var $177=HEAP32[(($size_i_i)>>2)];
 var $add_ptr_i_i=(($176+$177)|0);
 var $cmp2_i_i=($add_ptr_i_i>>>0)>($175>>>0);
 if($cmp2_i_i){label=180;break;}else{label=179;break;}
 case 179: 
 var $next_i_i=(($sp_0_i_i+8)|0);
 var $178=HEAP32[(($next_i_i)>>2)];
 var $cmp3_i_i=($178|0)==0;
 if($cmp3_i_i){label=181;break;}else{var $sp_0_i_i=$178;label=177;break;}
 case 180: 
 var $cmp32_i154=($sp_0_i_i|0)==0;
 if($cmp32_i154){label=181;break;}else{label=188;break;}
 case 181: 
 var $call34_i=_sbrk(0);
 var $cmp35_i156=($call34_i|0)==-1;
 if($cmp35_i156){var $tsize_07588_i=0;label=197;break;}else{label=182;break;}
 case 182: 
 var $179=$call34_i;
 var $180=HEAP32[((3980)>>2)];
 var $sub38_i=((($180)-(1))|0);
 var $and39_i=$sub38_i&$179;
 var $cmp40_i157=($and39_i|0)==0;
 if($cmp40_i157){var $ssize_0_i=$and11_i;label=184;break;}else{label=183;break;}
 case 183: 
 var $add43_i=((($sub38_i)+($179))|0);
 var $neg45_i=(((-$180))|0);
 var $and46_i=$add43_i&$neg45_i;
 var $sub47_i=((($and11_i)-($179))|0);
 var $add48_i=((($sub47_i)+($and46_i))|0);
 var $ssize_0_i=$add48_i;label=184;break;
 case 184: 
 var $ssize_0_i;
 var $181=HEAP32[((5600)>>2)];
 var $add51_i=((($181)+($ssize_0_i))|0);
 var $cmp52_i=($ssize_0_i>>>0)>($nb_0>>>0);
 var $cmp54_i158=($ssize_0_i>>>0)<2147483647;
 var $or_cond_i159=$cmp52_i&$cmp54_i158;
 if($or_cond_i159){label=185;break;}else{var $tsize_07588_i=0;label=197;break;}
 case 185: 
 var $182=HEAP32[((5608)>>2)];
 var $cmp57_i=($182|0)==0;
 if($cmp57_i){label=187;break;}else{label=186;break;}
 case 186: 
 var $cmp60_i=($add51_i>>>0)<=($181>>>0);
 var $cmp63_i=($add51_i>>>0)>($182>>>0);
 var $or_cond5_i=$cmp60_i|$cmp63_i;
 if($or_cond5_i){var $tsize_07588_i=0;label=197;break;}else{label=187;break;}
 case 187: 
 var $call65_i=_sbrk($ssize_0_i);
 var $cmp66_i160=($call65_i|0)==($call34_i|0);
 if($cmp66_i160){var $br_0_i=$call34_i;var $ssize_1_i=$ssize_0_i;label=190;break;}else{var $ssize_173_i=$ssize_0_i;var $br_074_i=$call65_i;label=191;break;}
 case 188: 
 var $183=HEAP32[((5180)>>2)];
 var $add74_i=((($add9_i)-($183))|0);
 var $and77_i=$add74_i&$neg_i151;
 var $cmp78_i=($and77_i>>>0)<2147483647;
 if($cmp78_i){label=189;break;}else{var $tsize_07588_i=0;label=197;break;}
 case 189: 
 var $call80_i=_sbrk($and77_i);
 var $184=HEAP32[(($base_i_i)>>2)];
 var $185=HEAP32[(($size_i_i)>>2)];
 var $add_ptr_i162=(($184+$185)|0);
 var $cmp82_i=($call80_i|0)==($add_ptr_i162|0);
 if($cmp82_i){var $br_0_i=$call80_i;var $ssize_1_i=$and77_i;label=190;break;}else{var $ssize_173_i=$and77_i;var $br_074_i=$call80_i;label=191;break;}
 case 190: 
 var $ssize_1_i;
 var $br_0_i;
 var $cmp86_i=($br_0_i|0)==-1;
 if($cmp86_i){var $tsize_07588_i=$ssize_1_i;label=197;break;}else{var $tsize_293_i=$ssize_1_i;var $tbase_294_i=$br_0_i;label=201;break;}
 case 191: 
 var $br_074_i;
 var $ssize_173_i;
 var $sub109_i=(((-$ssize_173_i))|0);
 var $cmp88_i=($br_074_i|0)!=-1;
 var $cmp90_i163=($ssize_173_i>>>0)<2147483647;
 var $or_cond2_i=$cmp88_i&$cmp90_i163;
 var $cmp93_i=($add_i149>>>0)>($ssize_173_i>>>0);
 var $or_cond6_i=$or_cond2_i&$cmp93_i;
 if($or_cond6_i){label=192;break;}else{var $ssize_2_i=$ssize_173_i;label=196;break;}
 case 192: 
 var $186=HEAP32[((3984)>>2)];
 var $sub96_i=((($sub_i150)-($ssize_173_i))|0);
 var $add98_i=((($sub96_i)+($186))|0);
 var $neg100_i=(((-$186))|0);
 var $and101_i=$add98_i&$neg100_i;
 var $cmp102_i=($and101_i>>>0)<2147483647;
 if($cmp102_i){label=193;break;}else{var $ssize_2_i=$ssize_173_i;label=196;break;}
 case 193: 
 var $call104_i=_sbrk($and101_i);
 var $cmp105_i=($call104_i|0)==-1;
 if($cmp105_i){label=195;break;}else{label=194;break;}
 case 194: 
 var $add107_i=((($and101_i)+($ssize_173_i))|0);
 var $ssize_2_i=$add107_i;label=196;break;
 case 195: 
 var $call110_i=_sbrk($sub109_i);
 var $tsize_07588_i=0;label=197;break;
 case 196: 
 var $ssize_2_i;
 var $cmp115_i164=($br_074_i|0)==-1;
 if($cmp115_i164){var $tsize_07588_i=0;label=197;break;}else{var $tsize_293_i=$ssize_2_i;var $tbase_294_i=$br_074_i;label=201;break;}
 case 197: 
 var $tsize_07588_i;
 var $187=HEAP32[((5612)>>2)];
 var $or_i165=$187|4;
 HEAP32[((5612)>>2)]=$or_i165;
 var $tsize_1_i=$tsize_07588_i;label=198;break;
 case 198: 
 var $tsize_1_i;
 var $cmp124_i=($and11_i>>>0)<2147483647;
 if($cmp124_i){label=199;break;}else{label=340;break;}
 case 199: 
 var $call128_i=_sbrk($and11_i);
 var $call129_i=_sbrk(0);
 var $cmp130_i166=($call128_i|0)!=-1;
 var $cmp132_i167=($call129_i|0)!=-1;
 var $or_cond1_i=$cmp130_i166&$cmp132_i167;
 var $cmp134_i=($call128_i>>>0)<($call129_i>>>0);
 var $or_cond7_i=$or_cond1_i&$cmp134_i;
 if($or_cond7_i){label=200;break;}else{label=340;break;}
 case 200: 
 var $sub_ptr_lhs_cast_i=$call129_i;
 var $sub_ptr_rhs_cast_i=$call128_i;
 var $sub_ptr_sub_i=((($sub_ptr_lhs_cast_i)-($sub_ptr_rhs_cast_i))|0);
 var $add137_i=((($nb_0)+(40))|0);
 var $cmp138_i168=($sub_ptr_sub_i>>>0)>($add137_i>>>0);
 var $sub_ptr_sub_tsize_1_i=($cmp138_i168?$sub_ptr_sub_i:$tsize_1_i);
 if($cmp138_i168){var $tsize_293_i=$sub_ptr_sub_tsize_1_i;var $tbase_294_i=$call128_i;label=201;break;}else{label=340;break;}
 case 201: 
 var $tbase_294_i;
 var $tsize_293_i;
 var $188=HEAP32[((5600)>>2)];
 var $add147_i=((($188)+($tsize_293_i))|0);
 HEAP32[((5600)>>2)]=$add147_i;
 var $189=HEAP32[((5604)>>2)];
 var $cmp148_i=($add147_i>>>0)>($189>>>0);
 if($cmp148_i){label=202;break;}else{label=203;break;}
 case 202: 
 HEAP32[((5604)>>2)]=$add147_i;
 label=203;break;
 case 203: 
 var $190=HEAP32[((5192)>>2)];
 var $cmp154_i=($190|0)==0;
 if($cmp154_i){label=204;break;}else{var $sp_0113_i=5616;label=211;break;}
 case 204: 
 var $191=HEAP32[((5184)>>2)];
 var $cmp156_i=($191|0)==0;
 var $cmp159_i170=($tbase_294_i>>>0)<($191>>>0);
 var $or_cond8_i=$cmp156_i|$cmp159_i170;
 if($or_cond8_i){label=205;break;}else{label=206;break;}
 case 205: 
 HEAP32[((5184)>>2)]=$tbase_294_i;
 label=206;break;
 case 206: 
 HEAP32[((5616)>>2)]=$tbase_294_i;
 HEAP32[((5620)>>2)]=$tsize_293_i;
 HEAP32[((5628)>>2)]=0;
 var $192=HEAP32[((3976)>>2)];
 HEAP32[((5204)>>2)]=$192;
 HEAP32[((5200)>>2)]=-1;
 var $i_02_i_i=0;label=207;break;
 case 207: 
 var $i_02_i_i;
 var $shl_i_i=$i_02_i_i<<1;
 var $arrayidx_i_i=((5208+($shl_i_i<<2))|0);
 var $193=$arrayidx_i_i;
 var $arrayidx_sum_i_i=((($shl_i_i)+(3))|0);
 var $194=((5208+($arrayidx_sum_i_i<<2))|0);
 HEAP32[(($194)>>2)]=$193;
 var $arrayidx_sum1_i_i=((($shl_i_i)+(2))|0);
 var $195=((5208+($arrayidx_sum1_i_i<<2))|0);
 HEAP32[(($195)>>2)]=$193;
 var $inc_i_i=((($i_02_i_i)+(1))|0);
 var $cmp_i11_i=($inc_i_i>>>0)<32;
 if($cmp_i11_i){var $i_02_i_i=$inc_i_i;label=207;break;}else{label=208;break;}
 case 208: 
 var $sub169_i=((($tsize_293_i)-(40))|0);
 var $add_ptr_i12_i=(($tbase_294_i+8)|0);
 var $196=$add_ptr_i12_i;
 var $and_i13_i=$196&7;
 var $cmp_i14_i=($and_i13_i|0)==0;
 if($cmp_i14_i){var $cond_i_i=0;label=210;break;}else{label=209;break;}
 case 209: 
 var $197=(((-$196))|0);
 var $and3_i_i=$197&7;
 var $cond_i_i=$and3_i_i;label=210;break;
 case 210: 
 var $cond_i_i;
 var $add_ptr4_i_i=(($tbase_294_i+$cond_i_i)|0);
 var $198=$add_ptr4_i_i;
 var $sub5_i_i=((($sub169_i)-($cond_i_i))|0);
 HEAP32[((5192)>>2)]=$198;
 HEAP32[((5180)>>2)]=$sub5_i_i;
 var $or_i_i=$sub5_i_i|1;
 var $add_ptr4_sum_i_i=((($cond_i_i)+(4))|0);
 var $head_i_i=(($tbase_294_i+$add_ptr4_sum_i_i)|0);
 var $199=$head_i_i;
 HEAP32[(($199)>>2)]=$or_i_i;
 var $add_ptr6_sum_i_i=((($tsize_293_i)-(36))|0);
 var $head7_i_i=(($tbase_294_i+$add_ptr6_sum_i_i)|0);
 var $200=$head7_i_i;
 HEAP32[(($200)>>2)]=40;
 var $201=HEAP32[((3992)>>2)];
 HEAP32[((5196)>>2)]=$201;
 label=338;break;
 case 211: 
 var $sp_0113_i;
 var $base184_i=(($sp_0113_i)|0);
 var $202=HEAP32[(($base184_i)>>2)];
 var $size185_i=(($sp_0113_i+4)|0);
 var $203=HEAP32[(($size185_i)>>2)];
 var $add_ptr186_i=(($202+$203)|0);
 var $cmp187_i=($tbase_294_i|0)==($add_ptr186_i|0);
 if($cmp187_i){label=213;break;}else{label=212;break;}
 case 212: 
 var $next_i=(($sp_0113_i+8)|0);
 var $204=HEAP32[(($next_i)>>2)];
 var $cmp183_i=($204|0)==0;
 if($cmp183_i){label=218;break;}else{var $sp_0113_i=$204;label=211;break;}
 case 213: 
 var $sflags190_i=(($sp_0113_i+12)|0);
 var $205=HEAP32[(($sflags190_i)>>2)];
 var $and191_i=$205&8;
 var $tobool192_i=($and191_i|0)==0;
 if($tobool192_i){label=214;break;}else{label=218;break;}
 case 214: 
 var $206=$190;
 var $cmp200_i=($206>>>0)>=($202>>>0);
 var $cmp206_i=($206>>>0)<($tbase_294_i>>>0);
 var $or_cond96_i=$cmp200_i&$cmp206_i;
 if($or_cond96_i){label=215;break;}else{label=218;break;}
 case 215: 
 var $add209_i=((($203)+($tsize_293_i))|0);
 HEAP32[(($size185_i)>>2)]=$add209_i;
 var $207=HEAP32[((5192)>>2)];
 var $208=HEAP32[((5180)>>2)];
 var $add212_i=((($208)+($tsize_293_i))|0);
 var $209=$207;
 var $add_ptr_i23_i=(($207+8)|0);
 var $210=$add_ptr_i23_i;
 var $and_i24_i=$210&7;
 var $cmp_i25_i=($and_i24_i|0)==0;
 if($cmp_i25_i){var $cond_i28_i=0;label=217;break;}else{label=216;break;}
 case 216: 
 var $211=(((-$210))|0);
 var $and3_i26_i=$211&7;
 var $cond_i28_i=$and3_i26_i;label=217;break;
 case 217: 
 var $cond_i28_i;
 var $add_ptr4_i29_i=(($209+$cond_i28_i)|0);
 var $212=$add_ptr4_i29_i;
 var $sub5_i30_i=((($add212_i)-($cond_i28_i))|0);
 HEAP32[((5192)>>2)]=$212;
 HEAP32[((5180)>>2)]=$sub5_i30_i;
 var $or_i31_i=$sub5_i30_i|1;
 var $add_ptr4_sum_i32_i=((($cond_i28_i)+(4))|0);
 var $head_i33_i=(($209+$add_ptr4_sum_i32_i)|0);
 var $213=$head_i33_i;
 HEAP32[(($213)>>2)]=$or_i31_i;
 var $add_ptr6_sum_i34_i=((($add212_i)+(4))|0);
 var $head7_i35_i=(($209+$add_ptr6_sum_i34_i)|0);
 var $214=$head7_i35_i;
 HEAP32[(($214)>>2)]=40;
 var $215=HEAP32[((3992)>>2)];
 HEAP32[((5196)>>2)]=$215;
 label=338;break;
 case 218: 
 var $216=HEAP32[((5184)>>2)];
 var $cmp215_i=($tbase_294_i>>>0)<($216>>>0);
 if($cmp215_i){label=219;break;}else{label=220;break;}
 case 219: 
 HEAP32[((5184)>>2)]=$tbase_294_i;
 label=220;break;
 case 220: 
 var $add_ptr224_i=(($tbase_294_i+$tsize_293_i)|0);
 var $sp_1112_i=5616;label=221;break;
 case 221: 
 var $sp_1112_i;
 var $base223_i=(($sp_1112_i)|0);
 var $217=HEAP32[(($base223_i)>>2)];
 var $cmp225_i=($217|0)==($add_ptr224_i|0);
 if($cmp225_i){label=223;break;}else{label=222;break;}
 case 222: 
 var $next228_i=(($sp_1112_i+8)|0);
 var $218=HEAP32[(($next228_i)>>2)];
 var $cmp221_i=($218|0)==0;
 if($cmp221_i){label=304;break;}else{var $sp_1112_i=$218;label=221;break;}
 case 223: 
 var $sflags232_i=(($sp_1112_i+12)|0);
 var $219=HEAP32[(($sflags232_i)>>2)];
 var $and233_i=$219&8;
 var $tobool234_i=($and233_i|0)==0;
 if($tobool234_i){label=224;break;}else{label=304;break;}
 case 224: 
 HEAP32[(($base223_i)>>2)]=$tbase_294_i;
 var $size242_i=(($sp_1112_i+4)|0);
 var $220=HEAP32[(($size242_i)>>2)];
 var $add243_i=((($220)+($tsize_293_i))|0);
 HEAP32[(($size242_i)>>2)]=$add243_i;
 var $add_ptr_i38_i=(($tbase_294_i+8)|0);
 var $221=$add_ptr_i38_i;
 var $and_i39_i=$221&7;
 var $cmp_i40_i=($and_i39_i|0)==0;
 if($cmp_i40_i){var $cond_i43_i=0;label=226;break;}else{label=225;break;}
 case 225: 
 var $222=(((-$221))|0);
 var $and3_i41_i=$222&7;
 var $cond_i43_i=$and3_i41_i;label=226;break;
 case 226: 
 var $cond_i43_i;
 var $add_ptr4_i44_i=(($tbase_294_i+$cond_i43_i)|0);
 var $add_ptr224_sum_i=((($tsize_293_i)+(8))|0);
 var $add_ptr5_i_i=(($tbase_294_i+$add_ptr224_sum_i)|0);
 var $223=$add_ptr5_i_i;
 var $and6_i45_i=$223&7;
 var $cmp7_i_i=($and6_i45_i|0)==0;
 if($cmp7_i_i){var $cond15_i_i=0;label=228;break;}else{label=227;break;}
 case 227: 
 var $224=(((-$223))|0);
 var $and13_i_i=$224&7;
 var $cond15_i_i=$and13_i_i;label=228;break;
 case 228: 
 var $cond15_i_i;
 var $add_ptr224_sum134_i=((($cond15_i_i)+($tsize_293_i))|0);
 var $add_ptr16_i_i=(($tbase_294_i+$add_ptr224_sum134_i)|0);
 var $225=$add_ptr16_i_i;
 var $sub_ptr_lhs_cast_i47_i=$add_ptr16_i_i;
 var $sub_ptr_rhs_cast_i48_i=$add_ptr4_i44_i;
 var $sub_ptr_sub_i49_i=((($sub_ptr_lhs_cast_i47_i)-($sub_ptr_rhs_cast_i48_i))|0);
 var $add_ptr4_sum_i50_i=((($cond_i43_i)+($nb_0))|0);
 var $add_ptr17_i_i=(($tbase_294_i+$add_ptr4_sum_i50_i)|0);
 var $226=$add_ptr17_i_i;
 var $sub18_i_i=((($sub_ptr_sub_i49_i)-($nb_0))|0);
 var $or19_i_i=$nb_0|3;
 var $add_ptr4_sum1_i_i=((($cond_i43_i)+(4))|0);
 var $head_i51_i=(($tbase_294_i+$add_ptr4_sum1_i_i)|0);
 var $227=$head_i51_i;
 HEAP32[(($227)>>2)]=$or19_i_i;
 var $228=HEAP32[((5192)>>2)];
 var $cmp20_i_i=($225|0)==($228|0);
 if($cmp20_i_i){label=229;break;}else{label=230;break;}
 case 229: 
 var $229=HEAP32[((5180)>>2)];
 var $add_i_i=((($229)+($sub18_i_i))|0);
 HEAP32[((5180)>>2)]=$add_i_i;
 HEAP32[((5192)>>2)]=$226;
 var $or22_i_i=$add_i_i|1;
 var $add_ptr17_sum39_i_i=((($add_ptr4_sum_i50_i)+(4))|0);
 var $head23_i_i=(($tbase_294_i+$add_ptr17_sum39_i_i)|0);
 var $230=$head23_i_i;
 HEAP32[(($230)>>2)]=$or22_i_i;
 label=303;break;
 case 230: 
 var $231=HEAP32[((5188)>>2)];
 var $cmp24_i_i=($225|0)==($231|0);
 if($cmp24_i_i){label=231;break;}else{label=232;break;}
 case 231: 
 var $232=HEAP32[((5176)>>2)];
 var $add26_i_i=((($232)+($sub18_i_i))|0);
 HEAP32[((5176)>>2)]=$add26_i_i;
 HEAP32[((5188)>>2)]=$226;
 var $or28_i_i=$add26_i_i|1;
 var $add_ptr17_sum37_i_i=((($add_ptr4_sum_i50_i)+(4))|0);
 var $head29_i_i=(($tbase_294_i+$add_ptr17_sum37_i_i)|0);
 var $233=$head29_i_i;
 HEAP32[(($233)>>2)]=$or28_i_i;
 var $add_ptr17_sum38_i_i=((($add26_i_i)+($add_ptr4_sum_i50_i))|0);
 var $add_ptr30_i53_i=(($tbase_294_i+$add_ptr17_sum38_i_i)|0);
 var $prev_foot_i54_i=$add_ptr30_i53_i;
 HEAP32[(($prev_foot_i54_i)>>2)]=$add26_i_i;
 label=303;break;
 case 232: 
 var $add_ptr16_sum_i_i=((($tsize_293_i)+(4))|0);
 var $add_ptr224_sum135_i=((($add_ptr16_sum_i_i)+($cond15_i_i))|0);
 var $head32_i_i=(($tbase_294_i+$add_ptr224_sum135_i)|0);
 var $234=$head32_i_i;
 var $235=HEAP32[(($234)>>2)];
 var $and33_i_i=$235&3;
 var $cmp34_i_i=($and33_i_i|0)==1;
 if($cmp34_i_i){label=233;break;}else{var $oldfirst_0_i_i=$225;var $qsize_0_i_i=$sub18_i_i;label=280;break;}
 case 233: 
 var $and37_i_i=$235&-8;
 var $shr_i55_i=$235>>>3;
 var $cmp38_i_i=($235>>>0)<256;
 if($cmp38_i_i){label=234;break;}else{label=246;break;}
 case 234: 
 var $add_ptr16_sum3233_i_i=$cond15_i_i|8;
 var $add_ptr224_sum145_i=((($add_ptr16_sum3233_i_i)+($tsize_293_i))|0);
 var $fd_i_i=(($tbase_294_i+$add_ptr224_sum145_i)|0);
 var $236=$fd_i_i;
 var $237=HEAP32[(($236)>>2)];
 var $add_ptr16_sum34_i_i=((($tsize_293_i)+(12))|0);
 var $add_ptr224_sum146_i=((($add_ptr16_sum34_i_i)+($cond15_i_i))|0);
 var $bk_i56_i=(($tbase_294_i+$add_ptr224_sum146_i)|0);
 var $238=$bk_i56_i;
 var $239=HEAP32[(($238)>>2)];
 var $shl_i57_i=$shr_i55_i<<1;
 var $arrayidx_i58_i=((5208+($shl_i57_i<<2))|0);
 var $240=$arrayidx_i58_i;
 var $cmp41_i_i=($237|0)==($240|0);
 if($cmp41_i_i){label=237;break;}else{label=235;break;}
 case 235: 
 var $241=$237;
 var $242=HEAP32[((5184)>>2)];
 var $cmp42_i_i=($241>>>0)<($242>>>0);
 if($cmp42_i_i){label=245;break;}else{label=236;break;}
 case 236: 
 var $bk43_i_i=(($237+12)|0);
 var $243=HEAP32[(($bk43_i_i)>>2)];
 var $cmp44_i_i=($243|0)==($225|0);
 if($cmp44_i_i){label=237;break;}else{label=245;break;}
 case 237: 
 var $cmp46_i59_i=($239|0)==($237|0);
 if($cmp46_i59_i){label=238;break;}else{label=239;break;}
 case 238: 
 var $shl48_i_i=1<<$shr_i55_i;
 var $neg_i_i=$shl48_i_i^-1;
 var $244=HEAP32[((5168)>>2)];
 var $and49_i_i=$244&$neg_i_i;
 HEAP32[((5168)>>2)]=$and49_i_i;
 label=279;break;
 case 239: 
 var $cmp54_i_i=($239|0)==($240|0);
 if($cmp54_i_i){label=240;break;}else{label=241;break;}
 case 240: 
 var $fd68_pre_i_i=(($239+8)|0);
 var $fd68_pre_phi_i_i=$fd68_pre_i_i;label=243;break;
 case 241: 
 var $245=$239;
 var $246=HEAP32[((5184)>>2)];
 var $cmp57_i_i=($245>>>0)<($246>>>0);
 if($cmp57_i_i){label=244;break;}else{label=242;break;}
 case 242: 
 var $fd59_i_i=(($239+8)|0);
 var $247=HEAP32[(($fd59_i_i)>>2)];
 var $cmp60_i_i=($247|0)==($225|0);
 if($cmp60_i_i){var $fd68_pre_phi_i_i=$fd59_i_i;label=243;break;}else{label=244;break;}
 case 243: 
 var $fd68_pre_phi_i_i;
 var $bk67_i_i=(($237+12)|0);
 HEAP32[(($bk67_i_i)>>2)]=$239;
 HEAP32[(($fd68_pre_phi_i_i)>>2)]=$237;
 label=279;break;
 case 244: 
 _abort();
 throw "Reached an unreachable!";
 case 245: 
 _abort();
 throw "Reached an unreachable!";
 case 246: 
 var $248=$add_ptr16_i_i;
 var $add_ptr16_sum23_i_i=$cond15_i_i|24;
 var $add_ptr224_sum136_i=((($add_ptr16_sum23_i_i)+($tsize_293_i))|0);
 var $parent_i61_i=(($tbase_294_i+$add_ptr224_sum136_i)|0);
 var $249=$parent_i61_i;
 var $250=HEAP32[(($249)>>2)];
 var $add_ptr16_sum4_i_i=((($tsize_293_i)+(12))|0);
 var $add_ptr224_sum137_i=((($add_ptr16_sum4_i_i)+($cond15_i_i))|0);
 var $bk74_i_i=(($tbase_294_i+$add_ptr224_sum137_i)|0);
 var $251=$bk74_i_i;
 var $252=HEAP32[(($251)>>2)];
 var $cmp75_i_i=($252|0)==($248|0);
 if($cmp75_i_i){label=252;break;}else{label=247;break;}
 case 247: 
 var $add_ptr16_sum2930_i_i=$cond15_i_i|8;
 var $add_ptr224_sum138_i=((($add_ptr16_sum2930_i_i)+($tsize_293_i))|0);
 var $fd78_i_i=(($tbase_294_i+$add_ptr224_sum138_i)|0);
 var $253=$fd78_i_i;
 var $254=HEAP32[(($253)>>2)];
 var $255=$254;
 var $256=HEAP32[((5184)>>2)];
 var $cmp81_i_i=($255>>>0)<($256>>>0);
 if($cmp81_i_i){label=251;break;}else{label=248;break;}
 case 248: 
 var $bk82_i_i=(($254+12)|0);
 var $257=HEAP32[(($bk82_i_i)>>2)];
 var $cmp83_i_i=($257|0)==($248|0);
 if($cmp83_i_i){label=249;break;}else{label=251;break;}
 case 249: 
 var $fd85_i_i=(($252+8)|0);
 var $258=HEAP32[(($fd85_i_i)>>2)];
 var $cmp86_i_i=($258|0)==($248|0);
 if($cmp86_i_i){label=250;break;}else{label=251;break;}
 case 250: 
 HEAP32[(($bk82_i_i)>>2)]=$252;
 HEAP32[(($fd85_i_i)>>2)]=$254;
 var $R_1_i_i=$252;label=259;break;
 case 251: 
 _abort();
 throw "Reached an unreachable!";
 case 252: 
 var $add_ptr16_sum56_i_i=$cond15_i_i|16;
 var $add_ptr224_sum143_i=((($add_ptr16_sum_i_i)+($add_ptr16_sum56_i_i))|0);
 var $arrayidx96_i_i=(($tbase_294_i+$add_ptr224_sum143_i)|0);
 var $259=$arrayidx96_i_i;
 var $260=HEAP32[(($259)>>2)];
 var $cmp97_i_i=($260|0)==0;
 if($cmp97_i_i){label=253;break;}else{var $R_0_i_i=$260;var $RP_0_i_i=$259;label=254;break;}
 case 253: 
 var $add_ptr224_sum144_i=((($add_ptr16_sum56_i_i)+($tsize_293_i))|0);
 var $child_i_i=(($tbase_294_i+$add_ptr224_sum144_i)|0);
 var $arrayidx99_i_i=$child_i_i;
 var $261=HEAP32[(($arrayidx99_i_i)>>2)];
 var $cmp100_i_i=($261|0)==0;
 if($cmp100_i_i){var $R_1_i_i=0;label=259;break;}else{var $R_0_i_i=$261;var $RP_0_i_i=$arrayidx99_i_i;label=254;break;}
 case 254: 
 var $RP_0_i_i;
 var $R_0_i_i;
 var $arrayidx103_i_i=(($R_0_i_i+20)|0);
 var $262=HEAP32[(($arrayidx103_i_i)>>2)];
 var $cmp104_i_i=($262|0)==0;
 if($cmp104_i_i){label=255;break;}else{var $R_0_i_i=$262;var $RP_0_i_i=$arrayidx103_i_i;label=254;break;}
 case 255: 
 var $arrayidx107_i_i=(($R_0_i_i+16)|0);
 var $263=HEAP32[(($arrayidx107_i_i)>>2)];
 var $cmp108_i_i=($263|0)==0;
 if($cmp108_i_i){label=256;break;}else{var $R_0_i_i=$263;var $RP_0_i_i=$arrayidx107_i_i;label=254;break;}
 case 256: 
 var $264=$RP_0_i_i;
 var $265=HEAP32[((5184)>>2)];
 var $cmp112_i_i=($264>>>0)<($265>>>0);
 if($cmp112_i_i){label=258;break;}else{label=257;break;}
 case 257: 
 HEAP32[(($RP_0_i_i)>>2)]=0;
 var $R_1_i_i=$R_0_i_i;label=259;break;
 case 258: 
 _abort();
 throw "Reached an unreachable!";
 case 259: 
 var $R_1_i_i;
 var $cmp120_i63_i=($250|0)==0;
 if($cmp120_i63_i){label=279;break;}else{label=260;break;}
 case 260: 
 var $add_ptr16_sum26_i_i=((($tsize_293_i)+(28))|0);
 var $add_ptr224_sum139_i=((($add_ptr16_sum26_i_i)+($cond15_i_i))|0);
 var $index_i64_i=(($tbase_294_i+$add_ptr224_sum139_i)|0);
 var $266=$index_i64_i;
 var $267=HEAP32[(($266)>>2)];
 var $arrayidx123_i_i=((5472+($267<<2))|0);
 var $268=HEAP32[(($arrayidx123_i_i)>>2)];
 var $cmp124_i_i=($248|0)==($268|0);
 if($cmp124_i_i){label=261;break;}else{label=263;break;}
 case 261: 
 HEAP32[(($arrayidx123_i_i)>>2)]=$R_1_i_i;
 var $cond41_i_i=($R_1_i_i|0)==0;
 if($cond41_i_i){label=262;break;}else{label=269;break;}
 case 262: 
 var $269=HEAP32[(($266)>>2)];
 var $shl131_i_i=1<<$269;
 var $neg132_i_i=$shl131_i_i^-1;
 var $270=HEAP32[((5172)>>2)];
 var $and133_i_i=$270&$neg132_i_i;
 HEAP32[((5172)>>2)]=$and133_i_i;
 label=279;break;
 case 263: 
 var $271=$250;
 var $272=HEAP32[((5184)>>2)];
 var $cmp137_i_i=($271>>>0)<($272>>>0);
 if($cmp137_i_i){label=267;break;}else{label=264;break;}
 case 264: 
 var $arrayidx143_i_i=(($250+16)|0);
 var $273=HEAP32[(($arrayidx143_i_i)>>2)];
 var $cmp144_i_i=($273|0)==($248|0);
 if($cmp144_i_i){label=265;break;}else{label=266;break;}
 case 265: 
 HEAP32[(($arrayidx143_i_i)>>2)]=$R_1_i_i;
 label=268;break;
 case 266: 
 var $arrayidx151_i_i=(($250+20)|0);
 HEAP32[(($arrayidx151_i_i)>>2)]=$R_1_i_i;
 label=268;break;
 case 267: 
 _abort();
 throw "Reached an unreachable!";
 case 268: 
 var $cmp156_i_i=($R_1_i_i|0)==0;
 if($cmp156_i_i){label=279;break;}else{label=269;break;}
 case 269: 
 var $274=$R_1_i_i;
 var $275=HEAP32[((5184)>>2)];
 var $cmp160_i_i=($274>>>0)<($275>>>0);
 if($cmp160_i_i){label=278;break;}else{label=270;break;}
 case 270: 
 var $parent165_i_i=(($R_1_i_i+24)|0);
 HEAP32[(($parent165_i_i)>>2)]=$250;
 var $add_ptr16_sum2728_i_i=$cond15_i_i|16;
 var $add_ptr224_sum140_i=((($add_ptr16_sum2728_i_i)+($tsize_293_i))|0);
 var $child166_i_i=(($tbase_294_i+$add_ptr224_sum140_i)|0);
 var $arrayidx167_i_i=$child166_i_i;
 var $276=HEAP32[(($arrayidx167_i_i)>>2)];
 var $cmp168_i_i=($276|0)==0;
 if($cmp168_i_i){label=274;break;}else{label=271;break;}
 case 271: 
 var $277=$276;
 var $278=HEAP32[((5184)>>2)];
 var $cmp172_i_i=($277>>>0)<($278>>>0);
 if($cmp172_i_i){label=273;break;}else{label=272;break;}
 case 272: 
 var $arrayidx178_i_i=(($R_1_i_i+16)|0);
 HEAP32[(($arrayidx178_i_i)>>2)]=$276;
 var $parent179_i_i=(($276+24)|0);
 HEAP32[(($parent179_i_i)>>2)]=$R_1_i_i;
 label=274;break;
 case 273: 
 _abort();
 throw "Reached an unreachable!";
 case 274: 
 var $add_ptr224_sum141_i=((($add_ptr16_sum_i_i)+($add_ptr16_sum2728_i_i))|0);
 var $arrayidx184_i_i=(($tbase_294_i+$add_ptr224_sum141_i)|0);
 var $279=$arrayidx184_i_i;
 var $280=HEAP32[(($279)>>2)];
 var $cmp185_i_i=($280|0)==0;
 if($cmp185_i_i){label=279;break;}else{label=275;break;}
 case 275: 
 var $281=$280;
 var $282=HEAP32[((5184)>>2)];
 var $cmp189_i_i=($281>>>0)<($282>>>0);
 if($cmp189_i_i){label=277;break;}else{label=276;break;}
 case 276: 
 var $arrayidx195_i_i=(($R_1_i_i+20)|0);
 HEAP32[(($arrayidx195_i_i)>>2)]=$280;
 var $parent196_i_i=(($280+24)|0);
 HEAP32[(($parent196_i_i)>>2)]=$R_1_i_i;
 label=279;break;
 case 277: 
 _abort();
 throw "Reached an unreachable!";
 case 278: 
 _abort();
 throw "Reached an unreachable!";
 case 279: 
 var $add_ptr16_sum7_i_i=$and37_i_i|$cond15_i_i;
 var $add_ptr224_sum142_i=((($add_ptr16_sum7_i_i)+($tsize_293_i))|0);
 var $add_ptr205_i_i=(($tbase_294_i+$add_ptr224_sum142_i)|0);
 var $283=$add_ptr205_i_i;
 var $add206_i_i=((($and37_i_i)+($sub18_i_i))|0);
 var $oldfirst_0_i_i=$283;var $qsize_0_i_i=$add206_i_i;label=280;break;
 case 280: 
 var $qsize_0_i_i;
 var $oldfirst_0_i_i;
 var $head208_i_i=(($oldfirst_0_i_i+4)|0);
 var $284=HEAP32[(($head208_i_i)>>2)];
 var $and209_i_i=$284&-2;
 HEAP32[(($head208_i_i)>>2)]=$and209_i_i;
 var $or210_i_i=$qsize_0_i_i|1;
 var $add_ptr17_sum_i_i=((($add_ptr4_sum_i50_i)+(4))|0);
 var $head211_i_i=(($tbase_294_i+$add_ptr17_sum_i_i)|0);
 var $285=$head211_i_i;
 HEAP32[(($285)>>2)]=$or210_i_i;
 var $add_ptr17_sum8_i_i=((($qsize_0_i_i)+($add_ptr4_sum_i50_i))|0);
 var $add_ptr212_i_i=(($tbase_294_i+$add_ptr17_sum8_i_i)|0);
 var $prev_foot213_i_i=$add_ptr212_i_i;
 HEAP32[(($prev_foot213_i_i)>>2)]=$qsize_0_i_i;
 var $shr214_i_i=$qsize_0_i_i>>>3;
 var $cmp215_i_i=($qsize_0_i_i>>>0)<256;
 if($cmp215_i_i){label=281;break;}else{label=286;break;}
 case 281: 
 var $shl221_i_i=$shr214_i_i<<1;
 var $arrayidx223_i_i=((5208+($shl221_i_i<<2))|0);
 var $286=$arrayidx223_i_i;
 var $287=HEAP32[((5168)>>2)];
 var $shl226_i_i=1<<$shr214_i_i;
 var $and227_i_i=$287&$shl226_i_i;
 var $tobool228_i_i=($and227_i_i|0)==0;
 if($tobool228_i_i){label=282;break;}else{label=283;break;}
 case 282: 
 var $or232_i_i=$287|$shl226_i_i;
 HEAP32[((5168)>>2)]=$or232_i_i;
 var $arrayidx223_sum_pre_i_i=((($shl221_i_i)+(2))|0);
 var $_pre_i66_i=((5208+($arrayidx223_sum_pre_i_i<<2))|0);
 var $F224_0_i_i=$286;var $_pre_phi_i67_i=$_pre_i66_i;label=285;break;
 case 283: 
 var $arrayidx223_sum25_i_i=((($shl221_i_i)+(2))|0);
 var $288=((5208+($arrayidx223_sum25_i_i<<2))|0);
 var $289=HEAP32[(($288)>>2)];
 var $290=$289;
 var $291=HEAP32[((5184)>>2)];
 var $cmp236_i_i=($290>>>0)<($291>>>0);
 if($cmp236_i_i){label=284;break;}else{var $F224_0_i_i=$289;var $_pre_phi_i67_i=$288;label=285;break;}
 case 284: 
 _abort();
 throw "Reached an unreachable!";
 case 285: 
 var $_pre_phi_i67_i;
 var $F224_0_i_i;
 HEAP32[(($_pre_phi_i67_i)>>2)]=$226;
 var $bk246_i_i=(($F224_0_i_i+12)|0);
 HEAP32[(($bk246_i_i)>>2)]=$226;
 var $add_ptr17_sum23_i_i=((($add_ptr4_sum_i50_i)+(8))|0);
 var $fd247_i_i=(($tbase_294_i+$add_ptr17_sum23_i_i)|0);
 var $292=$fd247_i_i;
 HEAP32[(($292)>>2)]=$F224_0_i_i;
 var $add_ptr17_sum24_i_i=((($add_ptr4_sum_i50_i)+(12))|0);
 var $bk248_i_i=(($tbase_294_i+$add_ptr17_sum24_i_i)|0);
 var $293=$bk248_i_i;
 HEAP32[(($293)>>2)]=$286;
 label=303;break;
 case 286: 
 var $294=$add_ptr17_i_i;
 var $shr253_i_i=$qsize_0_i_i>>>8;
 var $cmp254_i_i=($shr253_i_i|0)==0;
 if($cmp254_i_i){var $I252_0_i_i=0;label=289;break;}else{label=287;break;}
 case 287: 
 var $cmp258_i_i=($qsize_0_i_i>>>0)>16777215;
 if($cmp258_i_i){var $I252_0_i_i=31;label=289;break;}else{label=288;break;}
 case 288: 
 var $sub262_i_i=((($shr253_i_i)+(1048320))|0);
 var $shr263_i_i=$sub262_i_i>>>16;
 var $and264_i_i=$shr263_i_i&8;
 var $shl265_i_i=$shr253_i_i<<$and264_i_i;
 var $sub266_i_i=((($shl265_i_i)+(520192))|0);
 var $shr267_i_i=$sub266_i_i>>>16;
 var $and268_i_i=$shr267_i_i&4;
 var $add269_i_i=$and268_i_i|$and264_i_i;
 var $shl270_i_i=$shl265_i_i<<$and268_i_i;
 var $sub271_i_i=((($shl270_i_i)+(245760))|0);
 var $shr272_i_i=$sub271_i_i>>>16;
 var $and273_i_i=$shr272_i_i&2;
 var $add274_i_i=$add269_i_i|$and273_i_i;
 var $sub275_i_i=(((14)-($add274_i_i))|0);
 var $shl276_i_i=$shl270_i_i<<$and273_i_i;
 var $shr277_i_i=$shl276_i_i>>>15;
 var $add278_i_i=((($sub275_i_i)+($shr277_i_i))|0);
 var $shl279_i_i=$add278_i_i<<1;
 var $add280_i_i=((($add278_i_i)+(7))|0);
 var $shr281_i_i=$qsize_0_i_i>>>($add280_i_i>>>0);
 var $and282_i_i=$shr281_i_i&1;
 var $add283_i_i=$and282_i_i|$shl279_i_i;
 var $I252_0_i_i=$add283_i_i;label=289;break;
 case 289: 
 var $I252_0_i_i;
 var $arrayidx287_i_i=((5472+($I252_0_i_i<<2))|0);
 var $add_ptr17_sum9_i_i=((($add_ptr4_sum_i50_i)+(28))|0);
 var $index288_i_i=(($tbase_294_i+$add_ptr17_sum9_i_i)|0);
 var $295=$index288_i_i;
 HEAP32[(($295)>>2)]=$I252_0_i_i;
 var $add_ptr17_sum10_i_i=((($add_ptr4_sum_i50_i)+(16))|0);
 var $child289_i_i=(($tbase_294_i+$add_ptr17_sum10_i_i)|0);
 var $child289_sum_i_i=((($add_ptr4_sum_i50_i)+(20))|0);
 var $arrayidx290_i_i=(($tbase_294_i+$child289_sum_i_i)|0);
 var $296=$arrayidx290_i_i;
 HEAP32[(($296)>>2)]=0;
 var $arrayidx292_i_i=$child289_i_i;
 HEAP32[(($arrayidx292_i_i)>>2)]=0;
 var $297=HEAP32[((5172)>>2)];
 var $shl294_i_i=1<<$I252_0_i_i;
 var $and295_i_i=$297&$shl294_i_i;
 var $tobool296_i_i=($and295_i_i|0)==0;
 if($tobool296_i_i){label=290;break;}else{label=291;break;}
 case 290: 
 var $or300_i_i=$297|$shl294_i_i;
 HEAP32[((5172)>>2)]=$or300_i_i;
 HEAP32[(($arrayidx287_i_i)>>2)]=$294;
 var $298=$arrayidx287_i_i;
 var $add_ptr17_sum11_i_i=((($add_ptr4_sum_i50_i)+(24))|0);
 var $parent301_i_i=(($tbase_294_i+$add_ptr17_sum11_i_i)|0);
 var $299=$parent301_i_i;
 HEAP32[(($299)>>2)]=$298;
 var $add_ptr17_sum12_i_i=((($add_ptr4_sum_i50_i)+(12))|0);
 var $bk302_i_i=(($tbase_294_i+$add_ptr17_sum12_i_i)|0);
 var $300=$bk302_i_i;
 HEAP32[(($300)>>2)]=$294;
 var $add_ptr17_sum13_i_i=((($add_ptr4_sum_i50_i)+(8))|0);
 var $fd303_i_i=(($tbase_294_i+$add_ptr17_sum13_i_i)|0);
 var $301=$fd303_i_i;
 HEAP32[(($301)>>2)]=$294;
 label=303;break;
 case 291: 
 var $302=HEAP32[(($arrayidx287_i_i)>>2)];
 var $cmp306_i_i=($I252_0_i_i|0)==31;
 if($cmp306_i_i){var $cond315_i_i=0;label=293;break;}else{label=292;break;}
 case 292: 
 var $shr310_i_i=$I252_0_i_i>>>1;
 var $sub313_i_i=(((25)-($shr310_i_i))|0);
 var $cond315_i_i=$sub313_i_i;label=293;break;
 case 293: 
 var $cond315_i_i;
 var $head31743_i_i=(($302+4)|0);
 var $303=HEAP32[(($head31743_i_i)>>2)];
 var $and31844_i_i=$303&-8;
 var $cmp31945_i_i=($and31844_i_i|0)==($qsize_0_i_i|0);
 if($cmp31945_i_i){var $T_0_lcssa_i69_i=$302;label=300;break;}else{label=294;break;}
 case 294: 
 var $shl316_i_i=$qsize_0_i_i<<$cond315_i_i;
 var $T_046_i_i=$302;var $K305_047_i_i=$shl316_i_i;label=296;break;
 case 295: 
 var $shl326_i_i=$K305_047_i_i<<1;
 var $head317_i_i=(($305+4)|0);
 var $304=HEAP32[(($head317_i_i)>>2)];
 var $and318_i_i=$304&-8;
 var $cmp319_i_i=($and318_i_i|0)==($qsize_0_i_i|0);
 if($cmp319_i_i){var $T_0_lcssa_i69_i=$305;label=300;break;}else{var $T_046_i_i=$305;var $K305_047_i_i=$shl326_i_i;label=296;break;}
 case 296: 
 var $K305_047_i_i;
 var $T_046_i_i;
 var $shr322_i_i=$K305_047_i_i>>>31;
 var $arrayidx325_i_i=(($T_046_i_i+16+($shr322_i_i<<2))|0);
 var $305=HEAP32[(($arrayidx325_i_i)>>2)];
 var $cmp327_i_i=($305|0)==0;
 if($cmp327_i_i){label=297;break;}else{label=295;break;}
 case 297: 
 var $306=$arrayidx325_i_i;
 var $307=HEAP32[((5184)>>2)];
 var $cmp332_i_i=($306>>>0)<($307>>>0);
 if($cmp332_i_i){label=299;break;}else{label=298;break;}
 case 298: 
 HEAP32[(($arrayidx325_i_i)>>2)]=$294;
 var $add_ptr17_sum20_i_i=((($add_ptr4_sum_i50_i)+(24))|0);
 var $parent337_i_i=(($tbase_294_i+$add_ptr17_sum20_i_i)|0);
 var $308=$parent337_i_i;
 HEAP32[(($308)>>2)]=$T_046_i_i;
 var $add_ptr17_sum21_i_i=((($add_ptr4_sum_i50_i)+(12))|0);
 var $bk338_i_i=(($tbase_294_i+$add_ptr17_sum21_i_i)|0);
 var $309=$bk338_i_i;
 HEAP32[(($309)>>2)]=$294;
 var $add_ptr17_sum22_i_i=((($add_ptr4_sum_i50_i)+(8))|0);
 var $fd339_i_i=(($tbase_294_i+$add_ptr17_sum22_i_i)|0);
 var $310=$fd339_i_i;
 HEAP32[(($310)>>2)]=$294;
 label=303;break;
 case 299: 
 _abort();
 throw "Reached an unreachable!";
 case 300: 
 var $T_0_lcssa_i69_i;
 var $fd344_i_i=(($T_0_lcssa_i69_i+8)|0);
 var $311=HEAP32[(($fd344_i_i)>>2)];
 var $312=$T_0_lcssa_i69_i;
 var $313=HEAP32[((5184)>>2)];
 var $cmp346_i_i=($312>>>0)>=($313>>>0);
 var $314=$311;
 var $cmp350_i_i=($314>>>0)>=($313>>>0);
 var $or_cond_i70_i=$cmp346_i_i&$cmp350_i_i;
 if($or_cond_i70_i){label=301;break;}else{label=302;break;}
 case 301: 
 var $bk357_i_i=(($311+12)|0);
 HEAP32[(($bk357_i_i)>>2)]=$294;
 HEAP32[(($fd344_i_i)>>2)]=$294;
 var $add_ptr17_sum17_i_i=((($add_ptr4_sum_i50_i)+(8))|0);
 var $fd359_i_i=(($tbase_294_i+$add_ptr17_sum17_i_i)|0);
 var $315=$fd359_i_i;
 HEAP32[(($315)>>2)]=$311;
 var $add_ptr17_sum18_i_i=((($add_ptr4_sum_i50_i)+(12))|0);
 var $bk360_i_i=(($tbase_294_i+$add_ptr17_sum18_i_i)|0);
 var $316=$bk360_i_i;
 HEAP32[(($316)>>2)]=$T_0_lcssa_i69_i;
 var $add_ptr17_sum19_i_i=((($add_ptr4_sum_i50_i)+(24))|0);
 var $parent361_i_i=(($tbase_294_i+$add_ptr17_sum19_i_i)|0);
 var $317=$parent361_i_i;
 HEAP32[(($317)>>2)]=0;
 label=303;break;
 case 302: 
 _abort();
 throw "Reached an unreachable!";
 case 303: 
 var $add_ptr4_sum1415_i_i=$cond_i43_i|8;
 var $add_ptr368_i_i=(($tbase_294_i+$add_ptr4_sum1415_i_i)|0);
 var $mem_0=$add_ptr368_i_i;label=341;break;
 case 304: 
 var $318=$190;
 var $sp_0_i_i_i=5616;label=305;break;
 case 305: 
 var $sp_0_i_i_i;
 var $base_i_i_i=(($sp_0_i_i_i)|0);
 var $319=HEAP32[(($base_i_i_i)>>2)];
 var $cmp_i_i_i=($319>>>0)>($318>>>0);
 if($cmp_i_i_i){label=307;break;}else{label=306;break;}
 case 306: 
 var $size_i_i_i=(($sp_0_i_i_i+4)|0);
 var $320=HEAP32[(($size_i_i_i)>>2)];
 var $add_ptr_i_i_i=(($319+$320)|0);
 var $cmp2_i_i_i=($add_ptr_i_i_i>>>0)>($318>>>0);
 if($cmp2_i_i_i){label=308;break;}else{label=307;break;}
 case 307: 
 var $next_i_i_i=(($sp_0_i_i_i+8)|0);
 var $321=HEAP32[(($next_i_i_i)>>2)];
 var $sp_0_i_i_i=$321;label=305;break;
 case 308: 
 var $add_ptr_sum_i_i=((($320)-(47))|0);
 var $add_ptr2_sum_i_i=((($320)-(39))|0);
 var $add_ptr3_i_i=(($319+$add_ptr2_sum_i_i)|0);
 var $322=$add_ptr3_i_i;
 var $and_i15_i=$322&7;
 var $cmp_i16_i=($and_i15_i|0)==0;
 if($cmp_i16_i){var $cond_i18_i=0;label=310;break;}else{label=309;break;}
 case 309: 
 var $323=(((-$322))|0);
 var $and6_i_i=$323&7;
 var $cond_i18_i=$and6_i_i;label=310;break;
 case 310: 
 var $cond_i18_i;
 var $add_ptr2_sum1_i_i=((($add_ptr_sum_i_i)+($cond_i18_i))|0);
 var $add_ptr7_i_i=(($319+$add_ptr2_sum1_i_i)|0);
 var $add_ptr82_i_i=(($190+16)|0);
 var $add_ptr8_i_i=$add_ptr82_i_i;
 var $cmp9_i_i=($add_ptr7_i_i>>>0)<($add_ptr8_i_i>>>0);
 var $cond13_i_i=($cmp9_i_i?$318:$add_ptr7_i_i);
 var $add_ptr14_i_i=(($cond13_i_i+8)|0);
 var $324=$add_ptr14_i_i;
 var $sub16_i_i=((($tsize_293_i)-(40))|0);
 var $add_ptr_i11_i_i=(($tbase_294_i+8)|0);
 var $325=$add_ptr_i11_i_i;
 var $and_i_i_i=$325&7;
 var $cmp_i12_i_i=($and_i_i_i|0)==0;
 if($cmp_i12_i_i){var $cond_i_i_i=0;label=312;break;}else{label=311;break;}
 case 311: 
 var $326=(((-$325))|0);
 var $and3_i_i_i=$326&7;
 var $cond_i_i_i=$and3_i_i_i;label=312;break;
 case 312: 
 var $cond_i_i_i;
 var $add_ptr4_i_i_i=(($tbase_294_i+$cond_i_i_i)|0);
 var $327=$add_ptr4_i_i_i;
 var $sub5_i_i_i=((($sub16_i_i)-($cond_i_i_i))|0);
 HEAP32[((5192)>>2)]=$327;
 HEAP32[((5180)>>2)]=$sub5_i_i_i;
 var $or_i_i_i=$sub5_i_i_i|1;
 var $add_ptr4_sum_i_i_i=((($cond_i_i_i)+(4))|0);
 var $head_i_i_i=(($tbase_294_i+$add_ptr4_sum_i_i_i)|0);
 var $328=$head_i_i_i;
 HEAP32[(($328)>>2)]=$or_i_i_i;
 var $add_ptr6_sum_i_i_i=((($tsize_293_i)-(36))|0);
 var $head7_i_i_i=(($tbase_294_i+$add_ptr6_sum_i_i_i)|0);
 var $329=$head7_i_i_i;
 HEAP32[(($329)>>2)]=40;
 var $330=HEAP32[((3992)>>2)];
 HEAP32[((5196)>>2)]=$330;
 var $head_i19_i=(($cond13_i_i+4)|0);
 var $331=$head_i19_i;
 HEAP32[(($331)>>2)]=27;
 assert(16 % 1 === 0);HEAP32[(($add_ptr14_i_i)>>2)]=HEAP32[((5616)>>2)];HEAP32[((($add_ptr14_i_i)+(4))>>2)]=HEAP32[((5620)>>2)];HEAP32[((($add_ptr14_i_i)+(8))>>2)]=HEAP32[((5624)>>2)];HEAP32[((($add_ptr14_i_i)+(12))>>2)]=HEAP32[((5628)>>2)];
 HEAP32[((5616)>>2)]=$tbase_294_i;
 HEAP32[((5620)>>2)]=$tsize_293_i;
 HEAP32[((5628)>>2)]=0;
 HEAP32[((5624)>>2)]=$324;
 var $add_ptr2419_i_i=(($cond13_i_i+28)|0);
 var $332=$add_ptr2419_i_i;
 HEAP32[(($332)>>2)]=7;
 var $333=(($cond13_i_i+32)|0);
 var $cmp2720_i_i=($333>>>0)<($add_ptr_i_i_i>>>0);
 if($cmp2720_i_i){var $add_ptr2421_i_i=$332;label=313;break;}else{label=314;break;}
 case 313: 
 var $add_ptr2421_i_i;
 var $334=(($add_ptr2421_i_i+4)|0);
 HEAP32[(($334)>>2)]=7;
 var $335=(($add_ptr2421_i_i+8)|0);
 var $336=$335;
 var $cmp27_i_i=($336>>>0)<($add_ptr_i_i_i>>>0);
 if($cmp27_i_i){var $add_ptr2421_i_i=$334;label=313;break;}else{label=314;break;}
 case 314: 
 var $cmp28_i_i=($cond13_i_i|0)==($318|0);
 if($cmp28_i_i){label=338;break;}else{label=315;break;}
 case 315: 
 var $sub_ptr_lhs_cast_i_i=$cond13_i_i;
 var $sub_ptr_rhs_cast_i_i=$190;
 var $sub_ptr_sub_i_i=((($sub_ptr_lhs_cast_i_i)-($sub_ptr_rhs_cast_i_i))|0);
 var $add_ptr30_i_i=(($318+$sub_ptr_sub_i_i)|0);
 var $add_ptr30_sum_i_i=((($sub_ptr_sub_i_i)+(4))|0);
 var $head31_i_i=(($318+$add_ptr30_sum_i_i)|0);
 var $337=$head31_i_i;
 var $338=HEAP32[(($337)>>2)];
 var $and32_i_i=$338&-2;
 HEAP32[(($337)>>2)]=$and32_i_i;
 var $or33_i_i=$sub_ptr_sub_i_i|1;
 var $head34_i_i=(($190+4)|0);
 HEAP32[(($head34_i_i)>>2)]=$or33_i_i;
 var $prev_foot_i_i=$add_ptr30_i_i;
 HEAP32[(($prev_foot_i_i)>>2)]=$sub_ptr_sub_i_i;
 var $shr_i_i=$sub_ptr_sub_i_i>>>3;
 var $cmp36_i_i=($sub_ptr_sub_i_i>>>0)<256;
 if($cmp36_i_i){label=316;break;}else{label=321;break;}
 case 316: 
 var $shl_i21_i=$shr_i_i<<1;
 var $arrayidx_i22_i=((5208+($shl_i21_i<<2))|0);
 var $339=$arrayidx_i22_i;
 var $340=HEAP32[((5168)>>2)];
 var $shl39_i_i=1<<$shr_i_i;
 var $and40_i_i=$340&$shl39_i_i;
 var $tobool_i_i=($and40_i_i|0)==0;
 if($tobool_i_i){label=317;break;}else{label=318;break;}
 case 317: 
 var $or44_i_i=$340|$shl39_i_i;
 HEAP32[((5168)>>2)]=$or44_i_i;
 var $arrayidx_sum_pre_i_i=((($shl_i21_i)+(2))|0);
 var $_pre_i_i=((5208+($arrayidx_sum_pre_i_i<<2))|0);
 var $F_0_i_i=$339;var $_pre_phi_i_i=$_pre_i_i;label=320;break;
 case 318: 
 var $arrayidx_sum10_i_i=((($shl_i21_i)+(2))|0);
 var $341=((5208+($arrayidx_sum10_i_i<<2))|0);
 var $342=HEAP32[(($341)>>2)];
 var $343=$342;
 var $344=HEAP32[((5184)>>2)];
 var $cmp46_i_i=($343>>>0)<($344>>>0);
 if($cmp46_i_i){label=319;break;}else{var $F_0_i_i=$342;var $_pre_phi_i_i=$341;label=320;break;}
 case 319: 
 _abort();
 throw "Reached an unreachable!";
 case 320: 
 var $_pre_phi_i_i;
 var $F_0_i_i;
 HEAP32[(($_pre_phi_i_i)>>2)]=$190;
 var $bk_i_i=(($F_0_i_i+12)|0);
 HEAP32[(($bk_i_i)>>2)]=$190;
 var $fd54_i_i=(($190+8)|0);
 HEAP32[(($fd54_i_i)>>2)]=$F_0_i_i;
 var $bk55_i_i=(($190+12)|0);
 HEAP32[(($bk55_i_i)>>2)]=$339;
 label=338;break;
 case 321: 
 var $345=$190;
 var $shr58_i_i=$sub_ptr_sub_i_i>>>8;
 var $cmp59_i_i=($shr58_i_i|0)==0;
 if($cmp59_i_i){var $I57_0_i_i=0;label=324;break;}else{label=322;break;}
 case 322: 
 var $cmp63_i_i=($sub_ptr_sub_i_i>>>0)>16777215;
 if($cmp63_i_i){var $I57_0_i_i=31;label=324;break;}else{label=323;break;}
 case 323: 
 var $sub67_i_i=((($shr58_i_i)+(1048320))|0);
 var $shr68_i_i=$sub67_i_i>>>16;
 var $and69_i_i=$shr68_i_i&8;
 var $shl70_i_i=$shr58_i_i<<$and69_i_i;
 var $sub71_i_i=((($shl70_i_i)+(520192))|0);
 var $shr72_i_i=$sub71_i_i>>>16;
 var $and73_i_i=$shr72_i_i&4;
 var $add74_i_i=$and73_i_i|$and69_i_i;
 var $shl75_i_i=$shl70_i_i<<$and73_i_i;
 var $sub76_i_i=((($shl75_i_i)+(245760))|0);
 var $shr77_i_i=$sub76_i_i>>>16;
 var $and78_i_i=$shr77_i_i&2;
 var $add79_i_i=$add74_i_i|$and78_i_i;
 var $sub80_i_i=(((14)-($add79_i_i))|0);
 var $shl81_i_i=$shl75_i_i<<$and78_i_i;
 var $shr82_i_i=$shl81_i_i>>>15;
 var $add83_i_i=((($sub80_i_i)+($shr82_i_i))|0);
 var $shl84_i_i=$add83_i_i<<1;
 var $add85_i_i=((($add83_i_i)+(7))|0);
 var $shr86_i_i=$sub_ptr_sub_i_i>>>($add85_i_i>>>0);
 var $and87_i_i=$shr86_i_i&1;
 var $add88_i_i=$and87_i_i|$shl84_i_i;
 var $I57_0_i_i=$add88_i_i;label=324;break;
 case 324: 
 var $I57_0_i_i;
 var $arrayidx91_i_i=((5472+($I57_0_i_i<<2))|0);
 var $index_i_i=(($190+28)|0);
 var $I57_0_c_i_i=$I57_0_i_i;
 HEAP32[(($index_i_i)>>2)]=$I57_0_c_i_i;
 var $arrayidx92_i_i=(($190+20)|0);
 HEAP32[(($arrayidx92_i_i)>>2)]=0;
 var $346=(($190+16)|0);
 HEAP32[(($346)>>2)]=0;
 var $347=HEAP32[((5172)>>2)];
 var $shl95_i_i=1<<$I57_0_i_i;
 var $and96_i_i=$347&$shl95_i_i;
 var $tobool97_i_i=($and96_i_i|0)==0;
 if($tobool97_i_i){label=325;break;}else{label=326;break;}
 case 325: 
 var $or101_i_i=$347|$shl95_i_i;
 HEAP32[((5172)>>2)]=$or101_i_i;
 HEAP32[(($arrayidx91_i_i)>>2)]=$345;
 var $parent_i_i=(($190+24)|0);
 var $_c_i_i=$arrayidx91_i_i;
 HEAP32[(($parent_i_i)>>2)]=$_c_i_i;
 var $bk102_i_i=(($190+12)|0);
 HEAP32[(($bk102_i_i)>>2)]=$190;
 var $fd103_i_i=(($190+8)|0);
 HEAP32[(($fd103_i_i)>>2)]=$190;
 label=338;break;
 case 326: 
 var $348=HEAP32[(($arrayidx91_i_i)>>2)];
 var $cmp106_i_i=($I57_0_i_i|0)==31;
 if($cmp106_i_i){var $cond115_i_i=0;label=328;break;}else{label=327;break;}
 case 327: 
 var $shr110_i_i=$I57_0_i_i>>>1;
 var $sub113_i_i=(((25)-($shr110_i_i))|0);
 var $cond115_i_i=$sub113_i_i;label=328;break;
 case 328: 
 var $cond115_i_i;
 var $head11814_i_i=(($348+4)|0);
 var $349=HEAP32[(($head11814_i_i)>>2)];
 var $and11915_i_i=$349&-8;
 var $cmp12016_i_i=($and11915_i_i|0)==($sub_ptr_sub_i_i|0);
 if($cmp12016_i_i){var $T_0_lcssa_i_i=$348;label=335;break;}else{label=329;break;}
 case 329: 
 var $shl116_i_i=$sub_ptr_sub_i_i<<$cond115_i_i;
 var $T_017_i_i=$348;var $K105_018_i_i=$shl116_i_i;label=331;break;
 case 330: 
 var $shl127_i_i=$K105_018_i_i<<1;
 var $head118_i_i=(($351+4)|0);
 var $350=HEAP32[(($head118_i_i)>>2)];
 var $and119_i_i=$350&-8;
 var $cmp120_i_i=($and119_i_i|0)==($sub_ptr_sub_i_i|0);
 if($cmp120_i_i){var $T_0_lcssa_i_i=$351;label=335;break;}else{var $T_017_i_i=$351;var $K105_018_i_i=$shl127_i_i;label=331;break;}
 case 331: 
 var $K105_018_i_i;
 var $T_017_i_i;
 var $shr123_i_i=$K105_018_i_i>>>31;
 var $arrayidx126_i_i=(($T_017_i_i+16+($shr123_i_i<<2))|0);
 var $351=HEAP32[(($arrayidx126_i_i)>>2)];
 var $cmp128_i_i=($351|0)==0;
 if($cmp128_i_i){label=332;break;}else{label=330;break;}
 case 332: 
 var $352=$arrayidx126_i_i;
 var $353=HEAP32[((5184)>>2)];
 var $cmp133_i_i=($352>>>0)<($353>>>0);
 if($cmp133_i_i){label=334;break;}else{label=333;break;}
 case 333: 
 HEAP32[(($arrayidx126_i_i)>>2)]=$345;
 var $parent138_i_i=(($190+24)|0);
 var $T_0_c7_i_i=$T_017_i_i;
 HEAP32[(($parent138_i_i)>>2)]=$T_0_c7_i_i;
 var $bk139_i_i=(($190+12)|0);
 HEAP32[(($bk139_i_i)>>2)]=$190;
 var $fd140_i_i=(($190+8)|0);
 HEAP32[(($fd140_i_i)>>2)]=$190;
 label=338;break;
 case 334: 
 _abort();
 throw "Reached an unreachable!";
 case 335: 
 var $T_0_lcssa_i_i;
 var $fd145_i_i=(($T_0_lcssa_i_i+8)|0);
 var $354=HEAP32[(($fd145_i_i)>>2)];
 var $355=$T_0_lcssa_i_i;
 var $356=HEAP32[((5184)>>2)];
 var $cmp147_i_i=($355>>>0)>=($356>>>0);
 var $357=$354;
 var $cmp150_i_i=($357>>>0)>=($356>>>0);
 var $or_cond_i_i=$cmp147_i_i&$cmp150_i_i;
 if($or_cond_i_i){label=336;break;}else{label=337;break;}
 case 336: 
 var $bk155_i_i=(($354+12)|0);
 HEAP32[(($bk155_i_i)>>2)]=$345;
 HEAP32[(($fd145_i_i)>>2)]=$345;
 var $fd157_i_i=(($190+8)|0);
 var $_c6_i_i=$354;
 HEAP32[(($fd157_i_i)>>2)]=$_c6_i_i;
 var $bk158_i_i=(($190+12)|0);
 var $T_0_c_i_i=$T_0_lcssa_i_i;
 HEAP32[(($bk158_i_i)>>2)]=$T_0_c_i_i;
 var $parent159_i_i=(($190+24)|0);
 HEAP32[(($parent159_i_i)>>2)]=0;
 label=338;break;
 case 337: 
 _abort();
 throw "Reached an unreachable!";
 case 338: 
 var $358=HEAP32[((5180)>>2)];
 var $cmp250_i=($358>>>0)>($nb_0>>>0);
 if($cmp250_i){label=339;break;}else{label=340;break;}
 case 339: 
 var $sub253_i=((($358)-($nb_0))|0);
 HEAP32[((5180)>>2)]=$sub253_i;
 var $359=HEAP32[((5192)>>2)];
 var $360=$359;
 var $add_ptr255_i=(($360+$nb_0)|0);
 var $361=$add_ptr255_i;
 HEAP32[((5192)>>2)]=$361;
 var $or257_i=$sub253_i|1;
 var $add_ptr255_sum_i=((($nb_0)+(4))|0);
 var $head258_i=(($360+$add_ptr255_sum_i)|0);
 var $362=$head258_i;
 HEAP32[(($362)>>2)]=$or257_i;
 var $or260_i=$nb_0|3;
 var $head261_i=(($359+4)|0);
 HEAP32[(($head261_i)>>2)]=$or260_i;
 var $add_ptr262_i=(($359+8)|0);
 var $363=$add_ptr262_i;
 var $mem_0=$363;label=341;break;
 case 340: 
 var $call265_i=___errno_location();
 HEAP32[(($call265_i)>>2)]=12;
 var $mem_0=0;label=341;break;
 case 341: 
 var $mem_0;
 return $mem_0;
  default: assert(0, "bad label: " + label);
 }

}
Module["_malloc"] = _malloc;

function _free($mem){
 var label=0;

 label = 1; 
 while(1)switch(label){
 case 1: 
 var $cmp=($mem|0)==0;
 if($cmp){label=140;break;}else{label=2;break;}
 case 2: 
 var $add_ptr=((($mem)-(8))|0);
 var $0=$add_ptr;
 var $1=HEAP32[((5184)>>2)];
 var $cmp1=($add_ptr>>>0)<($1>>>0);
 if($cmp1){label=139;break;}else{label=3;break;}
 case 3: 
 var $head=((($mem)-(4))|0);
 var $2=$head;
 var $3=HEAP32[(($2)>>2)];
 var $and=$3&3;
 var $cmp2=($and|0)==1;
 if($cmp2){label=139;break;}else{label=4;break;}
 case 4: 
 var $and5=$3&-8;
 var $add_ptr_sum=((($and5)-(8))|0);
 var $add_ptr6=(($mem+$add_ptr_sum)|0);
 var $4=$add_ptr6;
 var $and8=$3&1;
 var $tobool9=($and8|0)==0;
 if($tobool9){label=5;break;}else{var $p_0=$0;var $psize_0=$and5;label=56;break;}
 case 5: 
 var $prev_foot=$add_ptr;
 var $5=HEAP32[(($prev_foot)>>2)];
 var $cmp13=($and|0)==0;
 if($cmp13){label=140;break;}else{label=6;break;}
 case 6: 
 var $add_ptr_sum231=(((-8)-($5))|0);
 var $add_ptr16=(($mem+$add_ptr_sum231)|0);
 var $6=$add_ptr16;
 var $add17=((($5)+($and5))|0);
 var $cmp18=($add_ptr16>>>0)<($1>>>0);
 if($cmp18){label=139;break;}else{label=7;break;}
 case 7: 
 var $7=HEAP32[((5188)>>2)];
 var $cmp22=($6|0)==($7|0);
 if($cmp22){label=54;break;}else{label=8;break;}
 case 8: 
 var $shr=$5>>>3;
 var $cmp25=($5>>>0)<256;
 if($cmp25){label=9;break;}else{label=21;break;}
 case 9: 
 var $add_ptr16_sum268=((($add_ptr_sum231)+(8))|0);
 var $fd=(($mem+$add_ptr16_sum268)|0);
 var $8=$fd;
 var $9=HEAP32[(($8)>>2)];
 var $add_ptr16_sum269=((($add_ptr_sum231)+(12))|0);
 var $bk=(($mem+$add_ptr16_sum269)|0);
 var $10=$bk;
 var $11=HEAP32[(($10)>>2)];
 var $shl=$shr<<1;
 var $arrayidx=((5208+($shl<<2))|0);
 var $12=$arrayidx;
 var $cmp29=($9|0)==($12|0);
 if($cmp29){label=12;break;}else{label=10;break;}
 case 10: 
 var $13=$9;
 var $cmp31=($13>>>0)<($1>>>0);
 if($cmp31){label=20;break;}else{label=11;break;}
 case 11: 
 var $bk34=(($9+12)|0);
 var $14=HEAP32[(($bk34)>>2)];
 var $cmp35=($14|0)==($6|0);
 if($cmp35){label=12;break;}else{label=20;break;}
 case 12: 
 var $cmp42=($11|0)==($9|0);
 if($cmp42){label=13;break;}else{label=14;break;}
 case 13: 
 var $shl45=1<<$shr;
 var $neg=$shl45^-1;
 var $15=HEAP32[((5168)>>2)];
 var $and46=$15&$neg;
 HEAP32[((5168)>>2)]=$and46;
 var $p_0=$6;var $psize_0=$add17;label=56;break;
 case 14: 
 var $cmp50=($11|0)==($12|0);
 if($cmp50){label=15;break;}else{label=16;break;}
 case 15: 
 var $fd67_pre=(($11+8)|0);
 var $fd67_pre_phi=$fd67_pre;label=18;break;
 case 16: 
 var $16=$11;
 var $cmp53=($16>>>0)<($1>>>0);
 if($cmp53){label=19;break;}else{label=17;break;}
 case 17: 
 var $fd56=(($11+8)|0);
 var $17=HEAP32[(($fd56)>>2)];
 var $cmp57=($17|0)==($6|0);
 if($cmp57){var $fd67_pre_phi=$fd56;label=18;break;}else{label=19;break;}
 case 18: 
 var $fd67_pre_phi;
 var $bk66=(($9+12)|0);
 HEAP32[(($bk66)>>2)]=$11;
 HEAP32[(($fd67_pre_phi)>>2)]=$9;
 var $p_0=$6;var $psize_0=$add17;label=56;break;
 case 19: 
 _abort();
 throw "Reached an unreachable!";
 case 20: 
 _abort();
 throw "Reached an unreachable!";
 case 21: 
 var $18=$add_ptr16;
 var $add_ptr16_sum260=((($add_ptr_sum231)+(24))|0);
 var $parent=(($mem+$add_ptr16_sum260)|0);
 var $19=$parent;
 var $20=HEAP32[(($19)>>2)];
 var $add_ptr16_sum261=((($add_ptr_sum231)+(12))|0);
 var $bk73=(($mem+$add_ptr16_sum261)|0);
 var $21=$bk73;
 var $22=HEAP32[(($21)>>2)];
 var $cmp74=($22|0)==($18|0);
 if($cmp74){label=27;break;}else{label=22;break;}
 case 22: 
 var $add_ptr16_sum265=((($add_ptr_sum231)+(8))|0);
 var $fd78=(($mem+$add_ptr16_sum265)|0);
 var $23=$fd78;
 var $24=HEAP32[(($23)>>2)];
 var $25=$24;
 var $cmp80=($25>>>0)<($1>>>0);
 if($cmp80){label=26;break;}else{label=23;break;}
 case 23: 
 var $bk82=(($24+12)|0);
 var $26=HEAP32[(($bk82)>>2)];
 var $cmp83=($26|0)==($18|0);
 if($cmp83){label=24;break;}else{label=26;break;}
 case 24: 
 var $fd86=(($22+8)|0);
 var $27=HEAP32[(($fd86)>>2)];
 var $cmp87=($27|0)==($18|0);
 if($cmp87){label=25;break;}else{label=26;break;}
 case 25: 
 HEAP32[(($bk82)>>2)]=$22;
 HEAP32[(($fd86)>>2)]=$24;
 var $R_1=$22;label=34;break;
 case 26: 
 _abort();
 throw "Reached an unreachable!";
 case 27: 
 var $child_sum=((($add_ptr_sum231)+(20))|0);
 var $arrayidx99=(($mem+$child_sum)|0);
 var $28=$arrayidx99;
 var $29=HEAP32[(($28)>>2)];
 var $cmp100=($29|0)==0;
 if($cmp100){label=28;break;}else{var $R_0=$29;var $RP_0=$28;label=29;break;}
 case 28: 
 var $add_ptr16_sum262=((($add_ptr_sum231)+(16))|0);
 var $child=(($mem+$add_ptr16_sum262)|0);
 var $arrayidx103=$child;
 var $30=HEAP32[(($arrayidx103)>>2)];
 var $cmp104=($30|0)==0;
 if($cmp104){var $R_1=0;label=34;break;}else{var $R_0=$30;var $RP_0=$arrayidx103;label=29;break;}
 case 29: 
 var $RP_0;
 var $R_0;
 var $arrayidx108=(($R_0+20)|0);
 var $31=HEAP32[(($arrayidx108)>>2)];
 var $cmp109=($31|0)==0;
 if($cmp109){label=30;break;}else{var $R_0=$31;var $RP_0=$arrayidx108;label=29;break;}
 case 30: 
 var $arrayidx113=(($R_0+16)|0);
 var $32=HEAP32[(($arrayidx113)>>2)];
 var $cmp114=($32|0)==0;
 if($cmp114){label=31;break;}else{var $R_0=$32;var $RP_0=$arrayidx113;label=29;break;}
 case 31: 
 var $33=$RP_0;
 var $cmp118=($33>>>0)<($1>>>0);
 if($cmp118){label=33;break;}else{label=32;break;}
 case 32: 
 HEAP32[(($RP_0)>>2)]=0;
 var $R_1=$R_0;label=34;break;
 case 33: 
 _abort();
 throw "Reached an unreachable!";
 case 34: 
 var $R_1;
 var $cmp127=($20|0)==0;
 if($cmp127){var $p_0=$6;var $psize_0=$add17;label=56;break;}else{label=35;break;}
 case 35: 
 var $add_ptr16_sum263=((($add_ptr_sum231)+(28))|0);
 var $index=(($mem+$add_ptr16_sum263)|0);
 var $34=$index;
 var $35=HEAP32[(($34)>>2)];
 var $arrayidx130=((5472+($35<<2))|0);
 var $36=HEAP32[(($arrayidx130)>>2)];
 var $cmp131=($18|0)==($36|0);
 if($cmp131){label=36;break;}else{label=38;break;}
 case 36: 
 HEAP32[(($arrayidx130)>>2)]=$R_1;
 var $cond278=($R_1|0)==0;
 if($cond278){label=37;break;}else{label=44;break;}
 case 37: 
 var $37=HEAP32[(($34)>>2)];
 var $shl138=1<<$37;
 var $neg139=$shl138^-1;
 var $38=HEAP32[((5172)>>2)];
 var $and140=$38&$neg139;
 HEAP32[((5172)>>2)]=$and140;
 var $p_0=$6;var $psize_0=$add17;label=56;break;
 case 38: 
 var $39=$20;
 var $40=HEAP32[((5184)>>2)];
 var $cmp143=($39>>>0)<($40>>>0);
 if($cmp143){label=42;break;}else{label=39;break;}
 case 39: 
 var $arrayidx149=(($20+16)|0);
 var $41=HEAP32[(($arrayidx149)>>2)];
 var $cmp150=($41|0)==($18|0);
 if($cmp150){label=40;break;}else{label=41;break;}
 case 40: 
 HEAP32[(($arrayidx149)>>2)]=$R_1;
 label=43;break;
 case 41: 
 var $arrayidx157=(($20+20)|0);
 HEAP32[(($arrayidx157)>>2)]=$R_1;
 label=43;break;
 case 42: 
 _abort();
 throw "Reached an unreachable!";
 case 43: 
 var $cmp162=($R_1|0)==0;
 if($cmp162){var $p_0=$6;var $psize_0=$add17;label=56;break;}else{label=44;break;}
 case 44: 
 var $42=$R_1;
 var $43=HEAP32[((5184)>>2)];
 var $cmp165=($42>>>0)<($43>>>0);
 if($cmp165){label=53;break;}else{label=45;break;}
 case 45: 
 var $parent170=(($R_1+24)|0);
 HEAP32[(($parent170)>>2)]=$20;
 var $add_ptr16_sum264=((($add_ptr_sum231)+(16))|0);
 var $child171=(($mem+$add_ptr16_sum264)|0);
 var $arrayidx172=$child171;
 var $44=HEAP32[(($arrayidx172)>>2)];
 var $cmp173=($44|0)==0;
 if($cmp173){label=49;break;}else{label=46;break;}
 case 46: 
 var $45=$44;
 var $46=HEAP32[((5184)>>2)];
 var $cmp176=($45>>>0)<($46>>>0);
 if($cmp176){label=48;break;}else{label=47;break;}
 case 47: 
 var $arrayidx182=(($R_1+16)|0);
 HEAP32[(($arrayidx182)>>2)]=$44;
 var $parent183=(($44+24)|0);
 HEAP32[(($parent183)>>2)]=$R_1;
 label=49;break;
 case 48: 
 _abort();
 throw "Reached an unreachable!";
 case 49: 
 var $child171_sum=((($add_ptr_sum231)+(20))|0);
 var $arrayidx188=(($mem+$child171_sum)|0);
 var $47=$arrayidx188;
 var $48=HEAP32[(($47)>>2)];
 var $cmp189=($48|0)==0;
 if($cmp189){var $p_0=$6;var $psize_0=$add17;label=56;break;}else{label=50;break;}
 case 50: 
 var $49=$48;
 var $50=HEAP32[((5184)>>2)];
 var $cmp192=($49>>>0)<($50>>>0);
 if($cmp192){label=52;break;}else{label=51;break;}
 case 51: 
 var $arrayidx198=(($R_1+20)|0);
 HEAP32[(($arrayidx198)>>2)]=$48;
 var $parent199=(($48+24)|0);
 HEAP32[(($parent199)>>2)]=$R_1;
 var $p_0=$6;var $psize_0=$add17;label=56;break;
 case 52: 
 _abort();
 throw "Reached an unreachable!";
 case 53: 
 _abort();
 throw "Reached an unreachable!";
 case 54: 
 var $add_ptr6_sum=((($and5)-(4))|0);
 var $head209=(($mem+$add_ptr6_sum)|0);
 var $51=$head209;
 var $52=HEAP32[(($51)>>2)];
 var $and210=$52&3;
 var $cmp211=($and210|0)==3;
 if($cmp211){label=55;break;}else{var $p_0=$6;var $psize_0=$add17;label=56;break;}
 case 55: 
 HEAP32[((5176)>>2)]=$add17;
 var $53=HEAP32[(($51)>>2)];
 var $and215=$53&-2;
 HEAP32[(($51)>>2)]=$and215;
 var $or=$add17|1;
 var $add_ptr16_sum=((($add_ptr_sum231)+(4))|0);
 var $head216=(($mem+$add_ptr16_sum)|0);
 var $54=$head216;
 HEAP32[(($54)>>2)]=$or;
 var $prev_foot218=$add_ptr6;
 HEAP32[(($prev_foot218)>>2)]=$add17;
 label=140;break;
 case 56: 
 var $psize_0;
 var $p_0;
 var $55=$p_0;
 var $cmp225=($55>>>0)<($add_ptr6>>>0);
 if($cmp225){label=57;break;}else{label=139;break;}
 case 57: 
 var $add_ptr6_sum258=((($and5)-(4))|0);
 var $head228=(($mem+$add_ptr6_sum258)|0);
 var $56=$head228;
 var $57=HEAP32[(($56)>>2)];
 var $and229=$57&1;
 var $phitmp=($and229|0)==0;
 if($phitmp){label=139;break;}else{label=58;break;}
 case 58: 
 var $and237=$57&2;
 var $tobool238=($and237|0)==0;
 if($tobool238){label=59;break;}else{label=112;break;}
 case 59: 
 var $58=HEAP32[((5192)>>2)];
 var $cmp240=($4|0)==($58|0);
 if($cmp240){label=60;break;}else{label=62;break;}
 case 60: 
 var $59=HEAP32[((5180)>>2)];
 var $add243=((($59)+($psize_0))|0);
 HEAP32[((5180)>>2)]=$add243;
 HEAP32[((5192)>>2)]=$p_0;
 var $or244=$add243|1;
 var $head245=(($p_0+4)|0);
 HEAP32[(($head245)>>2)]=$or244;
 var $60=HEAP32[((5188)>>2)];
 var $cmp246=($p_0|0)==($60|0);
 if($cmp246){label=61;break;}else{label=140;break;}
 case 61: 
 HEAP32[((5188)>>2)]=0;
 HEAP32[((5176)>>2)]=0;
 label=140;break;
 case 62: 
 var $61=HEAP32[((5188)>>2)];
 var $cmp251=($4|0)==($61|0);
 if($cmp251){label=63;break;}else{label=64;break;}
 case 63: 
 var $62=HEAP32[((5176)>>2)];
 var $add254=((($62)+($psize_0))|0);
 HEAP32[((5176)>>2)]=$add254;
 HEAP32[((5188)>>2)]=$p_0;
 var $or255=$add254|1;
 var $head256=(($p_0+4)|0);
 HEAP32[(($head256)>>2)]=$or255;
 var $add_ptr257=(($55+$add254)|0);
 var $prev_foot258=$add_ptr257;
 HEAP32[(($prev_foot258)>>2)]=$add254;
 label=140;break;
 case 64: 
 var $and261=$57&-8;
 var $add262=((($and261)+($psize_0))|0);
 var $shr263=$57>>>3;
 var $cmp264=($57>>>0)<256;
 if($cmp264){label=65;break;}else{label=77;break;}
 case 65: 
 var $fd268=(($mem+$and5)|0);
 var $63=$fd268;
 var $64=HEAP32[(($63)>>2)];
 var $add_ptr6_sum252253=$and5|4;
 var $bk270=(($mem+$add_ptr6_sum252253)|0);
 var $65=$bk270;
 var $66=HEAP32[(($65)>>2)];
 var $shl273=$shr263<<1;
 var $arrayidx274=((5208+($shl273<<2))|0);
 var $67=$arrayidx274;
 var $cmp275=($64|0)==($67|0);
 if($cmp275){label=68;break;}else{label=66;break;}
 case 66: 
 var $68=$64;
 var $69=HEAP32[((5184)>>2)];
 var $cmp278=($68>>>0)<($69>>>0);
 if($cmp278){label=76;break;}else{label=67;break;}
 case 67: 
 var $bk281=(($64+12)|0);
 var $70=HEAP32[(($bk281)>>2)];
 var $cmp282=($70|0)==($4|0);
 if($cmp282){label=68;break;}else{label=76;break;}
 case 68: 
 var $cmp291=($66|0)==($64|0);
 if($cmp291){label=69;break;}else{label=70;break;}
 case 69: 
 var $shl294=1<<$shr263;
 var $neg295=$shl294^-1;
 var $71=HEAP32[((5168)>>2)];
 var $and296=$71&$neg295;
 HEAP32[((5168)>>2)]=$and296;
 label=110;break;
 case 70: 
 var $cmp300=($66|0)==($67|0);
 if($cmp300){label=71;break;}else{label=72;break;}
 case 71: 
 var $fd317_pre=(($66+8)|0);
 var $fd317_pre_phi=$fd317_pre;label=74;break;
 case 72: 
 var $72=$66;
 var $73=HEAP32[((5184)>>2)];
 var $cmp303=($72>>>0)<($73>>>0);
 if($cmp303){label=75;break;}else{label=73;break;}
 case 73: 
 var $fd306=(($66+8)|0);
 var $74=HEAP32[(($fd306)>>2)];
 var $cmp307=($74|0)==($4|0);
 if($cmp307){var $fd317_pre_phi=$fd306;label=74;break;}else{label=75;break;}
 case 74: 
 var $fd317_pre_phi;
 var $bk316=(($64+12)|0);
 HEAP32[(($bk316)>>2)]=$66;
 HEAP32[(($fd317_pre_phi)>>2)]=$64;
 label=110;break;
 case 75: 
 _abort();
 throw "Reached an unreachable!";
 case 76: 
 _abort();
 throw "Reached an unreachable!";
 case 77: 
 var $75=$add_ptr6;
 var $add_ptr6_sum233=((($and5)+(16))|0);
 var $parent326=(($mem+$add_ptr6_sum233)|0);
 var $76=$parent326;
 var $77=HEAP32[(($76)>>2)];
 var $add_ptr6_sum234235=$and5|4;
 var $bk328=(($mem+$add_ptr6_sum234235)|0);
 var $78=$bk328;
 var $79=HEAP32[(($78)>>2)];
 var $cmp329=($79|0)==($75|0);
 if($cmp329){label=83;break;}else{label=78;break;}
 case 78: 
 var $fd333=(($mem+$and5)|0);
 var $80=$fd333;
 var $81=HEAP32[(($80)>>2)];
 var $82=$81;
 var $83=HEAP32[((5184)>>2)];
 var $cmp335=($82>>>0)<($83>>>0);
 if($cmp335){label=82;break;}else{label=79;break;}
 case 79: 
 var $bk338=(($81+12)|0);
 var $84=HEAP32[(($bk338)>>2)];
 var $cmp339=($84|0)==($75|0);
 if($cmp339){label=80;break;}else{label=82;break;}
 case 80: 
 var $fd342=(($79+8)|0);
 var $85=HEAP32[(($fd342)>>2)];
 var $cmp343=($85|0)==($75|0);
 if($cmp343){label=81;break;}else{label=82;break;}
 case 81: 
 HEAP32[(($bk338)>>2)]=$79;
 HEAP32[(($fd342)>>2)]=$81;
 var $R327_1=$79;label=90;break;
 case 82: 
 _abort();
 throw "Reached an unreachable!";
 case 83: 
 var $child356_sum=((($and5)+(12))|0);
 var $arrayidx357=(($mem+$child356_sum)|0);
 var $86=$arrayidx357;
 var $87=HEAP32[(($86)>>2)];
 var $cmp358=($87|0)==0;
 if($cmp358){label=84;break;}else{var $R327_0=$87;var $RP355_0=$86;label=85;break;}
 case 84: 
 var $add_ptr6_sum236=((($and5)+(8))|0);
 var $child356=(($mem+$add_ptr6_sum236)|0);
 var $arrayidx362=$child356;
 var $88=HEAP32[(($arrayidx362)>>2)];
 var $cmp363=($88|0)==0;
 if($cmp363){var $R327_1=0;label=90;break;}else{var $R327_0=$88;var $RP355_0=$arrayidx362;label=85;break;}
 case 85: 
 var $RP355_0;
 var $R327_0;
 var $arrayidx369=(($R327_0+20)|0);
 var $89=HEAP32[(($arrayidx369)>>2)];
 var $cmp370=($89|0)==0;
 if($cmp370){label=86;break;}else{var $R327_0=$89;var $RP355_0=$arrayidx369;label=85;break;}
 case 86: 
 var $arrayidx374=(($R327_0+16)|0);
 var $90=HEAP32[(($arrayidx374)>>2)];
 var $cmp375=($90|0)==0;
 if($cmp375){label=87;break;}else{var $R327_0=$90;var $RP355_0=$arrayidx374;label=85;break;}
 case 87: 
 var $91=$RP355_0;
 var $92=HEAP32[((5184)>>2)];
 var $cmp381=($91>>>0)<($92>>>0);
 if($cmp381){label=89;break;}else{label=88;break;}
 case 88: 
 HEAP32[(($RP355_0)>>2)]=0;
 var $R327_1=$R327_0;label=90;break;
 case 89: 
 _abort();
 throw "Reached an unreachable!";
 case 90: 
 var $R327_1;
 var $cmp390=($77|0)==0;
 if($cmp390){label=110;break;}else{label=91;break;}
 case 91: 
 var $add_ptr6_sum246=((($and5)+(20))|0);
 var $index394=(($mem+$add_ptr6_sum246)|0);
 var $93=$index394;
 var $94=HEAP32[(($93)>>2)];
 var $arrayidx395=((5472+($94<<2))|0);
 var $95=HEAP32[(($arrayidx395)>>2)];
 var $cmp396=($75|0)==($95|0);
 if($cmp396){label=92;break;}else{label=94;break;}
 case 92: 
 HEAP32[(($arrayidx395)>>2)]=$R327_1;
 var $cond279=($R327_1|0)==0;
 if($cond279){label=93;break;}else{label=100;break;}
 case 93: 
 var $96=HEAP32[(($93)>>2)];
 var $shl403=1<<$96;
 var $neg404=$shl403^-1;
 var $97=HEAP32[((5172)>>2)];
 var $and405=$97&$neg404;
 HEAP32[((5172)>>2)]=$and405;
 label=110;break;
 case 94: 
 var $98=$77;
 var $99=HEAP32[((5184)>>2)];
 var $cmp408=($98>>>0)<($99>>>0);
 if($cmp408){label=98;break;}else{label=95;break;}
 case 95: 
 var $arrayidx414=(($77+16)|0);
 var $100=HEAP32[(($arrayidx414)>>2)];
 var $cmp415=($100|0)==($75|0);
 if($cmp415){label=96;break;}else{label=97;break;}
 case 96: 
 HEAP32[(($arrayidx414)>>2)]=$R327_1;
 label=99;break;
 case 97: 
 var $arrayidx422=(($77+20)|0);
 HEAP32[(($arrayidx422)>>2)]=$R327_1;
 label=99;break;
 case 98: 
 _abort();
 throw "Reached an unreachable!";
 case 99: 
 var $cmp427=($R327_1|0)==0;
 if($cmp427){label=110;break;}else{label=100;break;}
 case 100: 
 var $101=$R327_1;
 var $102=HEAP32[((5184)>>2)];
 var $cmp430=($101>>>0)<($102>>>0);
 if($cmp430){label=109;break;}else{label=101;break;}
 case 101: 
 var $parent437=(($R327_1+24)|0);
 HEAP32[(($parent437)>>2)]=$77;
 var $add_ptr6_sum247=((($and5)+(8))|0);
 var $child438=(($mem+$add_ptr6_sum247)|0);
 var $arrayidx439=$child438;
 var $103=HEAP32[(($arrayidx439)>>2)];
 var $cmp440=($103|0)==0;
 if($cmp440){label=105;break;}else{label=102;break;}
 case 102: 
 var $104=$103;
 var $105=HEAP32[((5184)>>2)];
 var $cmp443=($104>>>0)<($105>>>0);
 if($cmp443){label=104;break;}else{label=103;break;}
 case 103: 
 var $arrayidx449=(($R327_1+16)|0);
 HEAP32[(($arrayidx449)>>2)]=$103;
 var $parent450=(($103+24)|0);
 HEAP32[(($parent450)>>2)]=$R327_1;
 label=105;break;
 case 104: 
 _abort();
 throw "Reached an unreachable!";
 case 105: 
 var $child438_sum=((($and5)+(12))|0);
 var $arrayidx455=(($mem+$child438_sum)|0);
 var $106=$arrayidx455;
 var $107=HEAP32[(($106)>>2)];
 var $cmp456=($107|0)==0;
 if($cmp456){label=110;break;}else{label=106;break;}
 case 106: 
 var $108=$107;
 var $109=HEAP32[((5184)>>2)];
 var $cmp459=($108>>>0)<($109>>>0);
 if($cmp459){label=108;break;}else{label=107;break;}
 case 107: 
 var $arrayidx465=(($R327_1+20)|0);
 HEAP32[(($arrayidx465)>>2)]=$107;
 var $parent466=(($107+24)|0);
 HEAP32[(($parent466)>>2)]=$R327_1;
 label=110;break;
 case 108: 
 _abort();
 throw "Reached an unreachable!";
 case 109: 
 _abort();
 throw "Reached an unreachable!";
 case 110: 
 var $or475=$add262|1;
 var $head476=(($p_0+4)|0);
 HEAP32[(($head476)>>2)]=$or475;
 var $add_ptr477=(($55+$add262)|0);
 var $prev_foot478=$add_ptr477;
 HEAP32[(($prev_foot478)>>2)]=$add262;
 var $110=HEAP32[((5188)>>2)];
 var $cmp479=($p_0|0)==($110|0);
 if($cmp479){label=111;break;}else{var $psize_1=$add262;label=113;break;}
 case 111: 
 HEAP32[((5176)>>2)]=$add262;
 label=140;break;
 case 112: 
 var $and487=$57&-2;
 HEAP32[(($56)>>2)]=$and487;
 var $or488=$psize_0|1;
 var $head489=(($p_0+4)|0);
 HEAP32[(($head489)>>2)]=$or488;
 var $add_ptr490=(($55+$psize_0)|0);
 var $prev_foot491=$add_ptr490;
 HEAP32[(($prev_foot491)>>2)]=$psize_0;
 var $psize_1=$psize_0;label=113;break;
 case 113: 
 var $psize_1;
 var $shr493=$psize_1>>>3;
 var $cmp494=($psize_1>>>0)<256;
 if($cmp494){label=114;break;}else{label=119;break;}
 case 114: 
 var $shl500=$shr493<<1;
 var $arrayidx501=((5208+($shl500<<2))|0);
 var $111=$arrayidx501;
 var $112=HEAP32[((5168)>>2)];
 var $shl503=1<<$shr493;
 var $and504=$112&$shl503;
 var $tobool505=($and504|0)==0;
 if($tobool505){label=115;break;}else{label=116;break;}
 case 115: 
 var $or508=$112|$shl503;
 HEAP32[((5168)>>2)]=$or508;
 var $arrayidx501_sum_pre=((($shl500)+(2))|0);
 var $_pre=((5208+($arrayidx501_sum_pre<<2))|0);
 var $F502_0=$111;var $_pre_phi=$_pre;label=118;break;
 case 116: 
 var $arrayidx501_sum245=((($shl500)+(2))|0);
 var $113=((5208+($arrayidx501_sum245<<2))|0);
 var $114=HEAP32[(($113)>>2)];
 var $115=$114;
 var $116=HEAP32[((5184)>>2)];
 var $cmp511=($115>>>0)<($116>>>0);
 if($cmp511){label=117;break;}else{var $F502_0=$114;var $_pre_phi=$113;label=118;break;}
 case 117: 
 _abort();
 throw "Reached an unreachable!";
 case 118: 
 var $_pre_phi;
 var $F502_0;
 HEAP32[(($_pre_phi)>>2)]=$p_0;
 var $bk521=(($F502_0+12)|0);
 HEAP32[(($bk521)>>2)]=$p_0;
 var $fd522=(($p_0+8)|0);
 HEAP32[(($fd522)>>2)]=$F502_0;
 var $bk523=(($p_0+12)|0);
 HEAP32[(($bk523)>>2)]=$111;
 label=140;break;
 case 119: 
 var $117=$p_0;
 var $shr527=$psize_1>>>8;
 var $cmp528=($shr527|0)==0;
 if($cmp528){var $I526_0=0;label=122;break;}else{label=120;break;}
 case 120: 
 var $cmp532=($psize_1>>>0)>16777215;
 if($cmp532){var $I526_0=31;label=122;break;}else{label=121;break;}
 case 121: 
 var $sub=((($shr527)+(1048320))|0);
 var $shr536=$sub>>>16;
 var $and537=$shr536&8;
 var $shl538=$shr527<<$and537;
 var $sub539=((($shl538)+(520192))|0);
 var $shr540=$sub539>>>16;
 var $and541=$shr540&4;
 var $add542=$and541|$and537;
 var $shl543=$shl538<<$and541;
 var $sub544=((($shl543)+(245760))|0);
 var $shr545=$sub544>>>16;
 var $and546=$shr545&2;
 var $add547=$add542|$and546;
 var $sub548=(((14)-($add547))|0);
 var $shl549=$shl543<<$and546;
 var $shr550=$shl549>>>15;
 var $add551=((($sub548)+($shr550))|0);
 var $shl552=$add551<<1;
 var $add553=((($add551)+(7))|0);
 var $shr554=$psize_1>>>($add553>>>0);
 var $and555=$shr554&1;
 var $add556=$and555|$shl552;
 var $I526_0=$add556;label=122;break;
 case 122: 
 var $I526_0;
 var $arrayidx559=((5472+($I526_0<<2))|0);
 var $index560=(($p_0+28)|0);
 var $I526_0_c=$I526_0;
 HEAP32[(($index560)>>2)]=$I526_0_c;
 var $arrayidx562=(($p_0+20)|0);
 HEAP32[(($arrayidx562)>>2)]=0;
 var $118=(($p_0+16)|0);
 HEAP32[(($118)>>2)]=0;
 var $119=HEAP32[((5172)>>2)];
 var $shl565=1<<$I526_0;
 var $and566=$119&$shl565;
 var $tobool567=($and566|0)==0;
 if($tobool567){label=123;break;}else{label=124;break;}
 case 123: 
 var $or570=$119|$shl565;
 HEAP32[((5172)>>2)]=$or570;
 HEAP32[(($arrayidx559)>>2)]=$117;
 var $parent571=(($p_0+24)|0);
 var $_c=$arrayidx559;
 HEAP32[(($parent571)>>2)]=$_c;
 var $bk572=(($p_0+12)|0);
 HEAP32[(($bk572)>>2)]=$p_0;
 var $fd573=(($p_0+8)|0);
 HEAP32[(($fd573)>>2)]=$p_0;
 label=136;break;
 case 124: 
 var $120=HEAP32[(($arrayidx559)>>2)];
 var $cmp576=($I526_0|0)==31;
 if($cmp576){var $cond=0;label=126;break;}else{label=125;break;}
 case 125: 
 var $shr578=$I526_0>>>1;
 var $sub581=(((25)-($shr578))|0);
 var $cond=$sub581;label=126;break;
 case 126: 
 var $cond;
 var $head583281=(($120+4)|0);
 var $121=HEAP32[(($head583281)>>2)];
 var $and584282=$121&-8;
 var $cmp585283=($and584282|0)==($psize_1|0);
 if($cmp585283){var $T_0_lcssa=$120;label=133;break;}else{label=127;break;}
 case 127: 
 var $shl582=$psize_1<<$cond;
 var $T_0284=$120;var $K575_0285=$shl582;label=129;break;
 case 128: 
 var $shl592=$K575_0285<<1;
 var $head583=(($123+4)|0);
 var $122=HEAP32[(($head583)>>2)];
 var $and584=$122&-8;
 var $cmp585=($and584|0)==($psize_1|0);
 if($cmp585){var $T_0_lcssa=$123;label=133;break;}else{var $T_0284=$123;var $K575_0285=$shl592;label=129;break;}
 case 129: 
 var $K575_0285;
 var $T_0284;
 var $shr588=$K575_0285>>>31;
 var $arrayidx591=(($T_0284+16+($shr588<<2))|0);
 var $123=HEAP32[(($arrayidx591)>>2)];
 var $cmp593=($123|0)==0;
 if($cmp593){label=130;break;}else{label=128;break;}
 case 130: 
 var $124=$arrayidx591;
 var $125=HEAP32[((5184)>>2)];
 var $cmp597=($124>>>0)<($125>>>0);
 if($cmp597){label=132;break;}else{label=131;break;}
 case 131: 
 HEAP32[(($arrayidx591)>>2)]=$117;
 var $parent602=(($p_0+24)|0);
 var $T_0_c242=$T_0284;
 HEAP32[(($parent602)>>2)]=$T_0_c242;
 var $bk603=(($p_0+12)|0);
 HEAP32[(($bk603)>>2)]=$p_0;
 var $fd604=(($p_0+8)|0);
 HEAP32[(($fd604)>>2)]=$p_0;
 label=136;break;
 case 132: 
 _abort();
 throw "Reached an unreachable!";
 case 133: 
 var $T_0_lcssa;
 var $fd609=(($T_0_lcssa+8)|0);
 var $126=HEAP32[(($fd609)>>2)];
 var $127=$T_0_lcssa;
 var $128=HEAP32[((5184)>>2)];
 var $cmp610=($127>>>0)>=($128>>>0);
 var $129=$126;
 var $cmp613=($129>>>0)>=($128>>>0);
 var $or_cond=$cmp610&$cmp613;
 if($or_cond){label=134;break;}else{label=135;break;}
 case 134: 
 var $bk620=(($126+12)|0);
 HEAP32[(($bk620)>>2)]=$117;
 HEAP32[(($fd609)>>2)]=$117;
 var $fd622=(($p_0+8)|0);
 var $_c241=$126;
 HEAP32[(($fd622)>>2)]=$_c241;
 var $bk623=(($p_0+12)|0);
 var $T_0_c=$T_0_lcssa;
 HEAP32[(($bk623)>>2)]=$T_0_c;
 var $parent624=(($p_0+24)|0);
 HEAP32[(($parent624)>>2)]=0;
 label=136;break;
 case 135: 
 _abort();
 throw "Reached an unreachable!";
 case 136: 
 var $130=HEAP32[((5200)>>2)];
 var $dec=((($130)-(1))|0);
 HEAP32[((5200)>>2)]=$dec;
 var $cmp628=($dec|0)==0;
 if($cmp628){var $sp_0_in_i=5624;label=137;break;}else{label=140;break;}
 case 137: 
 var $sp_0_in_i;
 var $sp_0_i=HEAP32[(($sp_0_in_i)>>2)];
 var $cmp_i=($sp_0_i|0)==0;
 var $next4_i=(($sp_0_i+8)|0);
 if($cmp_i){label=138;break;}else{var $sp_0_in_i=$next4_i;label=137;break;}
 case 138: 
 HEAP32[((5200)>>2)]=-1;
 label=140;break;
 case 139: 
 _abort();
 throw "Reached an unreachable!";
 case 140: 
 return;
  default: assert(0, "bad label: " + label);
 }

}
Module["_free"] = _free;


// EMSCRIPTEN_END_FUNCS
function _i64Add(a, b, c, d) {
    /*
      x = a + b*2^32
      y = c + d*2^32
      result = l + h*2^32
    */
    a = a|0; b = b|0; c = c|0; d = d|0;
    var l = 0, h = 0;
    l = (a + c)>>>0;
    h = (b + d + (((l>>>0) < (a>>>0))|0))>>>0; // Add carry from low word to high word on overflow.
    return tempRet0 = h,l|0;
  }
function _i64Subtract(a, b, c, d) {
    a = a|0; b = b|0; c = c|0; d = d|0;
    var l = 0, h = 0;
    l = (a - c)>>>0;
    h = (b - d)>>>0;
    h = (b - d - (((c>>>0) > (a>>>0))|0))>>>0; // Borrow one from high word to low word on underflow.
    return tempRet0 = h,l|0;
  }
function _bitshift64Shl(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = (high << bits) | ((low&(ander << (32 - bits))) >>> (32 - bits));
      return low << bits;
    }
    tempRet0 = low << (bits - 32);
    return 0;
  }
function _bitshift64Lshr(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = high >>> bits;
      return (low >>> bits) | ((high&ander) << (32 - bits));
    }
    tempRet0 = 0;
    return (high >>> (bits - 32))|0;
  }
function _bitshift64Ashr(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = high >> bits;
      return (low >>> bits) | ((high&ander) << (32 - bits));
    }
    tempRet0 = (high|0) < 0 ? -1 : 0;
    return (high >> (bits - 32))|0;
  }
function _llvm_ctlz_i32(x) {
    x = x|0;
    var ret = 0;
    ret = HEAP8[(((ctlz_i8)+(x >>> 24))|0)];
    if ((ret|0) < 8) return ret|0;
    ret = HEAP8[(((ctlz_i8)+((x >> 16)&0xff))|0)];
    if ((ret|0) < 8) return (ret + 8)|0;
    ret = HEAP8[(((ctlz_i8)+((x >> 8)&0xff))|0)];
    if ((ret|0) < 8) return (ret + 16)|0;
    return (HEAP8[(((ctlz_i8)+(x&0xff))|0)] + 24)|0;
  }
/* PRE_ASM */ var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);

function _llvm_cttz_i32(x) {
    x = x|0;
    var ret = 0;
    ret = HEAP8[(((cttz_i8)+(x & 0xff))|0)];
    if ((ret|0) < 8) return ret|0;
    ret = HEAP8[(((cttz_i8)+((x >> 8)&0xff))|0)];
    if ((ret|0) < 8) return (ret + 8)|0;
    ret = HEAP8[(((cttz_i8)+((x >> 16)&0xff))|0)];
    if ((ret|0) < 8) return (ret + 16)|0;
    return (HEAP8[(((cttz_i8)+(x >>> 24))|0)] + 24)|0;
  }
/* PRE_ASM */ var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

// ======== compiled code from system/lib/compiler-rt , see readme therein
function ___muldsi3($a, $b) {
  $a = $a | 0;
  $b = $b | 0;
  var $1 = 0, $2 = 0, $3 = 0, $6 = 0, $8 = 0, $11 = 0, $12 = 0;
  $1 = $a & 65535;
  $2 = $b & 65535;
  $3 = Math_imul($2, $1) | 0;
  $6 = $a >>> 16;
  $8 = ($3 >>> 16) + (Math_imul($2, $6) | 0) | 0;
  $11 = $b >>> 16;
  $12 = Math_imul($11, $1) | 0;
  return (tempRet0 = (($8 >>> 16) + (Math_imul($11, $6) | 0) | 0) + ((($8 & 65535) + $12 | 0) >>> 16) | 0, 0 | ($8 + $12 << 16 | $3 & 65535)) | 0;
}
function ___divdi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $1$0 = 0, $1$1 = 0, $2$0 = 0, $2$1 = 0, $4$0 = 0, $4$1 = 0, $6$0 = 0, $7$0 = 0, $7$1 = 0, $8$0 = 0, $10$0 = 0;
  $1$0 = $a$1 >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
  $1$1 = (($a$1 | 0) < 0 ? -1 : 0) >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
  $2$0 = $b$1 >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
  $2$1 = (($b$1 | 0) < 0 ? -1 : 0) >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
  $4$0 = _i64Subtract($1$0 ^ $a$0, $1$1 ^ $a$1, $1$0, $1$1) | 0;
  $4$1 = tempRet0;
  $6$0 = _i64Subtract($2$0 ^ $b$0, $2$1 ^ $b$1, $2$0, $2$1) | 0;
  $7$0 = $2$0 ^ $1$0;
  $7$1 = $2$1 ^ $1$1;
  $8$0 = ___udivmoddi4($4$0, $4$1, $6$0, tempRet0, 0) | 0;
  $10$0 = _i64Subtract($8$0 ^ $7$0, tempRet0 ^ $7$1, $7$0, $7$1) | 0;
  return (tempRet0 = tempRet0, $10$0) | 0;
}
function ___remdi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $rem = 0, $1$0 = 0, $1$1 = 0, $2$0 = 0, $2$1 = 0, $4$0 = 0, $4$1 = 0, $6$0 = 0, $10$0 = 0, $10$1 = 0, __stackBase__ = 0;
  __stackBase__ = STACKTOP;
  STACKTOP = STACKTOP + 8 | 0;
  $rem = __stackBase__ | 0;
  $1$0 = $a$1 >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
  $1$1 = (($a$1 | 0) < 0 ? -1 : 0) >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
  $2$0 = $b$1 >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
  $2$1 = (($b$1 | 0) < 0 ? -1 : 0) >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
  $4$0 = _i64Subtract($1$0 ^ $a$0, $1$1 ^ $a$1, $1$0, $1$1) | 0;
  $4$1 = tempRet0;
  $6$0 = _i64Subtract($2$0 ^ $b$0, $2$1 ^ $b$1, $2$0, $2$1) | 0;
  ___udivmoddi4($4$0, $4$1, $6$0, tempRet0, $rem) | 0;
  $10$0 = _i64Subtract(HEAP32[$rem >> 2] ^ $1$0, HEAP32[$rem + 4 >> 2] ^ $1$1, $1$0, $1$1) | 0;
  $10$1 = tempRet0;
  STACKTOP = __stackBase__;
  return (tempRet0 = $10$1, $10$0) | 0;
}
function ___muldi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $x_sroa_0_0_extract_trunc = 0, $y_sroa_0_0_extract_trunc = 0, $1$0 = 0, $1$1 = 0, $2 = 0;
  $x_sroa_0_0_extract_trunc = $a$0;
  $y_sroa_0_0_extract_trunc = $b$0;
  $1$0 = ___muldsi3($x_sroa_0_0_extract_trunc, $y_sroa_0_0_extract_trunc) | 0;
  $1$1 = tempRet0;
  $2 = Math_imul($a$1, $y_sroa_0_0_extract_trunc) | 0;
  return (tempRet0 = ((Math_imul($b$1, $x_sroa_0_0_extract_trunc) | 0) + $2 | 0) + $1$1 | $1$1 & 0, 0 | $1$0 & -1) | 0;
}
function ___udivdi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $1$0 = 0;
  $1$0 = ___udivmoddi4($a$0, $a$1, $b$0, $b$1, 0) | 0;
  return (tempRet0 = tempRet0, $1$0) | 0;
}
function ___uremdi3($a$0, $a$1, $b$0, $b$1) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  var $rem = 0, __stackBase__ = 0;
  __stackBase__ = STACKTOP;
  STACKTOP = STACKTOP + 8 | 0;
  $rem = __stackBase__ | 0;
  ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) | 0;
  STACKTOP = __stackBase__;
  return (tempRet0 = HEAP32[$rem + 4 >> 2] | 0, HEAP32[$rem >> 2] | 0) | 0;
}
function ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) {
  $a$0 = $a$0 | 0;
  $a$1 = $a$1 | 0;
  $b$0 = $b$0 | 0;
  $b$1 = $b$1 | 0;
  $rem = $rem | 0;
  var $n_sroa_0_0_extract_trunc = 0, $n_sroa_1_4_extract_shift$0 = 0, $n_sroa_1_4_extract_trunc = 0, $d_sroa_0_0_extract_trunc = 0, $d_sroa_1_4_extract_shift$0 = 0, $d_sroa_1_4_extract_trunc = 0, $4 = 0, $17 = 0, $37 = 0, $49 = 0, $51 = 0, $57 = 0, $58 = 0, $66 = 0, $78 = 0, $86 = 0, $88 = 0, $89 = 0, $91 = 0, $92 = 0, $95 = 0, $105 = 0, $117 = 0, $119 = 0, $125 = 0, $126 = 0, $130 = 0, $q_sroa_1_1_ph = 0, $q_sroa_0_1_ph = 0, $r_sroa_1_1_ph = 0, $r_sroa_0_1_ph = 0, $sr_1_ph = 0, $d_sroa_0_0_insert_insert99$0 = 0, $d_sroa_0_0_insert_insert99$1 = 0, $137$0 = 0, $137$1 = 0, $carry_0203 = 0, $sr_1202 = 0, $r_sroa_0_1201 = 0, $r_sroa_1_1200 = 0, $q_sroa_0_1199 = 0, $q_sroa_1_1198 = 0, $147 = 0, $149 = 0, $r_sroa_0_0_insert_insert42$0 = 0, $r_sroa_0_0_insert_insert42$1 = 0, $150$1 = 0, $151$0 = 0, $152 = 0, $154$0 = 0, $r_sroa_0_0_extract_trunc = 0, $r_sroa_1_4_extract_trunc = 0, $155 = 0, $carry_0_lcssa$0 = 0, $carry_0_lcssa$1 = 0, $r_sroa_0_1_lcssa = 0, $r_sroa_1_1_lcssa = 0, $q_sroa_0_1_lcssa = 0, $q_sroa_1_1_lcssa = 0, $q_sroa_0_0_insert_ext75$0 = 0, $q_sroa_0_0_insert_ext75$1 = 0, $q_sroa_0_0_insert_insert77$1 = 0, $_0$0 = 0, $_0$1 = 0;
  $n_sroa_0_0_extract_trunc = $a$0;
  $n_sroa_1_4_extract_shift$0 = $a$1;
  $n_sroa_1_4_extract_trunc = $n_sroa_1_4_extract_shift$0;
  $d_sroa_0_0_extract_trunc = $b$0;
  $d_sroa_1_4_extract_shift$0 = $b$1;
  $d_sroa_1_4_extract_trunc = $d_sroa_1_4_extract_shift$0;
  if (($n_sroa_1_4_extract_trunc | 0) == 0) {
    $4 = ($rem | 0) != 0;
    if (($d_sroa_1_4_extract_trunc | 0) == 0) {
      if ($4) {
        HEAP32[$rem >> 2] = ($n_sroa_0_0_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0);
        HEAP32[$rem + 4 >> 2] = 0;
      }
      $_0$1 = 0;
      $_0$0 = ($n_sroa_0_0_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0;
      return (tempRet0 = $_0$1, $_0$0) | 0;
    } else {
      if (!$4) {
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      HEAP32[$rem >> 2] = $a$0 & -1;
      HEAP32[$rem + 4 >> 2] = $a$1 & 0;
      $_0$1 = 0;
      $_0$0 = 0;
      return (tempRet0 = $_0$1, $_0$0) | 0;
    }
  }
  $17 = ($d_sroa_1_4_extract_trunc | 0) == 0;
  do {
    if (($d_sroa_0_0_extract_trunc | 0) == 0) {
      if ($17) {
        if (($rem | 0) != 0) {
          HEAP32[$rem >> 2] = ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0);
          HEAP32[$rem + 4 >> 2] = 0;
        }
        $_0$1 = 0;
        $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      if (($n_sroa_0_0_extract_trunc | 0) == 0) {
        if (($rem | 0) != 0) {
          HEAP32[$rem >> 2] = 0;
          HEAP32[$rem + 4 >> 2] = ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_1_4_extract_trunc >>> 0);
        }
        $_0$1 = 0;
        $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_1_4_extract_trunc >>> 0) >>> 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      $37 = $d_sroa_1_4_extract_trunc - 1 | 0;
      if (($37 & $d_sroa_1_4_extract_trunc | 0) == 0) {
        if (($rem | 0) != 0) {
          HEAP32[$rem >> 2] = 0 | $a$0 & -1;
          HEAP32[$rem + 4 >> 2] = $37 & $n_sroa_1_4_extract_trunc | $a$1 & 0;
        }
        $_0$1 = 0;
        $_0$0 = $n_sroa_1_4_extract_trunc >>> ((_llvm_cttz_i32($d_sroa_1_4_extract_trunc | 0) | 0) >>> 0);
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      $49 = _llvm_ctlz_i32($d_sroa_1_4_extract_trunc | 0) | 0;
      $51 = $49 - (_llvm_ctlz_i32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
      if ($51 >>> 0 <= 30) {
        $57 = $51 + 1 | 0;
        $58 = 31 - $51 | 0;
        $sr_1_ph = $57;
        $r_sroa_0_1_ph = $n_sroa_1_4_extract_trunc << $58 | $n_sroa_0_0_extract_trunc >>> ($57 >>> 0);
        $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($57 >>> 0);
        $q_sroa_0_1_ph = 0;
        $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $58;
        break;
      }
      if (($rem | 0) == 0) {
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      HEAP32[$rem >> 2] = 0 | $a$0 & -1;
      HEAP32[$rem + 4 >> 2] = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
      $_0$1 = 0;
      $_0$0 = 0;
      return (tempRet0 = $_0$1, $_0$0) | 0;
    } else {
      if (!$17) {
        $117 = _llvm_ctlz_i32($d_sroa_1_4_extract_trunc | 0) | 0;
        $119 = $117 - (_llvm_ctlz_i32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
        if ($119 >>> 0 <= 31) {
          $125 = $119 + 1 | 0;
          $126 = 31 - $119 | 0;
          $130 = $119 - 31 >> 31;
          $sr_1_ph = $125;
          $r_sroa_0_1_ph = $n_sroa_0_0_extract_trunc >>> ($125 >>> 0) & $130 | $n_sroa_1_4_extract_trunc << $126;
          $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($125 >>> 0) & $130;
          $q_sroa_0_1_ph = 0;
          $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $126;
          break;
        }
        if (($rem | 0) == 0) {
          $_0$1 = 0;
          $_0$0 = 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        HEAP32[$rem >> 2] = 0 | $a$0 & -1;
        HEAP32[$rem + 4 >> 2] = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
      $66 = $d_sroa_0_0_extract_trunc - 1 | 0;
      if (($66 & $d_sroa_0_0_extract_trunc | 0) != 0) {
        $86 = (_llvm_ctlz_i32($d_sroa_0_0_extract_trunc | 0) | 0) + 33 | 0;
        $88 = $86 - (_llvm_ctlz_i32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
        $89 = 64 - $88 | 0;
        $91 = 32 - $88 | 0;
        $92 = $91 >> 31;
        $95 = $88 - 32 | 0;
        $105 = $95 >> 31;
        $sr_1_ph = $88;
        $r_sroa_0_1_ph = $91 - 1 >> 31 & $n_sroa_1_4_extract_trunc >>> ($95 >>> 0) | ($n_sroa_1_4_extract_trunc << $91 | $n_sroa_0_0_extract_trunc >>> ($88 >>> 0)) & $105;
        $r_sroa_1_1_ph = $105 & $n_sroa_1_4_extract_trunc >>> ($88 >>> 0);
        $q_sroa_0_1_ph = $n_sroa_0_0_extract_trunc << $89 & $92;
        $q_sroa_1_1_ph = ($n_sroa_1_4_extract_trunc << $89 | $n_sroa_0_0_extract_trunc >>> ($95 >>> 0)) & $92 | $n_sroa_0_0_extract_trunc << $91 & $88 - 33 >> 31;
        break;
      }
      if (($rem | 0) != 0) {
        HEAP32[$rem >> 2] = $66 & $n_sroa_0_0_extract_trunc;
        HEAP32[$rem + 4 >> 2] = 0;
      }
      if (($d_sroa_0_0_extract_trunc | 0) == 1) {
        $_0$1 = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
        $_0$0 = 0 | $a$0 & -1;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      } else {
        $78 = _llvm_cttz_i32($d_sroa_0_0_extract_trunc | 0) | 0;
        $_0$1 = 0 | $n_sroa_1_4_extract_trunc >>> ($78 >>> 0);
        $_0$0 = $n_sroa_1_4_extract_trunc << 32 - $78 | $n_sroa_0_0_extract_trunc >>> ($78 >>> 0) | 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
    }
  } while (0);
  if (($sr_1_ph | 0) == 0) {
    $q_sroa_1_1_lcssa = $q_sroa_1_1_ph;
    $q_sroa_0_1_lcssa = $q_sroa_0_1_ph;
    $r_sroa_1_1_lcssa = $r_sroa_1_1_ph;
    $r_sroa_0_1_lcssa = $r_sroa_0_1_ph;
    $carry_0_lcssa$1 = 0;
    $carry_0_lcssa$0 = 0;
  } else {
    $d_sroa_0_0_insert_insert99$0 = 0 | $b$0 & -1;
    $d_sroa_0_0_insert_insert99$1 = $d_sroa_1_4_extract_shift$0 | $b$1 & 0;
    $137$0 = _i64Add($d_sroa_0_0_insert_insert99$0, $d_sroa_0_0_insert_insert99$1, -1, -1) | 0;
    $137$1 = tempRet0;
    $q_sroa_1_1198 = $q_sroa_1_1_ph;
    $q_sroa_0_1199 = $q_sroa_0_1_ph;
    $r_sroa_1_1200 = $r_sroa_1_1_ph;
    $r_sroa_0_1201 = $r_sroa_0_1_ph;
    $sr_1202 = $sr_1_ph;
    $carry_0203 = 0;
    while (1) {
      $147 = $q_sroa_0_1199 >>> 31 | $q_sroa_1_1198 << 1;
      $149 = $carry_0203 | $q_sroa_0_1199 << 1;
      $r_sroa_0_0_insert_insert42$0 = 0 | ($r_sroa_0_1201 << 1 | $q_sroa_1_1198 >>> 31);
      $r_sroa_0_0_insert_insert42$1 = $r_sroa_0_1201 >>> 31 | $r_sroa_1_1200 << 1 | 0;
      _i64Subtract($137$0, $137$1, $r_sroa_0_0_insert_insert42$0, $r_sroa_0_0_insert_insert42$1) | 0;
      $150$1 = tempRet0;
      $151$0 = $150$1 >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1;
      $152 = $151$0 & 1;
      $154$0 = _i64Subtract($r_sroa_0_0_insert_insert42$0, $r_sroa_0_0_insert_insert42$1, $151$0 & $d_sroa_0_0_insert_insert99$0, ((($150$1 | 0) < 0 ? -1 : 0) >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1) & $d_sroa_0_0_insert_insert99$1) | 0;
      $r_sroa_0_0_extract_trunc = $154$0;
      $r_sroa_1_4_extract_trunc = tempRet0;
      $155 = $sr_1202 - 1 | 0;
      if (($155 | 0) == 0) {
        break;
      } else {
        $q_sroa_1_1198 = $147;
        $q_sroa_0_1199 = $149;
        $r_sroa_1_1200 = $r_sroa_1_4_extract_trunc;
        $r_sroa_0_1201 = $r_sroa_0_0_extract_trunc;
        $sr_1202 = $155;
        $carry_0203 = $152;
      }
    }
    $q_sroa_1_1_lcssa = $147;
    $q_sroa_0_1_lcssa = $149;
    $r_sroa_1_1_lcssa = $r_sroa_1_4_extract_trunc;
    $r_sroa_0_1_lcssa = $r_sroa_0_0_extract_trunc;
    $carry_0_lcssa$1 = 0;
    $carry_0_lcssa$0 = $152;
  }
  $q_sroa_0_0_insert_ext75$0 = $q_sroa_0_1_lcssa;
  $q_sroa_0_0_insert_ext75$1 = 0;
  $q_sroa_0_0_insert_insert77$1 = $q_sroa_1_1_lcssa | $q_sroa_0_0_insert_ext75$1;
  if (($rem | 0) != 0) {
    HEAP32[$rem >> 2] = 0 | $r_sroa_0_1_lcssa;
    HEAP32[$rem + 4 >> 2] = $r_sroa_1_1_lcssa | 0;
  }
  $_0$1 = (0 | $q_sroa_0_0_insert_ext75$0) >>> 31 | $q_sroa_0_0_insert_insert77$1 << 1 | ($q_sroa_0_0_insert_ext75$1 << 1 | $q_sroa_0_0_insert_ext75$0 >>> 31) & 0 | $carry_0_lcssa$1;
  $_0$0 = ($q_sroa_0_0_insert_ext75$0 << 1 | 0 >>> 31) & -2 | $carry_0_lcssa$0;
  return (tempRet0 = $_0$1, $_0$0) | 0;
}
// =======================================================================


// EMSCRIPTEN_END_FUNCS

// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======


/*
  Copyright (C) 2013

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  https://github.com/johnmccutchan/ecmascript_simd/blob/master/src/ecmascript_simd.js
*/

"use strict";

/**
  * Construct a new instance of float32x4 number.
  * @param {double} value used for x lane.
  * @param {double} value used for y lane.
  * @param {double} value used for z lane.
  * @param {double} value used for w lane.
  * @constructor
  */
function float32x4(x, y, z, w) {
  if (!(this instanceof float32x4)) {
    return new float32x4(x, y, z, w);
  }
  this.storage_ = new Float32Array(4);
  this.storage_[0] = x;
  this.storage_[1] = y;
  this.storage_[2] = z;
  this.storage_[3] = w;
}

/**
  * Construct a new instance of float32x4 number with 0.0 in all lanes.
  * @constructor
  */
float32x4.zero = function() {
  return float32x4(0.0, 0.0, 0.0, 0.0);
}

/**
  * Construct a new instance of float32x4 number with the same value
  * in all lanes.
  * @param {double} value used for all lanes.
  * @constructor
  */
float32x4.splat = function(s) {
  return float32x4(s, s, s, s);
}

Object.defineProperty(float32x4.prototype, 'x', {
  get: function() { return this.storage_[0]; }
});

Object.defineProperty(float32x4.prototype, 'y', {
  get: function() { return this.storage_[1]; }
});

Object.defineProperty(float32x4.prototype, 'z', {
  get: function() { return this.storage_[2]; }
});

Object.defineProperty(float32x4.prototype, 'w',
  { get: function() { return this.storage_[3]; }
});

/**
  * Extract the sign bit from each lane return them in the first 4 bits.
  */
Object.defineProperty(float32x4.prototype, 'signMask', {
  get: function() {
    var mx = this.x < 0.0 ? 1 : 0;
    var my = this.y < 0.0 ? 1 : 0;
    var mz = this.z < 0.0 ? 1 : 0;
    var mw = this.w < 0.0 ? 1 : 0;
    return mx | my << 1 | mz << 2 | mw << 3;
  }
});

/**
  * Construct a new instance of int32x4 number.
  * @param {integer} 32-bit unsigned value used for x lane.
  * @param {integer} 32-bit unsigned value used for y lane.
  * @param {integer} 32-bit unsigned value used for z lane.
  * @param {integer} 32-bit unsigned value used for w lane.
  * @constructor
  */
function int32x4(x, y, z, w) {
  if (!(this instanceof int32x4)) {
    return new int32x4(x, y, z, w);
  }
  this.storage_ = new Int32Array(4);
  this.storage_[0] = x;
  this.storage_[1] = y;
  this.storage_[2] = z;
  this.storage_[3] = w;
}

/**
  * Construct a new instance of int32x4 number with 0xFFFFFFFF or 0x0 in each
  * lane, depending on the truth value in x, y, z, and w.
  * @param {boolean} flag used for x lane.
  * @param {boolean} flag used for y lane.
  * @param {boolean} flag used for z lane.
  * @param {boolean} flag used for w lane.
  * @constructor
  */
int32x4.bool = function(x, y, z, w) {
  return int32x4(x ? -1 : 0x0,
                  y ? -1 : 0x0,
                  z ? -1 : 0x0,
                  w ? -1 : 0x0);
}

/**
  * Construct a new instance of int32x4 number with the same value
  * in all lanes.
  * @param {integer} value used for all lanes.
  * @constructor
  */
int32x4.splat = function(s) {
  return int32x4(s, s, s, s);
}

Object.defineProperty(int32x4.prototype, 'x', {
  get: function() { return this.storage_[0]; }
});

Object.defineProperty(int32x4.prototype, 'y', {
  get: function() { return this.storage_[1]; }
});

Object.defineProperty(int32x4.prototype, 'z', {
  get: function() { return this.storage_[2]; }
});

Object.defineProperty(int32x4.prototype, 'w',
  { get: function() { return this.storage_[3]; }
});

Object.defineProperty(int32x4.prototype, 'flagX', {
  get: function() { return this.storage_[0] != 0x0; }
});

Object.defineProperty(int32x4.prototype, 'flagY', {
  get: function() { return this.storage_[1] != 0x0; }
});

Object.defineProperty(int32x4.prototype, 'flagZ', {
  get: function() { return this.storage_[2] != 0x0; }
});

Object.defineProperty(int32x4.prototype, 'flagW',
  { get: function() { return this.storage_[3] != 0x0; }
});

/**
  * Extract the sign bit from each lane return them in the first 4 bits.
  */
Object.defineProperty(int32x4.prototype, 'signMask', {
  get: function() {
    var mx = (this.storage_[0] & 0x80000000) >>> 31;
    var my = (this.storage_[1] & 0x80000000) >>> 31;
    var mz = (this.storage_[2] & 0x80000000) >>> 31;
    var mw = (this.storage_[3] & 0x80000000) >>> 31;
    return mx | my << 1 | mz << 2 | mw << 3;
  }
});

function isNumber(o) {
    return typeof o == "number" || (typeof o == "object" && o.constructor === Number);
}

function isTypedArray(o) {
  return (o instanceof Int8Array) ||
         (o instanceof Uint8Array) ||
         (o instanceof Uint8ClampedArray) ||
         (o instanceof Int16Array) ||
         (o instanceof Uint16Array) ||
         (o instanceof Int32Array) ||
         (o instanceof Uint32Array) ||
         (o instanceof Float32Array) ||
         (o instanceof Float64Array) ||
         (o instanceof Float32x4Array);
}

function isArrayBuffer(o) {
  return (o instanceof ArrayBuffer);
}

function Float32x4Array(a, b, c) {
  if (isNumber(a)) {
    this.storage_ = new Float32Array(a*4);
    this.length_ = a;
    this.byteOffset_ = 0;
    return;
  } else if (isTypedArray(a)) {
    if (!(a instanceof Float32x4Array)) {
      throw "Copying typed array of non-Float32x4Array is unimplemented.";
    }
    this.storage_ = new Float32Array(a.length * 4);
    this.length_ = a.length;
    this.byteOffset_ = 0;
    // Copy floats.
    for (var i = 0; i < a.length*4; i++) {
      this.storage_[i] = a.storage_[i];
    }
  } else if (isArrayBuffer(a)) {
    if ((b != undefined) && (b % Float32x4Array.BYTES_PER_ELEMENT) != 0) {
      throw "byteOffset must be a multiple of 16.";
    }
    if (c != undefined) {
      c *= 4;
      this.storage_ = new Float32Array(a, b, c);
    }
    else {
      // Note: new Float32Array(a, b) is NOT equivalent to new Float32Array(a, b, undefined)
      this.storage_ = new Float32Array(a, b);
    }
    this.length_ = this.storage_.length / 4;
    this.byteOffset_ = b != undefined ? b : 0;
  } else {
    throw "Unknown type of first argument.";
  }
}

Object.defineProperty(Float32x4Array.prototype, 'length',
  { get: function() { return this.length_; }
});

Object.defineProperty(Float32x4Array.prototype, 'byteLength',
  { get: function() { return this.length_ * Float32x4Array.BYTES_PER_ELEMENT; }
});

Object.defineProperty(Float32x4Array, 'BYTES_PER_ELEMENT',
  { get: function() { return 16; }
});

Object.defineProperty(Float32x4Array.prototype, 'BYTES_PER_ELEMENT',
  { get: function() { return 16; }
});

Object.defineProperty(Float32x4Array.prototype, 'byteOffset',
  { get: function() { return this.byteOffset_; }
});

Object.defineProperty(Float32x4Array.prototype, 'buffer',
  { get: function() { return this.storage_.buffer; }
});

Float32x4Array.prototype.getAt = function(i) {
  if (i < 0) {
    throw "Index must be >= 0.";
  }
  if (i >= this.length) {
    throw "Index out of bounds.";
  }
  var x = this.storage_[i*4+0];
  var y = this.storage_[i*4+1];
  var z = this.storage_[i*4+2];
  var w = this.storage_[i*4+3];
  return float32x4(x, y, z, w);
}

Float32x4Array.prototype.setAt = function(i, v) {
  if (i < 0) {
    throw "Index must be >= 0.";
  }
  if (i >= this.length) {
    throw "Index out of bounds.";
  }
  if (!(v instanceof float32x4)) {
    throw "Value is not a float32x4.";
  }
  this.storage_[i*4+0] = v.x;
  this.storage_[i*4+1] = v.y;
  this.storage_[i*4+2] = v.z;
  this.storage_[i*4+3] = v.w;
}


function Int32x4Array(a, b, c) {

  function isNumber(o) {
      return typeof o == "number" || (typeof o == "object" && o.constructor === Number);
  }

  function isTypedArray(o) {
    return (o instanceof Int8Array) ||
           (o instanceof Uint8Array) ||
           (o instanceof Uint8ClampedArray) ||
           (o instanceof Int16Array) ||
           (o instanceof Uint16Array) ||
           (o instanceof Int32Array) ||
           (o instanceof Uint32Array) ||
           (o instanceof Float32Array) ||
           (o instanceof Float64Array) ||
           (o instanceof Int32x4Array) ||
           (o instanceof Float32x4Array);
  }

  function isArrayBuffer(o) {
    return (o instanceof ArrayBuffer);
  }

  if (isNumber(a)) {
    this.storage_ = new Int32Array(a*4);
    this.length_ = a;
    this.byteOffset_ = 0;
    return;
  } else if (isTypedArray(a)) {
    if (!(a instanceof Int32x4Array)) {
      throw "Copying typed array of non-Int32x4Array is unimplemented.";
    }
    this.storage_ = new Int32Array(a.length * 4);
    this.length_ = a.length;
    this.byteOffset_ = 0;
    // Copy floats.
    for (var i = 0; i < a.length*4; i++) {
      this.storage_[i] = a.storage_[i];
    }
  } else if (isArrayBuffer(a)) {
    if ((b != undefined) && (b % Int32x4Array.BYTES_PER_ELEMENT) != 0) {
      throw "byteOffset must be a multiple of 16.";
    }
    if (c != undefined) {
      c *= 4;
      this.storage_ = new Int32Array(a, b, c);
    }
    else {
      // Note: new Int32Array(a, b) is NOT equivalent to new Float32Array(a, b, undefined)
      this.storage_ = new Int32Array(a, b);
    }
    this.length_ = this.storage_.length / 4;
    this.byteOffset_ = b != undefined ? b : 0;
  } else {
    throw "Unknown type of first argument.";
  }
}

Object.defineProperty(Int32x4Array.prototype, 'length',
  { get: function() { return this.length_; }
});

Object.defineProperty(Int32x4Array.prototype, 'byteLength',
  { get: function() { return this.length_ * Int32x4Array.BYTES_PER_ELEMENT; }
});

Object.defineProperty(Int32x4Array, 'BYTES_PER_ELEMENT',
  { get: function() { return 16; }
});

Object.defineProperty(Int32x4Array.prototype, 'BYTES_PER_ELEMENT',
  { get: function() { return 16; }
});

Object.defineProperty(Int32x4Array.prototype, 'byteOffset',
  { get: function() { return this.byteOffset_; }
});

Object.defineProperty(Int32x4Array.prototype, 'buffer',
  { get: function() { return this.storage_.buffer; }
});

Int32x4Array.prototype.getAt = function(i) {
  if (i < 0) {
    throw "Index must be >= 0.";
  }
  if (i >= this.length) {
    throw "Index out of bounds.";
  }
  var x = this.storage_[i*4+0];
  var y = this.storage_[i*4+1];
  var z = this.storage_[i*4+2];
  var w = this.storage_[i*4+3];
  return float32x4(x, y, z, w);
}

Int32x4Array.prototype.setAt = function(i, v) {
  if (i < 0) {
    throw "Index must be >= 0.";
  }
  if (i >= this.length) {
    throw "Index out of bounds.";
  }
  if (!(v instanceof int32x4)) {
    throw "Value is not a int32x4.";
  }
  this.storage_[i*4+0] = v.x;
  this.storage_[i*4+1] = v.y;
  this.storage_[i*4+2] = v.z;
  this.storage_[i*4+3] = v.w;
}

var SIMD = (function () {
  return {
    float32x4: {
        /**
        * @return {float32x4} New instance of float32x4 with absolute values of
        * t.
        */
      abs: function(t) {
        return new float32x4(Math.abs(t.x), Math.abs(t.y), Math.abs(t.z),
                             Math.abs(t.w));
      },
      /**
        * @return {float32x4} New instance of float32x4 with negated values of
        * t.
        */
      neg: function(t) {
        return new float32x4(-t.x, -t.y, -t.z, -t.w);
      },
      /**
        * @return {float32x4} New instance of float32x4 with a + b.
        */
      add: function(a, b) {
        return new float32x4(a.x + b.x, a.y + b.y, a.z + b.z, a.w + b.w);
      },
      /**
        * @return {float32x4} New instance of float32x4 with a - b.
        */
      sub: function(a, b) {
        return new float32x4(a.x - b.x, a.y - b.y, a.z - b.z, a.w - b.w);
      },
      /**
        * @return {float32x4} New instance of float32x4 with a * b.
        */
      mul: function(a, b) {
        return new float32x4(a.x * b.x, a.y * b.y, a.z * b.z, a.w * b.w);
      },
      /**
        * @return {float32x4} New instance of float32x4 with a / b.
        */
      div: function(a, b) {
        return new float32x4(a.x / b.x, a.y / b.y, a.z / b.z, a.w / b.w);
      },
      /**
        * @return {float32x4} New instance of float32x4 with t's values clamped
        * between lowerLimit and upperLimit.
        */
      clamp: function(t, lowerLimit, upperLimit) {
        var cx = t.x < lowerLimit.x ? lowerLimit.x : t.x;
        var cy = t.y < lowerLimit.y ? lowerLimit.y : t.y;
        var cz = t.z < lowerLimit.z ? lowerLimit.z : t.z;
        var cw = t.w < lowerLimit.w ? lowerLimit.w : t.w;
        cx = cx > upperLimit.x ? upperLimit.x : cx;
        cy = cy > upperLimit.y ? upperLimit.y : cy;
        cz = cz > upperLimit.z ? upperLimit.z : cz;
        cw = cw > upperLimit.w ? upperLimit.w : cw;
        return new float32x4(cx, cy, cz, cw);
      },
      /**
        * @return {float32x4} New instance of float32x4 with the minimum value of
        * t and other.
        */
      min: function(t, other) {
        var cx = t.x > other.x ? other.x : t.x;
        var cy = t.y > other.y ? other.y : t.y;
        var cz = t.z > other.z ? other.z : t.z;
        var cw = t.w > other.w ? other.w : t.w;
        return new float32x4(cx, cy, cz, cw);
      },
      /**
        * @return {float32x4} New instance of float32x4 with the maximum value of
        * t and other.
        */
      max: function(t, other) {
        var cx = t.x < other.x ? other.x : t.x;
        var cy = t.y < other.y ? other.y : t.y;
        var cz = t.z < other.z ? other.z : t.z;
        var cw = t.w < other.w ? other.w : t.w;
        return new float32x4(cx, cy, cz, cw);
      },
      /**
        * @return {float32x4} New instance of float32x4 with reciprocal value of
        * t.
        */
      reciprocal: function(t) {
        return new float32x4(1.0 / t.x, 1.0 / t.y, 1.0 / t.z, 1.0 / t.w);
      },
      /**
        * @return {float32x4} New instance of float32x4 with square root of the
        * reciprocal value of t.
        */
      reciprocalSqrt: function(t) {
        return new float32x4(Math.sqrt(1.0 / t.x), Math.sqrt(1.0 / t.y),
                             Math.sqrt(1.0 / t.z), Math.sqrt(1.0 / t.w));
      },
      /**
        * @return {float32x4} New instance of float32x4 with values of t
        * scaled by s.
        */
      scale: function(t, s) {
        return new float32x4(s * t.x, s * t.y, s * t.z, s * t.w);
      },
      /**
        * @return {float32x4} New instance of float32x4 with square root of
        * values of t.
        */
      sqrt: function(t) {
        return new float32x4(Math.sqrt(t.x), Math.sqrt(t.y),
                             Math.sqrt(t.z), Math.sqrt(t.w));
      },
      /**
        * @param {float32x4} t An instance of float32x4 to be shuffled.
        * @param {integer} mask One of the 256 shuffle masks, for example, SIMD.XXXX.
        * @return {float32x4} New instance of float32x4 with lanes shuffled.
        */
      shuffle: function(t, mask) {
        var _x = (mask) & 0x3;
        var _y = (mask >> 2) & 0x3;
        var _z = (mask >> 4) & 0x3;
        var _w = (mask >> 6) & 0x3;
        return new float32x4(t.storage_[_x], t.storage_[_y], t.storage_[_z],
                             t.storage_[_w]);
      },
      /**
        * @param {float32x4} t1 An instance of float32x4 to be shuffled. XY lanes in result
        * @param {float32x4} t2 An instance of float32x4 to be shuffled. ZW lanes in result
        * @param {integer} mask One of the 256 shuffle masks, for example, SIMD.XXXX.
        * @return {float32x4} New instance of float32x4 with lanes shuffled.
        */
      shuffleMix: function(t1, t2, mask) {
        var _x = (mask) & 0x3;
        var _y = (mask >> 2) & 0x3;
        var _z = (mask >> 4) & 0x3;
        var _w = (mask >> 6) & 0x3;
        return new float32x4(t1.storage_[_x], t1.storage_[_y], t2.storage_[_z],
                             t2.storage_[_w]);
      },
      /**
        * @param {double} value used for x lane.
        * @return {float32x4} New instance of float32x4 with the values in t and
        * x replaced with {x}.
        */
      withX: function(t, x) {
        return new float32x4(x, t.y, t.z, t.w);
      },
      /**
        * @param {double} value used for y lane.
        * @return {float32x4} New instance of float32x4 with the values in t and
        * y replaced with {y}.
        */
      withY: function(t, y) {
        return new float32x4(t.x, y, t.z, t.w);
      },
      /**
        * @param {double} value used for z lane.
        * @return {float32x4} New instance of float32x4 with the values in t and
        * z replaced with {z}.
        */
      withZ: function(t, z) {
        return new float32x4(t.x, t.y, z, t.w);
      },
      /**
        * @param {double} value used for w lane.
        * @return {float32x4} New instance of float32x4 with the values in t and
        * w replaced with {w}.
        */
      withW: function(t, w) {
        return new float32x4(t.x, t.y, t.z, w);
      },
      /**
        * @param {float32x4} t An instance of float32x4.
        * @param {float32x4} other An instance of float32x4.
        * @return {int32x4} 0xFFFFFFFF or 0x0 in each lane depending on
        * the result of t < other.
        */
      lessThan: function(t, other) {
        var cx = t.x < other.x;
        var cy = t.y < other.y;
        var cz = t.z < other.z;
        var cw = t.w < other.w;
        return int32x4.bool(cx, cy, cz, cw);
      },
      /**
        * @param {float32x4} t An instance of float32x4.
        * @param {float32x4} other An instance of float32x4.
        * @return {int32x4} 0xFFFFFFFF or 0x0 in each lane depending on
        * the result of t <= other.
        */
      lessThanOrEqual: function(t, other) {
        var cx = t.x <= other.x;
        var cy = t.y <= other.y;
        var cz = t.z <= other.z;
        var cw = t.w <= other.w;
        return int32x4.bool(cx, cy, cz, cw);
      },
      /**
        * @param {float32x4} t An instance of float32x4.
        * @param {float32x4} other An instance of float32x4.
        * @return {int32x4} 0xFFFFFFFF or 0x0 in each lane depending on
        * the result of t == other.
        */
      equal: function(t, other) {
        var cx = t.x == other.x;
        var cy = t.y == other.y;
        var cz = t.z == other.z;
        var cw = t.w == other.w;
        return int32x4.bool(cx, cy, cz, cw);
      },
      /**
        * @param {float32x4} t An instance of float32x4.
        * @param {float32x4} other An instance of float32x4.
        * @return {int32x4} 0xFFFFFFFF or 0x0 in each lane depending on
        * the result of t != other.
        */
      notEqual: function(t, other) {
        var cx = t.x != other.x;
        var cy = t.y != other.y;
        var cz = t.z != other.z;
        var cw = t.w != other.w;
        return int32x4.bool(cx, cy, cz, cw);
      },
      /**
        * @param {float32x4} t An instance of float32x4.
        * @param {float32x4} other An instance of float32x4.
        * @return {int32x4} 0xFFFFFFFF or 0x0 in each lane depending on
        * the result of t >= other.
        */
      greaterThanOrEqual: function(t, other) {
        var cx = t.x >= other.x;
        var cy = t.y >= other.y;
        var cz = t.z >= other.z;
        var cw = t.w >= other.w;
        return int32x4.bool(cx, cy, cz, cw);
      },
      /**
        * @param {float32x4} t An instance of float32x4.
        * @param {float32x4} other An instance of float32x4.
        * @return {int32x4} 0xFFFFFFFF or 0x0 in each lane depending on
        * the result of t > other.
        */
      greaterThan: function(t, other) {
        var cx = t.x > other.x;
        var cy = t.y > other.y;
        var cz = t.z > other.z;
        var cw = t.w > other.w;
        return int32x4.bool(cx, cy, cz, cw);
      },
      /**
        * @param {float32x4} t An instance of float32x4.
        * @return {int32x4} a bit-wise copy of t as a int32x4.
        */
      bitsToInt32x4: function(t) {
        var alias = new Int32Array(t.storage_.buffer);
        return new int32x4(alias[0], alias[1], alias[2], alias[3]);
      },
      /**
        * @param {float32x4} t An instance of float32x4.
        * @return {int32x4} with a integer to float conversion of t.
        */
      toInt32x4: function(t) {
        var a = new int32x4(t.storage_[0], t.storage_[1], t.storage_[2],
                             t.storage_[3]);
        return a;
      }
    },
    int32x4: {
      /**
        * @param {int32x4} a An instance of int32x4.
        * @param {int32x4} b An instance of int32x4.
        * @return {int32x4} New instance of int32x4 with values of a & b.
        */
      and: function(a, b) {
        return new int32x4(a.x & b.x, a.y & b.y, a.z & b.z, a.w & b.w);
      },
      /**
        * @param {int32x4} a An instance of int32x4.
        * @param {int32x4} b An instance of int32x4.
        * @return {int32x4} New instance of int32x4 with values of a | b.
        */
      or: function(a, b) {
        return new int32x4(a.x | b.x, a.y | b.y, a.z | b.z, a.w | b.w);
      },
      /**
        * @param {int32x4} a An instance of int32x4.
        * @param {int32x4} b An instance of int32x4.
        * @return {int32x4} New instance of int32x4 with values of a ^ b.
        */
      xor: function(a, b) {
        return new int32x4(a.x ^ b.x, a.y ^ b.y, a.z ^ b.z, a.w ^ b.w);
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @return {int32x4} New instance of int32x4 with values of ~t
        */
      not: function(t) {
        return new int32x4(~t.x, ~t.y, ~t.z, ~t.w);
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @return {int32x4} New instance of int32x4 with values of -t
        */
      neg: function(t) {
        return new int32x4(-t.x, -t.y, -t.z, -t.w);
      },
      /**
        * @param {int32x4} a An instance of int32x4.
        * @param {int32x4} b An instance of int32x4.
        * @return {int32x4} New instance of int32x4 with values of a + b.
        */
      add: function(a, b) {
        return new int32x4(a.x + b.x, a.y + b.y, a.z + b.z, a.w + b.w);
      },
      /**
        * @param {int32x4} a An instance of int32x4.
        * @param {int32x4} b An instance of int32x4.
        * @return {int32x4} New instance of int32x4 with values of a - b.
        */
      sub: function(a, b) {
        return new int32x4(a.x - b.x, a.y - b.y, a.z - b.z, a.w - b.w);
      },
      /**
        * @param {int32x4} a An instance of int32x4.
        * @param {int32x4} b An instance of int32x4.
        * @return {int32x4} New instance of int32x4 with values of a * b.
        */
      mul: function(a, b) {
        return new int32x4(Math.imul(a.x, b.x), Math.imul(a.y, b.y),
                           Math.imul(a.z, b.z), Math.imul(a.w, b.w));
      },
      /**
        * @param {int32x4} t An instance of float32x4 to be shuffled.
        * @param {integer} mask One of the 256 shuffle masks, for example, SIMD.XXXX.
        * @return {int32x4} New instance of float32x4 with lanes shuffled.
        */
      shuffle: function(t, mask) {
        var _x = (mask) & 0x3;
        var _y = (mask >> 2) & 0x3;
        var _z = (mask >> 4) & 0x3;
        var _w = (mask >> 6) & 0x3;
        return new int32x4(t.storage_[_x], t.storage_[_y], t.storage_[_z],
                             t.storage_[_w]);
      },
      /**
        * @param {int32x4} t1 An instance of float32x4 to be shuffled. XY lanes in result
        * @param {int32x4} t2 An instance of float32x4 to be shuffled. ZW lanes in result
        * @param {integer} mask One of the 256 shuffle masks, for example, SIMD.XXXX.
        * @return {int32x4} New instance of float32x4 with lanes shuffled.
        */
      shuffleMix: function(t1, t2, mask) {
        var _x = (mask) & 0x3;
        var _y = (mask >> 2) & 0x3;
        var _z = (mask >> 4) & 0x3;
        var _w = (mask >> 6) & 0x3;
        return new int32x4(t1.storage_[_x], t1.storage_[_y], t2.storage_[_z],
                             t2.storage_[_w]);
      },
      /**
        * @param {float32x4}
        */
      select: function(t, trueValue, falseValue) {
        var tv = SIMD.float32x4.bitsToInt32x4(trueValue);
        var fv = SIMD.float32x4.bitsToInt32x4(falseValue);
        var tr = SIMD.int32x4.and(t, tv);
        var fr = SIMD.int32x4.and(SIMD.int32x4.not(t), fv);
        return SIMD.int32x4.bitsToFloat32x4(SIMD.int32x4.or(tr, fr));
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @param {integer} 32-bit value used for x lane.
        * @return {int32x4} New instance of int32x4 with the values in t and
        * x lane replaced with {x}.
        */
      withX: function(t, x) {
        return new int32x4(x, t.y, t.z, t.w);
      },
      /**
        * param {int32x4} t An instance of int32x4.
        * @param {integer} 32-bit value used for y lane.
        * @return {int32x4} New instance of int32x4 with the values in t and
        * y lane replaced with {y}.
        */
      withY: function(t, y) {
        return new int32x4(t.x, y, t.z, t.w);
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @param {integer} 32-bit value used for z lane.
        * @return {int32x4} New instance of int32x4 with the values in t and
        * z lane replaced with {z}.
        */
      withZ: function(t, z) {
        return new int32x4(t.x, t.y, z, t.w);
      },
      /**
        * @param {integer} 32-bit value used for w lane.
        * @return {int32x4} New instance of int32x4 with the values in t and
        * w lane replaced with {w}.
        */
      withW: function(t, w) {
        return new int32x4(t.x, t.y, t.z, w);
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @param {boolean} x flag used for x lane.
        * @return {int32x4} New instance of int32x4 with the values in t and
        * x lane replaced with {x}.
        */
      withFlagX: function(t, flagX) {
        var x = flagX ? 0xFFFFFFFF : 0x0;
        return new int32x4(x, t.y, t.z, t.w);
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @param {boolean} y flag used for y lane.
        * @return {int32x4} New instance of int32x4 with the values in t and
        * y lane replaced with {y}.
        */
      withFlagY: function(t, flagY) {
        var y = flagY ? 0xFFFFFFFF : 0x0;
        return new int32x4(t.x, y, t.z, t.w);
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @param {boolean} z flag used for z lane.
        * @return {int32x4} New instance of int32x4 with the values in t and
        * z lane replaced with {z}.
        */
      withFlagZ: function(t, flagZ) {
        var z = flagZ ? 0xFFFFFFFF : 0x0;
        return new int32x4(t.x, t.y, z, t.w);
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @param {boolean} w flag used for w lane.
        * @return {int32x4} New instance of int32x4 with the values in t and
        * w lane replaced with {w}.
        */
      withFlagW: function(t, flagW) {
        var w = flagW ? 0xFFFFFFFF : 0x0;
        return new int32x4(t.x, t.y, t.z, w);
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @return {float32x4} a bit-wise copy of t as a float32x4.
        */
      bitsToFloat32x4: function(t) {
        var temp_storage = new Int32Array([t.storage_[0], t.storage_[1], t.storage_[2], t.storage_[3]]);
        var alias = new Float32Array(temp_storage.buffer);
        var fx4 = float32x4.zero();
        fx4.storage_ = alias;
        return fx4;      
      },
      /**
        * @param {int32x4} t An instance of int32x4.
        * @return {float32x4} with a float to integer conversion copy of t.
        */
      toFloat32x4: function(t) {
        var a = float32x4.zero();
        a.storage_[0] = t.storage_[0];
        a.storage_[1] = t.storage_[1];
        a.storage_[2] = t.storage_[2];
        a.storage_[3] = t.storage_[3];
        return a;
      }
    }
  }
})();

Object.defineProperty(SIMD, 'XXXX', { get: function() { return 0x0; } });
Object.defineProperty(SIMD, 'XXXY', { get: function() { return 0x40; } });
Object.defineProperty(SIMD, 'XXXZ', { get: function() { return 0x80; } });
Object.defineProperty(SIMD, 'XXXW', { get: function() { return 0xC0; } });
Object.defineProperty(SIMD, 'XXYX', { get: function() { return 0x10; } });
Object.defineProperty(SIMD, 'XXYY', { get: function() { return 0x50; } });
Object.defineProperty(SIMD, 'XXYZ', { get: function() { return 0x90; } });
Object.defineProperty(SIMD, 'XXYW', { get: function() { return 0xD0; } });
Object.defineProperty(SIMD, 'XXZX', { get: function() { return 0x20; } });
Object.defineProperty(SIMD, 'XXZY', { get: function() { return 0x60; } });
Object.defineProperty(SIMD, 'XXZZ', { get: function() { return 0xA0; } });
Object.defineProperty(SIMD, 'XXZW', { get: function() { return 0xE0; } });
Object.defineProperty(SIMD, 'XXWX', { get: function() { return 0x30; } });
Object.defineProperty(SIMD, 'XXWY', { get: function() { return 0x70; } });
Object.defineProperty(SIMD, 'XXWZ', { get: function() { return 0xB0; } });
Object.defineProperty(SIMD, 'XXWW', { get: function() { return 0xF0; } });
Object.defineProperty(SIMD, 'XYXX', { get: function() { return 0x4; } });
Object.defineProperty(SIMD, 'XYXY', { get: function() { return 0x44; } });
Object.defineProperty(SIMD, 'XYXZ', { get: function() { return 0x84; } });
Object.defineProperty(SIMD, 'XYXW', { get: function() { return 0xC4; } });
Object.defineProperty(SIMD, 'XYYX', { get: function() { return 0x14; } });
Object.defineProperty(SIMD, 'XYYY', { get: function() { return 0x54; } });
Object.defineProperty(SIMD, 'XYYZ', { get: function() { return 0x94; } });
Object.defineProperty(SIMD, 'XYYW', { get: function() { return 0xD4; } });
Object.defineProperty(SIMD, 'XYZX', { get: function() { return 0x24; } });
Object.defineProperty(SIMD, 'XYZY', { get: function() { return 0x64; } });
Object.defineProperty(SIMD, 'XYZZ', { get: function() { return 0xA4; } });
Object.defineProperty(SIMD, 'XYZW', { get: function() { return 0xE4; } });
Object.defineProperty(SIMD, 'XYWX', { get: function() { return 0x34; } });
Object.defineProperty(SIMD, 'XYWY', { get: function() { return 0x74; } });
Object.defineProperty(SIMD, 'XYWZ', { get: function() { return 0xB4; } });
Object.defineProperty(SIMD, 'XYWW', { get: function() { return 0xF4; } });
Object.defineProperty(SIMD, 'XZXX', { get: function() { return 0x8; } });
Object.defineProperty(SIMD, 'XZXY', { get: function() { return 0x48; } });
Object.defineProperty(SIMD, 'XZXZ', { get: function() { return 0x88; } });
Object.defineProperty(SIMD, 'XZXW', { get: function() { return 0xC8; } });
Object.defineProperty(SIMD, 'XZYX', { get: function() { return 0x18; } });
Object.defineProperty(SIMD, 'XZYY', { get: function() { return 0x58; } });
Object.defineProperty(SIMD, 'XZYZ', { get: function() { return 0x98; } });
Object.defineProperty(SIMD, 'XZYW', { get: function() { return 0xD8; } });
Object.defineProperty(SIMD, 'XZZX', { get: function() { return 0x28; } });
Object.defineProperty(SIMD, 'XZZY', { get: function() { return 0x68; } });
Object.defineProperty(SIMD, 'XZZZ', { get: function() { return 0xA8; } });
Object.defineProperty(SIMD, 'XZZW', { get: function() { return 0xE8; } });
Object.defineProperty(SIMD, 'XZWX', { get: function() { return 0x38; } });
Object.defineProperty(SIMD, 'XZWY', { get: function() { return 0x78; } });
Object.defineProperty(SIMD, 'XZWZ', { get: function() { return 0xB8; } });
Object.defineProperty(SIMD, 'XZWW', { get: function() { return 0xF8; } });
Object.defineProperty(SIMD, 'XWXX', { get: function() { return 0xC; } });
Object.defineProperty(SIMD, 'XWXY', { get: function() { return 0x4C; } });
Object.defineProperty(SIMD, 'XWXZ', { get: function() { return 0x8C; } });
Object.defineProperty(SIMD, 'XWXW', { get: function() { return 0xCC; } });
Object.defineProperty(SIMD, 'XWYX', { get: function() { return 0x1C; } });
Object.defineProperty(SIMD, 'XWYY', { get: function() { return 0x5C; } });
Object.defineProperty(SIMD, 'XWYZ', { get: function() { return 0x9C; } });
Object.defineProperty(SIMD, 'XWYW', { get: function() { return 0xDC; } });
Object.defineProperty(SIMD, 'XWZX', { get: function() { return 0x2C; } });
Object.defineProperty(SIMD, 'XWZY', { get: function() { return 0x6C; } });
Object.defineProperty(SIMD, 'XWZZ', { get: function() { return 0xAC; } });
Object.defineProperty(SIMD, 'XWZW', { get: function() { return 0xEC; } });
Object.defineProperty(SIMD, 'XWWX', { get: function() { return 0x3C; } });
Object.defineProperty(SIMD, 'XWWY', { get: function() { return 0x7C; } });
Object.defineProperty(SIMD, 'XWWZ', { get: function() { return 0xBC; } });
Object.defineProperty(SIMD, 'XWWW', { get: function() { return 0xFC; } });
Object.defineProperty(SIMD, 'YXXX', { get: function() { return 0x1; } });
Object.defineProperty(SIMD, 'YXXY', { get: function() { return 0x41; } });
Object.defineProperty(SIMD, 'YXXZ', { get: function() { return 0x81; } });
Object.defineProperty(SIMD, 'YXXW', { get: function() { return 0xC1; } });
Object.defineProperty(SIMD, 'YXYX', { get: function() { return 0x11; } });
Object.defineProperty(SIMD, 'YXYY', { get: function() { return 0x51; } });
Object.defineProperty(SIMD, 'YXYZ', { get: function() { return 0x91; } });
Object.defineProperty(SIMD, 'YXYW', { get: function() { return 0xD1; } });
Object.defineProperty(SIMD, 'YXZX', { get: function() { return 0x21; } });
Object.defineProperty(SIMD, 'YXZY', { get: function() { return 0x61; } });
Object.defineProperty(SIMD, 'YXZZ', { get: function() { return 0xA1; } });
Object.defineProperty(SIMD, 'YXZW', { get: function() { return 0xE1; } });
Object.defineProperty(SIMD, 'YXWX', { get: function() { return 0x31; } });
Object.defineProperty(SIMD, 'YXWY', { get: function() { return 0x71; } });
Object.defineProperty(SIMD, 'YXWZ', { get: function() { return 0xB1; } });
Object.defineProperty(SIMD, 'YXWW', { get: function() { return 0xF1; } });
Object.defineProperty(SIMD, 'YYXX', { get: function() { return 0x5; } });
Object.defineProperty(SIMD, 'YYXY', { get: function() { return 0x45; } });
Object.defineProperty(SIMD, 'YYXZ', { get: function() { return 0x85; } });
Object.defineProperty(SIMD, 'YYXW', { get: function() { return 0xC5; } });
Object.defineProperty(SIMD, 'YYYX', { get: function() { return 0x15; } });
Object.defineProperty(SIMD, 'YYYY', { get: function() { return 0x55; } });
Object.defineProperty(SIMD, 'YYYZ', { get: function() { return 0x95; } });
Object.defineProperty(SIMD, 'YYYW', { get: function() { return 0xD5; } });
Object.defineProperty(SIMD, 'YYZX', { get: function() { return 0x25; } });
Object.defineProperty(SIMD, 'YYZY', { get: function() { return 0x65; } });
Object.defineProperty(SIMD, 'YYZZ', { get: function() { return 0xA5; } });
Object.defineProperty(SIMD, 'YYZW', { get: function() { return 0xE5; } });
Object.defineProperty(SIMD, 'YYWX', { get: function() { return 0x35; } });
Object.defineProperty(SIMD, 'YYWY', { get: function() { return 0x75; } });
Object.defineProperty(SIMD, 'YYWZ', { get: function() { return 0xB5; } });
Object.defineProperty(SIMD, 'YYWW', { get: function() { return 0xF5; } });
Object.defineProperty(SIMD, 'YZXX', { get: function() { return 0x9; } });
Object.defineProperty(SIMD, 'YZXY', { get: function() { return 0x49; } });
Object.defineProperty(SIMD, 'YZXZ', { get: function() { return 0x89; } });
Object.defineProperty(SIMD, 'YZXW', { get: function() { return 0xC9; } });
Object.defineProperty(SIMD, 'YZYX', { get: function() { return 0x19; } });
Object.defineProperty(SIMD, 'YZYY', { get: function() { return 0x59; } });
Object.defineProperty(SIMD, 'YZYZ', { get: function() { return 0x99; } });
Object.defineProperty(SIMD, 'YZYW', { get: function() { return 0xD9; } });
Object.defineProperty(SIMD, 'YZZX', { get: function() { return 0x29; } });
Object.defineProperty(SIMD, 'YZZY', { get: function() { return 0x69; } });
Object.defineProperty(SIMD, 'YZZZ', { get: function() { return 0xA9; } });
Object.defineProperty(SIMD, 'YZZW', { get: function() { return 0xE9; } });
Object.defineProperty(SIMD, 'YZWX', { get: function() { return 0x39; } });
Object.defineProperty(SIMD, 'YZWY', { get: function() { return 0x79; } });
Object.defineProperty(SIMD, 'YZWZ', { get: function() { return 0xB9; } });
Object.defineProperty(SIMD, 'YZWW', { get: function() { return 0xF9; } });
Object.defineProperty(SIMD, 'YWXX', { get: function() { return 0xD; } });
Object.defineProperty(SIMD, 'YWXY', { get: function() { return 0x4D; } });
Object.defineProperty(SIMD, 'YWXZ', { get: function() { return 0x8D; } });
Object.defineProperty(SIMD, 'YWXW', { get: function() { return 0xCD; } });
Object.defineProperty(SIMD, 'YWYX', { get: function() { return 0x1D; } });
Object.defineProperty(SIMD, 'YWYY', { get: function() { return 0x5D; } });
Object.defineProperty(SIMD, 'YWYZ', { get: function() { return 0x9D; } });
Object.defineProperty(SIMD, 'YWYW', { get: function() { return 0xDD; } });
Object.defineProperty(SIMD, 'YWZX', { get: function() { return 0x2D; } });
Object.defineProperty(SIMD, 'YWZY', { get: function() { return 0x6D; } });
Object.defineProperty(SIMD, 'YWZZ', { get: function() { return 0xAD; } });
Object.defineProperty(SIMD, 'YWZW', { get: function() { return 0xED; } });
Object.defineProperty(SIMD, 'YWWX', { get: function() { return 0x3D; } });
Object.defineProperty(SIMD, 'YWWY', { get: function() { return 0x7D; } });
Object.defineProperty(SIMD, 'YWWZ', { get: function() { return 0xBD; } });
Object.defineProperty(SIMD, 'YWWW', { get: function() { return 0xFD; } });
Object.defineProperty(SIMD, 'ZXXX', { get: function() { return 0x2; } });
Object.defineProperty(SIMD, 'ZXXY', { get: function() { return 0x42; } });
Object.defineProperty(SIMD, 'ZXXZ', { get: function() { return 0x82; } });
Object.defineProperty(SIMD, 'ZXXW', { get: function() { return 0xC2; } });
Object.defineProperty(SIMD, 'ZXYX', { get: function() { return 0x12; } });
Object.defineProperty(SIMD, 'ZXYY', { get: function() { return 0x52; } });
Object.defineProperty(SIMD, 'ZXYZ', { get: function() { return 0x92; } });
Object.defineProperty(SIMD, 'ZXYW', { get: function() { return 0xD2; } });
Object.defineProperty(SIMD, 'ZXZX', { get: function() { return 0x22; } });
Object.defineProperty(SIMD, 'ZXZY', { get: function() { return 0x62; } });
Object.defineProperty(SIMD, 'ZXZZ', { get: function() { return 0xA2; } });
Object.defineProperty(SIMD, 'ZXZW', { get: function() { return 0xE2; } });
Object.defineProperty(SIMD, 'ZXWX', { get: function() { return 0x32; } });
Object.defineProperty(SIMD, 'ZXWY', { get: function() { return 0x72; } });
Object.defineProperty(SIMD, 'ZXWZ', { get: function() { return 0xB2; } });
Object.defineProperty(SIMD, 'ZXWW', { get: function() { return 0xF2; } });
Object.defineProperty(SIMD, 'ZYXX', { get: function() { return 0x6; } });
Object.defineProperty(SIMD, 'ZYXY', { get: function() { return 0x46; } });
Object.defineProperty(SIMD, 'ZYXZ', { get: function() { return 0x86; } });
Object.defineProperty(SIMD, 'ZYXW', { get: function() { return 0xC6; } });
Object.defineProperty(SIMD, 'ZYYX', { get: function() { return 0x16; } });
Object.defineProperty(SIMD, 'ZYYY', { get: function() { return 0x56; } });
Object.defineProperty(SIMD, 'ZYYZ', { get: function() { return 0x96; } });
Object.defineProperty(SIMD, 'ZYYW', { get: function() { return 0xD6; } });
Object.defineProperty(SIMD, 'ZYZX', { get: function() { return 0x26; } });
Object.defineProperty(SIMD, 'ZYZY', { get: function() { return 0x66; } });
Object.defineProperty(SIMD, 'ZYZZ', { get: function() { return 0xA6; } });
Object.defineProperty(SIMD, 'ZYZW', { get: function() { return 0xE6; } });
Object.defineProperty(SIMD, 'ZYWX', { get: function() { return 0x36; } });
Object.defineProperty(SIMD, 'ZYWY', { get: function() { return 0x76; } });
Object.defineProperty(SIMD, 'ZYWZ', { get: function() { return 0xB6; } });
Object.defineProperty(SIMD, 'ZYWW', { get: function() { return 0xF6; } });
Object.defineProperty(SIMD, 'ZZXX', { get: function() { return 0xA; } });
Object.defineProperty(SIMD, 'ZZXY', { get: function() { return 0x4A; } });
Object.defineProperty(SIMD, 'ZZXZ', { get: function() { return 0x8A; } });
Object.defineProperty(SIMD, 'ZZXW', { get: function() { return 0xCA; } });
Object.defineProperty(SIMD, 'ZZYX', { get: function() { return 0x1A; } });
Object.defineProperty(SIMD, 'ZZYY', { get: function() { return 0x5A; } });
Object.defineProperty(SIMD, 'ZZYZ', { get: function() { return 0x9A; } });
Object.defineProperty(SIMD, 'ZZYW', { get: function() { return 0xDA; } });
Object.defineProperty(SIMD, 'ZZZX', { get: function() { return 0x2A; } });
Object.defineProperty(SIMD, 'ZZZY', { get: function() { return 0x6A; } });
Object.defineProperty(SIMD, 'ZZZZ', { get: function() { return 0xAA; } });
Object.defineProperty(SIMD, 'ZZZW', { get: function() { return 0xEA; } });
Object.defineProperty(SIMD, 'ZZWX', { get: function() { return 0x3A; } });
Object.defineProperty(SIMD, 'ZZWY', { get: function() { return 0x7A; } });
Object.defineProperty(SIMD, 'ZZWZ', { get: function() { return 0xBA; } });
Object.defineProperty(SIMD, 'ZZWW', { get: function() { return 0xFA; } });
Object.defineProperty(SIMD, 'ZWXX', { get: function() { return 0xE; } });
Object.defineProperty(SIMD, 'ZWXY', { get: function() { return 0x4E; } });
Object.defineProperty(SIMD, 'ZWXZ', { get: function() { return 0x8E; } });
Object.defineProperty(SIMD, 'ZWXW', { get: function() { return 0xCE; } });
Object.defineProperty(SIMD, 'ZWYX', { get: function() { return 0x1E; } });
Object.defineProperty(SIMD, 'ZWYY', { get: function() { return 0x5E; } });
Object.defineProperty(SIMD, 'ZWYZ', { get: function() { return 0x9E; } });
Object.defineProperty(SIMD, 'ZWYW', { get: function() { return 0xDE; } });
Object.defineProperty(SIMD, 'ZWZX', { get: function() { return 0x2E; } });
Object.defineProperty(SIMD, 'ZWZY', { get: function() { return 0x6E; } });
Object.defineProperty(SIMD, 'ZWZZ', { get: function() { return 0xAE; } });
Object.defineProperty(SIMD, 'ZWZW', { get: function() { return 0xEE; } });
Object.defineProperty(SIMD, 'ZWWX', { get: function() { return 0x3E; } });
Object.defineProperty(SIMD, 'ZWWY', { get: function() { return 0x7E; } });
Object.defineProperty(SIMD, 'ZWWZ', { get: function() { return 0xBE; } });
Object.defineProperty(SIMD, 'ZWWW', { get: function() { return 0xFE; } });
Object.defineProperty(SIMD, 'WXXX', { get: function() { return 0x3; } });
Object.defineProperty(SIMD, 'WXXY', { get: function() { return 0x43; } });
Object.defineProperty(SIMD, 'WXXZ', { get: function() { return 0x83; } });
Object.defineProperty(SIMD, 'WXXW', { get: function() { return 0xC3; } });
Object.defineProperty(SIMD, 'WXYX', { get: function() { return 0x13; } });
Object.defineProperty(SIMD, 'WXYY', { get: function() { return 0x53; } });
Object.defineProperty(SIMD, 'WXYZ', { get: function() { return 0x93; } });
Object.defineProperty(SIMD, 'WXYW', { get: function() { return 0xD3; } });
Object.defineProperty(SIMD, 'WXZX', { get: function() { return 0x23; } });
Object.defineProperty(SIMD, 'WXZY', { get: function() { return 0x63; } });
Object.defineProperty(SIMD, 'WXZZ', { get: function() { return 0xA3; } });
Object.defineProperty(SIMD, 'WXZW', { get: function() { return 0xE3; } });
Object.defineProperty(SIMD, 'WXWX', { get: function() { return 0x33; } });
Object.defineProperty(SIMD, 'WXWY', { get: function() { return 0x73; } });
Object.defineProperty(SIMD, 'WXWZ', { get: function() { return 0xB3; } });
Object.defineProperty(SIMD, 'WXWW', { get: function() { return 0xF3; } });
Object.defineProperty(SIMD, 'WYXX', { get: function() { return 0x7; } });
Object.defineProperty(SIMD, 'WYXY', { get: function() { return 0x47; } });
Object.defineProperty(SIMD, 'WYXZ', { get: function() { return 0x87; } });
Object.defineProperty(SIMD, 'WYXW', { get: function() { return 0xC7; } });
Object.defineProperty(SIMD, 'WYYX', { get: function() { return 0x17; } });
Object.defineProperty(SIMD, 'WYYY', { get: function() { return 0x57; } });
Object.defineProperty(SIMD, 'WYYZ', { get: function() { return 0x97; } });
Object.defineProperty(SIMD, 'WYYW', { get: function() { return 0xD7; } });
Object.defineProperty(SIMD, 'WYZX', { get: function() { return 0x27; } });
Object.defineProperty(SIMD, 'WYZY', { get: function() { return 0x67; } });
Object.defineProperty(SIMD, 'WYZZ', { get: function() { return 0xA7; } });
Object.defineProperty(SIMD, 'WYZW', { get: function() { return 0xE7; } });
Object.defineProperty(SIMD, 'WYWX', { get: function() { return 0x37; } });
Object.defineProperty(SIMD, 'WYWY', { get: function() { return 0x77; } });
Object.defineProperty(SIMD, 'WYWZ', { get: function() { return 0xB7; } });
Object.defineProperty(SIMD, 'WYWW', { get: function() { return 0xF7; } });
Object.defineProperty(SIMD, 'WZXX', { get: function() { return 0xB; } });
Object.defineProperty(SIMD, 'WZXY', { get: function() { return 0x4B; } });
Object.defineProperty(SIMD, 'WZXZ', { get: function() { return 0x8B; } });
Object.defineProperty(SIMD, 'WZXW', { get: function() { return 0xCB; } });
Object.defineProperty(SIMD, 'WZYX', { get: function() { return 0x1B; } });
Object.defineProperty(SIMD, 'WZYY', { get: function() { return 0x5B; } });
Object.defineProperty(SIMD, 'WZYZ', { get: function() { return 0x9B; } });
Object.defineProperty(SIMD, 'WZYW', { get: function() { return 0xDB; } });
Object.defineProperty(SIMD, 'WZZX', { get: function() { return 0x2B; } });
Object.defineProperty(SIMD, 'WZZY', { get: function() { return 0x6B; } });
Object.defineProperty(SIMD, 'WZZZ', { get: function() { return 0xAB; } });
Object.defineProperty(SIMD, 'WZZW', { get: function() { return 0xEB; } });
Object.defineProperty(SIMD, 'WZWX', { get: function() { return 0x3B; } });
Object.defineProperty(SIMD, 'WZWY', { get: function() { return 0x7B; } });
Object.defineProperty(SIMD, 'WZWZ', { get: function() { return 0xBB; } });
Object.defineProperty(SIMD, 'WZWW', { get: function() { return 0xFB; } });
Object.defineProperty(SIMD, 'WWXX', { get: function() { return 0xF; } });
Object.defineProperty(SIMD, 'WWXY', { get: function() { return 0x4F; } });
Object.defineProperty(SIMD, 'WWXZ', { get: function() { return 0x8F; } });
Object.defineProperty(SIMD, 'WWXW', { get: function() { return 0xCF; } });
Object.defineProperty(SIMD, 'WWYX', { get: function() { return 0x1F; } });
Object.defineProperty(SIMD, 'WWYY', { get: function() { return 0x5F; } });
Object.defineProperty(SIMD, 'WWYZ', { get: function() { return 0x9F; } });
Object.defineProperty(SIMD, 'WWYW', { get: function() { return 0xDF; } });
Object.defineProperty(SIMD, 'WWZX', { get: function() { return 0x2F; } });
Object.defineProperty(SIMD, 'WWZY', { get: function() { return 0x6F; } });
Object.defineProperty(SIMD, 'WWZZ', { get: function() { return 0xAF; } });
Object.defineProperty(SIMD, 'WWZW', { get: function() { return 0xEF; } });
Object.defineProperty(SIMD, 'WWWX', { get: function() { return 0x3F; } });
Object.defineProperty(SIMD, 'WWWY', { get: function() { return 0x7F; } });
Object.defineProperty(SIMD, 'WWWZ', { get: function() { return 0xBF; } });
Object.defineProperty(SIMD, 'WWWW', { get: function() { return 0xFF; } });


// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  function applyData(data) {
    HEAPU8.set(data, STATIC_BASE);
  }
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    applyData(Module['readBinary'](memoryInitializer));
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      applyData(data);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}

run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}



//@ sourceMappingURL=sim.html.map